Windows Media Services

With Microsoft® Windows Media™ Services 9 Series in Windows® Server 2003, you can deliver content to users over the Internet or intranet. Windows Media Services has two administrative interfaces that can be used to configure and manage one or more servers running Windows Media Services. If you are an experienced Windows Media Services user, check out Changes to Windows Media Services to get up to speed quickly on the new and improved features of Windows Media Services 9 Series.

  • Comparing versions of Windows Media Services. Provides an overview of the different features available in Windows Media Services based on the edition of Microsoft Windows® Server 2003 you are running.
  • Documentation conventions. Provides information about the documentation conventions used to represent information in Windows Media Services Help.
  • Getting started. Provides information to help you start using Windows Media Services.
  • Scenarios. Discusses the top usage scenarios for Windows Media Services.
  • Concepts. Provides the concepts that are central to successfully using Windows Media Services.
  • How to…. Provides detailed procedures for administrative tasks.
  • Administration. Provides detailed information about the administrative interfaces of Windows Media Services.
  • Troubleshooting. Provides information to assist in solving common difficulties encountered when using Windows Media Services.
  • Playlist reference. Provides a guide to the elements and attributes used when creating server-side playlists.
  • Deployment guide. Provides a guide to the practical application of Windows Media Services in several frequently-encountered scenarios.
  • Accessibility for people with disabilities. Provides information about the features, products, and services that make Microsoft Windows Media Services more accessible for people with disabilities.
  • Glossary. Provides terms and definitions related to Windows Media Services.

Note Image Note

  • Windows Media 9 Series Privacy Statement. For more information about protecting your privacy while accessing the Internet, see the Windows Media 9 Series Privacy Statement at the Microsoft Web site.
© 2000-2003 Microsoft Corporation. All rights reserved.


Comparing versions of Windows Media Services

Windows Media Services 9 Series is available as an optional component of Windows Server 2003, Standard Edition, Windows Server 2003, Enterprise Edition, and Windows Server 2003, Datacenter Edition. However, additional features are available when Windows Media Services is used with Windows Server 2003, Enterprise Edition or Windows Server 2003, Datacenter Edition. The following table provides an overview of the available features.

Feature | Windows Server 2003, Standard Edition | Windows Server 2003, Enterprise Edition or Windows Server 2003, Datacenter Edition
Advertising server support | Check mark | Check mark
Cache/proxy server support |  | Check mark
Unicast content delivery | Check mark | Check mark
Multicast content delivery |  | Check mark
Multiple control protocol support (MMS, HTTP, RTSP) | Check mark | Check mark
Wireless streaming optimizations |  | Check mark
Multiple authorization methods (NTFS ACL, IP Address) | Check mark | Check mark
Internet authentication method (Digest) |  | Check mark
Intranet authentication methods (Negotiate authentication, Anonymous access) | Check mark | Check mark
Multiple playlist parser support (WSX, Directory) | Check mark | Check mark
Multiple media parser support (Windows Media, MP3) | Check mark | Check mark
Custom plug-in support |  | Check mark
Robust event notification (WMI, SNMP) | Check mark | Check mark
Event-based scripting support |  | Check mark
Fast Cache | Check mark | Check mark
Fast Start | Check mark | Check mark
Fast Streaming | Check mark | Check mark
Fast Reconnect | Check mark | Check mark
Fast Recovery |  | Check mark
RTSP streaming | Check mark | Check mark
Internet Protocol version 6 (IPv6) support | Check mark | Check mark
Internet Group Management Protocol version 3 (IGMPv3) support |  | Check mark
Server based content repacketization | Check mark | Check mark

Related topics

  • Windows Media Services


Documentation conventions

The following conventions are used in this Help system.

This convention | Indicates
Web administration feature | Information only applicable when administering Windows Media Services by using Windows Media Services Administrator for the Web.
Bold | User interface elements or text that should be typed exactly as shown.
Italics | Variables that you should replace with text appropriate to your environment.
Code

Sample code that you should replace with code appropriate to your environment.

  Note Image    Notes

  • When using Microsoft Management Console to administer Windows Media Services, there are many different methods to accomplish the same tasks, such as using menu commands, shortcut menus that can be accessed by right-clicking console tree items, taskpad buttons, toolbar buttons, and double-clicking. By default, this documentation uses a combination of menu commands and taskpad buttons in procedural topics.
    •

  • When using Windows Media Services Administrator for the Web, the interface is limited. For Windows Media Services Administrator for the Web procedures, this documentation uses a combination of buttons or other user interface items.
    •

Related topics

  • Windows Media Services
    •


Getting started

This section provides introductory information about Microsoft Windows Media Services. Windows Media Services has been completely redesigned for this version. If you are familiar with earlier versions of the product, you will notice new administrative interfaces, new terminology, and many new features. Review the topics in this section for more details about the features included in this release and information about installing or upgrading Windows Media Services.

This section contains the following topics:

  • Understanding Windows Media 9 Series. Provides an overview of the technologies that can be used with Windows Media Services.
  • Understanding terminology. Presents a quick overview of specialized terms used with streaming media technology.
  • Changes to Windows Media Services. Presents the changes made since the previous version of Windows Media Services.
  • Upgrading Windows Media Services. Describes the process of migrating existing Windows Media Services configuration information when upgrading.
  • New features in Windows Media Services. Describes the new features in Windows Media Services.
  • System requirements. Includes reference tables that provide minimum system specifications for hardware and software.
  • Deploying Windows Media Services. Provides an overview of the issues involved in deploying Windows Media Services.
  • Administering Windows Media Services. Provides an overview of managing Windows Media Services.

Related topics

  • Windows Media Services


Understanding Windows Media 9 Series

Windows Media 9 Series is the term for the family of digital media software developed by Microsoft. All of the series are designed to work together to provide the optimal digital media experience.

Windows Media Services is a platform for streaming audio and video content to clients over the Internet or an intranet. These clients may be other computers or devices that play back the content using a player, such as Windows Media Player, or they may be other computers running Windows Media Services (called Windows Media servers) that are proxying, caching, or redistributing your content. Clients can also be custom applications that have been developed using the Windows Media Software Development Kit (SDK).

The content your Windows Media server streams to clients can be either a live stream or preexisting content, such as a digital media file. If you are planning to stream live content, your server will connect to encoding software, such as Windows Media Encoder, that is capable of broadcasting a live stream in a format supported by the server. You can also stream preexisting content that has been encoded by Windows Media Encoder, Microsoft Producer for PowerPoint® 2002, Windows Movie Maker, Windows Media Player, or many other third-party encoding programs.

To learn more about the basics of streaming using Windows Media Services, see Streaming media system overview.

For more information about Windows Media 9 Series, see the Windows Media 9 Series page at the Microsoft Web site.

Related topics

  • Getting started


Understanding terminology

When reviewing this documentation and using the administrative interfaces, it is helpful to have an understanding of some specialized terms and concepts that are used when working in a streaming media environment. The following reference list is meant to give you a quick overview of these concepts. More detailed information can be found in the Concepts section of this documentation.

This section contains the following topics:

  • Announcement file
  • Bandwidth
  • Broadcast
  • Content
  • Cue
  • Distribution
  • Element
  • Encoder
  • File location
  • Interstitial advertisements
  • Logging
  • Loop
  • Multicast
  • On-demand
  • Playlist file
  • Plug-in
  • Port
  • Publishing point
  • Pull
  • Push
  • Shuffle
  • Streaming
  • Unicast
  • Windows Media file
  • WMRoot
  • Wrapper playlists

Related topics

  • Getting started


Announcement file

An announcement file is a Windows Media metafile with an .asx file name extension that is used to redirect clients to content on your Windows Media server. Announcement files can be distributed to clients from a Web site, sent as an e-mail attachment, or shared on network drive. By default, the announcement file is associated with Windows Media Player. The announcement file uses Extensible Markup Language (XML) syntax and can contain additional information to be displayed in the Player, such as file properties and captioning information. The announcement file can also contain additional instructions for the Player, such as instructions to open a Web page or to send logging data to a server.

In the Windows Media Services snap-in, you can create announcement files by using the Unicast Announcement Wizard. If you are using multicast transmission, you can create an announcement file when you create a multicast information file by using the Multicast Announcement Wizard.

Related Topics

  • About announcements
  • Delivering content as a multicast stream
  • Delivering content as a unicast stream
  • Understanding terminology


Bandwidth

Bandwidth is a measurement that reflects the data transfer capacity of a network. Bandwidth is usually expressed in the number of bits that a system is capable of transferring in a second: bits per second (bps) or kilobits per second (Kbps). Windows Media Services utilizes the available network bandwidth when streaming content to clients. Each stream from your server has a bandwidth requirement. Clients that are connecting to your server have defined available bandwidth, based on their network connection method. Therefore, when planning your streaming media system, you must include support for different bandwidths. Multicasting streaming is one method that is commonly used to conserve bandwidth on intranets because it only sends a single stream across the network.

Related topics

  • Delivering content as a multicast stream
  • Delivering content as a unicast stream
  • Streaming vs. downloading content
  • Understanding terminology


Broadcast

Broadcast is a means of transmitting data to a large audience simultaneously. In Windows Media Services, broadcasts are accomplished through the use of broadcast publishing points. Clients that receive a broadcast cannot control the start of the content or the rate of playback, and they cannot fast-forward or rewind the stream. The server is in control of the stream. Before clients can receive content from a broadcast publishing point, the publishing point must be started.

Related topics

  • About on-demand and broadcast playlists
  • About publishing point types
  • Broadcasting programmed content
  • Providing live broadcasts
  • Understanding terminology


Content

Content is a generic term that refers to any audio, video, images, text, or other information that is contained in a digital media file or stream. You can then use the content as a source for your publishing point and stream the content across a network using Windows Media Services.

Related topics

  • Obtaining content
  • Sourcing from playlists, files, and encoders
  • Understanding terminology


Cue

Cueing is a means of preloading content from a broadcast playlist into the memory of the server so that it can be transmitted to clients with less delay. By default, the next item in a playlist sequence is cued when the previous content is 90 percent complete. If you are going to skip a playlist entry during a broadcast, cueing the entry first provides a better playback experience. Cueing an element in a playlist can be done from the Source tab of the publishing point that is broadcasting the content.

Related topics

  • Sourcing from playlists, files, and encoders
  • To edit an online broadcast playlist
  • Understanding terminology


Distribution

Distribution describes the process by which content is transmitted from one computer to another. You can use the following types of distribution with Windows Media Services:

  • Server-to-server distribution. This occurs when a publishing point on your server acts as the content source for a publishing point on another Windows Media server, which then transmits the content to players that request it.
  • Push distribution. This occurs when an encoder initiates a broadcast and then uses a publishing point on a Windows Media server to transmit the content to the players that request it.
  • Pull distribution. This occurs when a server initiates a connection to an encoder to receive a content stream and then transmits the content to the players that request it.

Related topics

  • Ensuring the stability of your streaming media system
  • Understanding content delivery
  • Understanding terminology
  • Using distribution servers


Element

Element is an Extensible Markup Language (XML) term that refers to the "building blocks" of a playlist. When used in a playlist file, elements can define timelines, create groups of content, and define how the different pieces of the playlist interact with each other.

Related topics

  • Playlist reference
  • Understanding playlists
  • Understanding terminology


Encoder

An encoder is a computer which uses software, such as Windows Media Encoder, to apply a compression/decompression (codec) algorithm and stream format to content that is in either analog or digital audio and video format and then reproduces the content as a digital file or stream. This process is referred to as encoding. Once the content has been encoded, it can be distributed by Windows Media Services. In most cases, the software used to encode the content is installed on a separate computer from Windows Media Services.

Related topics

  • Sourcing from an encoder
  • Understanding terminology
  • Working with data sources


File location

The file location explains how and where Windows Media Services can locate the file you specify. The location can be specified as either an explicit path, such as C:\WMPub\WMRoot\Filename.wma, a URL address, such as http://servername/filename.wma, or a network resource path, such as \\Servername\Foldername\Filename.wma.

Related topics

  • Reference for content sources
  • Understanding terminology


Interstitial advertisements

Interstitial advertisements are advertisements that occur in the middle of the content that the user is receiving.

Related topics

  • Understanding advertising
  • Understanding terminology


Logging

Logging is the process of writing data about the activity of your server and its clients to a file.

Related topics

  • Log file reference information
  • Logging data and events
  • Understanding terminology


Loop

A loop is the continuous repetition of content streaming from a publishing point on your server. When content is looped, it plays from beginning to end and then starts over at the beginning without any perceptible wait time. The WMS Playlist Transform Plug-in must be enabled for the server to loop the content in your playlist or directory. Looping can be turned off and on through the properties sheet of the WMS Playlist Transform plug-in.

Related topics

  • Playlist transform category
  • Understanding terminology


Multicast

Multicast is a method of transmitting data across a network that allows many clients to receive the same data stream. This minimizes the amount of bandwidth required to transmit the data to a group of network clients. Multicast transmission requires that the routers and switches on the network be multicast-enabled, which means that they can transmit class D Internet Protocol (IP) addresses and interpret multicast information packets.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Delivering content as a multicast stream
  • Understanding terminology
  • Using broadcast publishing points


On-demand

On-demand describes a method of delivering content that uses unicast transmission to stream the content only when the client requests it from the server. Each client that requests a stream usually has full control of the stream and can fast-forward, rewind, pause, and restart the content. This is because on-demand publishing points provide a unique data path for every client that requests content.

Related topics

  • Delivering content as a unicast stream
  • Understanding terminology
  • Using on-demand publishing points


Playlist file

A playlist file can be used by Windows Media Services to stream a sequence of content, such as digital media files, encoder URLs, and other content server locations, to users from a publishing point. Playlist files can be either server-side or client-side. Server-side playlist files allow you to manage the playlist on the server while clients are receiving the content. Client-side playlists are transferred to the player, which then manages all of the content items. In client-side playlists, content references cannot be modified by the server.

Related topics

  • About on-demand and broadcast playlists
  • Understanding playlists
  • Understanding terminology


Plug-in

Plug-ins are used by Windows Media Services to enable different features. Plug-ins are managed along with the other configurable properties of your server through the Properties tab in the administrative interfaces. You can use plug-ins purchased from other software vendors and custom plug-ins created by using the Windows Media Services Software Development Kit (SDK) to extend the functionality of Windows Media Services.

Note Image Notes

  • Custom or third-party plug-ins should be located in a protected directory to prevent tampering. The protected directory can be any directory that has been set to deny write permissions to unauthorized users. For more information about restricting directory access, see Windows Help and Support.
  • Installation of custom or third-party plug-ins is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Plug-in architecture
  • Understanding terminology


Port

A port identifies a unique process through which a server can provide a service or a client can access a service. Windows Media Services uses both Transmission Control Protocol (TCP) ports and User Datagram Protocol (UDP) ports to stream content.

Related topics

  • Understanding protocols
  • Understanding terminology


Publishing point

A publishing point is the means by which you distribute your content to users. Content can be published by creating an announcement file that redirects clients to your publishing point or by distributing the URL to your publishing point.

Related topics

  • Announcing content
  • Understanding terminology


Pull

Pulling is one of the methods by which content is transmitted from a stream source, such as Windows Media Encoder or another Windows Media server, to the Windows Media server that is requesting it. Pull is used to denote that the transmission of the stream is initiated and managed by the requesting server.

Related topics

  • Sourcing from an encoder
  • Understanding terminology
  • Working with data sources


Push

Pushing is one of the methods by which content is transmitted from Windows Media Encoder to a Windows Media server. Push is used to denote that the transmission is initiated and managed by the encoder.

Related topics

  • Sourcing from an encoder
  • Understanding terminology
  • Working with data sources


Shuffle

Shuffle is a method of randomizing the content referenced either by a directory or playlist file before streaming it from your publishing point. When content is shuffled, it plays each item in the playlist or directory once in a random order. Shuffle can be used with looping to provide continuous, random playback. The WMS Playlist Transform plug-in must be enabled for the server to shuffle the content in your playlist or directory. Shuffle can be turned off and on through the properties sheet of the WMS Playlist Transform plug-in.

Related topics

  • Playlist transform category
  • Understanding terminology


Streaming

Streaming is a means of transmitting digital media in packets that can be rendered as they are received, allowing for the playback of data in a continuous flow without the delay required to download an entire file.

Related topics

  • Understanding streaming media
  • Understanding terminology


Unicast

Unicast is a method of transmitting data packets on a network that requires point-to-point communication between the client and the services transmitting the data. Unicast is also known as directed traffic, because the data is directed to a specific client on the network.

Related topics

  • Delivering content as a unicast stream
  • Understanding terminology


Windows Media file

A Windows Media file is a file containing audio, video, or script data that is stored in Windows Media Format. Depending on their content and purpose, Windows Media files use a variety of file name extensions, such as: .wma, .wme, .wms, .wmv, .wmx, .wmz, or .wvx.

Related topics

  • Obtaining content
  • Sourcing from files
  • Understanding terminology


WMRoot

WMRoot is the Windows Media root directory. Windows Media Services creates this folder by default during setup. In it you will find sample content files, a sample playlist file, and a sample wrapper playlist that you can use to learn about Windows Media Services. The Default publishing point uses %systemdrive%\WMPub\WMRoot as its source. Once Windows Media Services is running on your server, you can use a player to connect and view the sample content by using the following URL: mms://server_name/content_clip1.wmv.

You can place any existing content you have into WMRoot and quickly start streaming content.

Related topics

  • About the Default publishing point
  • Understanding terminology


Wrapper playlists

Wrapper playlists are Windows Media metafiles that add additional content to the beginning or end of a stream. Examples of content include welcome or goodbye messages, advertisements, and station branding. In the Create Wrapper Wizard, the content of the publishing point is represented by %Content requested by client%. In the wrapper playlist file, the content of the publishing point is represented by %requestedURL%.

Related topics

  • About wrapper playlists
  • Understanding terminology


Changes to Windows Media Services

Windows Media Services was redesigned for this release, making the server more flexible, unifying the core components, and simplifying the administrative process. Following is a brief overview of changes in the current release:

  • Four services combined into one— the Windows Media Services service. The Windows Media Services service replaces the four separate services that comprised Windows Media Services versions 4.0 and 4.1: Windows Media Monitor Service, Windows Media Program Service, Windows Media Station Service, and Windows Media Unicast Service.
  • Expanded use of plug-ins. With Windows Media Services version 4.x, you could expand the server through the use of custom authentication, authorization, or event notification plug-ins; other plug-in types were not supported. This version considerably increases the number of ways that you can customize and configure the server through an expanded plug-in architecture. Interfaces are provided for most of the plug-ins so you can build custom plug-ins that enhance the server's capabilities. You can use plug-ins to control the following behaviors:
    • How the server reads from devices. Use data source plug-ins to enable the server to read from databases, device drivers, and different network locations.
    • How data is sent over the network. Use data writer plug-ins with control protocol plug-ins to support a variety of network protocols.
    • How server-side playlists are translated. Use playlist parser plug-ins to enable the server to support different metafile formats.
  • Expanded use of publishing points. Publishing points handle the association of content to streams. Publishing points expand the basic functionality provided in previous versions of Windows Media Services and greatly simplify the functionality that was formerly provided by using a combination of programs, streams, and stations. You can now create both broadcast and on-demand publishing points, and you can customize these publishing points through property pages that control different server functions.
  • Flexible server-side playlists. Every publishing point (including on-demand publishing points) can stream content from a playlist. Each item in the playlist has a set of independent attributes such as repeat, duration, genre, and so on. You can specify these attributes to meet your particular needs. Playlists can even be modified during a broadcast, allowing you to respond to situations without having to interrupt your stream.
  • Flexible event architecture. In previous versions of Windows Media Services, external events were available only through station and unicast Microsoft ActiveX® objects. In this version, events are available internally through server interfaces, as well as externally through both Windows Management Instrumentation (WMI) and Simple Network Management Protocol (SNMP) events.
  • Fast Streaming. In previous versions of Windows Media Services, content was streamed at a constant bit rate to the clients. Fast Streaming allows for a combination of streaming, downloading, and caching in order to provide the best user experience. The following features provide Windows Media Services Fast Streaming capabilities:
    • Fast Start. Enables the beginning portion of the content to be quickly downloaded to Windows Media Player at the maximum available bandwidth, reducing the amount of time required to fill the buffer requirement of the Player and reducing the amount of time a user has to wait to begin receiving the stream.
    • Fast Cache. Enables Windows Media Services to make use of any additional bandwidth to send out additional data to the buffer of the Player, allowing the Player to better withstand network bandwidth fluctuations.
    • Fast Recovery. Enables the server to provide an uninterrupted viewing experience to users receiving content over high latency network connections, such as wireless and satellite networks, by using forward error correction to greatly reduce packet corruption and interruption.
    • Fast Reconnect. Enables the server to automatically restore client connections, including encoders, distribution servers, and players, that are lost during a broadcast due to network conditions.
  • Improved packet resend logic. In previous versions of Windows Media Services, packet resend requests from clients could only be fulfilled for the last two seconds of content. In this version, 10 seconds of data is stored in the server buffer, allowing for better error correction and stream quality.
  • Server-based content repacketization. In previous versions of Windows Media Services, the server could only stream data packets as defined by the stream format. In this version, the server administrators can set the optimum packet size for streaming in their environment, and the server can reallocate data to stream packets based on that property setting. This optimization is only applicable when streaming content using User Datagram Protocol (UDP) packets and the Real Time Streaming Protocol (RTSP).
  • IPv6 support. This version Windows Media Services has support for Internet Protocol Version 6 (IPv6) addressing.
  • IGMPv3 support. Internet Group Management Protocol (IGMP) version 3 provides Windows Media Services the ability to help prevent problems with multiple broadcast servers that use the same multicast IP address. This feature requires that the clients connecting to the multicast are using Windows Media Player 9 Series.

The following table cross-references Windows Media Services version 4.x terms and features to current Windows Media Services terms and features.

Previous term | New term
Advanced Systems Format (.asf) files | The .wma or .wmv file name extensions enable the client to tell whether a file includes video or is audio only and are often used instead of .asf. The file format is the same, and .asf files can be renamed with .wma or .wmv file name extensions (and vice versa) without difficulty.
ASFRoot | WMRoot
Broadcast unicast publishing points | Broadcast publishing points that use the unicast data writer.
Distribution stations | Broadcast publishing points that use the unicast data writer.
MSBD protocol | This protocol is no longer supported. Either the RTSP or HTTP protocols can be used instead for server-to-server data transfer. The HTTP protocol is used exclusively for encoder-to-server data transfer.
Multicast stations | Broadcast publishing points that use the multicast data writer
Programs | Playlists
Unicast publishing points | On-demand publishing points
Windows Media Station Service Windows Media Unicast Service Windows Media Program Service Windows Media Monitor Service | Windows Media Services service combines the functionality of these four services.

Note text Note

  • The features in Windows Media Services features differ depending on which version of Windows Server 2003 you are running. For a complete list of the features available in each version of Windows Media Services, see Comparing versions of Windows Media Services.

Related topics

  • Advertising support
  • Deploying Windows Media Services
  • Getting started
  • Managing your Windows Media server
  • Platform components
  • Plug-in architecture
  • Server-side playlists
  • Understanding playlists
  • Understanding publishing points
  • Upgrading Windows Media Services
  • Wireless delivery
  • Working with the administrative interfaces


Upgrading Windows Media Services

Windows Media Services 9 Series is available with Microsoft Windows Server 2003, Standard Edition, Windows Server 2003, Enterprise Edition, or Windows Server 2003, Datacenter Edition. You can upgrade your operating system from either Microsoft Windows NT® Server 4.0 or Windows 2000 Server. If you are running Windows Media Services version 4.1, it is upgraded to the latest version automatically when you upgrade the operating system.

If you installed Windows Media Services for the first time, the server is set up with a base configuration, which includes a default on-demand publishing point and a sample broadcast publishing point.

If you are upgrading from Windows Media Services 4.1, your previous configuration is moved over to the new version of Windows Media Services through a process called migration. Much of the previous configuration is migrated over to this version, such as on-demand publishing points. However, this version contains design improvements and features that were not available in version 4.1, and several elements of the previous configuration must be modified to work in the new environment. For example, broadcast stations and programs from Windows Media Services 4.1 are reconfigured as broadcast publishing points and playlists in this version. There might also be elements of your existing configuration that you need to change manually. For example, Windows Media Services no longer supports distribution using the Media Stream Broadcast Distribution (MSBD) protocol, so you must manually change any Windows Media metafiles or Windows Media Encoder configurations that use this protocol to the HTTP protocol.

The topics in this section describe the migration process. This process is mostly automatic; however, understanding how migration works can help you quickly get started using this version of Windows Media Services. When the upgrade process finishes, an upgrade log file is created that provides details of the migration.

This section includes the following topics:

  • Migration overview
  • How migration works
  • Configuration elements that are not migrated
  • Using the upgrade log

Related topics

  • Changes to Windows Media Services
  • Getting started


Migration overview

The upgrade process migrates as much as possible of the existing Windows Media Services 4.1 configuration with few or no changes. In cases where conversions are necessary, the upgrade process changes only what is necessary and migrates as much of the existing content and configuration as possible.

The following table provides a general overview of how the migration process affects version 4.1 elements.

This version 4.1 element | Migrates to
Publishing points | Publishing points
Stations | Broadcast publishing points
Programs | Playlists
Streams | media elements in playlists

The use of publishing points has not changed from version 4.1 to this version of Windows Media Services. A version 4.1 on-demand publishing point is still an on-demand publishing point in this version. However, the use of stations, programs, and streams for broadcasting has changed substantially from the previous version of Windows Media Services. In this version, all broadcasting is handled by using broadcast publishing points and playlists. If you want to broadcast by using multicast delivery, you enable a multicast data writer plug-in on a broadcast publishing point. During the upgrade process, stations are migrated to broadcast publishing points, and the programs and streams that provide the source content for the stations are migrated to server-side playlists that act as the sources of the broadcast publishing points. For example, if a publishing point in version 4.1 points to a station, two broadcast publishing points are created during the upgrade process: one that contains the station information and sources from a playlist, and a second one that sources from the first publishing point.

You may not need to know any more than these basic principles to update Windows Media Services. However, if your existing configuration is extensive, you should review this section, so you know the specifics of the migration process. The following list summarizes the primary principles of migrating from Windows Media Services version 4.1 to this version:

  • Unicast publishing points in Windows Media Services version 4.1 become on-demand publishing points in this version.
  • Stations in version 4.1 become broadcast publishing points.
  • Programs in version 4.1 become playlists and are copied to a new folder, %systemdrive%\WMPlaylists.
  • Streams in version 4.1 become playlist elements.
  • MSBD-based URLs in version 4.1 become HTTP-based URLs.
  • Multicast file transfers are no longer supported, so they are not migrated to this version of Windows Media Services.
  • The On-Line Presentation Broadcast service that provides integration with Microsoft PowerPoint® is no longer supported, so it is not migrated.
  • Distribution authentication user IDs and passwords are not migrated.
  • Any security settings that have been configured on the source directories of the version 4.1 publishing points are migrated. The migrated security settings are modified to allow the NETWORK SERVICE account to have read permissions for the source directories of the migrated publishing points. For more information about rights used by Windows Media Services, see Understanding rights.

Windows Media Services creates a log that indicates how the version 4.1 configuration was migrated to the latest version. Wmsupgrade.log is located in %systemroot%\System32\Windows Media\Server. To view the log file, open the file in a basic text editor, such as Notepad.

Related topics

  • How migration works
  • Upgrading Windows Media Services


How migration works

The migration process handles the conversion of version 4.1 configurations, such as publishing points and stations. The following topics describe the specific version 4.1 configurations that are converted during the upgrade process and how the conversions are handled:

  • Publishing points that point to directories
  • Publishing points that point to publishing points
  • Publishing points that point to local stations
  • Publishing points that point to remote sources
  • Stations with no publishing points
  • Stations and programs not associated
  • Publishing points and stations with the same name
  • Publishing point security

Related topics

  • Migration overview
  • Upgrading Windows Media Services


Publishing points that point to directories

In version 4.1, if the publishing point path points to a directory that contains Windows Media files, an on-demand publishing point is created in this version. The publishing point name is migrated, and the path is not changed, as described in the following table.

This version 4.1 configuration | Migrates to
Unicast publishing point pointing to a directory Example: Publishing point name: PubPoint Path: %systemroot%\WindowsMediaFiles | Publishing point Example: Publishing point name: PubPoint Path: %systemroot%\WindowsMediaFiles

Related topics

  • How migration works
  • Understanding publishing points


Publishing points that point to publishing points

In version 4.1, if a publishing point uses another publishing point as its source, a broadcast publishing point is created during the migration process. If the publishing point uses an MMS URL as its source, this is changed to HTTP during the migration process. The publishing point name is migrated but the publishing point path is changed to use the HTTP protocol in the URL as described in the following table.

This version 4.1 configuration | Migrates to
Unicast publishing point pointing to a remote publishing point Example: Publishing point name: PubPoint Path: mms://remote_server/remote_pp | Broadcast publishing point Example: Publishing point name: PubPoint Path: http://remote_server/remote_pp

Related topics

  • How migration works
  • Understanding publishing points


Publishing points and stations with the same name

In version 4.1, if a station and publishing point have the same name, then two broadcast publishing points are created during the migration process. The first publishing point acquires the station's properties and the original name followed by an incremented value, and the second publishing point points to the first publishing point and acquires the original name, as described in the following table.

This version 4.1 configuration | Migrates to
Unicast publishing point pointing to a station with the same name Example: Station name: MyStation Publishing point name: MyStation | Broadcast publishing point Example: Publishing point name 1: MyStation-1 Publishing point name 2: MyStation

This migration procedure is followed regardless of whether the publishing point is actually associated with the station or not.

Related topics

  • How migration works
  • Understanding publishing points


Stations and programs not associated

If a version 4.1 station exists but no program points to it, the station is migrated to this version. If a version 4.1 program points to a nonexistent station, a new playlist file is created, using the name of the program, and the playlist file is saved to a new directory (%systemroot%\WMPlaylists\Program_Name.wsx). A publishing point is not created.

The following table describes the migration of stations that are not associated with programs and programs that are not associated with stations.

These version 4.1 configurations | Migrate to
Station that is not associated with any programs | Broadcast publishing point
Program that is not associated with any station Example: Program name: MyProg | Playlist Example: Playlist: MyProg.wsx

Note Image Note

  • A program will lose its association with a station only if the station is deleted after the program is created.

Related topics

  • How migration works
  • Understanding publishing points


Publishing points that point to local stations

The following table describes what happens when publishing points and their associated local stations are migrated to this version of Windows Media Services from version 4.1.

This version 4.1 configuration | Migrates to
Unicast publishing point pointing to a local station associated with programs and streams using MSBD or HTTP Example: Station name: MyStation Program names: MyProg1, MyProg2 MyProg1 streams: Str11, Str12 MyProg2 streams: Str21, Str22 Str11 source: msbd://encoder:1000 Str21 source: http://server/stationx Publishing point name: PubPoint Path: msbd://localhost/mystation | Broadcast publishing point Example: Publishing point name: MyStation Path: \WMPlaylists\MyProg1.wsx Playlists: MyProg1.wsx, MyProg2.wsx MyProg1.wsx media: Str11, Str12 MyProg2.wsx media: Str21, Str22 Str11 src: http://encoder:1000 Str21 src: http://server/stationx Publishing point name: PubPoint Path: http://localhost/mystation

If the publishing point path uses the HTTP or MSBD protocol to point to an existing local station service and programs, the upgrade process results in the following:

  • A new playlist file is created, using the name of the program, and the playlist file is saved to a new directory (%systemroot%\WMPlaylists\Program_Name.wsx).
  • Each stream within the program becomes a media element within the playlist, and all properties associated with the stream become attributes of the media element.
  • References to MSBD in the source URL are replaced by HTTP.
  • If two programs exist for a single station:
    • A new playlist file is created for each program, using the name of the program, and the playlist file is saved to a new directory (%systemroot%\WMPlaylists\Program_Name.wsx).
    • A broadcast publishing point is created for the station and the path points to the playlist file that was created for the first program.
  • Two broadcast publishing points are created:
    • The version 4.1 station name becomes the name of the first broadcast publishing point, which points to the playlist path. The station properties are migrated to the publishing point.
    • The version 4.1 publishing point name becomes the name of the second broadcast publishing point, which points to the first publishing point.

Note Image Note

  • The upgrade process only covers the migration of Windows Media Services. Any remote servers and encoders must be reconfigured manually to use the HTTP protocol.
  • If you were using a port other than 80 to stream content from another server or an encoder, you will need to update the URLs in the playlist to reference the appropriate port number. For example if you streamed welcome.asf over port 8008 on your 4.1 server and your original URL was msbd://server1/welcome.asf the upgrade process will result in the URL http://server1/welcome.asf. However, that will not work if the content is not available on the default HTTP port, so you must modify the reference to http://server1:8008/welcome.asf.

Related topics

  • How migration works
  • Understanding publishing points


Publishing points that point to remote sources

The following table describes the migration of a publishing point that points to a remote server station in version 4.1 to this version.

This version 4.1 configuration | Migrates to
Unicast publishing point pointing to a remote server station Example: Publishing point name: PubPoint Path: msbd://remote_server/station | Broadcast publishing point Example: Publishing point name: PubPoint Path: http://remote_server/station

If the publishing point path in version 4.1 uses the HTTP or MSBD protocol to point to an encoder or station service on a remote server, a broadcast publishing point is created using the existing name. If the MSBD protocol is used, it is changed to HTTP during the migration.

The following table describes the migration of a publishing point that points to a remote encoder.

This version 4.1 configuration | Migrates to
Unicast publishing point pointing to a remote encoder Example: Publishing point name: PubPoint Path: msbd://remote_encoder:1000 | Broadcast publishing point Example: Publishing point name: PubPoint Path: http://remote_encoder:1000

Note that the MSBD protocol is changed to HTTP as in the previous table.

Note Image Note

  • The upgrade process includes only the migration of Windows Media Services. Any remote servers and encoders must be reconfigured manually to use the HTTP protocol.

Related topics

  • How migration works
  • Understanding publishing points


Stations with no publishing points

The following table describes the migration of stations in version 4.1 that are not associated with publishing points.

This version 4.1 configuration | Migrates to
Station with one or more existing programs Example: Station name: MyStation Program names: MyProg1, MyProg2 MyProg1 streams: Str11, Str12 MyProg2 streams: Str21, Str22 Str11 source: msbd://encoder1:1000 Str21 source: http://encoder2:2000 | Broadcast publishing point Example: Publishing point name: MyStation Path: \WMPlaylists\Prog1.wsx Playlists: Prog1.wsx, Prog2.wsx MyProg1.wsx media: Str11, Str12 MyProg2.wsx media: Str21, Str22 Str11 src: http://encoder1:1000 Str21 src: http://encoder2:2000

If a version 4.1 station exists and there is a program that points to that station, the following happens during the migration:

  • A new playlist file is created using the name of the program, and the playlist file is saved to a new directory (%systemroot%\WMPlaylists\Program_Name.wsx).
  • Each stream within the program becomes a media element within the playlist, and all associated stream properties become attributes of the media element
  • References to MSBD in the source URL are replaced by HTTP.
  • If two programs exist for a single station:
    • A new playlist file is created for each program using the name of the program, and the playlist file is saved to a new directory (%systemroot%\WMPlaylists\Program_Name.wsx).
    • A broadcast publishing point is created for the station, and the path is set to point to the playlist file that was created for the first program.
  • A broadcast publishing point is created. The existing station name becomes the name of the broadcast publishing point, which points to the playlist path.

Related topics

  • How migration works
  • Understanding publishing points


Publishing point security

Security on all publishing point source directories are migrated during the upgrade. The only access control list (ACL) security change made during migration is to add read access to the NETWORK SERVICE account. The following table provides an overview of how the settings are migrated.

Windows Media Services version 4.1 | Windows Media Services 9 Series
No authentication or authorization enabled (default server configuration). | The WMS Publishing Points ACL Authorization plug-in WMS Anonymous User Authentication plug-in and the WMS Negotiate Authentication plug-in are enabled.
The HTTP-BASIC and Membership Service Account Database authorization package is enabled. | The WMS Publishing Points ACL Authorization plug-in and and the WMS Negotiate Authentication plug-in are enabled. The WMS Anonymous User Authentication plug-in is disabled.
The HTTP-BASIC Authentication and NTLM Account Database authorization package is enabled. | The WMS Publishing Points ACL Authorization plug-in and the WMS Digest Authentication plug-in are enabled. The WMS Anonymous User Authentication plug-in is disabled.
The Windows NTLM Authentication and Account Database authorization package is enabled. | The WMS Publishing Points ACL Authorization plug-in and the WMS Negotiate Authentication plug-in are enabled. The WMS Anonymous User Authentication plug-in is disabled.

Note Image Note

  • In the Windows Media Services version 4.1 access control list (ACL), checking could be either enabled or disabled. The default installation of Windows Media Services enables the WMS Publishing Points ACL plug-in without regard to the ACL setting used with the previous version as a means of keeping your server secure until you have configured it.

Related topics

  • Configuring security options
  • How migration works
  • Understanding publishing points


Configuration elements that are not migrated

Certain elements of a version 4.1 configuration are not automatically migrated during an upgrade. The previous sections mentioned features, such as multicast file transfer, that are not migrated. In addition, migration does not remove content, such as files, folders, and certain registry settings, even though the content may be obsolete.

The following list describes elements that are not migrated and the manual configuration that might be necessary:

  • Security accounts and groups. The NetShow® Administrators or Windows Media Administrators local groups and the NetShowServices local user accounts are not removed during the upgrade process. To ensure maximum security, decide whether the accounts are still applicable, and then make them unavailable or remove them if they are no longer in use.
  • Access control lists (ACLs). ACLs that are associated with publishing points are not migrated. However the information is not removed from the system registry. If you want, you can remove the ACL information manually from the registry, by removing the following registry subkeys:

    \HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists

    \HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists\AllowDistribution

    \HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists\AllowUnicastClients

    \HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists\DisallowDistribution

    \HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\NetShow\AccessLists\DisallowUnicastClients

    If you want to reassign ACLs, you must enable the WMS Publishing Points ACL Authorization plug-in.

  • Authorization and authentication plug-ins. These plug-ins are not removed during migration. You can manually remove them after the upgrade is finished.
  • IP access lists. The list of IP addresses that you have configured to grant or deny access to your server are not migrated. You can recreate these lists by using the WMS IP Address Authorization plug-in properties dialog box.
  • Programs. All programs are migrated to playlists regardless of whether they contained streams, with the exception of programs containing multicast file transfer streams. You can remove the empty playlists if you choose.
  • Configuration folders. The following folders and any files contained in them are not removed:
    • %systemroot%\System32\Windows Media\Server\ASDB
    • %systemroot%\System32\Windows Media\Server\ASDB\NSP
    • %systemroot%\System32\Windows Media\Server\Station Data

    You can manually remove the folders if you choose.

  • Distribution Authentication. If you enabled server authentication proxy settings in Windows Media Services version 4.1, the name of the proxy server used to validate authentication credentials will be migrated during the upgrade. However, you must manually enter the user name and password used with the proxy server in the property sheet of the WMS Network Data Source plug-in. You must specify the user name and password for each protocol that uses the proxy server to connect to a network data source. For more information, see To configure the WMS Network Data Source plug-in.
  • On-Line Broadcast. This service, which provides integration with Microsoft PowerPoint, is not migrated. If you are running programs that require this service, you must continue to use Windows Media Services version 4.1 on a compatible operating system, such as Windows 2000 Server.
  • Windows Media File Transfer Services. This service is not migrated. If you are running programs that require this service, you must continue to use Windows Media Services version 4.1 on a compatible operating system, such as Windows 2000 Server.
  • Third party plug-ins. Third-party plug-ins used with Windows Media Services version 4.1 cannot be used with the new version of Windows Media Services. Several software developers have created new plug-ins for this version. Check with the plug-in developers to find out whether new plug-ins are available.
  • Incompatible publishing points. If a publishing point or station on your Windows Media Services version 4.1 server has a name that exceeds 260 characters it will not be migrated.

Note Image Note

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on the computer.

Related topics

  • How migration works
  • Upgrading Windows Media Services
  • Using the WMS Publishing Points ACL Authorization plug-in
  • Using the upgrade log


Using the upgrade log

Upon completion of an upgrade, Windows Media Services creates a log file, Wmsupgrade.log. You can use the log file to understand how your configuration was migrated during the upgrade process. The log describes in detail how every part of the previous configuration was migrated, including any errors that may have occurred.

Wmsupgrade.log is located in %systemroot%\System32\Windows Media\Server. To view the log file, you can open the file in a basic text editor, such as Notepad.

Related topics

  • How migration works
  • Upgrading Windows Media Services


New features in Windows Media Services

Windows Media Services has been completely redesigned for this release. If you are familiar with earlier versions of the product, you will notice new administrative interfaces, new terminology, and many new features. Review the topics in this section for more details about the features included in this release.

This section covers the following topics:

  • Platform components
  • Plug-in architecture
  • Advertising support
  • Server-side playlists
  • Wrapper playlists
  • Wireless delivery

Related topics

  • Getting started


Platform components

Windows Media Services is now a single service that runs on Windows Server 2003, Standard Edition, Windows Server 2003, Enterprise Edition, and Windows Server 2003, Datacenter Edition. Its core components were developed using the Component Object Model (COM), creating a flexible architecture that is easily customized for specific applications. It supports a greater variety of control protocols, including Real Time Streaming Protocol (RTSP), Microsoft Media Server (MMS) protocol, and Hypertext Transfer Protocol (HTTP).

The platform is compliant with the following industry standards:

  • Windows Management Instrumentation (WMI) for server event notification and messaging.
  • Simple Network Management Protocol (SNMP) for networking components.
  • Extensible Markup Language (XML), the Document Object Model (DOM), and the Synchronized Multimedia Integration Language (SMIL) 2.0 for playlist implementation.
  • Moving Picture Experts Group (MPEG) 1 and 2 for audio and video formats.

Most streaming scenarios can be accomplished using the core components installed with Windows Media Services. However, more advanced scenarios may require that you incorporate some custom programming and integration work. For developers and systems integrators, the Windows Media Services Software Development Kit (SDK) provides access to all elements of the server through a combination of plug-ins, a fully documented object model, and a rich set of external event notifications, all designed to be easily customizable.

As you explore the Windows Media Services snap-in and Windows Media Services Administrator for the Web, you will find a variety of plug-ins that accomplish different tasks. More than half of the server's features are implemented through the use of plug-ins. If necessary, custom plug-ins can be developed to integrate your Windows Media server with other systems. For example, if you have a large amount of high-bandwidth content stored in a proprietary database, a data source plug-in can be developed to retrieve the content from the database.

As you evaluate your Windows Media server implementation, you might decide that a custom approach works better. Any feature that you can configure in an administrative interface is exposed in the Windows Media server object model, which is documented in the Windows Media Services SDK. Using the object model, you can programmatically access every counter, interface, plug-in, publishing point, and playlist. In fact, the administrative interfaces were created by using this object model. For more information about creating a custom application, see the Windows Media Services SDK available on the Windows Media home page at the Microsoft Web site.

You might want to explore automating Windows Media Services. Windows Media Services provides events through both SNMP and WMI. It also supports command-line scripting. By combining scripting and events, you can automate many server management tasks.

Note Image Notes

  • For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • Custom or third-party plug-ins should be located in a protected directory to prevent tampering. The protected directory can be any directory that has been set to deny write permissions to unauthorized users. For more information about restricting directory access, see Windows Help and Support.

Related topics

  • New features in Windows Media Services
  • Obtaining content
  • Streaming media system overview
  • Understanding streaming media


Plug-in architecture

Windows Media Services supports customizable server configuration through the use of plug-ins. You can implement most of the features of Windows Media Services by enabling and configuring the plug-ins that you want to use. Certain system plug-ins provide core functionality and are enabled by default. You can use plug-ins to perform a wide range of tasks, including protocol handling, data parsing, authentication, authorization, and archiving. You can apply a plug-in to either an entire Windows Media server or to a specific publishing point on the server by enabling the plug-in at the appropriate level. You can modify the plug-in settings for each server or publishing point you are managing.

Windows Media Services plug-ins are divided into categories by function. Each category contains several types of plug-ins. The following table describes the plug-in categories.

Plug-in category | Description
Archiving | Used to archive content that is being streamed from a broadcast publishing point to a file.
Authentication | Used to validate client credentials before any additional data is sent to the client.
Authorization | Used to grant or deny client access to content.
Cache/Proxy Management | Used to control cache and proxy policies on your computer.
Control protocol | Used to control the data sent between clients and servers.
Data source | Used to receive data from an encoder, file system, or network source.
Event notification | Used to control and customize how the server responds to internal events.
Logging | Used to record server and client activity.
Media parser | Used to allow the server to translate different digital media file types or real-time streams.
Multicast streaming | Used to control the delivery of content through multicast transmission. This plug-in must be configured for each publishing point that is going to use multicast delivery.
Playlist parser | Used to allow the server to translate different playlist types.
Playlist transforms | Used to change the manner in which content is streamed from a playlist or directory.
Unicast streaming | Used to control the delivery of content through unicast transmission.

You can use third-party plug-ins or custom plug-ins with Windows Media Services in order to implement customized streaming solutions such as cache/proxy servers, multiple streaming formats, customized logging applications, and specialized data storage. A list of third-party plug-ins for Windows Media Services is available on the Windows Media Technologies Partner Center page at the Microsoft Web site. The Windows Media Services Software Development Kit (SDK) can be downloaded from the Windows Media Technologies Application Development page at the Microsoft Web site.

Note Image Note

  • Custom or third-party plug-ins should be located in a protected directory to prevent tampering. The protected directory can be any directory that has been set to deny write permissions to unauthorized users. For more information about restricting directory access, see Windows Help and Support.

Related topics

  • Manage servers
  • New features in Windows Media Services
  • Work with publishing points


Advertising support

Historically, the newspaper, radio, and television industries are able to realize revenue and offer information services to the public at a low cost because they are able to find sponsors who pay them to advertise products. The World Wide Web has embraced this business model; most Web sites include some form of advertising. Web sites that provide information services fund their operations through the sale of advertising, and companies and e-commerce sites can also market their own brands through strategic ad placement.

Windows Media Services provides support for advertising in a variety of ways:

  • Playlists. Playlists provide an easy way to provide interstitial advertisements during a broadcast. Dynamic playlists can respond to a client's user profile to target advertisements demographically.
  • Wrappers. Wrappers can be used to provide a set of advertisements at the beginning and end of the client's requested content. Wrappers are often used to implement bumper advertisements or lead-in/lead-out ads.
  • Reporting. Detailed log files and real-time performance counters provide a means of monitoring the activity of your Web site and evaluating your audience. Counters that reflect the number of clickthroughs, the number of plays, and the length of time the client viewed the advertisement are available for you to use in billing and reporting.

Related topics

  • Displaying banner ads
  • Displaying interstitial ads
  • New features in Windows Media Services
  • Supporting personalized on-demand content
  • Working with wrapper ads


Server-side playlists

Server-side playlists cover a wide range of scenarios: Internet radio and television stations, regional and custom advertising, fail-safe streaming, and content control. You can use server-side playlists to insert advertisements before, during, and after content, to switch seamlessly between alternating content and to provide a structure that defines how users receive multiple pieces of content. For example, you can use server-side playlists to create a user experience similar to that of a radio or TV station. Controlling your playlists with the Windows Media server enables you to make changes to a playlist during a broadcast.

Because playlists are a single file or directory, you can manage the resources on your server more easily. Playlist content can range from a list of Web pages to live encoder feeds to stored files.

Related topics

  • Creating and editing offline playlists
  • Editing online playlists
  • New features in Windows Media Services
  • Understanding playlists


Wrapper playlists

Windows Media Services supports wrappers, which are Windows Media metafiles that can be used to direct users to certain additional content before the requested content and then to an additional piece of content once the requested content ends. Wrappers are especially useful in the following situations:

  • Broadcast content. During a broadcast, users can connect at different times, making it difficult to ensure that a piece of content (such as an advertisement, station identification, or copyright notice) is received by every user. However, when a wrapper playlist is used in conjunction with the broadcast, the content in the first part of the wrapper is streamed to the user regardless of the point at which he or she connects to the broadcast. This makes it possible to ensure that a piece of content is received by every user who connects to your broadcast.
  • On-demand content. Wrappers are also an efficient way to play content, such as advertisements, to every user who connects to your server. Each publishing point on your server can use the same wrapper, so you only need to update one file when changes occur.

Related topics

  • About wrapper playlists
  • New features in Windows Media Services
  • To start the Create Wrapper Wizard
  • Working with wrapper ads


Wireless delivery

Windows Media Services enables you to create highly available and scalable systems. It helps ensure that your systems are always available and can support multiple processors and larger amounts of memory. Thus, it makes an excellent platform for large-scale streaming media delivery. One of the largest areas of potential growth for streaming media is the delivery of digital media content to wireless devices, such as cellular phones, handheld PCs, and laptop computers.

The Fast Recovery feature of Windows Media Services uses forward error correction to support streaming over wireless networks such as wireless local area networks (LANs), satellite connections, and mobile devices.

Note Image Note

  • Forward error correction is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • New features in Windows Media Services
  • Understanding Fast Recovery


System requirements

The default installation of Windows Media Services installs the following software on your server hard disk:

  • Windows Media Services service. This service allows you to stream digital media content to clients over an intranet or the Internet.
  • Windows Media Services snap-in. This snap-in enables you to manage and configure Windows Media Services using Microsoft Management Console (MMC).

You may choose to also install the following optional components on your server to provide support for additional features:

  • Windows Media Services Administrator for the Web. This component provides support for remote, browser-based administration of your Windows Media server. Selecting this component installs a set of Active Server Pages (ASP) for use with Internet Information Services (IIS). When installed, the Windows Media Services Administration site appears in the IIS Web sites folder. Windows Media Services Administrator for the Web may also be installed separately from the Windows Media Services service.
  • Multicast and advertisement logging agent. This component enables you to record statistics from players that connect to content through a Web server. Selecting this component installs an extension to the Internet Information Services Web server that collects the logging information and writes it to a log file in the location you specify.

Use the tables in the following topics to determine the minimum requirements for your system based on the components you choose to install:

  • Windows Media Services service and Windows Media Services snap-in
  • Windows Media Services Administrator for the Web
  • Multicast and advertisement logging agent

Related topics

  • Getting started


Windows Media Services service and Windows Media Services snap-in

The default Windows Media Services installation includes both the Windows Media Services service and the Windows Media Services snap-in. The Windows Media Services snap-in provides you with full control of the server and enables you to manage groups of Windows Media servers using Microsoft Management Console.

The following table shows the system requirements for the computer running the Windows Media Services service and the Windows Media Services snap-in:

Component | Requirement | Recommendation
Operating system | Windows Server 2003, Standard Edition | Windows Server 2003, Enterprise Edition or Windows Server 2003, Datacenter Edition
Processor | 233 megahertz (MHz) | 550 MHz or higher
Memory | 256 megabytes (MB) of RAM | 1 gigabyte (GB) of RAM or higher
Network interface card | Ethernet card and Transmission Control Protocol/Internet Protocol (TCP/IP) | Same
Free hard disk space | 21 MB (6 MB for system files and 15 MB for installation); adequate disk space for content storage | 21 MB (6 MB for system files and 15 MB for installation); 500 MB for content storage

The Windows Media Services snap-in can be added to clients that meet the following requirements and have the proper administrative rights.

Component | Requirement
Operating system | Windows Server 2003, Standard Edition, Windows Server 2003, Enterprise Edition, Windows Server 2003, Datacenter Edition
Software | Microsoft Management Console

Related topics

  • System requirements


Windows Media Services Administrator for the Web

To support administering Windows Media Services from remote computers, you have the option of installing Windows Media Services Administrator for the Web on a network server. The server may be a Windows Media server or any other computer running Windows Server 2003, Standard Edition, Windows Server 2003, Enterprise Edition, or Windows Server 2003, Datacenter Edition that has Internet Information Services (IIS) installed. Windows Media Services Administrator for the Web is a browser-based interface that uses Active Server Pages (ASP) hosted by IIS. This set of Active Server Pages is located under the Windows Media Administration site in IIS.

The following table shows the system requirements for the server hosting Windows Media Administrator for the Web:

Component | Requirement | Recommendation
Operating system | Windows Server 2003, Standard Edition | Windows Server 2003, Enterprise Edition or Windows Server 2003, Datacenter Edition
Processor | 233 megahertz (MHz) | 550 MHz or higher
Memory | 256 megabytes (MB) of RAM | 1 gigabyte (GB) of RAM or higher
Network interface card | Ethernet card and Transmission Control Protocol/Internet Protocol (TCP/IP) | Same
Free hard disk space | 3.4 MB | 3.4MB
Software | Microsoft Internet Information Services (IIS) to support the browser-based Windows Media Services Administrator for the Web | Same
File system | NTFS | Same

Once Windows Media Services Administrator for the Web is installed on your server, it can be accessed by clients that meet the following requirements and have the proper administrative rights.

Component | Requirement
Operating system | Windows 98, Windows Millennium Edition, Windows NT 4.0, Windows 2000, Windows XP, or Windows Server 2003
Software | Microsoft Internet Explorer 5.5 or later, or Netscape Communicator 6.0 or later

Note Image Notes

  • To function, the Windows Media Administration site must be able to install cookies on the remote client computer, so be sure that the client browser is using a security option that supports cookies.
  • Be sure to review the information in Securing the Windows Media Administration site to ensure that you provide security for this Web site.
  • ASP documents are not compatible with the file allocation table (FAT32) file structure. If you are having difficulty viewing Windows Media Services Administrator for the Web, ensure that your file system does not use the FAT32 architecture.

Related topics

  • System requirements


Multicast and advertisement logging agent

To log statistics from players that connect to a Web server to receive multicast broadcast or advertising content, you can install the multicast and advertisement logging agent on a network server. The server may be a Windows Media server or any other computer running Windows Server 2003, Standard Edition, Windows Server 2003, Enterprise Edition, or Windows Server 2003, Datacenter Edition that has Internet Information Services (IIS) installed. The multicast and advertisement logging agent is an IIS application extension that uses the Wmsiislog.dll to collect information from players. This Wmsiislog.dll is installed in the %systemdrive%\WMPub\Wmiislog folder.

The following table shows the system requirements for the computer hosting the multicast and advertisement logging agent:

Component | Requirement | Recommendation
Operating system | Windows Server 2003, Standard Edition | Windows Server 2003, Enterprise Edition or Windows Server 2003, Datacenter Edition
Processor | 233 megahertz (MHz) | 550 MHz or higher
Memory | 256 megabytes (MB) of RAM | 1 gigabyte (GB) of RAM or higher
Network interface card | Ethernet card and Transmission Control Protocol/Internet Protocol (TCP/IP) | Same
Software | Microsoft Internet Information Services (IIS) | Same

Related topics

  • System requirements


Deploying Windows Media Services

There are many scenarios in which you can deploy Windows Media Services. Some examples to consider are: live product demonstrations, interactive television shows and movies, real-time customer conferences, breaking news stories, broadband video stores, and interactive training presentations. Once a piece of content is available over the Internet, the number of clients who can discover the content and request it is tremendous. When planning your deployment, you need to be aware of how your server will react in situations in which it is being inundated with requests for content. Following are some requirements you should keep in mind when assessing your deployment:

Scalability

Windows Media Services is scalable by design to support a range of deployments, from small Internet radio stations that have hundreds of connection requests to large–scale streaming media Web sites that generate millions of requests. You can administer both groups of servers and publishing points and single servers and publishing points.

Security

You may want to secure certain content on your Windows Media server in order to allow only specific clients to connect. Windows Media Services supports several authentication and authorization methods that allow you to control access to your content.

Stream quality

As more clients connect to your server, its available bandwidth can decrease. Additionally, the load on your server can overwhelm the processor's ability to serve the content. If you are streaming video content, investigate encoding using multiple–bit–rate video so that the bandwidth can gracefully scale down and up as necessary.

Related topics

  • Deployment guide
  • Getting started
  • Scenarios


Administering Windows Media Services

You can administer Windows Media Services in a variety of ways depending on your needs and your environment. Windows Media Services can be administered by using the following interfaces:

  • Windows Media Services snap-in. This interface enables you to use Microsoft Management Console (MMC) to manage your Windows Media server. You can add the snap-in to Microsoft Management Console on any computer running Windows Server 2003, Standard Edition, Windows Server 2003, Enterprise Edition, or Windows Server 2003, Datacenter Edition, or you can access the snap-in by using a Remote Desktop connection.
  • Windows Media Services Administrator for the Web. This interface makes remote administration of your server easy through the use of a Web browser. Using a Web interface allows you to administer Windows Media Services over a firewall, on a low-bandwidth network connection, or in a non-Windows environment.
  • Command-line scripts. This interface enables you to manage your server quickly by using a Telnet connection or batch programs.

Once you have selected an administration method, you can manage the settings of your Windows Media server. These setting control the delivery of content to your client and may apply to properties, plug-ins, publishing points, and server-side playlists.

  • Properties are used to set rules that apply to the core behavior of Windows Media Services. You can apply properties to either the entire server or to specific publishing points. Plug-ins are used to supply additional features, such as logging, authentication, data sources, and control protocols. You can apply plug-ins to an entire Windows Media server or to specific publishing points. To learn more about properties and plug-ins, see About properties and plug-ins.
  • Publishing points are used to manage and distribute your content. There are two types of publishing points: on-demand publishing points or broadcast publishing points. To learn more about administering publishing points, see Understanding publishing points.
  • Server-side playlists are collections of content that the server streams to clients. Users perceive playlists as a single streaming experience. To learn more about playlists, see Understanding playlists.

If you use a network management console, such as Hewlett Packard HP OpenView, Compaq Insight Manager XE, and Dell OpenManage, you can receive events through Simple Network Management Protocol (SNMP) and Windows Management Instrumentation (WMI). With these events, you can keep apprised of server activity and react quickly to situations as they arise. To learn more about options for monitoring events, see Monitoring performance.

Note Image Note

  • Regardless of the interface you use to access your server, you must have administrative rights and privileges for the server to manage it or change its settings. For more information about administrative rights and privileges, see Limiting user rights.

Related topics

  • Getting started
  • Managing your Windows Media server
  • Working with the administrative interfaces


Scenarios

This section provides common scenarios for streaming audio and video content from a server running Windows Media Services. Each scenario contains an overview and links to key concepts and procedures within Help to get you started quickly. This section contains the following topics:

  • Distributing corporate communications. Learn how you can use Windows Media Services to communicate more effectively in a corporate environment.
  • Streaming entertainment programming and advertising. Learn how you can use Windows Media Services to create a broadcast presence on the Web.
  • Streaming programming to subscribers. Learn about how Windows Media Services can support a streaming subscription service.

Related topics

  • Implement streaming scenarios
  • Windows Media Services


Streaming entertainment programming and advertising

One of the most common uses for streaming media is to create a user experience that is similar to traditional broadcast media, such as radio and television programs, by using the World Wide Web. With Windows Media Services, you can stream Windows Media-based content over a network in a variety of ways to create a Web-based radio or television station. This section provides common scenarios for creating a radio or television presence on the Web. This section contains the following topics:

  • Broadcasting programmed content
  • Supporting personalized on-demand content
  • Providing live broadcasts
  • Displaying banner ads
  • Displaying interstitial ads
  • Working with wrapper ads
  • Replacing ads

Related topics

  • Scenarios


Broadcasting programmed content

Using Windows Media Services, you can rebroadcast existing content, such as radio or television programs, or you can create original programs for the Web that provide a similar user experience. You can add advertisements to the playlist the same way you add digital media files. Loop and shuffle features randomize play so that your broadcast behaves like a real radio or TV station.

Windows Media Services can generate content-specific logs which you can then forward to advertisers to help evaluate advertising performance. Logs can also help you track the content played in order to determine licensing fees.

When implementing this scenario, consider the following:

  • Wrappers are useful for station identification, bumpers, or short advertisements. You can use wrappers to stream content to users when a connection is requested, when a stream ends, or both.
  • You need to determine the content for your broadcast, such as music, a live talk, video, or advertisements, and organize it into a playlist.
  • You need to specify the order in which you want your playlist to play. By default, your playlist will play the sequence of content that you specify; however, you can include the following elements to modify the playlist order:
    • excl element. Use this element to set a rule that only one media element can play at a given time. For example, if you are broadcasting a live stream and want to switch to advertisements at certain times in the broadcast, you can place the live stream and the ads inside an excl element in your playlist. The ads can then be triggered by events generated by the encoder.
    • priorityClass element. Use this element to create a subset of media elements defined by their priority class, which specifies how items in a playlist can interrupt other items. For example, you may assign emergency broadcast information to a higher priority class so that it can interrupt any content that is playing.
  • On the Source tab of your broadcast publishing point, you can specify values for the attributes of the items in your playlist. The following attributes are commonly used:
    • repeatCount. Use this attribute to repeat or loop the selected content a specified number of times. This is useful if you want to stream content 24 hours a day, 7 days a week.
    • role. Use this attribute to identify specific content as an advertisement for reporting purposes and for script events that are specific to ad behavior.
    • dur. Use this attribute to configure how long content should play.
  • Monitor your publishing point activity accurately by enabling logging on the publishing point. For example, you can use data from the log file to create a report about the number of users that click a specific advertisement.

Related topics

  • About publishing point types
  • Obtaining content
  • Streaming entertainment programming and advertising
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To create a playlist using the Windows Media Playlist Editor
  • To create a streaming radio station
  • Understanding playlists


Supporting personalized on-demand content

If you have a large amount of content on your Web site that you want to use, one of the best ways to drive traffic to your site is to support personalized user experiences. You can host content on your Web site that users can select to create their own customized radio playlists. Your Web site generates traffic when users return to the site to hear their playlists, which they also might want to share with their friends. You can also use your Web site to create playlists customized for an individual user based on his or her personal preferences, past behavior, or demographic information. In addition, by using demographic information, you can better target advertising to your users, making your Web site more attractive to Web advertisers.

When implementing this scenario, consider the following:

  • To provide a compelling user experience, obtain a variety of content and organize it into categories appropriate for personalization, such as genre, region, hobbies, local news, politics, and so on.
  • Use Active Server Pages (ASP pages) to gather the information needed to create a dynamic playlist for the user. As an additional feature, you can prompt users to specify whether the server should add new content automatically to their playlists or whether they prefer to add new content manually.
  • Use a relational database to store unique user information.
  • Use custom scripting to create a playlist that uses the information in the database and then store that playlist on a Windows Media server. For more information about custom scripting, see the Windows Media Services Software Development Kit (SDK).
  • Create an on-demand publishing point on your Windows Media server that references the URL of the user's playlist.

Related topics

  • About publishing point types
  • Obtaining content
  • Streaming entertainment programming and advertising
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To create a playlist using the Windows Media Playlist Editor
  • To create a streaming radio station
  • Understanding playlists


Creating syndicated programming

If you have created and licensed digital media content, you can use Windows Media Services to create syndicated programming, which you can then sell to content providers. You can use live or prerecorded content for your syndicated program, but it must be encoded in a supported streaming format. You can also organize your content by using a playlist. Playlists enable you to set policies that control how the content is played and ensure that content providers comply with the terms of your licensing agreement.

When implementing this scenario, consider the following:

  • Encoding content is a processor–intensive activity. A stable, high–quality streaming system normally has computers dedicated to encoding content to Windows Media Format. If you plan to encode live content, the encoding computer must have the appropriate audio or video capture cards. You can download the latest version of Windows Media Encoder from the Windows Media home page at the Microsoft Web site. For more information about encoding content, see Windows Media Encoder Help.
  • Create a playlist from your content on the Windows Media server. You can organize your content sequentially in the playlist or create an "online jukebox" from which users can choose available content. You can intersperse advertisements in the playlist that are set to play according to events that you specify. For example, an advertisement could play after five songs, when a user clicks a certain area in the content, or after 10 minutes. To learn more about scripting events, see the Windows Media Services SDK.
  • Distribute your content by setting up a broadcast publishing point that content providers can use to redistribute your content.

Related topics

  • Obtaining content
  • Streaming entertainment programming and advertising
  • To create a playlist using the Windows Media Playlist Editor
  • Understanding playlists


Providing live broadcasts

You can distribute live broadcasts, or webcasts as they are often called, by using Windows Media Services. You can either produce new content for a live broadcast or simultaneously broadcast content that is also being broadcast on the television or radio. You can archive the live broadcast and make it available to users on demand at a later time. Examples of live broadcasts include news conferences, sporting events, and music concerts.

When implementing this scenario, consider the following:

  • Use a computer running Windows Media Encoder to encode content into Windows Media Format and create an encoded stream. You can then broadcast the stream from a Windows Media server. You can download the latest version of Windows Media Encoder from the Windows Media home page at the Microsoft Web site. For more information about encoding, see Windows Media Encoder Help.
  • On a Windows Media server, create a broadcast publishing point that uses the encoded stream as the data source. If you want to switch from the live stream to a file, such as a file containing advertising or prerecorded content, and then back to the live content, create an exclusive playlist that uses script commands from the encoder to initiate the stream switch. Consider using a wrapper playlist to play some content before and after your live broadcast. Wrapper playlists are commonly used for site branding, welcome messages, and sponsor identification.
  • A webcast has a scheduled start time, which means that most users will attempt to connect to it in a short period of time. By creating a group in Windows Media Services, you can use several Windows Media servers to distribute the load of connection requests.
  • Let your users know that content is available. You can create a link on your existing Web site that users can use to connect to your publishing point and access your content. You can also create a default Web page with a link to your content and then customize the page to meet your needs.

Related topics

  • About publishing point types
  • About wrapper playlists
  • Obtaining content
  • Sourcing from an encoder
  • Streaming entertainment programming and advertising
  • To access the Add Publishing Point Wizard
  • To broadcast a stream pulled from an encoder
  • To create a playlist using the Windows Media Playlist Editor
  • To start the Create Wrapper Wizard
  • Understanding playlists


Displaying banner ads

You can use Windows Media Services to display banner advertisements in a player or on a Web site. Banners can include any type of digital media content, such as animations, video streams, or audio streams. For example, while a song is streaming from your server, you can display information about the artist, album, and concert schedule in the banner. Alternatively, your banner could feature a link to a concert schedule that users can click to go to the concert promoter's Web site without disrupting the audio stream.

When implementing banner advertisements, consider the following:

  • Banners can be displayed for the entire duration of the playlist or can change as each new piece of content streams.
  • You can implement customized banners for each user by referencing dynamic URLs created by reading cookies from advertising service vendors.
  • Rotate banners based on playback duration.
  • You also can use the banner space to display other Web-based information, such as news and advertisements links.
  • Design various sizes of banners, depending on the advertiser's requirements and your needs. The banner advertisement is displayed regardless of how the player is implemented, whether it is an embedded player, a standard player, or a skin.

Banners are implemented by associating an advertising banner URL with a BANNER metadata element in the announcement file or by using a bannerURL attribute with a clientData element in a server-side playlist file. For more information about elements that can be used in an announcement file, see the Windows Media Metafile Elements Reference at the Microsoft Web site. For more information about server-side playlists, see the Playlist reference.

Related topics

  • Streaming entertainment programming and advertising
  • To add a banner advertisement to a stream


Displaying interstitial ads

You can mix advertisements in with other content in your playlist by using interstitial advertisements. The advertisements in the playlist can be from a local server or from an advertising service vendor.

When implementing interstitial advertising, consider the following:

  • Switch between content streams by using stream switches. Stream switches can correspond with time duration, script commands, or client events.
  • Use a URL to a specific advertising service vendor in the playlist locations in which you want advertisements to appear. Frequently, the advertising service vendor will provide a link to an advertisement that best matches the user profile.
  • Use the noSkip attribute to prevent users from skipping the advertisement.
  • If you are logging data about your publishing points and want to be able to differentiate between the advertisements and the other content, set the value of the role attribute for the advertising content to Advertisement. You can then search the log file for that value and use only the relevant data.

Related topics

  • Include interstitial advertising in your on-demand playlist
  • Streaming entertainment programming and advertising
  • To add an interstitial advertisement to a stream


Working with wrapper ads

You can use wrappers to provide advertisements or other content when users first connect to your server and/or when the content stream ends. When you specify a wrapper for your content, Windows Media Services includes that content as part of a wrapper playlist. A wrapper playlist enables you to insert your choice of opening and closing content as a playlist item before and after the primary content.

In addition to advertisements, content commonly streamed as wrappers includes dynamic playlists that are generated by Active Server Pages (ASP), site branding, and sponsor identification.

For example, a unicast client that connects to a live stream for which a wrapper advertisement was specified must first play back all of the content specified in the wrapper playlist before it can stream the live content.

Related topics

  • About wrapper playlists
  • Streaming entertainment programming and advertising
  • To add a wrapper advertisement to a stream
  • Use wrappers to provide advertising with your live broadcast
  • Working with the Create Wrapper Wizard
  • Wrapper playlists


Replacing ads

It is common for radio stations to broadcast their content over the radio and the Internet simultaneously (called simulcasting). Internet radio broadcasts enable regional radio stations to access a much wider audience at a low additional operating cost. However, certain problems may arise when local advertising content is broadcast over the Internet. Local advertising is often not suitable for a global audience, and therefore it is sometimes necessary to substitute Internet-specific ads for local advertisements. This task is made more difficult because of the need for it to be done in real-time.

The most effective advertisement replacement technique is to use a server-side playlist containing excl and priorityClass playlist elements in coordination with an encoder that has been configured to send a script command to the Windows Media server. This script command signals the start of the advertising segment. The signal is interpreted at the publishing point by the excl playlist element. If the script command value matches the begin attribute value of the excl element, the content in the excl element interrupts the live stream. The replacement advertising content is contained within a priorityClass element which has a peers attribute value of pause. When the replacement advertisement ends, the pause value causes playback to resume with the live stream. .

This advertisement replacement strategy works best if the length of the local advertisement and the replacement advertising content match. Differences in the lengths of the two types of content can cause the server to return to the original content late or prematurely.

The key to successful advertisement replacement is seamless switching. The transition from one content source to another should occur quickly in order to appear as professional as possible. Transition delays of more than two-tenths of a second can cause a late return to the live stream after a break. To reduce the delay, you can configure the encoder to send a cueing script command prior to the switching command. When the server receives the cueing command, it prebuffers data from the upcoming advertisement before the switch.

Related topics

  • excl element
  • priorityClass element
  • Streaming entertainment programming and advertising


Distributing corporate communications

Using Windows Media Services, you can improve both internal and external business communications. You can stream internal communications, such as meetings, speeches, and training, over a corporate intranet, and you can stream external communications to customers, vendors, and business partners over the Internet.

In the following scenarios, you can use playlists to intersperse Hypertext Markup Language (HTML) content or Active Server Pages (ASP) pages with other streaming media content. These scenarios also rely on authentication and authorization methods to control access to content and on logging to report on the activity of the publishing point through which the content is streamed.

This topic contains the following sections:

  • Broadcasting executive speeches
  • Presenting training seminars
  • Holding financial briefings

Related topics

  • Archiving content
  • Control access to content
  • Scenarios
  • To broadcast a stream pulled from an encoder


Broadcasting executive speeches

Two of the most common corporate uses of Windows Media Services is for broadcasting executive speeches and company meetings. When these corporate speeches and meetings are broadcast by using Windows Media Services, employees that are located in other areas do not have to travel or miss the speech, presenters can give the speech at their convenience, and the meeting can be prerecorded instead of live.

Using Windows Media Services, the corporations can choose to broadcast the content as a live presentation or record it and broadcast it later. In addition, the presentations can be made available to viewers when they request it.

When implementing this scenario, consider the following:

  • Encoding software is optimized for live streaming or recording. Choose the appropriate encoding software for the approach you want to use. For example, Windows Media Encoder can encode a live stream directly to your Windows Media server but it does not provide you with the opportunity to edit the content. Alternatively, Microsoft Producer for PowerPoint 2002 enables you to create and edit a presentation from a live source and synchronize it with a set of PowerPoint slides, but it cannot transmit a live stream. For more information about content creation tools, see the Windows Media home page at the Microsoft Web site.
  • Each client that connects to your server requires network bandwidth. Determine whether it is best for all of your clients to connect to the stream at the same time or whether it is be better to schedule users to access the server at different times. Also consider whether you want to deliver the broadcast using multicast transmission to conserve network bandwidth.
  • You can use Windows Media Services to archive a broadcast stream to a file. Once the stream has been archived, you can rebroadcast the file or make it available for clients later by using an on-demand publishing point.

Related topics

  • About publishing point types
  • Archiving content
  • Distributing corporate communications
  • Obtaining content
  • Setting up Windows Media Services
  • Sourcing from an encoder
  • To access the Add Publishing Point Wizard
  • To archive content
  • To broadcast a live presentation
  • To broadcast a stream pulled from an encoder
  • To broadcast content pushed from an encoder
  • To configure a multicast stream from a broadcast publishing point
  • To rebroadcast archived content


Presenting training seminars

Employee training is one of the most important uses of streaming media in corporations. By making training seminars available by using Windows Media Services, corporations can ensure that employees learn additional skills or refresh existing knowledge at a time that is most convenient for their schedules in the locations of their choice.

If the training is designed to be online, the course materials can be integrated with screen shots, Web pages, and slides to provide an interactive training experience. If the training is being presented live, it may be simultaneously broadcast as a live presentation and archived to be made available to viewers when they request it.

When implementing this scenario, consider the following:

  • Encoding software is optimized for live streaming or recording. Choose the appropriate encoding software for the approach you want to use. For example, Windows Media Encoder can encode a live stream directly to your Windows Media server but it does not provide you with the opportunity to edit the content. Alternatively, Microsoft Producer for PowerPoint 2002 enables you to create and edit a presentation from a live source and synchronize it with a set of PowerPoint slides, but it cannot transmit a live stream. For more information about content creation tools, see the Windows Media home page at the Microsoft Web site.
  • You can use Windows Media Services to archive a broadcast stream to a file. Once the stream has been archived, you can rebroadcast the file or make it available for clients later by using an on-demand publishing point.
  • Using authentication, authorization, and logging can provide you with information about the users that have received the content from your server.
  • By using passwords with your publishing points, you can limit employees' access to training until they have completed the prerequisites or received permission.

Related topics

  • Archiving content
  • Distributing corporate communications
  • Obtaining content
  • Sourcing from an encoder
  • Sourcing from files
  • To archive content
  • To broadcast a stream pulled from an encoder
  • To provide an on-demand training seminar
  • To stream a Windows Media file from an on-demand publishing point


Holding financial briefings

Regular financial briefings are required by companies whose stocks are publicly traded. The information in these briefings is often confidential and may have an effect on the company's success or failure in the marketplace if the information is revealed at the improper time.

Windows Media Services enables you to control which users can connect to your content, prevent users from caching your content, and log how long each client was connected to the broadcast.

When implementing this scenario, consider the following:

  • Encoding software is optimized for live streaming or recording. Choose the appropriate encoding software for the approach you want to use. For example, Windows Media Encoder can encode a live stream directly to your Windows Media server but it does not provide you with the opportunity to edit the content. Alternatively, Microsoft Producer for PowerPoint 2002 enables you to create and edit a presentation from a live source and synchronize it with a set of PowerPoint slides, but it cannot transmit a live stream. For more information about content creation tools, see the Windows Media home page at the Microsoft Web site.
  • You can use Windows Media Services to archive a broadcast stream to a file. Once the stream has been archived, you can rebroadcast the file or make it available for clients later by using an on-demand publishing point.
  • Using authentication, authorization, and logging can provide you with information about the users that have received the content from your server.
  • By using passwords with your publishing points, you can limit access to content to users that have registered and have met the requirements for receiving the content.

Related topics

  • Archiving content
  • Distributing corporate communications
  • Obtaining content
  • Sourcing from an encoder
  • Sourcing from files
  • To archive content
  • To broadcast a recorded presentation
  • To broadcast a stream pulled from an encoder
  • To stream a Windows Media file from an on-demand publishing point


Streaming programming to subscribers

With Windows Media Services, you can ensure that information is being transmitted only to users that have been authorized to access the content by distributing unique user licenses and by limiting access to your server resources.

This section contains the following topics:

  • Providing video on demand
  • Providing a subscription service
  • Creating a client activity report
  • Wireless streaming

Related topics

  • Scenarios


Providing video on demand

Users can connect to your Web site, select a movie, and either purchase it as a rental with a limited number of playbacks or purchase it for unlimited playback. You can provide users with the option of downloading or streaming the content from the server.

When implementing this scenario, consider the following:

  • You must have suitable video content, as close to DVD quality as possible, with a high frame rate and full–screen capability.
  • You must have a suitable method for licensing your content. For more information about the methods for streaming protected Windows Media-based content, see the Windows Media Rights Manager SDK.
  • Because this scenario assumes that streaming will require high bandwidth, you can avoid excessive buffering and network congestion by distributing your publishing points across several servers and by placing limits on each publishing point to control how many users can stream from each.
  • You can use the authentication and authorization plug-ins included with Windows Media Services to control access to your content. You can also use a logging plug-in to record the activity on the publishing point.
  • Windows Media Services includes announcement features which can help you create a link on your existing Web site that users can click to connect to your publishing point or create a default Web page that contains a link to your content.

Related topics

  • About publishing point types
  • Configuring security options
  • Obtaining content
  • Sourcing from files
  • Streaming programming to subscribers
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To set limits for a server or publishing point


Providing a subscription service

Another method of providing content to users is as a subscription service. In this scenario, a user pays a fee to play back content a certain number of times and to receive licenses for a variety of content each billing period. When implementing this scenario, consider the following:

  • Determine the method for licensing your content. For more information about the methods for streaming protected Windows Media-based content, see the Windows Media Rights Manager Software Development Kit (SDK).
  • Use the Windows Media Services snap-in to create on-demand publishing points on your server to distribute subscription content.
  • Enable the authentication and authorization plug-ins that you want to use to control access to your content. You may also want to enable a logging plug-in to record the activity on the publishing point. Using data collected in the log files, you can create reports to verify that your system is performing as expected.
  • Let your users know that content is available. You can create a link on your existing Web site that users can use to connect to your publishing point and access your content. You can also create a default Web page with a link to your content and then customize the page to meet your needs.

Related topics

  • About publishing point types
  • Configuring security options
  • Obtaining content
  • Sourcing from files
  • Streaming programming to subscribers
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method


Creating a client activity report

Part of providing a streaming service is providing reporting data to clients to verify your claims. Using the data collected in Windows Media Services log files, you can verify that users are accessing only the content for which they have been granted access.

You can use the data in a log file to create reports that reflect the client activity for a server or publishing point. Reports can detail the total number of clients per URL, the average stream duration, and the advertisements that each client viewed. When implementing this scenario, consider the following:

  • Use a database to store the data you collect. By storing data over time, you can analyze trends and provide historical information about the performance of your Web site.
  • Determine the audience of your client activity reports. Be sure that you create reports that meet the needs of your audience and focus on the most important statistics.
  • Investigate different reporting products. There are several companies that specialize in reporting software. For more information about reporting software, see the Windows Media Partner Center at the Microsoft Web site.

Related topics

  • Logging data about unicast streams
  • Logging data and events
  • Streaming programming to subscribers
  • To configure and enable unicast logging


Wireless streaming

Wireless streaming scenarios apply primarily to three kinds of devices that are or very soon will be capable of rendering streaming media content: portable computers, personal digital assistants, and Internet-capable phones. If your target audience includes these devices, consider the following:

  • Enable forward error correction on your publishing points. Forward error correction (FEC) is a common method of preserving the integrity of data transmitted over unreliable or slow network connections. When forward error correction is used, the server broadcasts extra packets on the assumption that some of the packets will be lost before they reach the client. This process enables the client to reconstruct the original transmission even if a significant portion of the packets are missing.
  • PDAs typically have a much smaller viewing area than desktop computers or even portable computers. When encoding video for a PDA, you must accommodate not only the PDA's small screen size, but also its modest computing power. For example, the screen size of a Pocket PC is 320 pixels by 240 pixels, but the best compromise of picture quality, frame rate, and bit rate suggests a frame size of 208 pixels by 160 pixels and a frame rate of 20 frames per second. In order to render streaming video at full screen size, the frame rate must be reduced, which often makes movement on the screen excessively jerky. Additional encoding profiles for encoding content for mobile devices are available from the Windows Media Encoder page at the Microsoft Web site
  • Cellular data transfer technology has not advanced to the point of permitting broadband access to streaming media. Devices that use Cellular Digital Packet Data (CDPD) or other cellular modem technology are generally restricted to a bit rate of 9.6 kilobits per second (Kbps or less). Bit rates in this range cannot support streaming video.

Note Image Note

  • Forward error correction is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Streaming programming to subscribers
  • To configure the Enable forward error correction property


Concepts

This section is designed to help you become familiar with terms and concepts related to Windows Media Technologies. This section contains the following topics:

  • Understanding streaming media. Provides an overview of the different methods, configurations, and issues you should consider when using Windows Media Services to stream content.
  • Networking and content delivery. Describes the networking features of Windows Media Services, which enable you to stream audio and video data over computer networks.
  • Managing your Windows Media server. Provides an overview of the Windows Media Services snap-in, the feature of Windows Media Services used for managing your server.
  • Understanding publishing points. Describes publishing points and how they can be used to help you develop a successful strategy for managing content.
  • Sourcing from playlists, files, and encoders. Provides an overview of publishing point sources and how they are used.
  • Announcing content. Provides information about how announcement files are created and how players use announcements to receive content from a Windows Media server.
  • Understanding advertising. Provides information about streaming advertising along with other digital media content.
  • Logging data and events. Provides information about logging client data and using event handler plug-ins.
  • Configuring security options. Provides information about the various methods you can use to protect your server and your content.
  • Securing the Windows Media Administration site. Provides information about configuring Internet Information Services to increase the security of the Web site that supports Windows Media Services Administrator for the Web.
  • Caching and proxying content. Provides information about caching and proxying content to provide a better viewing experience for users and reduce your operating costs.

Related topics

  • Windows Media Services


Understanding streaming media

This section introduces concepts that are important to understand as you prepare to implement a streaming media system. This section contains the following topics:

  • Streaming vs. downloading content
  • Streaming media system overview
  • Obtaining content
  • Setting up Windows Media Services

Related topics

  • Concepts


Streaming vs. downloading content

You can deliver digital media files to clients over a network by using one of two methods: streaming or downloading. This topic provides an overview and a comparison of each method.

Downloading

To deliver content to users by using the downloading method, you typically save the content to a Web server and provide users with a link to the content by adding the link to the content on a Web page, for example. The user then clicks the link, downloads the file to his or her local hard disk, and then plays back the content using a player.

Downloading requires that users copy entire files to their computers before they can play the content, which consumes both time and disk space. In addition, because the entire file must be downloaded to a computer before it can play, downloading can not be used with live content.

Downloading does not make efficient use of available bandwidth. When a client begins to download a digital media file, all available network bandwidth is used to transfer the data as quickly as possible. As a result, other network functions may slow down or be disrupted.

Streaming

To deliver content to users by using a streaming method, you can save the content to a Windows Media server, and then assign the content to a publishing point. You can then provide users with access to the content by either creating an announcement file or by supplying users with the URL of the publishing point. You can embed the announcement file or the URL in a Web page or send it in an e-mail message. When the user clicks the link or the announcement file, the player opens and connects to the stream.

Streaming uses bandwidth more efficiently than downloading because it sends data over the network only at the speed that is necessary for the client to render it properly. This helps prevent the network from becoming overloaded and helps maintain system reliability. There is typically a delay between the time the stream is received by the player and the point at which it begins playing because the player must first buffer the data in case there are delays or gaps in the stream. Because data streaming and rendering occurs at the same time, streaming also enables you to deliver live content.

To stream content smoothly, the bit rate of the content must be lower than the bandwidth of the network. If the bit rate is higher than the available bandwidth, the player will attempt to thin the stream so it can render the stream properly by using a process called stream thinning. Because of this, the player may render only key frames of the video stream with audio so that the video is not in motion, creating a viewing experience similar to a slide show. If the bit rate requirements greatly exceed the available bandwidth, video playback may stop altogether and only the audio portion will be played.

The impact of inadequate available client bandwidth can be minimized if multiple-bit-rate (MBR) content is streamed. MBR content enables the player to request a lower bit rate stream from the server so that stream thinning is not necessary.

Fast Streaming

Windows Media Services 9 Series includes Fast Streaming, which provides several features that combine the advantages of streaming and downloading.

The server can use the Fast Start feature to ensure that the client can begin playing the content as quickly as possible after the stream begins. This feature enables the player to download and buffer a small portion of the content from the server as fast as the network will permit before the content begins to play. Once the buffer has been established on the player, the server slows down the stream until it matches the rendering speed of the player.

When the server uses the Fast Cache feature, it streams all of the content to the player at the highest possible bit rate so that the effects of network congestion or interruption can be minimized. As with normal streaming, the player begins rendering the content as soon as the necessary amount of data has been buffered. The rest of the data is stored in a temporary cache on the client computer.

If you are streaming variable-bit-rate (VBR) content, the amount of bandwidth required to transmit the stream can fluctuate based on the complexity of the content. Fast Streaming can take advantage of periods of lower bandwidth by sending extra data to the player to replenish the content buffer, enabling the VBR content to play back smoothly when streamed from the server.

Related topics

  • Obtaining content
  • Streaming media system overview
  • Setting up Windows Media Services
  • Understanding streaming media


Streaming media system overview

A streaming media system based on Windows Media Technologies typically consists of a computer running an encoder (such as Microsoft Windows Media Encoder), a server running Windows Media Services, and players. The encoder enables you to convert both live and prerecorded audio, video, and computer screen images to Windows Media Format. The server running Windows Media Services, called a Windows Media server, enables you to distribute the content over a network. Users receive the content you distribute by using a player, such as Windows Media Player.

Overview of streaming media request

In a typical scenario, a user clicks a link on a Web page to request content. The Web server redirects the request to the Windows Media server and opens the player on the user's computer. At this point, the Web server no longer plays a role in the streaming media process and the Windows Media server establishes a direct connection with the player and begins streaming the content directly to the user.

Overview of streaming media sources

The Windows Media server can receive content from several different sources. Prerecorded content can be stored locally on the server or retrieved from a networked file server. Live events can be captured using a digital recording device and processed through an encoder before being sent to the Windows Media server for broadcast. Windows Media Services can also rebroadcast content streamed from a publishing point on a remote Windows Media server.

Note Image Note

  • For information about implementing security measures in your streaming media system, see Configuring security options.

Related topics

  • Ensuring the stability of your streaming media system
  • Obtaining content
  • Setting up Windows Media Services
  • Streaming from a Windows Media server vs. a Web server
  • Understanding streaming media


Streaming from a Windows Media server vs. a Web server

You can deliver Windows Media-based content either from a server running Windows Media Services or from a Web server. However, a Windows Media server is designed specifically for streaming Windows Media-based content; a standard Web server is not. If you decide to use a Web server, be aware of the following differences in the way the content is delivered, which can affect the playback quality:

  • The method of sending data differs between a Web server and a Windows Media server. A Web server is designed to send as much data as it can, as quickly as possible. This is the preferred method for sending static images, text, and Web page scripts, but it is not the best method for streaming digital media. Ideally, the data packets for streaming media content should be delivered in real time, not in large bursts, and players should receive packets immediately before rendering them.
  • A Windows Media server regulates the delivery of packets according to feedback information it receives while sending a stream to a player and according to the configuration of certain features such as Fast Cache and Fast Start. When a player receives packets in this way, the presentation is much more likely to be smooth. Because bandwidth use is controlled, more users can connect at the same time and still receive streams that are free of interruptions.
  • Web servers do not support multiple-bit-rate (MBR) video. When a file streams from a Web server, the quality of the delivery is not monitored and the bit rate cannot be adjusted, which can cause the playback quality to vary during the duration of the stream and can result in a poor user experience.
  • Web servers cannot use the preferred delivery protocol for streaming media, User Datagram Protocol (UDP), so delivery of a stream is more likely to be interrupted by periods of silence while the player buffers data.
  • Web servers do not support live streaming or multicast streams.
  • Web servers do not support indexed Windows Media files. (Indexing provides users with a means of fast-forwarding and rewinding through a file that is streaming.)
  • A Windows Media server includes built-in monitoring and logging capabilities with which you can gather valuable information about your streaming media session and its audience.

Note Image Note

  • There are times when you may prefer to stream from a Web server—for example, if you plan to offer only a small amount of content or if you have a site with limited resources. A Web server can also be used for downloading files that you do not intend to stream, such as files with a high bit rate that is intended for local playback only. For more information about streaming from a Web server, see the Microsoft Web site.

Related topics

  • Streaming media system overview


Ensuring the stability of your streaming media system

To ensure that your streaming media system is stable, redundant, and capable of bearing the predicted load, keep the following in mind:

  • If you plan to encode live content, it is recommended that you install the encoder and Windows Media Services on separate computers. Live encoding requires a large amount of processing capability; the additional load of serving client requests can adversely affect the quality of an encoded stream.
  • Have multiple encoders encoding content so that publishing points on your Windows Media servers can switch to an alternate source in case there is a problem on the original encoder source.
  • If you want to archive encoded content for later playback, do not use the encoder to create the archive file, instead configure your Windows Media server to create an archived copy. This reduces the processing load on the encoding computer.
  • Distribute content between numerous Windows Media servers. This enables the servers to provide content to different network segments, which reduces the number of routers that the stream must traverse in order to reach clients and improves the overall stream quality. In addition, extra servers provide redundancy and additional capacity if there are any server problems.
  • If you intend to stream high volumes of Windows Media files, consider dedicating a separate NTFS volume for storing the files. An NTFS volume permits the use of access control list (ACL) checking on your content files as well as better file management capabilities.
  • Consider using multicast streaming with unicast rollover. Multicast streaming can deliver content to any number of clients from a single stream. When additional clients connect through a multicast-enabled network, they do not require extra bandwidth from the server or place an additional load on the network, thus increasing the efficiency of the stream.

Related topics

  • Streaming media system overview


Obtaining content

You can stream many types of content in Windows Media Format, including a radio show, a song, a television program, or a music video. Content can either be a stored Windows Media file or a live stream. You can also create a playlist file that references a combination of files and live streams and generates a continuous stream. The following table lists software available from Microsoft that you can use to create and edit Windows Media-based content.

Tool | Description
Windows Media Encoder | Use to convert both live and prerecorded content to Windows Media Format. Windows Media Services is compatible with Windows Media Encoder version 4.1 and later.
Windows Media Encoding Script | Use this command-line tool to convert both live and prerecorded audio and video into Windows Media files or streams.
Windows Media Player | Use to copy existing content from a CD.
Windows Movie Maker | Use to capture audio and video and do simple video editing. Windows Movie Maker is a feature of Windows XP Home Edition and Professional.
Windows Media Stream Editor | Use to split or combine streams in existing Windows Media files into new Windows Media files.
Microsoft Producer for PowerPoint 2002 | Use to combine slides from a presentation created in Microsoft PowerPoint or Web pages created with Microsoft FrontPage® with audio and video.
Windows Media File Editor | Use to open and edit a file with a .wmv, .wma, or .asf file name extension. This utility enables you to trim the start and end points of a file, as well as add attributes, markers, and script commands.

For more information about obtaining and using any of the above products as well as information about additional content creation tools, see the Windows Media home page at the Microsoft Web site.

Note Image Notes

  • Support for encoding content in Windows Media Format is included in many third-party programs, such as Vegas Video and Sound Forge from Sonic Foundry, Premiere from Adobe, and VideoWave from MGI. Most of these products are used for advanced editing and processing of video and audio. When you finish working on a file, the program enables you to encode it as a Windows Media file.
  • Windows Media Services can create content from a broadcast stream using the WMS Archive Data Writer. For more information, see Archiving content.
  • Windows Media Services will not stream variable-bit-rate (VBR) MP3 files.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.

Related topics

  • Setting up Windows Media Services
  • Sourcing from playlists, files, and encoders


Setting up Windows Media Services

After you have obtained your content, the next step is to set up a server running Windows Media Services to distribute that content. The basic steps involved in setting up a Windows Media server include adding and configuring publishing points to identify the content you plan to stream, and communicating to users that the content is available.

A Windows Media server uses publishing points to translate a client request for content into a physical path on the server hosting the content. You can add two types of publishing points to a Windows Media server, broadcast and on-demand. If you want to stream live content from an encoder, a broadcast publishing point is the best choice. If you plan to stream a file and want to allow users to control playback of the content (for example, to pause, rewind, or fast-forward it), an on-demand publishing point is the best choice.

After you have added a publishing point and identified the content you want to stream from it, you need to communicate that the content is available. An easy method for accomplishing this is to create an announcement for the content.

You may also want to implement some of the more advanced features available through Windows Media Services. For example, you can modify settings to limit the number of client connections, set up security measures to protect your content, log data about client activity, and set up a distribution server.

When selecting the type of publishing point to use, you should consider how you want to deliver the content; for example, whether you want to deliver the content as a unicast or multicast stream. With a unicast stream, clients connect to a Windows Media server to access content. With a multicast stream, the server streams content to a single multicast IP address on the network, and all clients access that IP address to receive the stream instead of connecting to the server. This reduces the amount of bandwidth required on the network as the single stream is able to fulfill multiple client requests.

You can deliver content as a unicast stream from either an on-demand or a broadcast publishing point. You can deliver content as a multicast stream only from a broadcast publishing point. For more information about multicast and unicast streaming, see Selecting unicast vs. multicast distribution.

This section contains the following topics:

  • Delivering content as a unicast stream
  • Delivering content as a multicast stream
  • Announcing your content to users

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Caching and proxying content
  • Configuring security options
  • Controlling unicast connections to a publishing point
  • Logging data and events
  • Obtaining content
  • Understanding publishing points


Delivering content as a unicast stream

A unicast stream is a one-to-one connection between the server and a client, which means that each client receives a distinct stream and only those clients that request the stream receive it. You can deliver content as a unicast stream from either an on-demand or a broadcast publishing point.

Unicast streaming is the default method by which a Windows Media server delivers content. Unicast streaming is automatically enabled by the WMS Unicast Data Writer plug-in, which is enabled by default.

The following figure shows an example of delivering content as a unicast stream by using an on-demand publishing point.

Unicast streaming example

As shown in the figure, there is an on-demand publishing point named TV1 on the Windows Media server called Server1. This publishing point identifies the location of the content you want to stream. The content can be hosted on the local server or a network file system. You can source from a specific file, a playlist file, or a directory. In this example, the publishing point is sourcing from a playlist file that is stored locally on Server1. When you are ready for users to begin streaming, you can create an announcement to give users the URL to the content. Because the content is being delivered as a unicast stream, each player has a unique connection to Server1.

Related topics

  • Announcing your content to users
  • Understanding publishing points


Delivering content as a multicast stream

Multicast streaming is a one-to-many relationship between a Windows Media server and the clients receiving the stream. With a multicast stream, the server streams to a multicast IP address on the network, and clients receive the stream by subscribing to the IP address. All clients receive the same stream. Because there is only one stream from the server regardless of the number of clients receiving the stream, a multicast stream requires the same amount of bandwidth as a single unicast stream containing the same content. Using a multicast stream preserves network bandwidth and can be useful for low bandwidth local area networks.

You can deliver content as a multicast stream only from a broadcast publishing point. In addition, your network routers must be multicast-enabled, meaning that they can transmit class D IP addresses. If your network routers are not multicast-enabled, you can still deliver content as a multicast stream over the local segment of your local area network.

The following figure shows an example of content being distributed from an encoder as a multicast stream by using a broadcast publishing point.

Multicast streaming example

These steps describe one way you can multicast live content from an encoder, as shown in the previous figure.

  • Send the live images from a digital video camera to a video capture card on a computer running Windows Media Encoder. The images are encoded into Windows Media Format, and then streamed to the server using HTTP.
  • On the Windows Media server called Server1, use the Add Publishing Point Wizard to add a broadcast publishing point that sources from the encoder. As part of the wizard. you may choose to allow unicast rollover. Unicast rollover ensures that players that cannot access the multicast stream can still receive the content by switching to an available unicast stream. For example, a player may be unable to access the multicast stream if the network routers are not multicast-enabled, or if the player is beyond the time-to-live (TTL) radius of the multicast stream.
  • Use the Multicast Announcement Wizard to create an announcement to provide users with the URL to the content. The wizard can create a multicast information file (with an .nsc file name extension), an announcement file (with an .asx file name extension), the code necessary to embed an announcement within a Web page, or any combination of those three options.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Announcing your content to users
  • To configure a multicast stream from a broadcast publishing point


Announcing your content to users

After you set up your Windows Media server and the content you want to stream, you need to let users know the content is available and how to access it. Users can access content by typing the URL to the content in their players. However, users do not always know the URL or even that your content exists. To make it easy for users to access your content, you can create an announcement. An announcement is a Windows Media metafile with an .asx extension that gives a player the information needed to connect to a Windows Media server.

Announcing a unicast stream

To enable players to access a unicast stream, you can create an announcement file by using the Unicast Announcement Wizard. An announcement provides the information that the player needs to connect to and receive your content. You can place a link to an announcement on a Web page, make the announcement available on a shared network location, or send an announcement in an e-mail message. Users can access your content either by clicking the link on the Web page or by directly opening the announcement.

Announcing a multicast stream

To enable players to access a multicast stream, you can create an announcement file and a multicast information file by using the Multicast Announcement Wizard. An announcement provides the information that the player needs to connect to and receive your content.

A multicast information file is a Windows Media metafile with an .nsc extension that contains information a player needs to decode the stream. You can place a link to the announcement on a Web page, make the announcement available on a shared file location, or send an announcement in an e-mail message. Users can access the announcement either by clicking the link to the announcement on the Web page or by directly opening the announcement. The announcement opens briefly, points to the multicast information file, and then the player begins receiving the content.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Announcing content
  • Understanding publishing points


Networking and content delivery

This section contains information about how a computer running Windows Media Services interacts with the other computers on your network to deliver content to clients. This section contains the following topics:

  • Understanding protocols
  • Understanding Fast Streaming
  • Understanding content delivery

Related topics

  • Concepts


Understanding protocols

To enable streaming, Windows Media Services supports the Microsoft Media Server (MMS) protocol, Real Time Streaming Protocol (RTSP), and Hypertext Transfer Protocol (HTTP) through the use of control protocol plug-ins. This section contains the following topics:

  • Protocol overview
  • Using the MMS protocol
  • Using the RTSP protocol
  • Using the HTTP protocol
  • How protocol rollover works
  • How unicast works
  • How multicast works

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Networking and content delivery


Protocol overview

A data transfer protocol is a standardized format for transmitting data between two devices. The type of protocol used can determine such variables as the error checking method, the data compression method, and end-of-file acknowledgements. If all networks were constructed in the same manner and all networking software and equipment behaved similarly, only one protocol would be necessary to handle all of our data transmission needs. In reality, the Internet is comprised of millions of different networks running a wide array of hardware and software combinations. As a result, the ability to stream digital media content reliably to clients depends on a set of several well-engineered protocols. The protocols used to stream Windows Media-based content are:

  • Real Time Streaming Protocol (RTSP)
  • Microsoft Media Server (MMS) protocol
  • Hypertext Transfer Protocol (HTTP)

Windows Media Services manages the use of these protocols by using control protocol plug-ins. Windows Media Services includes the WMS MMS Control Protocol plug-in, the WMS RTSP Control Protocol plug-in, and the WMS HTTP Control Protocol plug-in. With the exception of the WMS HTTP Control Protocol plug-in, these plug-ins are enabled by default.

The control protocol plug-in receives the incoming client request, determines what action is indicated by the request (for example, to start or stop streaming), translates the request into a command form, and then passes the command to the server. Control protocol plug-ins can also return notification information to clients if there is an error condition or a change of status.

While the previously listed protocol plug-ins listed handle the high-level exchange of data, basic networking protocols such as User Datagram Protocol (UDP) and Transmission Control Protocol (TCP) are used to manage more fundamental tasks such as network connectivity and packet error correction. The MMS and RTSP protocols are used in combination with both the UDP or TCP protocols.

The following diagram depicts how Windows Media Services uses different protocols to negotiate connections between a Windows Media server, encoders, content sources, and clients.

Windows Media Services 9 Series in Windows Server 2003, Enterprise Edition or in Windows Server 2003, Datacenter Edition includes the following additional networking capabilities:

  • Multicast transmission. You can deliver content as a multicast stream from a broadcast publishing point on your server.

Clients that receive content as a multicast stream do not use a connection-based protocol. Instead, they receive the stream by joining to a multicast broadcast. The information the client needs to locate and join a multicast stream is contained in a multicast information file with an .nsc file name extension. The client first opens the file from a Web server or from a link in an e-mail and then uses the information contained in the file to connect to the multicast stream.

  • Wireless optimizations. You can use forward error correction to send additional data packets in your stream to correct errors caused by the lossy transmission methods used by wireless networks.

Note Image Note

  • When setting up distribution servers to use the Fast Streaming feature, use either the RTSPT or HTTP protocols to connect to the origin server. For more information about Fast Streaming, see Understanding Fast Streaming. For more information about distribution servers, see Using distribution servers.

Related topics

  • How protocol rollover works
  • Understanding protocols
  • Using the HTTP protocol
  • Using the MMS protocol
  • Using the RTSP protocol


Using the MMS protocol

The Microsoft Media Server (MMS) protocol is a proprietary streaming media protocol developed by Microsoft for earlier versions of Windows Media Services. You can use the MMS protocol when delivering content as a unicast stream. It supports player control actions such as fast-forwarding, rewinding, pausing, starting, and stopping an indexed digital media file. If you are supporting clients that are using earlier versions of Windows Media Player, you will need to use either the MMS or the HTTP protocol to service their stream requests.

MMS protocol overview

If the connection URL specified by the Player uses MMS (for example, mms://server_name/publishing_point_name/file_name), then the Player can use protocol rollover to negotiate the best protocol to use. MMSU and MMST are specialized versions of the MMS protocol. MMSU is a User Datagram Protocol (UDP)-based protocol, which is the preferred protocol for streaming. MMST is the Transmission Control Protocol (TCP)-based protocol used on a network that does not support UDP.

If you want to force the server to use a specific protocol, you can identify the protocol to be used in the announcement file. The user can also specify the protocol in the content address (for example, mmsu://server_name/publishing_point_name/file_name). To facilitate protocol rollover, it is recommended that the URL use the generalized MMS protocol. That way, the Player can use either the MMSU or MMST protocols to connect to the stream. If the Player cannot connect to the stream successfully by using either of these protocols, it attempts to connect to the stream by using Hypertext Transfer Protocol (HTTP). For more information about protocol rollover, see How protocol rollover works.

Windows Media Services implements the MMS protocol through the WMS MMS Server Control Protocol plug-in. In a default installation of Windows Media Services, this plug-in is enabled and bound to TCP port 1755 and UDP port 1755.

Note Image Notes

  • When setting up distribution servers for the Fast Streaming feature, use either the RTSPT or HTTP protocols to connect to the origin server. For more information about Fast Streaming, see Understanding Fast Streaming. For more information about distribution servers, see Using distribution servers.
  • Some ISA clients may have trouble connecting to port 1755. To correct this problem, create a file called Wspcfg.ini and save it to the folder named %systemroot%\Windows\System32\Windows Media\Server. The file should contain the following text:
    [WMServer]
LocalBindTcpPorts=1755
LocalBindUdpPorts=1755

Related topics

  • Understanding protocols


Using the RTSP protocol

You can use Real Time Streaming Protocol (RTSP) to deliver content as a unicast stream. It is an application-level protocol that was created specifically to control the delivery of real-time data, such as audio and video content. It is implemented over a correction-oriented transport protocol. It supports player control actions such as stopping, pausing, rewinding, and fast-forwarding indexed Windows Media files. You can use RTSP to stream content to computers running Windows Media Player 9 Series or Windows Media Services 9 Series. RTSP is a control protocol that works in tandem with the data delivery Real Time Protocol (RTP) to provide content to clients.

RTSP protocol overview

If the connection URL uses RTSP (for example, rtsp://server_name/publishing_point_name/file_name), RTSP automatically negotiates the best delivery mechanism for the content. It then directs the RTP protocol to deliver streaming content using the User Datagram Protocol (UDP) or using a Transmission Control Protocol (TCP)-based protocol on a network that does not support UDP.

If you want to force the server to use a specific protocol, you can identify the protocol to be used in the announcement file. The user can also specify the protocol in the content address (for example, rtspu://server_name/publishing_point_name/file_name). To facilitate protocol rollover, it is recommended that the URL use the generalized RTSP protocol. That way, the Player can use either the RTSPU or RTSPT protocols to connect to the stream. If the Player cannot connect to the stream successfully by using either of the RTSP protocols, it attempts to connect to the stream by using one of the MMS protocols. For more information about protocol rollover, see How protocol rollover works.

Windows Media Services implements RTSP through the WMS RTSP Server Control Protocol plug-in. In a default installation of Windows Media Services, this plug-in is enabled and bound to TCP port 554.

Note Image Notes

  • When setting up distribution servers for Fast Streaming, use either RTSPT or HTTP protocols to connect to the origin server. For more information about the Fast Streaming feature, see Understanding Fast Streaming. For more information about distribution servers, see Using distribution servers.
  • When using RTSPU, setting the RTP packet size to a small value may prevent the Windows Media server from streaming. For more information about unicast packet sizes, see How unicast works.
  • If a client that supports RTSP attempts to connect to the Windows Media server using a URL that starts with mms://, the content will be streamed to the client using RTSP.

Related topics

  • Understanding protocols


Using the HTTP protocol

You can use Hypertext Transfer Protocol (HTTP) to stream content from an encoder to a Windows Media server, to distribute streams between computers running different versions of Windows Media Services or computers that are separated by a firewall, and to download dynamically-generated playlists from a Web server. HTTP is especially useful for clients that receive streaming content through a firewall because HTTP is usually set up to use port 80, which is not blocked by most firewalls.

HTTP protocol overview

You can use HTTP to deliver streams to all Windows Media Player versions and to other Windows Media servers. If a client uses HTTP to connect to the server, protocol rollover is not used

Windows Media Services uses the WMS HTTP Server Control Protocol plug-in to control HTTP-based client connections. You must enable this plug-in for Windows Media Services to use HTTP to stream content to clients or to receive streams from Windows Media Encoder.

When you enable the WMS HTTP Server Control Protocol plug-in, it attempts to bind to port 80. If another service, such as Internet Information Services (IIS), is using port 80 on the same IP address, then you cannot enable the plug-in. For more information about HTTP streaming concurrently with other services, see Using HTTP streaming and other services on the same computer.

The HTTP protocol is also used when a server running Windows Media Services is streaming a dynamic playlist generated by an ASP page or Web script. For more information about dynamic playlists, see Using dynamic sources.

Note Image Notes

  • When setting up distribution servers to use Fast Streaming, use either the RTSPT or HTTP protocols to connect to the origin server. For more information about the Fast Streaming feature, see Understanding Fast Streaming. For more information about distribution servers, see Using distribution servers.
  • Clients that receive a HTTP broadcast stream may not be able to reconnect to the stream for a period of up to 90 seconds after the stream ends. This delay occurs because the Windows Media server holds the data path open after the content ends in order to receive logging data.

Related topics

  • To enable HTTP streaming
  • Understanding protocols


Using HTTP streaming and other services on the same computer

If you use both Windows Media Services and a Web service such as Microsoft Internet Information Services (IIS) on the same server, both services will attempt to bind to port 80. You can avoid such conflicts by assigning each service to a different port. If you assign a service to a port other than 80, the network administrator must open the corresponding port on the network firewall. For more information about changing the port that Windows Media services binds to, see To change the port Windows Media Services uses for HTTP streaming.

As an alternative, you can assign additional IP addresses to the server, enabling each service to have its own IP address and still use port 80. The simplest way to accomplish this is to install multiple network interface cards on your server. However, if this solution is not possible, you can create multiple IP addresses on a single network interface card and assign separate port 80 addresses to them. You must then configure Windows Media Services and your Web service to bind to separate IP address/port 80 combinations. Windows Media Services includes a tool for assigning additional IP addresses to your services. For information on adding IP addresses to your servers, see To add IP addresses to resolve port 80 conflicts.

Related topics

  • To change the port Windows Media Services uses for HTTP streaming
  • To configure the WMS HTTP Server Control Protocol plug-in
  • To enable HTTP streaming
  • Using the HTTP protocol


How protocol rollover works

The ability of Windows Media Services to choose the right protocol for a client depending on its environment is known as protocol rollover. Protocol rollover is useful if you are supporting a variety of client versions, clients that are connecting through a firewall, or clients that are connecting through different types of networks. Protocol rollover works best if all the server control protocol plug-ins available on your server (including the WMS HTTP Server Control plug-in) are enabled.

The Windows Media server uses protocol rollover in order to establish the optimal connection to the client. When a client attempts to connect to a server, it sends information about its type and what protocols it can support. The Windows Media server compares that information to the protocols that are enabled and then uses the best protocol for the situation. Typically, the first connection attempt between the server and the client is successful and no further action is taken. If that connection request is not successful, the client attempts to connect to the server using another supported protocol. The client experiences a very small, usually unnoticeable period of latency during each protocol rollover attempt.

In addition, when a client attempts to establish a new connection to the server, preference is given to the protocol that the client used in the previous connection. If you use an announcement to enable clients to access your content, the Microsoft Media Server (MMS) protocol is used automatically, ensuring that protocol rollover will occur if necessary.

It is recommended that you use protocol rollover to ensure that your clients have the optimal streaming experience. If clients connect to your stream using a URL with an mms:// prefix, protocol rollover will occur if necessary. Be aware that users can disable protocols in the property settings of their players. If the player only supports a single protocol, rollover cannot occur. The logic used with protocol rollover differs depending on the type of client connecting to the server.

Windows Media Player 9 Series

Protocol rollover using Windows Media Player 9 Series

When Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control attempts to connect to the server using a URL with an mms:// prefix, the server automatically uses RTSP. If Fast Cache is enabled on the server (the default condition for all new publishing points), the server tries to connect to the client using RTSP with TCP-based transport (RTSPT) first. If the Player does not support that protocol, then the server attempts to connect using RTSP with UDP-based transport (RTSPU). If that connection is also not successful, the server will attempt to connect using the HTTP protocol if the WMS HTTP Server Control Protocol plug-in is enabled. If Fast Cache is not enabled, the server first tries to connect to the client using RTSPU, then RTSPT, and finally HTTP.

Earlier players

Protocol rollover using earlier versions of Windows Media Player

Earlier versions of Windows Media Player, such as Windows Media Player for Windows XP, do not support the RTSP protocol. However, the MMS protocol provides protocol rollover support for those players. Thus, when an earlier version of the Player attempts to connect to the server using a URL with an mms:// prefix, the server automatically negotiates the best protocol for the Player. The server first tries to connect to the client using MMS with UDP-based transport (MMSU). If that protocol is not supported, then the server attempts to connect using MMS with TCP-based transport (MMST). If that connection is also not successful, the server will attempt to connect using the HTTP protocol if the WMS HTTP Server Control Protocol plug-in is enabled.

Distribution servers

Protocol rollover is not used when a distribution server attempts to connect to an origin server. Distribution servers cannot use a URL with an mms:// prefix to request a connection to the origin server. If the distribution server attempts to connect using RTSP, that request is translated as RTSPU. If TCP-based transport is preferred or required, then the URL must use an rtspt:// prefix. If the servers must connect using HTTP, then the URL must use an http:// prefix.

Note Image Note

  • If the Windows Media server is separated from the client by a firewall or a proxy server that cannot pass UDP packets, you should disable UDP packet transmission in the WMS Unicast Data Writer plug-in properties. Clients that attempt to receive UDP transmissions through network components that are not UDP-enabled may experience latency during the protocol rollover process. For more information about the WMS Unicast Data Writer plug-in, see To configure the WMS Unicast Data Writer plug-in.

Related topics

  • Announcing content
  • Understanding protocols


How unicast works

Unicasting is a method of transmitting a single stream of data to a single client. Unicast delivery provides each client with an individual stream from the server. Clients that receive content through unicast delivery can connect to the server using any of the supported connection protocols.

Once the client has connected to the server, the content can be delivered through either the User Datagram Protocol (UDP) or the Transmission Control Protocol (TCP). The difference between these two protocols is how clients acknowledge the receipt of data packets.

If a UDP delivery method is used, such as MMSU or RTSPU, the server does not have to receive verification that a data packet was successfully received before transmitting another data packet. This method works best for streaming. If the client does not receive a packet, it can request that the server resend the missing data packet. This is known as a UDP resend request. When the server receives a request for a UDP resend, it checks its buffer to see if it still has the data available. If it does, the data is resent to the client. If it does not, the server cannot fulfill the request. The client can withstand some packet loss and can continue to render content even after an unsuccessful UDP resend request.

If a TCP delivery method is used, such as HTTP, MMST or RTSPT, the server must wait for the client to acknowledge a successful receipt of a data packet before it can send another. If the data packet is lost, the server must resend it before continuing with the data transmission. This method works best for connections between platform components, such as encoders, cache/proxy servers, and distribution servers, because it maintains the highest quality stream.

By default, Windows Media Services determines the optimum packet size for streaming based on the content. If you are streaming content over a unicast connection by using the RTSP protocol and are experiencing a high amount of packet loss or fragmentation, you may want to set a specific unicast packet size for your server by using the properties sheet of the WMS Unicast Data Writer plug-in. When determining the correct packet size for your server, consider the following:

  • If the packet size exceeds the capacity of the router that is forwarding it to the client, the packet is fragmented by the router, and then the fragments are sent to the client. When all of the packets are received by the client, they are reassembled into the original packet. This can result in a high amount of packet loss because the loss of any one of the fragments will result in the entire packet being lost.
  • Each packet sent by the server has an additional bandwidth requirement in order to transfer header information, such as the control protocol, stream format, and server address. Sending out a large number of small packets can result in a large increase in bandwidth use.
  • Each resend requires the same amount of bandwidth and time to send as the original data packet.
  • Different audiences can support varying packet sizes. Optimize your packet size for your target audience.
  • When using UDP with the RTSP protocol (RTSPU), setting the RTP packet size to too small a small value may prevent the Windows Media server from being able to stream.

Related topics

  • Understanding protocols
  • WMS Unicast Data Writer - general properties


How multicast works

Multicasting is a method of transmitting a single stream of data to multiple clients. Multicasting is connectionless; clients receive a multicast by monitoring a specific multicast IP address and port that receives the content stream from the server.

To successfully use multicast delivery with your server, your network must use multicast-enabled routers. Multicast-enabled routers are routers that are able to interpret class-D IP addresses use the Internet Group Management Protocol (IGMP) to route clients to the multicast IP address.

All multicast content must have a specified time-to-live value that limits the number of routers that the multicast can traverse before it expires.

The WMS Multicast Data Writer plug-in controls how the server uses multicast delivery with your publishing point. This plug-in is disabled by default and can only be enabled on broadcast publishing points.

This section contains the following topics:

  • About multicast IP addresses and ports
  • About time-to-live values

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Understanding protocols


About multicast IP addresses and ports

Multicast IP addresses are class D addresses that fall within two ranges: 224.0.0.0 through 239.255.255.255 and FF00:0000:0000:0000:0000:0000:0000:0000 through FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF:FFFF. The addresses in the first range are Internet Protocol version 4 (IPv4) addresses, which is the current version of the Internet Protocol. The addresses in the second range are IPv6 addresses, which is the new version of the protocol. For more information about implementing IPv6 addresses on your server, see Windows Help and Support.

For intranet use, it is recommended that you use IPv4 addresses in the range 239.*.*.*. Port numbers can range between 1 and 65535. The routers on the network over which you are transmitting your content must multicast-enabled, meaning that they must be able to interpret class D addresses or they will not be able to forward your multicast information to clients.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About time-to-live values
  • Understanding protocols


About time-to-live values

A multicast stream is distributed over a specific number of routers in a network, which is determined by the time-to-live (TTL) value. The time-to-live value decreases every time the content passes through a router. When the value reaches zero, the multicast stream travels no further. The WMS Multicast Data Writer plug-in has the following preset time-to-live values based on the type of distribution:

  • 1 : Local network
  • 32 : Intranet
  • 64 : Internet, intra-continent
  • 128 : Internet, inter-continent
  • 255 : Maximum-allowed value

You may also specify any whole number between 1 and 255 to meet the needs of your multicast.

If you use an IPv6 multicast address, the time-to-live value is included in the first field of the address. For example, the first field in the address FF01:0000:0000:0000:0000:0000:0000:0000 is FF01, which indicates the address is locally scoped, meaning that the content is restricted to the local computer and the time-to-live value is set to 1. The following list shows the standard first field values and their corresponding scopes:

  • FF01 : local node or computer
  • FF02 : local area network (LAN)
  • FF05 : local site
  • FF08 : organization
  • FF0E : Internet

Note Image Notes

  • IP addresses in the range 239.*.* are administratively scoped, which means that TTL values do not have a special meaning. For example, the value 32 does not limit the stream to an intranet, and the value 64 does not limit the stream to the intra-continent Internet. The TTL assignment should be used to limit addresses in the range 239.192.000.000 through 239.255.255.255 to a single organization, and addresses from 239.255.000.000 through 239.255.255.255 to a single site.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About multicast IP addresses and ports
  • Understanding protocols


Understanding Fast Streaming

Fast Streaming refers to a group of features included in Windows Media Services to improve the quality of streaming media content for the user. This topic includes the following sections:

  • Understanding Fast Cache
  • Understanding Fast Start
  • Understanding Fast Recovery
  • Understanding Fast Reconnect

Note Image Note

  • Fast Recovery is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Networking and content delivery


Understanding Fast Cache

When used with the Windows Media Player 9 Series, Fast Cache provides a way to stream content to clients faster than the data rate specified by the stream format. For example, using Fast Cache, the server can transmit a 128-kilobits-per-second (Kbps) stream at 700 Kbps. The stream is still rendered in Windows Media Player at the specified data rate, but the client is able to buffer a much larger portion of the content before rendering it. This allows the client to handle variable network conditions without a perceptible impact on the playback quality of either on-demand or broadcast content.

This ability is useful in the following situations:

  • When the available network bandwidth of the client exceeds the required bandwidth of the content; for example, clients that use a cable modem, DSL connection, or corporate intranets.
  • When the network connectivity is intermittent or has high latency; for example, wireless networks.
  • When the quality of the content received is of paramount importance; for example, businesses that provide pay-per-view movies.

You can configure the Fast Cache settings for your server on the Properties tab of your publishing point. For more information on these settings, see Enable Fast Cache and Limit Fast Cache content delivery rate. Fast cache is supported by both the RTSP and the HTTP protocols. Clients that connect using the MMS protocol will not receive the stream using Fast Cache, but will instead receive the standard bit rate stream.

Note Image Notes

  • When setting up distribution servers to use Fast Cache, use either the RTSPT or HTTP protocols to connect to the origin server. For more information about distribution servers, see Using distribution servers.
  • The RTSPU control protocol is incompatible with the Fast Cache feature and is not available when Fast Cache is enabled.
  • You can control the behavior of individual streams by adding Fast Streaming modifiers to the URL that a client uses to connect to the stream. For example, the WMCache modifier enables a client to use the Fast Cache feature when it uses the following URL format to connect to the server: http://servername/file.wmv?WMCache=1. You can also control the maximum bandwidth available to stream a file or live stream by using the modifiers WMBitrate and WMContentBitrate. For more information, see Controlling streaming behavior.
  • The Fast Cache feature is only used by clients that connect to a unicast stream.
  • If you are using Fast Cache with a server-side playlist, clients that connect to your server must use the RTSP or the HTTP 1.1 protocol to receive the benefit of the Fast Cache feature.
  • If you define the src attribute of a server-side playlist media element as being a publishing point on the local server using the lpp:// syntax, you must enable or disable player caching on the source publishing point. Changing the setting of the Enable Fast Cache property on any publishing point except the source will not affect the ability of players to cache content.

Related topics

  • Understanding Fast Streaming


Understanding Fast Start

Windows Media Player must buffer a certain amount of data before it can start rendering content. If your clients are using Windows Media Player for Windows XP or a later version of the Player you can use Fast Start to provide data directly to the buffer at speeds higher than the bit rate of the content requested. This enables users to start receiving content more quickly. After the initial buffer requirement is fulfilled, on-demand and broadcast content streams at the bit rate defined by the content stream.

Using Fast Start enables your users to have a better experience when playing back your content. Users can fast-forward and rewind content without additional delay and rebuffering. A Player that connects through broadband networks start playing the content more quickly, making the experience much more like viewing a television program or listening to a radio broadcast. Users will notice that server-side playlists streaming from your publishing point switch smoothly and seamlessly between content items. Additionally, the pre-buffering of data makes the Player resistant to playback errors due to lost packets or other network issues.

The increased bandwidth that the Fast Start feature initially uses to send data to the Player can overburden a network if many Players connect to the stream at the same time. To reduce the risk of network congestion caused by the Fast Start feature, you can limit the amount of bandwidth the Fast Start feature uses to stream to each Player. For more information about limiting Fast Start bandwidth, see Limit Fast Start bandwidth per player (Kbps).

Note Image Notes

  • Fast Start requires that Windows Media Services continuously maintain a buffer of content to be streamed to new clients. When the Start publishing point when first client connects property is enabled in a live broadcast publishing point, Fast Start can cause an additional rendering delay of 8 to 10 seconds for the first client that connects to the stream because Windows Media Services must first collect a content buffer. Clients connecting to a broadcast stream that is in progress will not experience any additional delays due to Fast Start buffering.
  • The Fast Start feature is only used by clients that connect to a unicast stream.

Related topics

  • Understanding Fast Streaming


Understanding Fast Recovery

Fast Recovery is accomplished by enabling forward error correction (FEC) on a publishing point. With the help of FEC, Windows Media Player can usually recover lost or damaged data packets without having to request that the data be resent by the Windows Media server. In environments that are subject to latency problems, such as satellite networks and other wireless networks, this process of receiving data is much more efficient. You can specify the amount of error correction data transmitted per span of data sent on the Forward Error Correction properties sheet.

Note Image Notes

  • Forward error correction can only be used with players that connect to your server through the RTSPU protocol.
  • The Fast Recovery feature is only used by clients that connect to a unicast stream.
  • Users may develop customized players that request FEC data packets. If you have not specified a number for the FEC packets per span setting, the server will attempt to deliver the amount of FEC data requested by the player. Excessive FEC data requests can cause the server's processor to be overloaded and may result in poor server performance. If you notice that the processor use is out of the normal range, set the FEC packets per span setting to a lower number.
  • Forward error correction is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Forward Error Correction - general properties
  • Understanding Fast Streaming
  • Using the RTSP protocol


Understanding Fast Reconnect

Fast Reconnect minimizes the impact to each client during a temporary network outage by enabling the client to reconnect to the server automatically and restart streaming. If the client was connected to an on-demand publishing point, the client restarts playback at the point at which the connection was lost by synchronizing itself with the content timeline. If the content includes video, the client estimates the approximate video frame at which the connection was lost. If the content is indexed, this estimate is more accurate. If the client is connected to a broadcast publishing point, the client reconnects to the broadcast in progress. Depending on the content, the user may experience a gap in the broadcast.

The following are some key details about the Fast Reconnect feature:

  • Fast Reconnect can be used with clients that connect through any of the default connection protocols (MMS, HTTP, and RTSP).
  • A successful reconnection is reflected in the log file with a status code of 210.
  • Both broadcast and on-demand publishing points can use the Fast Reconnect feature.

Note Image Notes

  • You can control the behavior of individual streams by adding Fast Streaming modifiers to the URL that clients use to connect to the stream. The WMReconnect modifier sets the number of times a client will attempt to reconnect to a stream if a connection is lost. For example, a client that connects to a stream using the following URL format will attempt to reconnect three times before stopping: http://servername/broadcast?WMReconnect=3. For more information, see Controlling streaming behavior.
  • The Fast Reconnect feature is only used by clients that connect to a unicast stream.

Related topics

  • Understanding Fast Streaming


Understanding content delivery

The topics in this section are designed to help you understand the processes used when delivering digital media content to users.

  • Working with data sources
  • Using distribution servers
  • Understanding variable-bit-rate content delivery
  • Understanding intelligent streaming

Related topics

  • Networking and content delivery


Working with data sources

Windows Media Services supports multiple data sources through the use of data source plug-ins. By default, Windows Media Services has the following data source plug-ins available:

  • WMS File Data Source plug-in. When the source of the content streamed by your publishing point is a located on a Common Internet File System (CIFS) Windows Media Services uses the WMS File Data Source plug-in to access the content. This plug-in is able to read data from any CIFS file system, including the NTFS file system, file allocation table (FAT), or FAT32, and can use the UNC address system. If you are storing your content by using an alternate file system, then you need to obtain a custom data source plug-in so that Windows Media Services can read the data.
  • WMS Network Data Source plug-in. When the source of the content streamed by your publishing point is another computer on your network, such as an encoder or another Windows Media server, Windows Media Services uses the WMS Network Data Source plug-in to access the content. This plug-in is able to read streaming data packets from a network and uses a control protocol plug-in to negotiate a connection to the network source.
  • WMS HTTP Download Data Source plug-in. When the source of the content streamed by your publishing point is a playlist that is retrieved from a Web server, Windows Media Services uses the WMS HTTP Download Data Source plug-in to transfer the playlist file from the Web server to the Windows Media server.
  • 7WMS Push Data Source plug-in. When the source of the content streamed by your publishing point originates from an encoder that is capable of pushing content, the encoder administrator has the option of broadcasting directly from the encoder or broadcasting through a Windows Media server. If the administrator chooses to broadcast through a Windows Media server, the encoder can initiate a connection to the Windows Media server, create a broadcast publishing point for its use, and send the stream over the network to the server. This series of events is commonly called an encoder push or push distribution, because the encoder initiates the connection to the server to broadcast the stream. In this situation, Windows Media Services uses the WMS Push Data Source plug-in to maintain the connection between the encoder and the server. This plug-in is able to accept incoming digital media data packets from an encoder.

    If the encoder administrator chooses to broadcast directly from the encoder, Windows Media Services can still initiate a connection to the encoder using the encoder connection URL and can then broadcast the stream. This scenario is known as encoder pull or pull distribution. In this situation, the WMS Network Data Source plug-in is used.

These data source plug-ins provide support for the most common streaming scenarios. You can use the Windows Media Services Software Development Kit (SDK) to create custom data source plug-ins to handle more specific scenarios.

Note Image Notes

  • Any data source accessed must have the appropriate permissions settings for Windows Media Services to retrieve the content from the location. By default, Windows Media Services uses the Network Service account when responding to network authentication and authorization requests. The Network Service account should be granted at least read access permissions for any data source you want to use with Windows Media Services. For more information see Understanding rights.
  • Custom or third-party plug-ins should be located in a protected directory to prevent tampering. The protected directory can be any directory that has been set to deny write permissions to unauthorized users. For more information about restricting directory access, see the Windows Help and Support Center.
  • If the content source for your publishing point is a computer running Windows 2000 Server you may have difficulty streaming the content because Windows 2000 Server and Windows Server 2003 handle user account authorization and privileges differently. If the two servers are members of the same domain, on-demand publishing points that have the WMS NTFS ACL Authorization plug-in enabled will cause remote clients to receive an "Access denied" error message when they attempt to retrieve content from the computer running Windows 2000 Server. Local clients, such as the Test stream feature of Windows Media Services, are not affected. If the two computers are not members of the same domain, see To access content on a computer running Windows 2000 Server.

Related topics

  • Data source category
  • Understanding content delivery


Using distribution servers

A distribution server publishes content received from another streaming source, such as another Windows Media server. Any computer running Windows Media Services can operate as a distribution server. The origin server is the source of the content being streamed by the distribution server. Clients then connect to the distribution server as if it were the origin server. Distribution servers are located between the origin server and the client in the content stream and are therefore able to perform several different functions, such as:

  • Load balancing. Distribution servers are an easy way to reduce the client load on your Windows Media server because you can distribute the client content requests to several servers on your network.

  • Network security policies. A distribution server can be placed inside your network firewall and source from an origin server that is outside your firewall, providing clients inside your firewall with access to the content without opening additional ports. Alternatively, a distribution server can be placed outside the network firewall and source from an origin server that is inside the firewall, providing clients that are outside the firewall with access to your content.

  • Server rollover. You can use distribution servers when multicasting content to clients that are on multicast-enabled networks. Clients that are not on multicast-enabled networks can be redirected to another distribution server for standard unicast delivery of the content.

Syntax for distribution server connections

Distribution servers connect to origin servers by using a connection protocol. Use the following information to determine the URL syntax that the distribution server should use.

Origin server | Scenario | Syntax
Windows Media Services 9 Series | Servers are on an intranet. Some data loss between servers is acceptable, so UDP transport can be used. | rtsp://server_name/publishing_point
Windows Media Services 9 Series | Servers are on an intranet. Data loss is not acceptable, so TCP transport must be used. | rtspt://server_name/publishing_point
Windows Media Services 9 Series | Servers are on separate networks and need to connect through a firewall. | http://server_name/publishing_point
Windows Media Services 9 Series (multicast) | Server is rebroadcasting a multicast stream to a network segment that is not multicast-enabled. | MCast://%systemdrive%\Wmpub\Wmroot\File.nsc -or- MCast://\\MachineName\Inetpub\Wwwroot\File.nsc
Windows Media Services 4.1 (unicast) | Server is rebroadcasting unicast content from a server running Windows 2000 Server. | http://server_name/publishing_point/file_name
Windows Media Services 4.1 (multicast) | Server is rebroadcasting multicast content from a server running Windows 2000 Server | mcast://\\server_name\shared_folder\station.nsc

For more information about control protocols, see Understanding protocols.

Note Image Note

  • When setting up distribution servers to use the Fast Streaming feature, use the RTSPU, RTSPT, or HTTP protocols to connect to the origin server. For more information about the Fast Streaming feature, see Understanding Fast Streaming.

Related topics

  • Understanding content delivery


Understanding variable-bit-rate content delivery

When encoding variable-bit-rate content, additional bandwidth is temporarily required in order to handle content that is challenging to encoding algorithms, such as high motion and highly detailed content. By using the additional bandwidth, the encoder can use more key frames and capture more detail, which improves the content quality. In the same encoded stream, simple content will require less bandwidth for compression. Thus, the overall quality of the content achieved by using variable-bit-rate encoding often exceeds the quality of the same content encoded by using a traditional encoding scheme.

When streaming variable-bit-rate content, the Windows Media server must be able to reallocate bandwidth based on the requirements of the stream, or it must be able to buffer the higher bit rate content on the Player in order for the Player to render it correctly. Therefore, when delivering variable-bit-rate content, it is recommended that both Fast Cache and Fast Start be used.

Related topics

  • Understanding content delivery
  • Understanding Fast Cache
  • Understanding Fast Start
  • Understanding Fast Streaming


Understanding intelligent streaming

Intelligent streaming refers to the method by which your Windows Media server works with Windows Media Player to detect network conditions and adjust the properties of a stream automatically to maximize playback quality. With intelligent streaming, users receive a continuous flow of content tailored to their specific connection speeds.

For the server to provide the full advantage of intelligent streaming, you should encode your content using multiple bit rates. Multiple-bit-rate (MBR) content contains several streams encoded at different bit rates, each of which usually corresponds to a common connection rate. When a distribution server is used to deliver multiple-bit-rate content, all of the streams are sent by the origin server to the distribution server. When multiple-bit-rate content is sent to a Player, either from the origin server or a distribution server, only the bit rate that is the most appropriate for current bandwidth conditions is streamed. Windows Media Player determines which bit rate stream to use and communicates this information to the Windows Media server, which then transmits the appropriate stream to the Player. The bit rate evaluation and selection process is completely invisible to the user. Windows Media Services can distribute both multiple-bit-rate streams from an encoder and multiple-bit-rate files.

Related topics

  • Understanding content delivery


Managing your Windows Media server

Using Windows Media Services, you can configure your Windows Media server to stream content over an intranet or the Internet. Before you begin streaming content, you must configure settings for your server running Windows Media Services, add and configure publishing points, and set up your content.

This section contains the following topics:

  • Administering servers
  • Using groups
  • Monitoring performance

Related topics

  • Configuring security options
  • Logging data and events
  • Sourcing from playlists, files, and encoders
  • Understanding publishing points


Administering servers

Windows Media servers can be administered by using the Windows Media Services snap-in or by using Windows Media Services Administrator for the Web. If you use the Windows Media Services snap-in, you can add any server that is running Windows Media Services to the console as long as you have administrative rights for the server. If you remove a server from the snap-in, you can still manage that server by using Windows Media Services Administrator for the Web. You can also use command-line scripts and custom programs created using the Windows Media Services 9 Series Software Development Kit (SDK) to administer your server.

This section contains the following topics:

  • Allowing or denying unicast client connections
  • Setting server limits
  • Using Windows Media Services Administrator for the Web

Related topics

  • Managing your Windows Media server
  • To start Windows Media Services on a server
  • To stop Windows Media Services on a server
  • Understanding publishing points


Allowing or denying unicast client connections

You can choose to allow or deny new unicast connections to your server or publishing point. Once you allow new connections, clients can connect to publishing points on a server and receive content.

If you deny new connections, new clients are prevented from connecting to the content, but current clients are not disconnected. As connected clients stop receiving content (when the stream ends or they disconnect from the server), the number of connections gradually decreases. You may want to deny client connections to your server when conducting various activities, such as updating your plug-in configuration, modifying server property settings, or modifying your content source. If these activities are performed while clients are connected to the server, there is a chance that streaming will be interrupted for a short period of time.

Note Image Notes

  • If you choose to deny new connections, a client that is connected through HTTP will be disconnected from the server if the user attempts to stop, pause, fast-forward, or rewind content.
  • You can only deny or allow connections to clients that are receiving content as a unicast stream. If clients are receiving the content as a multicast stream, you must stop the broadcast publishing point in order to disconnect them from the content.

Related topics

  • Controlling unicast connections to a publishing point
  • To allow unicast connections to a server
  • To deny unicast connections to a server


Setting server limits

To manage server resources, you can set limits for a number of connection parameters. Limits set at the server level apply to all of the publishing points on that server. You can set the limits for the following parameters on the Properties tab:

  • Limit player connections. Sets the maximum number of player connections.
  • Limit outgoing distribution connections. Sets the maximum number of distribution servers that can connect to this origin server.
  • Limit aggregate player bandwidth. Specifies the maximum amount of bandwidth in kilobits per second (Kbps) that all player connections can use.
  • Limit aggregate outgoing distribution bandwidth. Specifies the maximum amount of bandwidth in Kbps that distribution server connections can use.
  • Limit bandwidth per stream per player. Specifies the maximum amount of bandwidth in Kbps that a single player connection can use.
  • Limit bandwidth per outgoing distribution stream. Specifies the maximum amount of bandwidth in Kbps that a single distribution server connection can use.
  • Limit connection rate. Specifies the maximum number of connection requests processed per second. The default value is 50.
  • Limit player timeout inactivity. Specifies the number of seconds that a player can remain connected but inactive before being automatically disconnected. The default value is 86,400 seconds (24 hours). This default value supports users pausing playback of content for an extended period of time and then restarting playback without having to reconnect to the server.
  • Limit connection acknowledgement. Specifies the number of seconds that the server will wait for the player to respond to a connection acknowledgement request before disconnecting the player. Connection acknowledgement requests are sent to the player by the server to verify the connection to the player. The default value is 60 seconds. If you are streaming in an environment with high latency, consider increasing this value to correspond with network conditions.

When a limit is reached, subsequent connection requests are refused, and a limit hit event is displayed in the Troubleshooting event list.

Related topics

  • To set limits for a server or publishing point
  • Using distribution servers


Using Windows Media Services Administrator for the Web

Windows Media Services Administrator for the Web enables you to administer Windows Media servers remotely by using a browser such as Internet Explorer. Windows Media Services Administrator for the Web has most of the functionality of the Windows Media Services snap-in, but it also enables you to administer Windows Media servers in diverse scenarios, including servers that are separated from server administrators by firewalls, servers that are using a low-bandwidth network connection, or servers that are in a non-Windows environment. Using the Windows Media Services Administrator for the Web, you can perform common tasks such as creating and starting publishing points, monitoring publishing point activity, and configuring plug-ins. Tasks that require a fixed network location, such as creating announcement files, browsing folders, and creating and editing playlists, however, can only be done with the Windows Media Services snap-in.

Windows Media Services Administrator for the Web is a complete Web site that is hosted on your Windows Media server by Microsoft Internet Information Services (IIS). You can add Windows Media Services Administrator for the Web during installation or at any time using the Windows Components Wizard. After adding Windows Media Services Administrator for the Web, it is recommended that you configure an appropriate level of security for the administration Web site to protect data transferred between a remote computer and your Windows Media server and to protect your network from unauthorized access. For more information, see Securing the Windows Media Administration site.

Once you have installed Windows Media Services Administrator for the Web, configured the appropriate security settings, and started the Web site, you can access the Web site from any browser that supports Active Server Pages (ASP). Windows Media Services Administrator for the Web is useful if you want to administer one or more servers from a single location or if physical or network access to the server is difficult, such as when you administer a server across a network firewall. Windows Media Services Administrator for the Web is also useful for use in temporary remote locations. For example, you could use Windows Media Services Administrator for the Web to control broadcast publishing points from a remote location where you are producing and encoding a live event.

Once the main administration Web site has been opened remotely, Windows Media Services Administrator for the Web requires only a small amount of bandwidth. To access Windows Media Services Administrator for the Web, you must log on to the remote computer using an account that has administrative privileges. If you would like to provide non-administrators with access to Windows Media Services Administrator for the Web, you can modify the security settings in Windows Media Services to give specified users rights to administer the server. For more information, see Limiting user rights.

The system requirements for the server hosting Windows Media Services Administrator for the Web are roughly equivalent to those of a server running Windows Media Services. For more information about system requirements, see Windows Media Services Administrator for the Web.

Note Image Note

  • Windows Media Services Administrator for the Web can only be installed on an NTFS-formatted drive.

Related topics

  • Managing your Windows Media server
  • To install and use Windows Media Services Administrator for the Web


Using groups

By grouping servers, you can monitor their performance in one area of the Windows Media Services snap-in, making it possible to organize your servers according to your needs. For example, you can group your servers by administrative area, business application, geographic location, or content source.

The group summary page provides the total number of players and the total amount of bandwidth being used by the server group. This allows you to determine when to add additional resources or when to establish limits on your servers. It also provides a quick way to see the status for all the servers in your group.

Note Image Note

  • This information only applies to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • About groups
  • To add a group
  • To add a server to a group
  • To export a console configuration
  • To import a console configuration


Monitoring performance

There are many different methods that you can use to monitor the performance of your Windows Media server.

  • Monitor tab. This tab is available for both the server itself and for each publishing point on the server. It provides a general overview of the activity on the server or publishing point. For more information, see About the Monitor tab for a server and About the Monitor tab for a publishing point.
  • Windows Performance Monitor. This feature, accessible from the Monitor tab, provides a graphical view of several different performance counters. It can be customized to display the statistics that are most important in your system. For more information, see Using Windows Media performance counters.
  • SNMP object monitoring. Windows Media Services provides extensive support for Simple Network Management Protocol (SNMP) objects and traps. For more information, see About the Windows Media SNMP objects.
  • WMI event monitoring. Windows Media Services is a fully extensible Windows Management Instrumentation (WMI) provider. Your WMI monitoring application can subscribe to WMI events from Windows Media Services in the same way that it uses events from other providers. For more information, see Subscribing to Windows Media WMI events.

This section contains the following topics:

  • Using Windows Media performance counters
  • About the Windows Media SNMP objects
  • Subscribing to Windows Media WMI events

Note Image Note

  • The default settings for SNMP service access in Windows Server 2003 prevent unauthorized access to your server. If you are using SNMP to monitor a local server, you do not need to change the SNMP service settings. If you plan to use SNMP objects to monitor your server from another computer, you must authorize remote access to your SNMP service by configuring the SNMP Services Properties settings on the Windows Media server to accept SNMP packets from the remote computer that you want to use to monitor the Windows Media server.

Related topics

  • Setting publishing point limits
  • Setting server limits


Using Windows Media performance counters

Windows Media Services provides two sets of performance object counters that you can use to monitor your Windows Media servers and publishing points: Windows Media Services and Windows Media Publishing Points.

On the Monitor tabs of both your server and publishing point, you can click the Performance button to open a performance monitor that reports the most commonly used Windows Media performance counters for the selected object. You can add or remove counters from the monitor to suit your needs.

Windows Media performance counters can provide useful information in the following scenarios:

  • Real-time usage statistics. Performance counters provide information about the current usage of the server, such as the number of currently connected players, the amount of bandwidth utilization, and the number of distribution streams.
  • Identify streaming problems. Performance counters can provide information to help you identify and troubleshoot issues in your streaming system, such as the number of stream errors and resend requests.
  • Monitor encoder and distribution streams. Encoder and distribution server packet counters help identify when streams from an encoder or streams through a distribution server are failing.
  • Report peak usage. Most counters provide peak values, which enable you to track the maximum capacity of your system.

The following table identifies the performance monitor counters that are available for each performance object.

Performance monitor counter name and description | Windows Media Services | Windows Media Publishing Points
Current Cache Downloads The number of concurrent streams being downloaded to the memory area of the cache/proxy server. | X |
Current Connected Players The current number of players with unicast connections to the server. This number does not include distribution server connections. | X | X
Current Connection Queue Length The current number of connection requests that are pending on the server from both players and distribution servers. | X |
Current Connection Rate The current number of clients per second that are connecting to the server. | X |
Current File Read Rate The current rate, in kilobits per second (Kbps), at which data packets are read from a file. | X | X
Current Incoming Bandwidth The current bandwidth, in Kbps, allocated for streams from other servers. | X | X
Current Late Read Rate The current number of data packets per second that take longer than 400 milliseconds to read from the file system. | X | X
Current Late Send Rate The current number of packets that are sent out 0.5 seconds or more after the marked send time. | X |
Current Outgoing Distribution Allocated Bandwidth The current bandwidth, in Kbps, allocated for streams to distribution servers. | X | X
Current Outgoing Distribution Connections The current number of distribution servers that are connected to this server. | X | X
Current Outgoing Distribution Send Rate The current rate, in Kbps, at which data packets are being streamed to distribution servers. | X |
Current Player Allocated Bandwidth The current amount of bandwidth, in Kbps, that is allocated for all streams to players. | X | X
Current Player Send Rate The current rate, in Kbps, at which data packets are being streamed to players. | X |
Current Stream Error Rate The current number of errors per second due to dropped packets. | X | X
Current Streaming HTTP Players The current number of players that are being streamed data through the HTTP protocol. This does not include players that are stopped or paused. | X | X
Current Streaming MMS Players The current number of players that are being streamed data through the MMS protocol. This does not include players that are stopped or paused. | X | X
Current Streaming Players The current number of players that are being streamed data across all protocols. This does not include players that are stopped or paused. | X | X
Current Streaming RTSP Players The current number of players that are being streamed data through the RTSP protocol. This does not include players that are stopped or paused. | X | X
Current UDP Resend Requests Rate The current number of requests for UDP resends per second received from clients. | X |
Current UDP Resends Sent Rate The current number of UDP resends per second sent to clients. | X |
Peak Connected Players The peak number of players that have connected since the last time the counter was reset. | X | X
Peak Outgoing Distribution Allocated Bandwidth The peak bandwidth, in Kbps, allocated for all streams to distribution servers that have connected since the last time the counter was reset. | X | X
Peak Outgoing Distribution Connections The peak number of distribution servers that have connected since the last time the counter was reset. | X | X
Peak Outgoing Distribution Send Rate The peak rate, in Kbps, at which data was streamed to distribution servers since the last time the counter was reset. | X |
Peak Player Allocated Bandwidth The peak bandwidth, in Kbps, that has been allocated for all streams to players since the last time the counter was reset. | X | X
Peak Player Send Rate The peak rate, in Kbps, at which data was streamed to players since the last time the counter was reset. | X |
Peak Streaming Players The peak number of players that have been streamed data concurrently since the last time the counter was reset. | X | X
Total Advertisements The total number of advertisements that have been streamed from playlists since the last time the counter was reset. | X | X
Total Connected Players The total number of players that have connected to the server since the last time the counter was reset. | X | X
Total File Bytes Read The total number of bytes read from files by the server since the last time the counter was reset. |  | X
Total Late Reads The total number of times that the server required more than 400 milliseconds to read data from the file system since the last time the counter was reset. | X | X
Total Late Sends The total number of times the server sent out data packets 0.5 seconds or more after the marked send time since the last time the counter was reset. | X |
Total Outgoing Distribution Bytes Sent The total number of bytes streamed to all distribution servers since the last time the counter was reset. | X | X
Total Outgoing Distribution Connections The total number of distribution servers that have connected to the server or publishing point since the last time the counter was reset. | X | X
Total Player Bytes Sent The total number of bytes streamed to all players since the last time the counter was reset. | X | X
Total Server Uptime The elapsed time, in seconds, that the Windows Media Services service has been running since it was last started. | X |
Total Stream Denials The total number of times the server refused to send a requested stream to a client since the last time the counter was reset. This includes denials that occurred due to failure to be authorized or authenticated, as well as denials that occurred because limits were exceeded. | X | X
Total Stream Errors The total number of stream errors due to dropped packets since the last time the counter was reset. | X | X
Total Stream Terminations The total number of streams that were terminated due to inactivity or errors since the last time the counter was reset. This includes terminations that occurred because player inactivity and timeout limits were exceeded, as well as terminations due to events such as late reads. | X | X
Total Streaming Players The total number of players that have been streamed data since the last time the counter was reset. | X | X
Total UDP Resend Requests The total number of requests for UDP resends received from clients since the last time the counter was reset. | X |
Total UDP Resends Sent The total number of UDP resends sent to clients since the last time the counter was reset. | X |

Note Image Note

  • Windows Media Services has built-in support for cache/proxy plug-ins. In the performance monitor Add Counters dialog box, you will see the following additional publishing point instances: Cache/Proxy Broadcast and Cache/Proxy On-Demand. These publishing points are only active if you have installed a cache/proxy server plug-in and are using your server as a cache/proxy server. For more information on cache/proxy servers, see Caching and proxying content.

Related topics

  • Monitoring performance


About the Windows Media SNMP objects

Windows Media Services provides support for Simple Network Management Protocol (SNMP)-based management consoles through an extensive set of SNMP objects. These objects are defined in the Windows Media Services SNMP management information base file WMSSNMP.mib, which is located on your Windows Media server in %systemroot%\System 32\Windows Media\Server.

To use Windows Media Services SNMP objects, you must first register the DLL Wmssnmp.dll. For more information about registering the DLL, see To register Windows Media Services SNMP objects for SNMP monitoring.

It is recommended that you configure your server to use Internet Protocol security (IPSec) for SNMP data transfers. Otherwise, the SNMP service will transfer data in clear text, which means that the data could be intercepted and decoded by network analyzers. IPSec encrypts data and communications between the SNMP agent and management stations, so the information is safer from interception.

If you decide to use IPSec for SNMP data transfers, you should create an IPSec policy on your computer that filters data transferred on both UDP and TCP ports 161 and 162 and that uses Kerberos authentication. For more information about creating Internet Protocol security policies, see Windows Help and Support.

The following table lists the objects that you can receive in your SNMP browser. All of the objects have read-only access.

Object and description | Syntax
wmsCurrentPlayerAllocatedBandwidth The current bandwidth, in kilobits per second (Kbps), that is allocated for streams to all players. | INTEGER
wmsCurrentOutgoingDistributionAllocatedBandwidth The current bandwidth, in Kbps, that is allocated for streams to distribution servers. | INTEGER
wmsCurrentConnectedPlayers The current number of players with unicast connections to the server. | INTEGER
wmsCurrentConnectionQueueLength The current number of connection requests that are pending on the server. | INTEGER
wmsCurrentConnectionRate The current number of clients per second that are connecting to the server. | INTEGER
wmsCurrentStreamingHttpPlayers The current number of players that are being streamed data through the HTTP protocol. This number does not include players that are stopped or paused. | INTEGER
wmsCurrentStreamingMmsPlayers The current number of players that are being streamed data through the MMS protocol. This number does not include players that are stopped or paused. | INTEGER
wmsCurrentOutgoingDistributionConnections The current number of connections to distribution servers. | INTEGER
wmsCurrentStreamingRtspPlayers The current number of players that are being streamed data through the RTSP protocol. This number does not include players that are stopped or paused. | INTEGER
wmsCurrentStreamingPlayers The current number of players that are being streamed data across all protocols. This number does not include players that are stopped or paused. | INTEGER
wmsCurrentCacheDownloads The current number of streams downloaded to a cache server that have not yet expired. | INTEGER
wmsCurrentOutgoingDistributionSendRate The current rate, in Kbps, at which data is being streamed to distribution servers. | INTEGER
wmsCurrentPlayerSendRate The current rate, in Kbps, at which data is being streamed to players. | INTEGER
wmsCurrentLateReadRate The current number of data packets per second that take longer than 400 milliseconds to read from the file system. | INTEGER
wmsCurrentLateSendRate The current number of packets that are sent out 0.5 seconds or more after the marked send time. | INTEGER
wmsCurrentStreamErrorRate The current number of errors per second due to dropped packets. | INTEGER
wmsCurrentUdpResendRequestsRate The current number of requests for UDP resends per second received from clients. | INTEGER
wmsCurrrendUdpResendsSentRate The current number of UDP resends per second sent to clients. | INTEGER
wmsPeakPlayerAllocatedBandwidth The peak bandwidth, in Kbps, allocated for all streams to players since the last time the counter was reset. | INTEGER
wmsPeakOutgoingDistributionAllocatedBandwidth The peak bandwidth, in Kbps, allocated for all streams to distribution servers that have connected since the last time the counter was reset. | INTEGER
wmsPeakConnectedPlayers The peak number of players that have connected since the last time the counter was reset. | INTEGER
wmsPeakOutgoingDistributionConnections The peak number of distribution servers that have connected since the last time the counter was reset. | INTEGER
wmsPeakOutgoingDistributionSendRate The peak rate, in Kbps, at which data was streamed to distribution servers since the last time the counter was reset. | INTEGER
wmsPeakPlayerSendRate The peak rate, in Kbps, at which data was streamed to players since the last time the counter was reset. | INTEGER
wmsPeakStreamingPlayers The peak number of players that have been streamed data concurrently since the last time the counter was reset. | INTEGER
wmsTotalConnectedPlayers The total number of players that have been connected to your server since the last time the counter was reset. | INTEGER
wmsTotalOutgoingDistributionConnections The total number of distribution servers that have connected since the last time the counter was reset. | INTEGER
wmsTotalLateReads The total number of times that the server required more than 400 milliseconds to read data from the file system since the last time the counter was reset. | INTEGER
wmsTotalLateSends The total number of times the server sent out data packets 0.5 seconds or more after the marked send time. | INTEGER
wmsTotalStreamDenials The total number of times the server refused to send a requested stream to a client since the last time the counter was reset. This includes both denials that occurred due to failure to be authorized or authenticated, as well as denials that occurred because limits were exceeded. | INTEGER
wmsTotalStreamErrors The total number of stream errors due to dropped packets since the last time the counter was reset. | INTEGER
wmsTotalStreamingPlayers The total number of players that have been streamed data since the last time the counter was reset. | INTEGER
wmsTotalStreamTerminations The total number of streams that were terminated due to inactivity or errors since the last time the counter was reset. This includes terminations that occurred because player inactivity and timeout limits were exceeded, as well as terminations due to events such as late reads. | INTEGER
wmsTotalUdpResendRequests The total number of requests for UDP resends received from clients since the last time the counter was reset. | INTEGER
wmsTotalUdpResendsSent The total number of UDP resends sent to clients since the last time the counter was reset. | INTEGER
wmsTotalServerUptime The elapsed time, in seconds, that the Windows Media Services service has been running since it was last started. | INTEGER
wmsTotalAdvertisements The total number of advertisements that have been streamed from playlists since the last time the counter was reset. | INTEGER
wmsTotalPlayerBytesSent The total number of bytes streamed to all players since the last time the counter was reset. | Counter64
wmsTotalOutgoingDistributionBytesSent The total number of bytes streamed to all distribution servers since the last time the counter was reset. | Counter64

Note Image Note

SNMP services are not installed by default with either the Windows Server 2003 operating system or Windows Media Services. Before attempting to use Windows Media Services SNMP objects, ensure that SNMP services are installed on your computer. For more information about installing SNMP services, see Windows Help and Support.

Related topics

  • Monitoring performance
  • To register Windows Media Services SNMP objects for SNMP monitoring


Subscribing to Windows Media WMI events

If you are using a Windows Management Instrumentation (WMI)-based console to manage your servers, you can subscribe to different WMI events that report on your Windows Media server activity and set alerts that enable you to respond to situations as they arise. Windows Media Services includes the WMS WMI Event Handler plug-in. WMI is the Microsoft implementation of Web-Based Enterprise Management (WBEM), which is an industry initiative to develop a standard technology for accessing management information in an enterprise environment. WMI uses the Common Information Model (CIM) industry standard to represent systems, applications, networks, devices, and other managed components in an enterprise environment. For more information about WMI events and classes, see the Windows Media Services SDK at the Microsoft Web site.

Related topics

  • Monitoring performance


Understanding publishing points

Windows Media Services uses publishing points to translate a client request for content into a physical path on the server hosting the content. After a client successfully connects to a publishing point, your Windows Media server manages the connection and streams the content. This section contains the following topics:

  • About publishing point types
  • Adding publishing points
  • Configuring publishing points
  • Streaming from publishing points
  • Archiving content

Related topics

  • Concepts
  • Sourcing from playlists, files, and encoders
  • Understanding streaming media


About publishing point types

Clients access content streams from your server by connecting to a publishing point. Windows Media Services includes two types of publishing points: on-demand and broadcast. Either type can be configured to deliver a stream from one of several types of sources, such as a live stream from an encoder, a file, or a playlist. One Windows Media server can be configured to run multiple publishing points, hosting a combination of broadcast and on-demand content.

The two types of publishing point are similar in many ways, but have a few important differences. In general, you would use an on-demand publishing point if you want the client to control playback; a broadcast publishing point if you want to control playback on the server. This section describes more differences between the two types of publishing point. Keep this information in mind when choosing the type of publishing point you want to use to stream content. This section includes the following topics:

  • Using on-demand publishing points
  • Using broadcast publishing points

Related topics

  • Understanding publishing points
  • Working with the Add Publishing Point Wizard


Using on-demand publishing points

Streaming content from an on-demand publishing point is best suited for scenarios in which you want users to be able to control playback of the content that is being streamed. This type of publishing point is most often used to host content sourced from files, playlists, or directories. When a client connects to the publishing point, the content starts at the beginning and the end-user can use the playback controls on the Player to pause, fast-forward, rewind, skip between items in a playlist, or stop.

An on-demand publishing point streams content only when a client is connected to receive the stream. Content streamed from an on-demand publishing point is always delivered as a unicast stream, which means that the server maintains a separate connection with each client.

An on-demand publishing point can also be used to deliver a broadcast stream from an encoder, a remote server, or another publishing point. Any of these can be selected as the sole source of content or included as part of a content playlist. When content originates from a source other than the Windows Media server, the user cannot use the playback controls on the Player to pause, fast-forward, rewind, skip items in a playlist, or stop.

Note Image Notes

  • The ability to fast-forward, skip, rewind, and pause while playing content from a server-side playlist is only supported by Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control. Users that are connecting with a previous version of the Player will not be able to control the playback of the content in the server-side playlist. If these users stop and then restart the Player, playback will start from the beginning of the playlist.
  • If your publishing point is accessing files on a computer running Windows 2000 Server as a source of content, you may have difficulty streaming the content due to differences in the way that Windows 2000 Server and Windows Server 2003 handle user account authorization and privileges. If the two computers are members of the same domain, on-demand publishing points that have the WMS NTFS ACL Authorization plug-in enabled and attempt to retrieve content from a computer running Windows 2000 Server will cause remote clients to receive an "Access denied" error message. Local clients, such as the Test stream feature of Windows Media Services, are not affected. If the two computers are not members of the same domain, see To access content on a computer running Windows 2000 Server.

Related topics

  • Delivering content as a unicast stream
  • Reference for content sources


Using broadcast publishing points

Streaming content from a broadcast publishing point is best suited for scenarios in which you want to create an experience similar to viewing a television program—the content is controlled and streamed at the point of origin or the server. This type of publishing point is most often used to deliver live streams from encoders, remote servers, or other broadcast publishing points. When a client connects to a broadcast publishing point, the client is joining a broadcast that is already underway. For example, if a company-wide meeting is broadcast at 10:00 A.M., clients connecting at 10:18 A.M. have missed the first 18 minutes of the meeting. A client can start and stop the stream, but cannot pause, fast-forward, rewind, or skip.

You can also stream files and playlists of files on a broadcast publishing point. When they are sourced by a broadcast publishing point, the file or playlist is sent as a broadcast stream by the server and the player cannot control playback as it can with an on-demand stream. The user experience is just like that of receiving a broadcast of a live encoded stream; the client begins playing the stream in progress.

Typically, a broadcast publishing point streams as soon as it is started and then continues until it is stopped or the content finishes. However, you can configure a broadcast publishing point to start and run automatically only if one or more clients are connected. By doing so, network and server resources are saved when no clients are connected.

You can deliver content from a broadcast publishing point as either a unicast or multicast stream. You can save the stream from a broadcast publishing point as an archive file and then offer the file to end-users as an on-demand replay of the original broadcast. For more information, see Archiving content.

Note Image Notes

  • Manually starting a broadcast publishing point overrides the Start publishing point when first client connects property. If you want the broadcast publishing point to start and stop automatically based on client connections, do not start the publishing point manually.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Adding publishing points
  • Delivering content as a multicast stream
  • Delivering content as a unicast stream
  • Reference for content sources


Adding publishing points

The publishing points on your server are listed in the console tree. By clicking a publishing point in the list, you can modify or view its settings in the details pane. By clicking Publishing Points in the console tree, you can view a list of all existing publishing points in the details pane. You can also perform basic tasks such as adding, configuring, and removing publishing points.

When you install Windows Media Services, a broadcast and an on-demand publishing point are set up automatically. You can use these initial publishing points as they are provided, modify them to suit your needs, or remove them and add your own publishing points. The on-demand publishing point is designated as the default. A client connecting to a Windows Media server typically must use the server and publishing point names as part of the address. If no publishing point name is given, the Windows Media server will direct the request to the Default publishing point.

The following information is required to add a publishing point:

  • Type of publishing point. Broadcast or on-demand. The type of publishing point you use depends on the scenario you are implementing.
  • Name for the publishing point. The name, which will become part of the URL a client uses to access content. Use a meaningful name, such as the type of content to be streamed from the publishing point (for example, MusicCDs). The name is not case-sensitive.
  • Source location. The source of a publishing point, which can be a file, a directory of files, a playlist, a stream from an encoder, a publishing point on a remote Windows Media server, or a local publishing point. You must specify the location and name of the source. For example, you could specify a directory of files as %systemdrive%\Wmpub\Wmroot or as \\RemoteServer\Wmpub\Wmroot.
  • Delivery method. When adding a broadcast publishing point, you have the choice of unicast streaming or multicast streaming. Multicast streaming offers a unicast rollover feature that allows clients to connect to your broadcast even if they are unable to receive multicast streams.

Windows Media Services provides two methods for adding a publishing point: the Add Publishing Point Wizard and the Add Publishing Point (Advanced) dialog box. In addition to gathering this primary information, the wizard also helps you configure the publishing point. For example, with the wizard, you can create an announcement file, create a wrapper playlist, add media elements to a playlist and immediately start a broadcast publishing point after the wizard finishes. For advanced users, the Add Publishing Point (Advanced) dialog box can be a faster alternative to the wizard when you are creating simple publishing points. For more information about announcement files, see Streaming from publishing points.

After adding a publishing point, you can configure publishing point properties, and modify your publishing point settings further. The Monitor, Source, Advertisement, Publish, and Properties tabs contain the tools with which you can make modifications and view settings. For more information, see Configuring publishing points.

You can also perform the following tasks with publishing points:

  • Duplicating a publishing point. By duplicating a publishing point, you create a copy on the same server that includes all of the settings of the original publishing point, such as the source path, plug-in configuration, and property settings. This feature can help you set up your system more efficiently. For example, if you are planning to implement the same policies on all of the publishing points on your server, but want to specify different sources for each, you can make copies of your basic setup, then change the sources on each of the copies.
  • Renaming a publishing point. The publishing point name is part of the address that the client uses to connect to the publishing point. If you rename a publishing point, keep in mind that announcement files and Web pages that referenced the old name will need to be updated.
  • Removing a publishing point. When a publishing point is no longer needed, it is a good idea to remove it in order to avoid clutter and confusion with more current publishing points. When you remove a publishing point, only the publishing point and its settings are deleted. Source content such as files, directories, playlists, and any related data such as announcement files and log files are not removed or changed.

This section contains the following topics:

  • About the Default publishing point
  • Protecting the Default publishing point

Note Image Notes

  • When naming a publishing point, avoid names that are identical to those of directories on your Windows Media server. A publishing point with the same name as a directory may interfere with another publishing point that sources from that directory.
  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are sourcing from a location other than C:\WMPub and its subdirectories, make sure that the folder is shared and that the Network Service account has at least read permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to stream content from it. For more information about rights and permissions, see Understanding rights.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About publishing point types
  • Sourcing from playlists, files, and encoders
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • Understanding publishing points


About the Default publishing point

When you install Windows Media Services, a default on-demand publishing point is added to the server automatically. This publishing point uses the %systemdrive%\WMPub\WMRoot folder as the source for its content. For security reasons, the Default publishing point does not allow unicast connections by default. After you place files in the %systemdrive%\WMPub\WMRoot folder and allow unicast connections to the Default publishing point, you can begin streaming content. You can manage the Default publishing point in the same way you would manage any other publishing point on your server. For example, you can choose a different source of content, enable and disable plug-ins, and create announcement files for it.

The benefit of using the Default publishing point is that it allows users to access content on your server through a simplified URL. When streaming from an on-demand Default publishing point, the corresponding URL to receive the stream consists of the connection protocol, the Windows Media server name, and the file name (for example, mms://server_name/file_name). The publishing point does not need to be specified in the URL. If you are streaming from a broadcast Default publishing point, you also do not need to include the file name in your URL; for example, mms://server_name.

A Default publishing point is not necessary to the operation of the Windows Media server. To remove a default assignment from a publishing point, you only need to rename it. Once it has been renamed, you can assign a different publishing point as the default.

Related topics

  • Protecting the Default publishing point
  • Reference for content sources
  • Sourcing from playlists, files, and encoders
  • To assign a publishing point as the Default publishing point


Protecting the Default publishing point

During installation of Windows Media Services, an on-demand Default publishing point and a sample broadcast publishing point are added. To prevent unauthorized access to the publishing points immediately after installation, two security measures are added: the Default publishing point is set to deny all connections, and the Start publishing point when first client connects property of the sample broadcast publishing point is disabled. In order to use the Default publishing point, you must first configure it to allow connections.

If you do not change the access properties of these publishing points and attempt to test a stream by clicking the Test button on the Source tab, you will receive a warning message that access is denied on a publishing point and you will be asked if you want to change the setting. Clicking Yes will automatically change the setting and the test will begin.

Related topics

  • About the Default publishing point
  • To allow unicast connections to a publishing point


Configuring publishing points

This section provides an overview of the methods you can use and properties you can modify to configure a publishing point. Details about individual items and how to configure them are provided through links to other areas of Windows Media Services Help.

Content sources

A publishing point is the portal through which a client connects to receive a stream. The source is the location of the content that a client can receive from a publishing point. You can assign any of several different types of sources to a publishing point, such as a file, a directory of files, a content playlist, or a live stream from an encoder.

Dynamic content sources can be created for use with Windows Media Services. A dynamic source is typically a playlist created by a client-side agent and used with an on-demand publishing point. For more information about dynamic sources, see Using dynamic sources.

The range of content sources can be expanded further through the use of custom data source plug-ins. The Windows Media Services SDK enables you to create and customize data source plug-ins to suit your needs.

Streaming properties

On the Properties tab, you can change property settings and add plug-ins that modify how a publishing point streams content. Publishing point properties affect the way the publishing point operates, while plug-ins can add functionality to the publishing point. Windows Media Services includes several of the most commonly used plug-ins as part of the installation. Additional plug-ins can be created by using the Windows Media Services SDK or can be obtained from third-party vendors. For more information about the standard properties and plug-ins that are included with Windows Media Services, see About properties and plug-ins.

Client logging

Logging can be enabled on a publishing point to capture usage information on clients connecting to unicast and multicast streams. Logs can be used for several different purposes, including advertiser feedback, troubleshooting, and subscriber billing. To log data about unicast clients, the WMS Client Logging plug-in is enabled. Multicast logging is provided by the Windows Media Internet Server Application Programming Interface (ISAPI) extension (wmsiislog.dll). For more information, see Logging data and events.

Security

You can control access to a publishing point by configuring and enabling one or more security-related plug-ins. The authentication and authorization plug-ins have the most direct effect on publishing point security, but there is a wide range of additional measures you can take to improve the security of your publishing point. You can also control access by placing limits on client connections. By limiting certain aspects of streaming behavior (such as the number of client connections or the bandwidth used for each client), you can also limit the effect that a malicious attack will have on your publishing point performance.

Related topics

  • Adding publishing points
  • Configuring security options
  • Controlling unicast connections to a publishing point
  • Setting publishing point limits
  • Streaming from publishing points
  • Work with publishing points


Controlling unicast connections to a publishing point

The options for controlling client connections depend on the type of publishing point you use. You can find tools to control client connections to your publishing point on the Monitor, Source, and Properties tabs.

On-demand publishing points

To control client connections to on-demand publishing points, use the following buttons on the Monitor tab:

  • Deny. Prevents new connections to the publishing point, but does not disconnect currently connected clients. As connected clients stop receiving the stream and disconnect from the server, the number of connections gradually decreases.
  • Allow. Enables the publishing point to begin accepting new unicast connections.
  • Disconnect all. Immediately disconnects all currently connected clients. (To prevent new connections, you should also deny new connections.)

Broadcast publishing points

To enable clients to receive content from a broadcast publishing point, use one of the following options:

  • Enable the automatic start feature. For publishing points that are delivering content as a unicast stream, this feature is controlled by the Start streaming when first client connects property that is enabled by default in the General category on the Properties tab. When you use the automatic start feature, a broadcast publishing point does not start until the first client connects. This feature is useful when you are sourcing from an encoder or distribution server and want to minimize bandwidth usage. If only one client is connected to the publishing point and that client disconnects, the server closes the connection with the encoding computer and stops streaming the content after 30 seconds, thus saving bandwidth. If another client connects, the server automatically reconnects to the encoding computer and resumes streaming the content.
  • Start the publishing point. When you start a broadcast publishing point manually (for example, by clicking the Start button), the content begins streaming regardless of whether any clients are connected. A client connecting to the broadcast publishing point begins playing the broadcast stream in progress. You can also stop a broadcast publishing point. If you do so, all clients stop receiving the stream

After a broadcast publishing point is started, you can enable the Deny new unicast connections option, which prevents new unicast connections to the publishing point. This option does not disconnect currently connected clients. As connected clients stop receiving the stream, the number of connections gradually decreases. If you want to disconnect all clients immediately, you can select the Disconnect all clients command. If you have denied connections to your publishing point and want to begin granting client access, you can choose the Allow new unicast connections option.

You can control client connections by configuring limits in publishing point properties. For example, you can limit the number of client connections and bandwidth usage. For more information, see Setting publishing point limits.

Note Image Notes

  • If you are delivering content both as a unicast stream and a multicast stream, denying new connections only affects clients receiving the content as a unicast stream.
  • Stopping the broadcast publishing point also stops a multicast transmission.
  • If you are delivering content as a multicast stream you cannot use the automatic start property because multicast clients do not connect directly to the server. You can choose to automatically start the publishing point after completion of the Multicast Announcement Wizard. Otherwise, you must manually start the publishing point.
  • Manually starting a broadcast publishing point overrides the Start publishing point when first client connects property. If you want the broadcast publishing point to start and stop automatically based on client connections, do not start the publishing point manually.

Related topics

  • Managing connections to a publishing point
  • Streaming from publishing points
  • Understanding publishing points


Setting publishing point limits

To manage network resources, you can set limits on a number of parameters for a publishing point. The following limit properties can be adjusted on the Properties tab of a publishing point:

  • Limit player connections. Sets the maximum number of player connections.
  • Limit outgoing distribution connections. Sets the maximum number of distribution servers that can connect to this origin server.
  • Limit aggregate player bandwidth. Specifies the maximum amount of bandwidth in kilobits per second (Kbps) that player connections can use.
  • Limit aggregate outgoing distribution bandwidth. Specifies the maximum amount of bandwidth in Kbps that distribution server connections can use.
  • Limit bandwidth per stream per player. Specifies the maximum amount of bandwidth in Kbps that a single player connection can use.
  • Limit bandwidth per outgoing distribution stream. Specifies the maximum amount of bandwidth in Kbps that a single distribution server connection can use.
  • Limit Fast Start bandwidth per player. Specifies the maximum amount of bandwidth in Kbps that a single player can use for accelerated initial buffering of the streaming content.
  • Limit Fast Cache content delivery rate. (Only available for on-demand publishing points) Limits the acceleration factor of the of the streaming content and controls how much additional bandwidth can be used to stream content into the player's local cache.

Note Image Notes

  • If the same limits are set for the server and publishing point, the lowest value is used.
  • To optimize server security when adding player connection limits, you should set the value of Limit outgoing distribution connections to be equal to or less than the value of Limit player connections.

Related topics

  • Controlling unicast connections to a publishing point
  • Setting server limits
  • To set limits for a server or publishing point
  • Understanding publishing points


Streaming from publishing points

After a publishing point has been created and configured, clients can connect to the publishing point and stream content. A client locates the content by using the URL of the publishing point, which a client can acquire by using one of the following methods:

  • Direct connection. A client program, such as Windows Media Player, can connect to a unicast publishing point directly by using the URL of the publishing point. For example, in Windows Media Player, a user can type the URL in the Open URL dialog box. A URL consists of the protocol type, server or domain name, and publishing point name. If the publishing point sources a directory of files, you can also specify a particular file name. For example, the URL mms://my_server/my_pub_pt/my_file.wmv streams the file My_File.wmv in the publishing point My_Pub_Pt on the server My_Server using either the MMS protocol or a protocol that was selected by the server using protocol rollover logic. For more information on protocol rollover, see How protocol rollover works.

    If are using an embedded Player in a Web page, you specify the publishing point URL as the source for the Windows Media Player ActiveX® control. For more information about using the Windows Media Player ActiveX control, see the Windows Media Player SDK at the Microsoft Web site. For more information about publishing point URLs, see Client URL reference.

  • Announcement file. A client can connect to the URL of a publishing point by opening an announcement file, which is a Windows Media metafile with an .asx file name extension. Announcement files are most often used to provide access to streaming media content from a Web page link. When the user clicks the link, the browser downloads and reads the announcement file. Then the browser opens the Player and accesses the URL. Announcement files should be used instead of direct links in Web pages, because many browsers cannot access streaming media content directly. For more information, see About announcements.
  • Multicast information file. A client can connect to a multicast stream by reading a multicast information file. Because a client does not connect directly to a server to receive a multicast broadcast, multicast information files are used to provide clients with all the necessary connection and stream information, also known as header information. Often an announcement file is used to distribute the multicast information file. For example, a Web page link can point to an announcement, which contains the URL of the multicast information file. For more information, see About multicast information files.

When a publishing point is started, you should test the stream to make sure your configuration is working as expected. For more information, see Testing a stream.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Archiving content
  • Work with publishing points


Archiving content

When you use a broadcast publishing point to stream content, you can archive the content to a file. (The archiving feature is not available for on-demand publishing points.) Archiving is useful when you are streaming content that is not already recorded—for example, a stream from an encoder. The content is archived to a file as it streams. After the broadcast is over, the archive file enables you to make the content available for on-demand requests or a rebroadcast.

Before you can archive content, you must enable an archive data writer plug-in on the broadcast publishing point. After the plug-in is enabled, you can either start archiving manually or you can configure the archive data writer plug-in to begin archiving content automatically when the publishing point starts. In either case, archiving stops when the publishing point stops.

A new archive file is created each time you start archiving. If the content source for a publishing point is a playlist, each media element in the playlist is archived to a unique file. If you create a broadcast publishing point by using the Add Publishing Point Wizard, you are given the option of creating an archive of the broadcast, which enables the WMS Archive Data Writer plug-in with the default settings.

If you enable a wrapper playlist for a broadcast publishing point and then enable the WMS Archive plug-in for that publishing point, the files referenced by the wrapper playlist are not included in the archive file. However, if you distribute the stream to a remote publishing point and enable the WMS Archive plug-in on the remote publishing point, the files referenced by the wrapper playlist on the original publishing point are archived.

Content is archived in the same manner that it is streamed to a client. In other words, when you play archived content after the broadcast is complete, will play back the same way it did for the client during the original broadcast.

If you want to create more than one archive of your broadcast, you can enable additional archive data writer plug-ins. Ensure that you have sufficient storage space on the drive on which you are saving your archive files. The WMS Archive Data Writer plug-in will stop archiving and post a warning message to the troubleshooting list if there is less than 60 megabytes (MB) of free disk space in the archive location. Once the required free disk space is available, you can manually restart the plug-in. If the content is a server-side playlist, the archive file created for the current playlist element will be closed. When the required free disk space is available, the archive plug-in will begin archiving the next item in the playlist.

Windows Media Services includes the WMS Archive Data Writer plug-in. You can also create a custom archive data writer plug-in by using the Windows Media Services SDK, which can be downloaded from the Windows Media page at the Microsoft Web site.

By default, archive files created by Windows Media Services are indexed when the archive is stopped. However, if the broadcast is extremely long, the file will not be indexed. Windows Media Services has the following file indexing limits:

  • Single stream. If the broadcast consists of a single stream, Windows Media Services will only create an index if the broadcast is less than 146 hours (approximately 6 days).
  • Multiple streams. If Windows Media Services is broadcasting a multiple-bit-rate stream, each stream consumes a portion of the broadcast time. For example, a multiple-bit-rate stream that supports three different bit rates consumes 72 hours of broadcast time each day. If a broadcast contains multiple streams, Windows Media Services will only create an index if the total duration of the broadcast is less 218 hours (approximately 9 days). In the previous three stream example, Windows Media Services would create an index only if the content is less than 72 hours (3 days) in length.

Content that is not indexed by Windows Media Services can still be indexed using other indexing tools, such as Windows Media File Editor. Windows Media File Editor is available for download from the Microsoft Web site.

This section contains the following topic:

  • Archive wildcard characters reference

Note Image Note

  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are archiving content to a folder other than C:\WMPub\WMArchive, make sure that the folder is shared and that the Network Service account has read, write, and modify permissions for the folder. If the Network Service account does not have permissions for the folder, the server will not be able to connect to it. For more information about rights and permissions, see Understanding rights.

Related topics

  • Setting up a publishing point
  • Understanding publishing points
  • Working with the Add Publishing Point Wizard


Archive wildcard characters reference

When you configure the WMS Archive Data Writer plug-in for a publishing point, you have the option of using wildcard characters when you name your archive file. These wildcard characters are substituted with the appropriate values when the archive file is created. The use of wildcard characters enables the data writer plug-in to create multiple archive files from a publishing point. Each file is named according to a known schema. This creates archived content that can be easily categorized and managed.

The following is a list of the valid wildcard characters for use with the WMS Archive Data Writer plug-in.

Character | Description
a | Abbreviated name for the day of the week (three letters).
A | Full name for the day of the week.
b | Abbreviated name for the month (three letters).
B | Full name for the month.
c | Date and time representation appropriate for the location of the server generating the archive file.
d | Day of month in two-digit format (01 to 31).
E | Numeric counter that starts at 1 and increases every time that the archive data writer plug-in creates a new digital media file.
F | The expanded value of the role attribute. If the archive file is created from a media element in a playlist that contains a role attribute describing its use, such as Advertisement, Movie, and so on, this wildcard character is expanded to the value for the attribute. If this attribute does not exist, then the wildcard character is replaced with an underscore (_). For more information, see role attribute.
H | Hour (24-hour format) in two-digit format (00 to 23).
I | Hour (12-hour format) in two-digit format (01 to 12).
j | Day of year in three-digit format (001 to 366).
m | Month in two-digit format (01 to 12).
M | Minute in two-digit format (00 to 59).
L Last path segment of the content source. If the archive file is created from a media element in a playlist, use this wildcard character to include the last path segment in the URL referenced by the src attribute in the archive file name. The last path segment in the URL includes all of the characters after the last forward slash (/) or backward slash (\) in the URL. If the last path segment contains a colon (:), then the colon and all characters after it are removed.

For example:

  • Individual files. If the src attribute references C:\WMPub\WMRoot\Welcome1.asf, the L wildcard character returns a value of "Welcome1.asf"
  • Remote publishing point (on-demand or broadcast). The L wildcard character returns the value of the file name of the source content from the origin server.
  • Encoder push. If the src attribute references http://encoder1 in a push scenario, the L wildcard character returns a value of "_"
  • Encoder pull. If the src attribute references http://encoder 2 in a pull scenario, the wildcard character returns a value of "_"

For more information, see src attribute and mediaName attribute.
N | A four-digit sequence that starts at 0 and increases every time a new file is needed. The counter resets to 0 when the rest of the file name changes in any way.
p | The indicator for 12-hour format (A.M. or P.M.) of the server generating the archive file.
S | Seconds in two-digit format (00 to 59).
T | The computer name of the server generating the archive file.
U | Week of the year in two-digit format (00 to 53, with Sunday as the first day of week).
V | The name of the publishing point from which content is being archived. If content is being logged from the Default publishing point, the word "[Default]" is inserted in the archive file name. If the publishing point name contains a forward slash (/), the forward slash is replaced with an underscore (_) in the log file name. If the publishing point is renamed, the archive file automatically cycles to reflect the new name.
w | Day of the week in one-digit format (0 to 6, with Sunday as 0).
W | Week of the year in two-digit format (00 to 53, with Monday as first day of the week).
x | Date representation for the location of the server generating the log file.
X | Time representation for the location of the server generating the log file.
y | Year without century in two-digit format (00 to 99).
Y | Year with century in four digit format (for example, 1999, 2003).
Z | Time zone name or abbreviation. There are no characters if the time zone is unknown.

Note Image Notes

  • If the media element in the playlist contains a mediaName attribute, then the value for the mediaName attribute is used instead of the value of the src attribute.
  • When archiving content streamed from a playlist, each media element in the playlist creates a separate archive file that shares the same basic name. Each archive file name ends in a three-digit number that increases by one for every archive file that uses the same file name. The first archive file with a specific name will end with 001. The next file with that name will end with 002. When archiving other streamed content, file name incrementing begins only with the first duplicate file name.
  • When you broadcast content as part of a playlist, each playlist item will be archived in a separate file. The name of each archive file will depend on your wildcard character selections and its sequence in the broadcast.
  • If the value of the wildcard character cannot be resolved, it will be replaced in the file name by an underscore (_) character.
  • Wildcard characters can also be used as custom system environment variables. For example, you could define a system environment variable of %ArchiveRoot% that automatically resolves to the path C:\Wmpub\Wmarchive\Archive_<Y>-<m>-<d>.asf. If you create custom system environment variables, you must restart Windows Media Services before those variables can be recognized and expanded. For more information about adding or changing environment variables, see Windows Help and Support.

Related topics

  • Archiving content
  • Understanding publishing points


Sourcing from playlists, files, and encoders

When you add a publishing point to your Windows Media server, you identify the source and location of the content in the publishing point path. You can change publishing point paths by using the Source tab of a publishing point. The paths can refer to a number of different data sources, which are explained in the following sections:

  • Understanding playlists
  • Sourcing from files
  • Sourcing from a directory
  • Sourcing from an encoder
  • Sourcing from a remote publishing point
  • Sourcing from a multicast broadcast
  • Sourcing from an encrypted directory
  • Using dynamic sources
  • Reference for content sources
  • Controlling streaming behavior

Related topics

  • Concepts


Understanding playlists

Playlists provide a means of organizing different pieces of digital media content into a single user experience. Both client-side playlists and server-side playlists can be used with Windows Media-based content. For example, you can create a playlist using Windows Media Player (called a client-side playlist) composed of your favorite songs, and then shuffle and loop the playlist during playback. If you use a playlist with your Windows Media server (called a server-side playlist), you have the ability to stream multiple pieces of digital media content as you would with a client-side playlist, and you can use additional attributes to further control the behavior of the content. Client-side playlists created by the Player or by Web scripts are saved as Windows Media metafiles with an .asx file name extension. Server-side playlists that are created by content producers, server administrators, or Web page scripts are saved as Windows Media metafiles with a .wsx file name extension.

You can use playlists on a publishing point to accomplish several different goals —for example, to add advertisements, to switch between live and stored streams, or to dynamically respond to a user's demographic information. If you reference your content in a playlist, you can combine different Windows Media files into a single stream.

You can use a combination of server-side playlists and client-side playlists to provide a high degree of connection reliability for your streaming system. The client-side playlist can direct the player to the different Windows Media servers that are streaming the content, and the switch element in the server-side playlist on the Windows Media server can reference alternate content sources for the server. For more information on implementing this type of scenario, see switch element.

Windows Media playlist files are Extensible Markup Language (XML) documents that are based on the Synchronized Multimedia Integration Language (SMIL 2.0) language specification.

By default, playlist files are Windows Media files with .wsx or .asx file name extensions. You can create playlist files by using the Playlist Editor on the Source tab or by using any text editor.

The section contains the following topics:

  • About on-demand and broadcast playlists
  • About wrapper playlists
  • About creating and editing playlists
  • About playlist elements

Note Image Notes

  • For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • If you have enabled the WMS NTFS ACL Authorization plug-in on either the server or a publishing point, every piece of content streamed by the server is authenticated against the user account. This means that if you are streaming content from a playlist, the user must be authenticated against every item listed in the playlist, not just the playlist file. If a user cannot be authenticated for an item in the playlist, that item is skipped.
  • If you want to save playlist files to another computer or network drive, you must first grant write permissions to the Network Services account for that computer or network drive. For more information about how Windows Media Services uses rights, see Understanding rights.
  • If you are using multicast distribution with your playlist file, you should only add content to a currently playing playlist if the content is in a known stream format. If the content is in a stream format that is not identified in the multicast information file, players receiving the multicast stream will be in an indefinite waiting state.
  • If you are creating or editing server-side playlists using either a text editor or an automated script, make sure that you list the playlist elements and attributes in the correct case. Extensible Markup Language (XML) is a case-sensitive language, and Windows Media Services does not recognize any playlist elements or attributes that are not listed properly. For more information about playlist elements and attributes, see Playlist elements and Playlist attributes.
  • If your playlist includes JPEG image files, do not include any syntax in your playlist that would cause the image to pause while rendering on the client's computer. Pausing a JPEG image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • If your playlist includes JPEG image files and you are using the playlist file with a broadcast publishing point, be aware that users who connect to the broadcast while the JPEG image is being streamed will not receive the image. They will instead see a black screen. Once the playlist continues on to the next item, playback will continue as expected. If you want a JPEG image to be displayed for a certain period of time, you should use the repeatCount attribute to repeat the image for short durations that together equal the amount of time that the image is to be displayed. That way, players that connect while the image is being streamed can receive the image when it repeats. For example, if a JPEG image is to be displayed for 60 seconds, you could set a dur attribute value of five seconds and a repeatCount attribute value of 12. If a user connects two seconds into the broadcast, the image would be displayed after three seconds. If the repeatCount and dur attribute values were not used, the user would see a black screen for 58 seconds.

Related topics

  • Playlist reference
  • Sourcing from playlists, files, and encoders


About on-demand and broadcast playlists

You can provide different user experiences depending on whether you make your playlists available through an on-demand or a broadcast publishing point.

If you want your users to have control over the content you reference in a playlist, you can post your playlist to an on-demand publishing point. Users can fast-forward the content, skip to different entries in the playlist, and pause playback, thereby controlling the method by which they receive the content.

In contrast, if you have users connect to a playlist through a broadcast publishing point, they can only receive the stream exactly as dictated by the playlist; they have no control over how they receive content, and they can only start and stop the playback. If users stop the content on their players, the content stream on the broadcast publishing point continues. When a user resumes playing the content by clicking start, the player synchronizes with the playlist that is currently playing, regardless of the point at which the user stopped it.

Note Image Note

  • The ability to fast-forward, skip, rewind, and pause while playing content from a server-side playlist is only supported by Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control. Users that are connecting with a previous version of the Player will not be able to control the playback of the content in the server-side playlist. If these users stop and then restart the Player, playback will start from the beginning of the playlist.

Related topics

  • About creating and editing playlists
  • Creating and editing offline playlists
  • Editing online playlists
  • Playlist reference
  • Understanding playlists


About wrapper playlists

Wrapper playlists are a special type of playlist that you can use to implement bumper advertisements on your publishing points. Wrapper playlists enable you to append content to the beginning and end of a unicast stream.

The following illustration shows a client requesting a movie from the server and the wrapper playlist content that the client will receive along with the requested movie.

Wrapper playlist illustration

First, the client attempts to connect to the server. When the server receives the connection request, it locates the publishing point that corresponds to the specified URL. In the previous illustration, since no publishing point name is specified, the content is associated with the Default publishing point. When a wrapper playlist is enabled for use with a publishing point, the publishing point streams both the content specified in the wrapper and the content requested by the user. In the previous illustration, the publishing point streams Advertisement.wmv before streaming the requested content (Movie.wmv) and then streams Thankyou.wma when the content ends.

All publishing points can point to the same wrapper, meaning that you only need to modify one wrapper playlist file to apply a universal change. There is no limit to the number of streams that you can reference in a wrapper, nor is there a limit to the number of publishing points that point to that wrapper.

You can easily use wrapper playlists to customize a stream with your own branding and message without having to change the content from the content creator. Additionally, wrapper playlists help to ensure that users who connect to broadcast publishing points always receive certain content, such as a sponsor identification, disclaimer, or advertisement, regardless of when they connected to the broadcast.

Wrappers are managed from the Advertising tab on your publishing point. From there you can change which wrappers are used with the publishing point, enable or disable the wrapper playlist, or start the Create Wrapper Wizard.

Note Image Notes

  • Content contained in wrapper playlists is always provided to users as on-demand content, regardless of the type of publishing point on which the wrapper is enabled.
  • Wrappers require a unicast connection. You can create a similar experience for content that is delivered as a multicast stream by modifying the announcement file (with a .asx file name extension) in order to send the content to the multicast players.

Related topics

  • About creating and editing playlists
  • Creating and editing offline playlists
  • Editing online playlists
  • Playlist reference
  • To simulate a wrapper for a multicast publishing point
  • To start the Create Wrapper Wizard
  • To open an existing wrapper playlist
  • Understanding playlists


About creating and editing playlists

There are many ways to create and edit server-side playlists. You can use the Playlist Editor, the Source tab of the publishing point, an Extensible Markup Language (XML) editor, or a text editor. The following list provides some guidelines for using each method:

  • Playlist Editor. The Playlist Editor provides a simple, graphical interface for creating playlists and specifying attributes for the items in the playlist. When the playlist is saved to a playlist file, it will be saved using the correct XML syntax and structure. You can access the Playlist Editor from the Summary tab of the Publishing Points console tree item or by clicking the View Playlist Editor button on the Source tab of a publishing point.
  • Source tab. The Source tab includes an embedded version of the Playlist Editor that you can use to edit playlists that are currently assigned to publishing points. You can modify playlist files at any time by using the toolbar on the Source tab. If you change a playlist while the publishing point is streaming, the change affects users in two ways:
    • If you are streaming from an on-demand publishing point, users who connect to the publishing point after you change and save the playlist receive the content specified by the new playlist, while users who were connected to the publishing point before you changed the playlist continue to receive the content specified by the old playlist.
    • If you are streaming from a broadcast publishing point, all connected users receive content from the new playlist as soon as you make the change. However, if you do not the save the changes to the playlist file, the previous version of the playlist will be used when the broadcast publishing point is stopped and restarted.
  • Text or XML editor. If you are familiar with XML syntax and with creating XML documents, you can use this knowledge create and edit playlist files. By using a text or XML editor, you can add comments to your file and modify all XML elements and attributes.

Note Image Notes

  • The Playlist Editor can also be opened as a standalone program by double-clicking the wmseditor.exe file, which can be found in the folder in which you installed the administrative interface. By default, this is %systemroot%\System32\Windows Media\Server\Admin\MMC.
  • If you are using multicast distribution with your playlist file, you should only add content to a currently playing playlist if the content is in a known stream format. If the content is in a stream format that is not identified in the multicast information file, players receiving the multicast will be in an indefinite waiting state.
  • You can include a multicast stream as a content source in a playlist by specifying the URL to the multicast information file as a src attribute of a media element. To do this, the playlist that references the multicast stream must already be assigned to a broadcast publishing point. Then, using the Source tab in the Windows Media Services snap-in, add a media element that sources from the multicast stream. You cannot add a multicast stream to a playlist by using the Windows Media Playlist Editor.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.
  • If your playlist includes JPEG image files, do not include any syntax in your playlist that would cause the image to pause while rendering on the client's computer. Pausing a JPEG image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • If your playlist includes JPEG image files and you are using the playlist file with a broadcast publishing point, be aware that users who connect to the broadcast while the JPEG image is being streamed will not receive the image. They will instead see a black screen. Once the playlist continues on to the next item, playback will continue as expected. If you want a JPEG image to be displayed for a certain period of time, you should use the repeatCount attribute to repeat the image for short durations that together equal the amount of time that the image is to be displayed. That way, players that connect while the image is being streamed can receive the image when it repeats. For example, if a JPEG image is to be displayed for 60 seconds, you could set a dur attribute value of five seconds and a repeatCount attribute value of 12. If a user connects two seconds into the broadcast, the image would be displayed after three seconds. If the repeatCount and dur attribute values were not used, the user would see a black screen for 58 seconds.

Related topics

  • About playlist elements
  • Creating and editing offline playlists
  • Editing online playlists
  • Playlist reference
  • Understanding playlist syntax
  • Understanding playlists


About playlist elements

A playlist is composed of elements and their associated attributes. Elements are the building blocks that make up a playlist written in XML. Attributes are values that enable you to customize the behavior of the elements defined in the playlist. For example, you can use attributes to cause media elements to start based on the start or end points of other media elements. You can also use attributes to prioritize elements to ensure that some elements (advertisements, for example) are not interrupted by others.

The following table identifies the elements as they appear in the Playlist Editor. The phrase in parentheses identifies how the element would appear in XML syntax. The XML identification is used in the description.

Element | Description
SMIL (smil) | The smil element is the root element of any playlist. Synchronized Multimedia Integration Language (SMIL) is a XML-based markup language that Windows Media Services uses to construct playlists based on your input. The smil element is placed as the first element in your playlist. The smil element has the same behavior and attributes as the seq element. For more information, see smil element in the Playlist reference.
Media (media) | The media element is the basic element in a playlist, used to represent the content you want to stream. A media element describes the location of the content and can include attributes that specify when the content should be played and for how long. A media element can refer to a file on a Windows Media server, an encoder stream, a remote stream, another playlist file, an ASP page on a Web server that generates a playlist, or a file on a third-party storage system. For more information, see media element in the Playlist reference.
Sequence (seq) | The seq element is used to group a set of media elements into a continuous stream in which elements are streamed in order. Each media element within the seq element is streamed one after the other and their playback is synchronized with the presentation timeline, which identifies the start and stop times of each media element. For more information, see seq element in the Playlist reference.
Exclusive (excl) | The excl element is used to group a set of media elements into a continuous stream in which elements have indeterminate start times and are not required to be played in sequence. The excl element is synchronized to the presentation timeline, which can be used to explicitly specify the start and stop times of the media elements. Unlike media elements contained in seq elements, the media elements contained within an excl element do not play unless they are explicitly started by either a programmatic event or the begin attribute. For more information, see excl element in the Playlist reference.
Priority Class (priorityClass) | The priorityClass element is used with excl elements to group playlist elements into categories and define the rules for how playlist elements in each category can interrupt or be interrupted by playlist elements in other categories. For more information, see priorityClass element in the Playlist reference.
Switch (switch) | The switch element is used to provide set of alternate elements. The server evaluates the possible alternatives in order and selects the first element that references content that can be streamed. For more information, see switch element in the Playlist reference.
Client Data (clientData) | The clientData element is used to provide descriptive information and logging information about content items. This information can be displayed to users in their players. For more information, see clientData element in the Playlist reference.

Note Image Notes

  • To ensure that users always get the most current version of the playlist when they connect to your server, on the Properties tab for the publishing point, under Cache/Proxy Management, set the Enable cache expiration property to Immediately. If this property is not set, the user will receive the playlist content from the local cache of the player and will not attempt to reconnect to the server to receive the content.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.
  • For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.

Related topics

  • About creating and editing playlists
  • Creating and editing offline playlists
  • Editing online playlists
  • Playlist reference
  • Understanding playlist syntax
  • Understanding playlists


Sourcing from files

You can configure either a broadcast or an on-demand publishing point to stream a single file from a directory.

If you are using a broadcast publishing point, set the publishing point path to reference the directory and the name of the file you want to stream, such as C:\WMPub\WMRoot\Myfile.wma.

If you are using an on-demand publishing point, you can set the publishing point path to the directory and name of the file you want to stream, such as C:\WMPub\WMRoot \myfile.wma, or you can set the publishing point to simply reference the directory, such as C:\WMPub\WMRoot, and make the connection URL for the publishing point specify the file in the directory that you want to stream. For more information about streaming files from a directory, see Sourcing from a directory.

Note Image Notes

  • The server does not use your user account to access files and streams; it uses the Network Service account by default. If you are sourcing from a file that is in a folder other than C:\WMPub, make sure that the folder is shared and that the Network Service account has at least read permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to connect to it. For more information about rights and permissions, see Understanding rights. .
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.
  • If your publishing point is accessing files on a computer running Windows 2000 Server as a source of content, you may have difficulty streaming the content due to differences in the way that Windows 2000 Server and Windows Server 2003 handle user account authorization and privileges. If the two computers are members of the same domain, on-demand publishing points that have the WMS NTFS ACL Authorization plug-in enabled and attempt to retrieve content from a computer running Windows 2000 Server will cause remote clients to receive an "Access denied" error message. Local clients, such as the Test stream feature of Windows Media Services, are not affected. If the two computers are not members of the same domain, see To access content on a computer running Windows 2000 Server.

Related topics

  • About publishing point types
  • Announcing content
  • Sourcing from playlists, files, and encoders
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To stream a Windows Media file from an on-demand publishing point


Sourcing from a directory

You can configure either a broadcast or an on-demand publishing point to stream files from a directory.

  • For a broadcast publishing point, set the publishing point path to reference the directory that contains the files you want to stream, such as C:\WMPub\WMRoot. All of the digital media files in the directory are streamed to connected clients automatically. To play the stream, users type the URL for the publishing point in their players; for example, mms://servername/publishing_point_name.
  • For an on-demand publishing point, set the publishing point path to reference the directory that contains the files you want to stream, such as C:\ WMPub\WMRoot. Users can either receive a single file or all the files in the directory. If you want to stream all the files in the directory, you must enable the Enable access to directory content using wildcards property on the Properties tab of the publishing point. This property enables you to use wildcard characters in the URL of the publishing point. The following examples show how you can use this to provide different content streams to users:
    • Stream all digital media files in a directory. Use the asterisk (*) wildcard character in place of the file name in the connection URL to stream all of the digital media files within a directory; for example, mms://servername/publishing_point_name/*.
    • Stream only certain file types in a directory. Use the asterisk (*) wildcard character in place of the file name in the connection URL but specify the file extension to stream all of the digital media files of a certain type. For example, you can use mms://server_name/publishing_point_name/*.wmv to stream only the video files or mms://server_name/publishing_point_name/*.wma to stream only the audio files.

Note Image Notes

  • The asterisk (*) wildcard character cannot be used to replace portions of a file name or extension.
  • The server does not use your user account to access files and streams; it uses the Network Service account by default. If you are sourcing from a file that is in a folder other than C:\WMPub, make sure that the folder is shared and that the Network Service account has at least read permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to connect to it. For more information about rights and permissions, see Understanding rights.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.
  • If your publishing point is accessing files on a computer running Windows 2000 Server as a source of content, you may have difficulty streaming the content due to differences in the way that Windows 2000 Server and Windows Server 2003 handle user account authorization and privileges. If the two computers are members of the same domain, on-demand publishing points that have the WMS NTFS ACL Authorization plug-in enabled and attempt to retrieve content from a computer running Windows 2000 Server will cause remote clients to receive an "Access denied" error message. Local clients, such as the Test stream feature of Windows Media Services, are not affected. If the two computers are not members of the same domain, see To access content on a computer running Windows 2000 Server.

Related topics

  • About publishing point types
  • Announcing content
  • Sourcing from playlists, files, and encoders
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To stream a directory of files


Sourcing from an encoder

When an encoder is providing a stream for a broadcast, it can either push the stream to the server or the server can pull it from the encoder. When pushing a stream, the encoder initiates the connection with the server; on the other hand, when pulling the stream from the encoder, the server initiates the connection. The decision whether to push or pull depends upon your situation.

Pushing the stream from the encoder is useful if the encoder is behind a firewall or if the encoder administrator needs to be in control of the broadcast. For information on how to configure your server to broadcast content from an encoder, see To broadcast content pushed from an encoder.

Pulling the stream from the encoder is useful in several scenarios. First, if there are multiple distribution servers, all connecting at different times, each server can initiate the connection when it is ready to stream. In addition, pulling a stream from a server is useful if you need to minimize bandwidth usage between the server and encoder. For example, the server administrator can add a publishing point and configure it to start automatically, which means that the server doesn't initiate the connection with the encoder until the first client connects. This eliminates unnecessary bandwidth use between the server and the encoder. Pulling from the server is also useful when the server is behind a firewall.

Whether you decide to use push or pull to receive the stream from the encoder, the following rules apply:

  • Encoder streams are broadcast content. When the encoder pushes a stream through the server it must use a broadcast publishing point. If you are pulling the stream from an encoder you can use either an on-demand or a broadcast publishing point, but the user experience will not change. The content is still treated as a broadcast and users cannot control the content — they cannot fast-forward, rewind, seek or pause regardless of whether they connect to an on-demand or broadcast publishing point.
  • The encoder and the server connect using Hypertext Transfer Protocol (HTTP). HTTP is used to transmit a stream between an encoder and a Windows Media server in order to enable communication through firewalls. If the encoder is pushing the content, the HTTP server control must be enabled in order for the encoder to successfully connect to the server. If you are pulling the stream, set the publishing point path to reference the URL of the encoder from which you want to stream content, such as http://encodername:port. To verify that you have the correct URL and that the encoder is broadcasting, open the encoder URL in Windows Media Player. The Player should render the stream from the encoder.
  • Using redundant encoders increases the reliability of the source content. You can configure Windows Media Services to switch from one encoder to another if the primary encoder fails.

To receive the content, users type the URL of the publishing point in their players; for example, mms://servername/publishing_point_name.

Related topics

  • About publishing point types
  • Announcing content
  • Sourcing from playlists, files, and encoders
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To broadcast a stream pulled from an encoder
  • To enable content rollover in case of encoder failure


Sourcing from a remote publishing point

You can use a publishing point on another Windows Media server as the source for either an on-demand or a broadcast publishing point. When your publishing point sources from a remote publishing point, your server is used as a distribution server for the origin server.

You cannot create a publishing point that sources from a remote publishing point by using the Add Publishing Point Wizard. You must use the Add Publishing Point (Advanced) dialog box or modify the source location on the Source tab of an existing publishing point.

If you are sourcing from a remote publishing point, the location is specified by using the URL for the client connection. You can use either of the following formats, replacing servername with the name of the remote server, and replacing publishing_point_name with the name of the remote publishing point:

  • rtsp://servername/publishing_point_name
  • http://servername/publishing_point_name

Note Image Note

  • If you are sourcing from a remote publishing point or station on a server running Windows 2000 Server with Windows Media Services version 4.1, you must use the HTTP protocol. RTSP streaming is not supported by Windows Media Services version 4.1.

Related topics

  • Publishing points that point to remote sources
  • Sourcing from playlists, files, and encoders
  • To add a publishing point using the advanced method
  • Using distribution servers


Sourcing from a multicast broadcast

You can use a remote multicast broadcast as a source of content for a broadcast publishing point or to create an archive file for later, on-demand or broadcast playback. By setting a distribution server at the edge of a network to receive a multicast transmission and rebroadcasting it to network clients as a unicast broadcast, you can overcome multicast incompatibilities within your network and reach users who would not normally be able to receive your multicast content. If you are broadcasting content to widely distributed networks from a central location, you can reduce the necessary bandwidth at the origin server by multicasting the content. Local distribution servers can then rebroadcast the content to individual users or can archive the content for on-demand access.

Note Image Note

  • You can include a multicast stream as a content source in a server-side playlist by specifying the URL to the multicast information file as a src attribute of a media element. To do this, the playlist that references the multicast stream must already be assigned to a broadcast publishing point. Then, using the playlist editing control on the Source tab in the Windows Media Services snap-in, add a media element for the multicast stream. You cannot add a multicast stream to a playlist using the Playlist Editor. When adding the URL to the multicast information file, you must specify an absolute path, such as MCast://C:\Wmpub\Wmroot\File.nsc or MCast://\\MachineName\Inetpub\Wwwroot\File.nsc.

Related topics

  • Sourcing from playlists, files, and encoders
  • To use a multicast stream as a content source


Sourcing from an encrypted directory

Security concerns may require that you maintain some or all of your content in an encrypted directory. The encryption process encodes the data in a file so that it is unreadable to a computer or account that does not have the appropriate file encryption key. In the Windows operating system, the file encryption key is assigned to an account. Anyone who logs on using that account is then able to decrypt and use the content.

Windows Media Services can decrypt and stream encrypted content if it is logged on to the proper account. By default, Windows Media Services logs on to the Network Service account. To access the encrypted content, you must set Windows Media Services to log on to the same account that encrypted the content. You can change the account Windows Media Services uses to log on to the computer by using Microsoft Management Console. For more information about encryption, accounts, and user privileges, see Windows Help and Support.

Note Image Note

  • By using the account that originally encrypted the files as the Windows Media Services logon account, you give Windows Media Services administrator rights and permissions for your computer. This can result in reduced network security. Consult your network administrator to assess the risks and benefits of streaming encrypted content.

Related topics

  • Sourcing from playlists, files, and encoders


Using dynamic sources

You can use a playlist created on a Web server by either an ASP page or by a Web script as the source for an on-demand publishing point or broadcast publishing point. Because this custom playlist can be dynamically created each time the server accesses it, it is referred to as a dynamic source.

When you generate a playlist from a dynamic source, Windows Media Services must first retrieve the playlist from the Web server to the Windows Media server and then parse the playlist into a collection of digital media content which is then streamed to the client. Windows Media Services uses the WMS HTTP Download Data Source plug-in to download the playlist from the Web server. The playlist is then parsed by the WMS SMIL Playlist Parser plug-in and the content is streamed to the user.

The dynamic playlist is downloaded from the Web server using the Hypertext Transfer Protocol (HTTP). It can also be downloaded from a secure Web server that uses Secure Sockets Layer (SSL) to transfer data. If you are sourcing from a dynamic source, you must specify the source location by using the URL of the Web server. You can use the following formats to specify the URL, replacing Web_server_name with the name of your server, and replacing dynamic_playlist.asp with the name of the script file that creates the playlist being downloaded:

  • httpd://Web_server_name/dynamic_playlist.asp, if the playlist file will be downloaded from a standard Web server.
  • httpsd://Web_server_name/dynamic_playlist.asp, if the playlist file will be downloaded from a secure Web server.

The "d" is appended to either the http or https prefixes to specify that the WMS HTTP Download Data Source plug-in be used with this content.

Note Image Notes

  • For more information about creating an ASP page that can generate Windows Media playlist files automatically, see the Windows Media Services 9 Series SDK on the Microsoft Web site.
  • Windows Media Services may be required to supply authentication information to the Web server from which it is downloading the playlist. If authentication is enabled on the Web server that is used for playlist generation, make sure that the proper user name and password are entered in the Specify distribution credentials property of your publishing point. These credentials will allow Windows Media Services to be authenticated if the Web server is using NTLM, Kerberos, or Digest authentication. Windows Media Services cannot be authenticated if the Web server is using Basic or Passport authentication. If a client certificate is required for authentication, Windows Media Services will use the certificate obtained for the Web browser. Windows Media Services does not have its own client certificate.

Related topics

  • Editing online playlists
  • Sourcing from playlists, files, and encoders
  • To add a publishing point using the advanced method
  • Working with data sources


Reference for content sources

The path to your content should be the location of the content specified by a local path, a Universal Naming Convention (UNC) path, or a URL. The following table provides examples of paths for different publishing point sources.

Content source | Content type | Example path
Windows Media Encoder | Stream | http://encoder1: 8080
Windows Media Services 9 Series | Unicast stream - or - Multicast stream | rtsp://mediaserver1/publishing_point_1 http://mediaserver1/publishing_point_1 - or - MCast://C:\WMPub\WMRoot\multicast1.nsc
Directory | Multiple files played sequentially | C:\WMPub\WMRoot
File system (includes playlist files and digital media files) | File (with an .asf, .mp3, .wma, .wmv, or .wsx file name extension) | C:\WMPub\WMRoot\File_name
Windows Media Services in Windows 2000 Server (version 4.1) | Unicast stream - or - Multicast stream | http://mediaserver2/publishing_point_2 http://mediaserver2/station2 - or - MCast://\\Server_name\Inetpub\Wwwroot\Multicast2.nsc
Dynamic source | Playlist | httpd://web_server_3/dynamic_playlist.asp httpsd://web_server_4/dynamic_playlist.asp

Note Image Note

  • UNC paths are not the most efficient way to specify a content source because the server cannot take advantage of NTFS caching when a UNC path is used. For optimal performance, store the content on a local drive.

Related topics

  • Sourcing from playlists, files, and encoders


Controlling streaming behavior

You can control how players and distribution servers receive a stream by modifying one or more Fast Streaming properties. Fast Streaming refers to a group of technologies that improve the perceptive quality of streaming media to the user. By adding a modifier to the path of a source, you can specify certain Fast Streaming properties of individual files and live streams.

You add a modifier the same way you would add a query string to an URL. After the URL, add a question mark character (?), followed by the modifier and the modifier value:

http://server/source?modifier=value

You can combine multiple modifiers with ampersands (&):

http://server/source?modifier1=value&modifier2=value

The modifier can be added anywhere a source value is used or entered, such as a src attribute value in a server-side or client-side playlist. If you need to use multiple modifiers in a playlist, you must do it differently than you would in a URL. This is because playlists are Extensible Markup Language (XML) documents in which the ampersand character (&) has a defined behavior. Therefore, you must explicitly specify the ampersand character and then separate the entries with a semicolon. For example, two modifiers combined would look like this:

http://server/source?modifier1=value&amp;modifier2=value

The following table describes the Fast Streaming modifiers.

Modifier | Client | Value description
WMBitrate Distribution servers

Players

 Specifies the bit rate that the server cannot exceed when delivering a stream in bits per second. When the Fast Cache feature is enabled, you can use this modifier to restrict the amount of bandwidth that the server can use. For example, WMBitrate=100000 restricts the bit rate to a maximum of 100 kilobits per second (Kbps). If this value is greater than any of the per stream bandwidth limits set for the server or publishing point, content will be streamed at the bit rate specified by the limit rather than at the bit rate specified by the modifier.
WMCache | Players | Specifies whether Fast Cache streaming is enabled. A value of 1 explicitly enables Fast Cache streaming; 0 explicitly disables Fast Cache streaming. When Fast Cache is enabled, the server streams data faster than the client plays it back. The extra data is stored in a cache on the client. By caching data ahead of playback, the client is better able to handle inconsistencies in network bandwidth. If Fast Cache has been disabled on the server, this modifier will have no effect.
WMContentBitrate Distribution servers

Players

 Specifies the maximum bit rate that can be streamed from a source, in bits per second. This modifier is most commonly used with multiple-bit-rate (MBR) streaming content. No stream with a bit rate higher than the value given can be streamed. For example, if an MBR file contains streams at 80 Kbps, 100 Kbps, and 300 Kbps, and WMContentBitrate is set at 150 Kbps, the highest bit rate stream that can be delivered is the 100-Kbps stream. If this value is greater than any of the per stream bandwidth limits set for the server or publishing point, content will be streamed at the bit rate specified by the limit rather than at the bit rate specified by the modifier.
WMFecPktsPerSpan | Players | Defines how many forward error correction (FEC) packets are sent along with the content data packets defined by WMFecSpan. This value must be less than or equal to value specified for WMFecSpan, with a minimum value of 1 and a maximum value of 24.
WMFecSpan | Players | Specifies the number of content data packets that will be covered by the FEC data packets. This value cannot exceed the limit specified in the Forward Error Correction properties dialog box of the server. The maximum value and default setting is 24. If this value is set to 0, FEC is disabled.
WMReconnect Distribution servers

Players

 Specifies the number of times the client should attempt to reconnect to a source if the connection is lost. For example, if the value of this modifier is 3, the client will attempt to reconnect three times. If the value is -1, the client will attempt to reconnect an infinite number of times. If the value is 0, the client will not attempt to reconnect.

You can use a value of 0 if you plan to use a rollover URL. For example, if you configure backup encoders to act as content rollovers, you can set a WMReconnect value of 0 for the primary encoder. If you do that, the client will not attempt to reconnect to that encoder if the connection is lost. Instead the client will immediately roll over to the backup encoder. For example:

<?wsx version="1.0"?>
<smil>
    <media src="http://encoder1:8081?WMReconnect=0" />
    <media src="http://encoder2:8081" />
</smil>
WMThinning | Players | Specifies whether stream thinning is enabled. If a value of 1 is set, stream thinning is used if necessary to maintain as much playback quality as possible when network conditions deteriorate and bandwidth availability is reduced. If a value of 0 is set, stream thinning is disabled. With stream thinning, the server gracefully reduces the bit rate of a stream to accommodate inconsistencies in the current bandwidth available to a client.

Related topics

  • Set up content to stream
  • Sourcing from playlists, files, and encoders
  • Streaming vs. downloading content
  • Understanding Fast Recovery
  • Understanding Fast Streaming
  • Understanding intelligent streaming


Announcing content

Before you can stream content, you need to let your users know that the content is available. An easy way to accomplish this is to use the announcement wizards to create an announcement for the publishing point. The announcement wizards are located on the Announce tab of the publishing point.

As an alternative to using announcements, you can simply provide the URL a client needs to access the content in an e-mail or on a public shared resource.

This section contains the following topics:

  • About announcements
  • About multicast information files
  • Client URL reference

Note Image Note

  • Distribution servers cannot use announcement files to connect to a publishing point. To enable a distribution server to connect to your publishing point, you must give the publishing point URL to the distribution server administrator.

Related topics

  • Concepts


About announcements

An announcement is a Windows Media metafile with an .asx extension that provides a player with the information needed to connect to a Windows Media server to receive content. You can place a link to an announcement on a Web page, make the announcement available in a shared file, or send an announcement in an e-mail message. Users can access your content either by clicking the link to the announcement on a Web page or by opening the announcement directly. The announcement wizards on the Announce tab of the Windows Media Services snap-in help you create announcement files (.asx files) and multicast information files (.nsc files) that players can use connect to your content. The wizards can also help you create a Web page with an embedded Windows Media Player control or provide you with the syntax to embed a Player in your own Web page.

When delivering content as a unicast stream, either through an on-demand publishing point or a broadcast publishing point, use the Unicast Announcement Wizard to create the announcement file. The announcement file contains the following information:

  • The URL of the content
  • Announcement metafile elements, such as the author, title, and copyright

When a user opens the announcement in his or her player, the player extracts the URL of the content and the metafile elements from the announcement and then begins playing the content.

If you are delivering content as a multicast stream through a broadcast publishing point, you must use the Multicast Announcement Wizard. When you use this wizard, the announcement that is created contains the following information:

  • The URL of the multicast information file
  • Announcement metafile elements, such as author, title, and copyright,

When a user opens the announcement in his or her player, the player extracts the URL of a multicast information file. This file contains information the player needs to access and decode the stream, such as the IP address, port, and stream format. The player downloads the multicast information file and then begins playing the content.

This section contains the following topics:

  • Sample announcement file
  • Customizing announcement files
  • Embedding the Player in a Web page
  • Understanding MIME types

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Announcing content
  • Working with the announcement wizards


Sample announcement file

An announcement is a Windows Media metafile with an .asx file name extension that provides a player with the information it needs to connect to a Windows Media server to receive content. Announcement files are based on Extensible Markup Language (XML) and use different tags to control player behavior. The .asx extension is registered to Windows Media Player, so the Player will automatically start when users click the announcement file.

The following code sample is an example of the most basic type of announcement file which only directs the Player to the location of the content:

<asx version = "3.0">
  <entry>
    <ref href = "mms://servername/publishingpointname/filename.wmv"/>
  </entry>
</asx>

To create an announcement for your content, you can copy this code into a text document, replace servername with the name of your server, publishingpointname with the name of your publishing point, and filename.wmv with the name of your content, and then save that file with an .asx file name extension. An announcement created by the Unicast Announcement Wizard uses the same formatting and syntax, so you can create announcements by using the wizard and then modify them in a text editor, if you wish.

Announcement files have a variety of other features you can customize through the use of XML tags to provide additional features or information to players. For more information on common uses of announcement files, see Customizing announcement files.

Related topics

  • About announcements
  • Announcing content


Customizing announcement files

You can use a text editor to modify an announcement and make use of the following advanced features:

Server rollover

You can add a <REF> tag to the announcement file in order to specify a rollover URL. The rollover URL identifies alternate Windows Media servers that are streaming the same content. In the following example announcement file, if the client cannot successfully connect to Server1, it automatically connects to Server2 without reentering the URL.

<asx version = "3.0">
  <entry>
    <ref href = "mms://server1/filename.wmv"/>
    <ref href = "mms://server2/filename.wmv"/>
  </entry>
</asx>

Multicast wrappers

You can add a <REF> tag to the announcement file to specify the content to be played before and after the multicast stream. If a client attempts to connect to a multicast stream using the following example announcement file, the client will connect first to a unicast server to view an introductory file, then will connect to the multicast stream. After the multicast stream has ended, the client will be directed to a concluding file at the end of the broadcast.

<asx version = "3.0">
  <entry>
    <ref href = "mms://server1/introduction.wmv"/>
  </entry>
  <entry>
    <ref href = "http://web_server_name/multicast_information_file_name.nsc"/>
  </entry>
  <entry>
    <ref href = "mms://server1/conclusion.wmv"/>
  </entry>
</asx>

Fast Recovery

To send forward error correction (FEC) data to clients, you must modify the announcement file so that the client connection URL requests the data. The following example announcement file uses the URL modifier WMFecSpan to define how many data packets the forward error correction data will encompass and the modifier WMFecPktsPerSpan to define how many error correction packets are sent with the data packets. In this example, the parameters specify that the server will send one FEC packed for every four data packets.

<asx version = "3.0">
  <entry>
    <ref href = "mms://server1/filename.wmv?WMFecSpan=4&WMFecPktsPerSpan=1"/>
  </entry>
</asx>

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About announcements


Embedding the Player in a Web page

By embedding a Windows Media Player ActiveX control in your Web page, you provide your users with a professional-looking and easy to use alternative to stand-alone players. The embedded Player is an integral part of the Web page, and it begins playing the content immediately after the page opens. An embedded Player can be used to play back both unicast and multicast streams.

In the Windows Media Services snap-in, you can use the Unicast Announcement Wizard and the Multicast Announcement Wizard to create basic, preconfigured, Web pages with embedded Player controls which you can then modify to suit your needs and your Web site. Alternatively, you can also select an option in the announcement wizards to copy the HTML commands for embedding a Windows Media Player ActiveX control to Notepad so that you can insert these commands as part of your Web site source code.

Related topics

  • About announcements


Understanding MIME types

The Multipurpose Internet Mail Extensions (MIME) standard was developed so that Web browsers could accurately interpret files. For example, when an announcement file is opened from a Web site, the MIME type indicates that the browser should use Windows Media Player to render the file. When the Web server sends the file to the browser, it specifies the MIME type in the HTTP header.

Each MIME type identifier consists of two parts. The first part indicates the general category to which the file belongs, such as text. The second part of the identifier details the specific file type, such as html. For example, a text/html MIME type identifier indicates that the file is a standard Web page.

If you are using Internet Information Services (IIS) 6.0, all of the appropriate MIME types for Windows Media Services are already set. If you are using a different Web server, make sure that the following MIME types are defined in the HTTP Header properties:

File extension | MIME type
.asx | video/x-ms-asx
.nsc | video/x-ms-asf

Related topics

  • About announcements


About multicast information files

The Multicast Announcement Wizard creates both an announcement file and a multicast information file. The multicast information file is a Windows Media metafile with an .nsc extension. The multicast information file contains information a player needs to use in order to decode a stream. Before receiving content delivered as a multicast stream, the player must access the multicast information file to extract the following information:

  • Multicast IP address
  • Multicast port
  • Time-to-live value
  • Default error correction span
  • Multicast logging URL
  • Unicast rollover URL
  • Stream formats used by the content being delivered

If you make any changes to the publishing point configuration, such as modifying settings for the multicast data writer plug-in or renaming the publishing point, you must use the Multicast Announcement Wizard to create a new multicast information file so that players will be able to connect to your content.

Note Image Notes

  • Multicast information files must include all the stream formats used by your content. If the stream formats are not listed in the multicast information file, clients cannot access the multicast stream.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About stream formats
  • Announcing content
  • How multicast works
  • Logging data about multicast streams
  • Working with the announcement wizards


About stream formats

A player uses stream format information to decode a stream. A stream format includes information about the stream, including codecs, bit rates, and frame sizes.

Stream format information is transmitted to players when they first connect to a publishing point on your server. However, if you are delivering your content as a multicast stream, players do not connect directly to your server to receive the stream. In this situation, the multicast information file incorporates the stream format information instead. The multicast information file is created when you run the Multicast Announcement Wizard.

When you use the Multicast Announcement Wizard to announce content that is delivered as a multicast stream, you must list the stream formats used by the content. If you are combining multiple pieces of content into one multicast stream and the content uses different codecs, bit rates, or frame sizes, you must specify the stream format for each piece of content. For example, if you have set up a playlist to stream two files that use different codecs, you must specify the stream format for each file. The method used to specify stream formats for a multicast stream differs depending on the type of content you are streaming, as follows.

Content type | Location of stream format information
File | Stream format information is obtained from the header portion of the file. To include the stream format information for the file, you must specify a UNC path or a local path to the file in the Multicast Announcement Wizard.
Stream from an encoder | Stream format information is stored in a stream format file that is generated by an encoder. For Windows Media Encoder version 4.1 (included with Windows 2000 Server), this file has an .asd extension. For Windows Media Encoder 7 or later, this file has an .asf extension. To include the stream format information for the encoder stream, you must specify a UNC path or a local path to the stream format file. Windows Media Encoder 9 Series automatically transmits the stream format information to the server when it connects. For more information about streaming from an encoder, see Windows Media Encoder Help.

If stream format information is missing or incorrect for a piece of content, the player cannot render that content.

Note Image Notes

  • Multicast information files must include all the stream formats used by your content. If the stream formats are not listed in the multicast information file, clients cannot access the multicast stream.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About multicast information files


Client URL reference

This topic provides sample URLs that clients (players or distribution servers) can use to receive a stream. In the sample URLs, server_name and publishing_point_name refer to the Windows Media server and publishing point that are streaming the content, respectively. Announcement files are one method you can use to provide clients the URLs to connect to your stream.

This section contains the following topics:

  • Player URLs for broadcast publishing points
  • Player URLs for on-demand publishing points
  • Player URLs for default publishing points
  • Distribution server URLs

Related topics

  • Announcing content


Player URLs for broadcast publishing points

If you are streaming content from a broadcast publishing point, you must use the following URL format: <protocol>://server_name/publishing_point_name.

Related topics

  • Client URL reference


Player URLs for on-demand publishing points

  • The URL format you should use when streaming from an on-demand publishing point depends on the content source. Use the following table to identify the player URL for your publishing point.
Content source | URL | Description
Any | mms://server_name/publishing_point_name, mms://server_name/publishing_point_name/*, or mms://server_name/publishing_point_name/*.* | Requests all content. If you are sourcing from a directory, this URL includes subdirectories.
Directory | mms://server_name/publishing_point_name/ *.content_file_name_extension | Requests all digital media files with a particular file name extension, such as .mp3 or .wma.
Directory | mms://server_name/publishing_point_name/ *.playlist_file_name_extension | Requests all playlist files with a particular extension, such as .wsx.
Directory | mms://server_name/publishing_point_name/ subdirectory/content_file_name or mms://server_name/publishing_point_name/ subdirectory/playlist_file_name | Requests a specific file, such as mms://server1/ publishing_point1/movie1.wmv.

Note Image Note

  • The asterisk (*) wildcard character can be used to replace the entire file name, for example *.wma, or to replace both the file name and extension, for example *.*. In the examples provided in the table, if an asterisk (*) is used as a wildcard character or if nothing is specified after the publishing point name, then you must enable the WMS Directory Playlist Parser plug-in and the Enable access to directory content using wildcards property (located on the Properties tab of the publishing point). If either of those is not enabled, then an error message is returned to the client.

Related topics

  • Client URL reference


Player URLs for default publishing points

The URL format a client should use when connecting to a stream from a default publishing point depends on whether you have set up the default publishing point as an on-demand or broadcast publishing point, as follows:

  • If the default publishing point is an on-demand publishing point, use any valid syntax for an on-demand publishing point. For more information about on-demand publishing point syntax, see Player URLs for on-demand publishing points. The requested content must be explicitly stated in the URL, such as mms://server_name/filename.wmv.
  • If the default publishing point is a broadcast publishing point, use the format mms://server_name/* or mms://server_name/*.*, which requests all content referenced by the publishing point. If the publishing point is sourcing from a directory, this URL includes subdirectories.

Note Image Note

  • Because of the way that Windows Media Player versions 6.4 and 7.0 parse URLs that start with MMSU and MMST, the following URL formats to request content from the default publishing point will fail if used with those players:

    mmst://server_name or mmst://server_name/

    mmsu://server_name or mmsu://server_name/

    To support those players and to use the simplified URL format, you can enable the WMS HTTP Control Protocol plug-in. This plug-in allows players that cannot resolve the URL to roll over to HTTP, which uses the URL format http://server_name.

Related topics

  • Client URL reference


Distribution server URLs

If you are using a distribution server to stream content from an origin server, you can use the following URL formats to connect to the origin server from the distribution server:

  • If the origin server is inside a firewall, use rtsp://server_name/publishing_point_name.
  • If the origin server is separated from the distribution server by a firewall and an RTSP port cannot be opened by the firewall administrator, use http://server_name/publishing_point_name.

Related topics

  • About publishing point types
  • Announcing content
  • Client URL reference
  • Understanding protocols
  • Working with the announcement wizards


Understanding advertising

Windows Media Services offers another way to provide advertising to your users through the use of streaming digital media. You can prepare new or existing advertising content, such as TV and radio commercials, for streaming and then place the content on your Windows Media server. This section contains the following topics:

  • Choosing an advertising infrastructure
  • Choosing an advertising type
  • Creating advertisement policies
  • Logging advertising data
  • Personalizing advertising content

Related topics

  • Concepts


Choosing an advertising infrastructure

Windows Media Services supports both hosting advertising content on your Windows Media server and referencing advertising content hosted by an advertising service vendor.

If are hosting your own advertising, you control and store the advertising content. You can track advertising consumption directly and modify the content in response to situational changes.

If you sign up with an advertising service vendor, the advertising service vendor controls and stores the advertising content. You include references to the server that is hosting the advertising content in your playlist. The advertising service vendor is responsible for reporting advertising usage.

Many systems use a combination of self-hosted advertising and advertising from advertising service vendors. This combination provides both the benefits of local control over relevant advertising and the ease of employing an advertising service vendor to generate additional revenue.

This section contains the following topics:

  • Hosting advertising on your Windows Media server
  • Using an advertising service vendor

Related topics

  • Understanding advertising


Hosting advertising on your Windows Media server

If you are hosting advertising on your Windows Media server, the advertising content is treated just like any other content you want to stream. You should use playlists to reference your advertising content in order to better track the consumption of the advertising content. Use wrapper playlists to insert advertising before and after the content that users request. You can also use a standard playlist to reference any number of advertisements during a user session.

Advertising content that is used for site branding, such as station identifications and welcome messages, is often stored locally and referenced in wrapper playlists. Conversely, advertisements that play at various times during the user's session are usually included in standard playlists.

Related topics

  • About wrapper playlists
  • Choosing an advertising infrastructure
  • To add an advertisement to a playlist
  • To start the Create Wrapper Wizard
  • Understanding advertising
  • Understanding playlists


Using an advertising service vendor

Advertising service vendors are companies that provide advertisements to Web sites, including streaming media advertisements. If you choose to use an advertising service vendor, you must specify the URL of the advertising service vendor's server at the point in the playlist where you want the ad to appear.

Additionally, many content producers use content delivery networks (CDNs) to distribute their content to users rather than using their own servers to stream the content. CDNs are content providers that own Web servers and networks. They host content from content producers and distribute it to users. CDNs often have existing relationships with advertising service vendors to obtain advertising content that they can then incorporate into the Web sites they manage in order to generate revenue. If you decide to use a CDN to distribute advertising content, you will either need to give the CDN the ability to modify your playlist or obtain the relevant advertising vendor information from the CDN before you post your content to their network.

Regardless of whether you are distributing the content from your server or using a CDN, Windows Media Services can stream advertisements from an advertising service vendor using the following methods:

  • Static ads. In this situation, the advertisements are the same for all users, and the content distributor is in control of the advertising content. For example, if a content creator produces a sports video that received funding from several sportswear manufacturers, the content creator can specify that ads from those companies should be streamed to users who request the video. The distributor receives the advertising content from an advertising service vendor and places the ads in a wrapper playlist to be played before and after the sports video stream.
  • Dynamic playlists. In this situation, the advertisements change based on the user, and the advertising service vendor creates a playlist file that includes the requested content and the appropriate advertisements. For example, if a user is reading an article about animal behavior on a news Web site, and then he clicks a link to watch a video of an interview with a noted authority in the field, the playlist containing the interview can also include ads that are associated with pets. The information for creating the customized playlist can be provided to the advertising service vendor in either a query string or as a cookie.

Related topics

  • About wrapper playlists
  • Choosing an advertising infrastructure
  • To add an advertisement to a playlist
  • To start the Create Wrapper Wizard
  • Understanding advertising
  • Understanding playlists


Choosing an advertising type

You can use the following types of advertisements in Windows Media Services:

  • Banner advertisements. Static or rotating advertisements that appear in a specific region of a player. The banner is identified using the clientData element with the associated media element.
  • Interstitial advertisements. Advertisements that are interspersed with a content stream. Interstitial advertisements can be an audio and video stream, a dynamic playlist, or a JPEG image. You can play interstitial advertisements as part of a playlist sequence or in response to an event, such as a script command from an encoder.
  • Bumper advertisements. Advertisements that are played before and after content. These advertisements are commonly used for site branding, station identification, and listing content sponsors. Wrapper playlists provide an easy way to implement this type of advertisement.

Related topics

  • About wrapper playlists
  • To add an advertisement to a playlist
  • To start the Create Wrapper Wizard
  • Understanding advertising
  • Understanding playlists


Creating advertisement policies

You can use policies to control how advertising content is received by users. An advertisement policy defines the user experience by combining the following:

  • Events. You can use an event to trigger a switch to a certain advertisement. For example, in a live broadcast stream, you can use an event to insert regional advertising in place of national advertising and vice versa.
  • Playlist attributes. You can configure playlist attributes to control the user experience with advertising. For example, if you set the noSkip attribute to True, the fast-forward and seek controls on the user's player are disabled. For the user to continue to receive the content in the playlist, the advertisement must play to completion.

Related topics

  • About wrapper playlists
  • To add an advertisement to a playlist
  • To start the Create Wrapper Wizard
  • Understanding advertising
  • Understanding playlists


Logging advertising data

If you want to log data about the advertisements you stream, the best way to gather the data is by using playlists to reference your content.

Because playlists in Windows Media Services are Extensible Markup Language (XML) documents, each element in a playlist supports attributes. Each piece of content in a playlist is a separate media element, so you can differentiate advertising content from other media elements easily by using the role attribute. When a specific media element is selected in either the Playlist Editor or on the Source tab, you can select its role attribute and then specify the value as Advertisement. When you specify a value for the role attribute, Windows Media Services will provide advertising-specific statistics to the administrative interfaces. These statistics can help you keep track of the number of advertisements streamed from a server or publishing point.

You can use the WMS Client Logging plug-in to create log files that you can analyze. The log files that are created by the plug-in are simple comma-delimited text files in which data is grouped into different fields. To extract useful information from the log file, you must determine a method to use to analyze the data. One useful method is to group items by the value of their cs-media-role field, which is the field that reflects the value you specified for the role attribute. You can summarize the data to find out information about a particular advertisement, such as:

  • The number of users that played the entire advertisement.
  • The number of users that disconnected from the stream during the advertisement.
  • The average amount of time users played the advertisement.
  • The number of users that received the advertisement.
  • The content that was requested before and after the advertisement played.

This information can help you determine which advertisements are most effective, bill clients, and make decisions about future advertising content.

Note Image Note

  • For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.

Related topics

  • Log file entries reference
  • Logging data and events
  • To configure and enable unicast logging
  • Understanding advertising


Personalizing advertising content

There are many different methods that you can use to personalize advertising content for your users, including:

  • Cookies. You can use information stored in cookies to access the demographic data of your users and target advertising that is relevant to user profiles. This method is used by most advertising service vendors. For more information about using cookies with Windows Media Services, see the Windows Media Services 9 SDK on the Microsoft Web site.
  • Usage history. If you are using authentication, you can track users' choices and activities on your Web site and then provide appropriate advertisements, based on these activities. Over time, the usage history can help you to target advertising to your site audience. This method is good for Web sites that have high user return rates.
  • User provided interest information. This is the easiest way to provide personalized advertising to your users. It requires that you use an authentication method to identify your users to the server. You can ask users what their interests are when they set up accounts on your Web site and then provide advertisements that are appropriate.

Related topics

  • About wrapper playlists
  • To add an advertisement to a playlist
  • To start the Create Wrapper Wizard
  • Understanding advertising
  • Understanding playlists


Logging data and events

Logging is a means of recording the activity of the clients that connect to your content.

Logging for unicast streams is provided by the WMS Logging plug-in.

This section includes the following topics:

  • Understanding logging
  • Logging data about unicast streams
  • Logging data about multicast streams
  • Distributing log files to customers
  • Log file reference information
  • Understanding event handler plug-ins

Note Image Notes

  • Logging for multicast streams broadcast by Windows Media Services is provided by the Multicast and Advertisement Logging Agent, which is an Internet Server Application Programming Interface (ISAPI) extension. You can use this extension with your Web server to log data about players that receive content as a multicast stream.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Concepts
  • Understanding publishing points
  • Managing your Windows Media server


Understanding logging

Logging is important in a streaming media system for a variety of reasons:

  • Client activity and server activity logs allow you to keep a record of what you have streamed from your server and to whom.
  • Log information can help you track the usage of your server and estimate when you might need to add more resources to your system.
  • Log files can assist you in planning your security implementation. If your system is subjected to a denial of service attack, log files can help you determine which clients are being used in the attack.
  • Log files can help you identify user-reported issues with your streaming system by providing event codes that correspond to common issues.
  • Log files provide historical data for use in trend analysis and business cases.

The log files created by the WMS Logging plug-in are space delimited text files that adhere to the World Wide Web Consortium (W3C) standard for log files. Each entry in the log file corresponds to a server or client event and has corresponding result code. For more information about log file entries and result codes, see Log file reference information.

By default, log files created by the WMS Client Logging plug-in are saved to %systemroot%\System32\LogFiles\WMS and log files created by the Multicast and Advertisement Logging Agent are saved to %systemroot%\System32\LogFiles\WMS_ISAPI. If you do not have adequate disk space on the drive to which log files are being written, the logging plug-in will stop logging and post a warning message to the troubleshooting list.

This section contains the following topics:

  • Reading log files
  • About GUID types
  • Comparing log features
  • Simulating logs

Related topics

  • Logging data and events


Reading log files

Log files are space delimited text files that can be read by any program that can import text files, such as a text editor, a spreadsheet program, a word processing program, or a database program.

The information contained in the Log file reference information section identifies the different fields in the log file and what the entry codes represent. In some cases, the information in the log file requires special interpretation. Please keep in mind the following when analyzing log file information:

  • If the client does not send log information to the server at the end of the stream, the server simulates log information using the information obtained when the client connected to the server and the server streaming statistics. Client statistics and fields relevant to the stream are filled with zeros and hyphens because no information was sent.
  • The server will generate a log entry for each piece of digital media content streamed from a server-side playlist. Windows Media Player version 6.4 or embedded players that use the version 6.4 ActiveX control only send log information at the end of a session. This results in log entries that do not have client statistics for all of the playlist content except the last one. After the last item is streamed to the client, the client will send a log that has aggregated all of the client statistics from the beginning of the playlist.

Related topics

  • Simulating logs
  • Understanding logging


About GUID types

Log files store information about the globally unique identifiers (GUIDs) of the clients that connect to your server in the c-playerID field. This information can be useful for tracking client activity. You may encounter the following types of GUIDs in your log files:

  • Unique GUID: If the user has not disabled unique identification, the player will send a unique identifier to the server.
  • Anonymous GUID. If the user has disabled unique identification, the player will send an anonymous identifier to the server. This GUID value is reported as 3300AD50-2C39-46c0-AE0A-xxxxxxxxxxx, where xxxxxxxxxxx is replaced by the session ID of the client. The session ID of the client is a randomly generated value that the server assigns to the client when it connects.
  • Server GUID. If the client is a distribution server, the GUID value will be filled with zeroes (0000000000).

Related topics

  • Log file entries reference
  • Understanding logging


Comparing log features

Windows Media Services provides several new logging capabilities and features that are unavailable in previous versions. This topic compares the log file structure and plug-in features of the current version of Windows Media Services to those of version 4.1.

Log types

Windows Media Services now logs downstream server data as well as client data. Downstream Windows Media servers that are acting as distribution or cache/proxy servers upload a log to the origin server at the completion of the stream. This information is recorded in the log file.

Additionally, efforts to reduce the latency of streaming broadcasts have made it necessary to separate the streaming and rendering portions of client log data because they may no longer take place at the same time.

Text format

Previous versions of the Windows Media server only supported ANSI output of log files. This most recent version supports both ANSI and UTF-8 text formats. You can adjust the properties of the plug-in to toggle between the two formats.

File names

The log file name structure in Windows Media Services is now configurable. Through the use of environment variables and wildcard characters you can specify a file name structure that represents the data contained in the file. Use the default settings to create log file names that are compatible with version 4.1.

Headers

The current version of Windows Media Services ads six new headers to the log file:

  • StartDate. The date and time that the log file was created.
  • EndDate. The date and time that the log file was closed.
  • TimeFormat. The time format used in the log file (can be UTC or local time).
  • EncodingFormat. Whether the text format of the log file is ANSI or UTF-8.
  • ServerName. The name of the server which generated the log file.
  • ServerIP. The IP address that the server is bound to.

For more information on log headers, see Log file header reference.

Log status codes

In addition to the status codes used in version 4.1, the Windows Media Services 9 Series uses:

  • 210. Client successfully reconnected.
  • 401. Access denied.
  • 404. File not found.
  • 420. Client reconnect error.
  • 500. Internal server error.

In some cases, users of previous Windows Media server versions have set up automated parsing of log files. The additional information and organization provided by the WMS Client Logging plug-in are likely to be incompatible with such processes. If you wish to continue receiving log files in version 4.1 format, you have the option of turning off the updated format in the plug-in properties.

Related topics

  • Logging data about unicast streams
  • Understanding logging


Simulating logs

Under certain circumstances, the Windows Media server will simulate log files or entries. Simulated logs are the result of missing or insufficient logging data received from the client. Simulated logs can be used to analyze or troubleshoot interrupted or unsuccessful streaming attempts.

Log files or events are typically simulated when the server recognizes that it should have received a log entry and didn't, for example:

  • At the end of each playlist entry when streaming to Windows Media Player version 6.4. This is because this version of the player does not submit logs during a playlist entry change.
  • At the end of a streaming broadcast to Windows Media Player version 6.4. This is because this version of the player enters a never ending buffering state.
  • When the client abnormally disconnects. This is because the player does not have an opportunity to send up a log entry.

Simulated log entries contain whatever server-side data is available as well as any client information that may have been transferred at the beginning of the streaming session (such as player ID and IP address).

Related topics

  • Understanding logging


Logging data about unicast streams

To log data about players or servers that receive content as a unicast stream, you can use the WMS Client Logging plug-in. You can enable this plug-in at the server level to provide global logging coverage, or you can enable it at the publishing point level if you want to log data only for a specific publishing point.

Significant changes have been made to the logging tool over previous versions in order to accommodate fast streaming and to gather data from downstream client servers. Because of this, log files can take several different forms and represent a wide range of client data, depending on the nature of the streaming session. Overall, there are two main types of logs: client logs and server logs. Client logs are intended to gather information about player events, while server logs gather data about downstream servers. This section contains the following topics:

  • Using client logs
  • Using server logs

The log files that are generated are stored in the folder specified in the WMS Client Logging Plug-in Properties dialog box.

Note Image Notes

  • Windows Media Services does not include a logging plug-in for encoder push scenarios. You can log encoder push broadcast data by creating an event notification plug-in or an event notification script for use with the WMS Active Script Event Handler plug-in on your Windows Media server. For more information about creating a custom plug-in, see the Windows Media Services Software Development Kit (SDK), which can be downloaded from the Windows Media home page at the Microsoft Web site.
  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you want to save logging information to a file that is in a folder other than %systemroot%\System32\LogFiles\WMS, ensure that the folder is shared and that the Network Service account has read, write, and modify permissions for the folder. If the Network Service account does not have the appropriate permissions for the folder, the server will not be able to save log information to it. For more information about rights and permissions, see Understanding rights.

Related topics

  • Logging data and events


Using client logs

In previous versions of Windows Media Services, content streaming and rendering occurred simultaneously for the player. With the addition of the Fast Start and Fast Cache features in Windows Media Services 9 Series, content may be delivered more quickly than it can be rendered by the player. Therefore, client logs must be able to display separate data for streaming and rendering events, and clients must submit three different types of client logs: render logs, stream logs, and combination logs. This section contains the following topics:

  • About render logs
  • About stream logs
  • About combination logs

Related topics

  • Logging data about unicast streams


About render logs

Render logs are the most common type of log that the player returns to the origin server. A render log contains only information about playback events. A render log entry is sent to the server whenever the player stops rendering the content, such as when user clicks the stop, pause, fast forward or rewind buttons.

A player that reads the content from a local cache, such as during a Fast Streaming session, sends a render log when it finishes playing back the content.

Render logs are only available when streaming on-demand content using the TCP network protocol. Streaming protocols that do not support Fast Streaming, such as UDP and MMST, also do not support render logs. A render log contains no network statistics, always lists network quality as 100 percent, and always lists the network protocol as "CACHE."

Note Image Note

  • Render logs are not supported by Windows Media Player for Windows XP and earlier.

Related topics

  • Using client logs


About stream logs

Stream logs are sent to the server when content is streamed to a player-side cache. The stream log indicates how the client received the data, but not how it was rendered. It displays information about the content that was streamed and the network conditions.

Stream logs are only available when streaming on-demand content using the TCP network protocol. Streaming protocols that do not support Fast Streaming, such as UDP and MMST, also do not support stream logs.

Note Image Note

  • Stream logs are not supported by Windows Media Player for Windows XP and earlier.

Related topics

  • Using client logs


About combination logs

Combination logs contain both client stream and rendering data and are identical to the logs sent by Windows Media Player for Windows XP and earlier. Combination logs are sent when either of the following conditions is met:

  • The client player is an earlier version. Players compatible with Windows Media Player for Windows XP and earlier do not have the ability to use the Fast Streaming feature or to generate separate rendering and streaming logs.
  • Fast Streaming is not enabled for this session. Separate rendering and streaming logs are only necessary when content is not streamed in real time.

Related topics

  • Using client logs


Using server logs

Server logs indicate how a downstream server received content. No rendering data is included in the server logs. Server log data is sent when the downstream server stops receiving content. There are two types of server logs that can be created: distribution logs and propagated cache/proxy logs. A distribution log records information about a downstream distribution server, while a propagated cache/proxy log records information about a downstream cache/proxy server.

  • About distribution logs
  • About propagated cache/proxy logs

Related topics

  • Logging data about unicast streams


About distribution logs

Data logged from distribution servers indicate how the distribution server received the content. When the distribution server stops receiving data from the origin server it sends a distribution log to the origin server.

This log does not indicate any rendering statistics, but instead indicates the quality and duration of the content that it received.

Distribution servers using Windows Media Services versions 4.1 and earlier cannot send distribution data back to the origin server. The distribution log notes this inability and records any server-side distribution statistics it has collected instead.

Related topics

  • Using server logs


About propagated cache/proxy logs

A cache/proxy server can receive data from an origin server in the following ways:

  • Streamed from the origin server directly into cache storage.
  • Streamed from the origin server through the cache/proxy server to the requesting client.
  • Streamed into the cache/proxy server and then split into multiple broadcast streams.

The log sent by the cache/proxy server indicates the quality and duration of the content that was received from the origin server. The WMS Logging plug-in on the origin server can be configured to request that client logs are forwarded to the origin server upon receipt or are retained on the cache/proxy server. If there are multiple cache/proxy servers between the origin server and the client, logs will be transferred through any intermediate cache/proxy servers to the origin server.

Related topics

  • Using server logs


Logging data about multicast streams

To log data about players that receive content as a multicast stream, you can use the Multicast and Advertisement Logging Agent, which installs the Windows Media Internet Server Application Programming Interface (ISAPI) extension (wmsiislog.dll).

The Multicast and Advertisement Logging Agent must be installed by an administrator to allow it to write its properties to the registry and is available as an optional component of Windows Media Services setup. After installation it reads its configuration setting from the registry of the Web server it is installed on. For more information on the properties of the ISAPI application, see the ISAPI properties reference. The ISAPI extension is installed in the %systemdrive%\WMPub\Wmiislog folder.

Log files for multicast clients are saved to the %systemroot%\System32\LogFiles\WMS_ISAPI folder. This folder is created automatically when you register wmsiislog.dll. Each log file name uses the WMS_ISAPI_yyyymmdd.log format, where yyyymmdd is the year, month, and day when the log file is created. If more than one log file is generated in a day, an incremented number is added to the file name, using the format WMS_yyyymmdd_iiii.log, where iiii is a number that starts at 0001 and increases by one for every log file generated after the first one. Make sure you have configured Internet Information Services (IIS) to support Internet Server Application Programming Interface (ISAPI) applications so that Wmsiislog.dll can receive logs. You can also write a Common Gateway Interface (CGI) script to generate a log file.

The information that is generated in a log file for a multicast client is the same as information generated by the WMS Client Logging plug-in, except that it does not have server statistics. For information about the fields in a log file, see Log file header reference and Log file entries reference.

Note Image Notes

  • The log file contains data for all multicast clients receiving a stream from the server, regardless of the publishing point. You can also use the ISAPI extension to distribute log files to customers so they can have a record of activity for multicast clients.
  • Windows Media Services does not include a logging plug-in for encoder push scenarios. You can log encoder push broadcast data by creating an event notification plug-in or an event notification script for use with the WMS Active Script Event Handler plug-in on your Windows Media server. For more information about creating a custom plug-in, see the Windows Media Services Software Development Kit (SDK), which can be downloaded from the Windows Media home page at the Microsoft Web site.
  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you want to save logging information to a file that is in a folder other than %systemroot%\System32\LogFiles\WMS_ISAPI, ensure that the folder is shared and that the Network Service account has read, write, and modify permissions for the folder. If the Network Service account does not have the appropriate permissions for the folder, the server will not be able to save log information to it. For more information about rights and permissions, see Understanding rights.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • To configure and enable multicast logging
  • Distributing log files to customers
  • Log file reference information
  • Logging data and events


Distributing log files to customers

If you host content, you may have customers who want to receive log files for their content. Windows Media Services offers the following two methods to accomplish this: you can add a LOGURL tag to the client-side playlist file (also called the announcement file) for your customers' content or you can use the logURL attribute in a server-side playlist to send log files to your customers.

Client-side playlists

The LOGURL tag has the syntax <LOGURL href="URL" />, where URL is the path to a directory specified by your customer. The LOGURL tag within an announcement file can be used with clients running Microsoft Windows Media Player version 7.0 or later.

To process the log data, your customers can use the Multicast and Advertisement Agent Internet Server Application Programming Interface (ISAPI) extension (wmsiislog.dll). They can also write a Common Gateway Interface (CGI) script or develop an ASP page to process the log data.

You must use HTTP or HTTPS for the LOGURL tag. You can add the tag to the ASX scope or to the ENTRY scope. If you add the tag to the ASX scope, the tag applies to all content referenced in the announcement file, including content that is referenced by secondary announcement files. If you add the tag to the ENTRY scope, the tag applies only to the content referenced in the ENTRY scope. Therefore, only client actions associated with content in the ENTRY scope are logged.

You can add multiple LOGURL tags. If you do so, data is logged to each URL you specify. The ENTRY scope inherits tags from the ASX scope. Therefore, if you add one URL to the ASX scope and another to the ENTRY scope, data for the content in the ENTRY scope is logged to both URLs. If you add the same URL to both the ASX and ENTRY scopes, the data is logged only once to the URL. If the announcement file references secondary announcement files, the secondary announcement files inherit any LOGURL tags that are in the primary announcement file. Therefore, LOGURL tags in the primary announcement file also apply to entries in the secondary ASX scopes.

After you add the tag, when Windows Media Player submits a log entry, it performs an HTTP Get first to the URL that was specified in the LOGURL tag to guarantee that the URL is valid. After an acceptable header is returned, Windows Media Player reconnects to the HTTP server and uses an HTTP Post tag to the same URL. The fields logged by the Multicast and Advertisement Logging Agent are the same as the fields logged by the WMS Client Logging plug-in. The only exception is that there are no server statistics because Windows Media Player is only submitting client data.

To provide the customer with more flexibility in sorting and classifying log files, you can specify the values for some of the log file entry fields in the announcement file. When a player connects to the server, the player receives this information in the form of a Content Description List (CDL). When the player sends log information back to the server, it also returns some fields with the values you specified. The cs-media-name and cs-media-role fields can be specified in this manner.

Server-side playlists

The logURL attribute is an attribute of a clientData element in a server-side playlist. The clientData element is a child element that associates text information, banner images, and logging information to the parent media element. Using the logURL attribute of a clientData element is helpful when streaming content from several different sources, each of which need to receive content-specific logging information. The logURL attribute only directs log data that is specific to the media elements in the playlist that have associated clientData elements. If the client is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. For more information about the logURL attribute, see logURL attribute. For more information about the clientData element, see clientData element.

Related topics

  • Log file reference information
  • Logging data and events


Log file reference information

A log file is a text file that is divided into two general areas: the header and the log entries. The header, which appears first in the log file, contains data about the log file. The log entries contain data about client activity. This section contains tables that provide reference information about the fields that appear in the log file header and log file entries. This section also contains a table of the wildcard characters you can add to a log file name if you want a log file name to be more meaningful.

This section contains the following topics:

  • Log file header reference
  • Log file entries reference
  • Wildcard characters reference
  • ISAPI properties reference

Related topics

  • Logging data and events


Log file header reference

The log file header consists of a number of lines, each starting with a number sign (#), followed by the header field name, a colon, a single space, and the field's value. Each line ends with a carriage return (\n). The header consists of the following entries (in order).

Field name | Description | Example
StartDate | The date (in international date format, YYYY-MM-DD) and time (hh:mm:ss) the log file was created. It represents the date and time by using the locale of the server generating the log file. This field is named Date in log files that are generated by the Multicast and Advertisement Logging Agent ISAPI extension. | #StartDate: 2001-11-30 16:05:03
EndDate | The date (in international date format, YYYY-MM-DD) and time (hh:mm:ss) the log file was closed. It represents the date and time by using the locale of the server generating the log file. This field does not appear in log files that are generated by the Multicast and Advertisement Logging Agent ISAPI extension. | #EndDate: 2001-11-30 16:05:42
TimeFormat | The time format used in the log file (Coordinated Universal Time (UTC) or local). If the time format is local, the number in parentheses represents the number of minutes before UTC. | #TimeFormat: Local(480)
EncodingFormat | The text encoding used in creating the log file, which can be either UTF-8 or ANSI. UTF-8 is the default. | #EncodingFormat: ANSI
ServerName | The name of the server generating the log file. This field does not appear in log files that are generated by the Multicast and Advertisement Logging Agent ISAPI extension. | #ServerName: WMS_Server_1
ServerIP | A comma-separated list of Internet Protocol (IP) addresses that the Windows Media Services service is bound to. This may not include every IP address the computer is bound to. This field does not appear in log files that are generated by the Multicast and Advertisement Logging Agent ISAPI extension. | #ServerIP: 192.168.1.2, 192.168.1.33
Software | The software name. | #Software: Windows Media Services
Version | The version of the Windows Media Services service. | #Version: 9.0
Publishing Point | The name of the publishing point the log file is associated with. The field includes any forward slash (/) characters in the name. This field does not appear in log files that are generated by the Multicast and Advertisement Logging Agent ISAPI extension. | #Publishingpointname: [Global] (represents the entire server) #Publishingpointname: Name
Fields | Space-separated list of all the field names that are logged in the order in which they are logged. The Fields header is always the last header entry in the header. | #Fields: c-ip date time c-dns

Related topics

  • Log file reference information


Log file entries reference

Each client event in a log file is represented as a single line, or log entry. Each log entry contains a number of space-delimited fields. All spaces embedded in a field value are replaced by underscore (_) characters (for example, Windows NT appears as Windows_NT). If there is no value available for a given field, a single hyphen (-) character is used to indicate the value is either not available or not applicable. For example, there is no data available for server statistics fields in log files created by the Multicast and Advertisement Logging Agent, so those fields contain single hyphens.

The following table contains a list of each field (in the order in which the field appears in the log file), a description, and a sample value. It also identifies whether the data in the field is reported from unicast clients, multicast clients, or both..

Field name | Description | Sample value | Client data reported
c-ip The source Internet Protocol (IP) address of the connected socket. This may be the IP address of a proxy server or firewall. 157.56.219.146 Unicast

Multicast
date Date when a client connected (in international date format). 2001-04-19 Unicast

Multicast
time Time when the client connected. The time format is either in Coordinated Universal Time or local time, depending on how the logging plug-in is configured. 15:30:30 Unicast

Multicast
c-dns This field is always blank. - Unicast

Multicast
cs-uri-stem The path (requested URL without the schema, host, port number, and question mark) to the content that was requested. See cs-url for the full URL. Note that this represents a change from Windows Media Services version 4.1, in which this field contained the full URL. /test/sample.wmv
or
/broadcast 		Unicast

Multicast
c-starttime Timestamp (in seconds, no fractions) indicating the point in the stream when the client started to render content. For live broadcasts, this field is set to 0. 39 Unicast

Multicast
x-duration Length of time (in seconds) of the data received by the client. For player log entries, the value does not include buffered data. For distribution server log entries, the value includes all time spent receiving data, including any buffering. 31 Unicast

Multicast
c-rate The rate at which data is sent from the server to the client. Possible values:
0.5: Half of the real-time rate.

1: Real-time rate

2: Twice as fast as real-time

5: fast forward

-5: fast rewind

If you are using Fast Streaming, these values could be considerably higher or lower depending on the content and the available bandwidth.

 1 Unicast

Multicast
c-status Codes that describe client status. Possible codes:
200: The connection was successful.
210: The client reconnected (after first disconnecting).
400: The requested URL was invalid.

401: The client was denied access.
404: The requested content was not found.
408: The client failed to submit a log because the client disconnected.
420: The client was disconnected and attempted to reconnect but failed. The client will then connect again starting a new session. This code reflects the client's statistics when it was originally disconnected. For each log entry with this code there should be a 408 that has the same session ID.

500: The Windows Media server encountered an internal error and stopped streaming.

200 Unicast

Multicast
c-playerid Globally unique identifier (GUID) of the client. For player log entries, if the player is configured not to send unique player identification information to content providers, the value is: {3300AD50-2C39-46c0-AE0A-xxxxxxxxxxxx}, where x is the session ID of the client. For distribution server log entries, this value is always a series of zeroes. {c579d042-cecc-11d1-bb31-00a0c9603954} Unicast

Multicast
c-playerversion For player log entries, this field represents the version number of the player. For distribution server log entries, this field represents the version number of the distribution server. 6.2.5.415 Unicast

Multicast
c-playerlanguage Language and country/region code of the player. en-US Unicast

Multicast
cs(User-Agent) | Browser type used if the player was embedded in a browser. If the player was not embedded, this field refers to the user agent of the client that generated the log. | Mozilla/4.0_(compatible;_MSIE_4.01;_Windows_98) | Unicast
cs(Referer) | URL to the Web page in which the player was embedded (if it was embedded). If this is unknown, this field is blank. | http://www.example.microsoft.com | Unicast
c-hostexe For player log entries, the host program (.exe) that was run. For example, a Web page in a browser, a Microsoft Visual Basic applet, or a stand-alone player. For distribution server log entries, the name of the distribution server's service program (.exe) that was run. iexplore.exe
vb.exe
mplayer2.exe
WMServer.exe 		Unicast

Multicast
c-hostexever Host program (.exe) version number. 4.70.1215 Unicast

Multicast
c-os Client operating system. Windows_NT Unicast

Multicast
c-osversion Version number of the client operating system. 4.0.0.1381 Unicast

Multicast
c-cpu Client CPU type. Pentium Unicast

Multicast
filelength | Length of the digital media file (in seconds). This value is zero for a stream delivered from a broadcast publishing point. | 60 | Unicast
filesize | Size of the digital media file (in bytes). This value is zero for a stream delivered from a broadcast publishing point. | 86000 | Unicast
avgbandwidth Average bandwidth (in bits per second) at which the client was connected to the server. The value is calculated across the entire duration of the connection. 24300 Unicast

Multicast
protocol Actual protocol used to access the content (may differ from the protocol requested by the client). A value of "Cache" indicates that a client played the content from its disk-based cache. A value of "asfm" indicates that the content was delivered using multicast transmission. MMST Unicast

Multicast
transport Transport protocol used to stream content. Multicast content is always streamed using UDP. UDP
TCP
 Unicast

Multicast
audiocodec For player log entries, the audio codecs used to encode the audio streams the client accessed. If multiple codecs were used, the values are delimited by a semicolon. This field contains a hyphen (-) in distribution server log entries. Microsoft_Audio_Codec Unicast

Multicast
videocodec For player log entries, the video codecs used to encode the video streams the client accessed. If multiple codecs were used, the values are delimited by a semicolon. This field contains a hyphen (-) in distribution server log entries. Microsoft_MPEG-4_Video_Codec_V2 Unicast

Multicast
channelURL URL to the multicast information file. This field contains a hyphen (-) in a client receiving content as a unicast stream unless the unicast stream is a result of a unicast rollover from a multicast stream. http://www.example.microsoft.com/channel.nsc Unicast

Multicast
sc-bytes Total number of bytes the server sent to the client. The value does not include any overhead that is added by the network stack. However, protocols such as MMS, RTSP, and HTTP may introduce some overhead. Therefore, the same content streamed by using different protocols may result in different values.

This field contains a hyphen (-) in propagated cache/proxy logs and in multicast log files.

 30000 Unicast
c-bytes Number of bytes received by the client from the server. The value does not include any overhead that is added by the network stack. However, protocols such as MMS, RTSP, and HTTP may introduce some overhead. Therefore, the same content streamed by using different protocols may result in different values. If c-bytes and sc-bytes are not identical, packet loss occurred. 28583 Unicast

Multicast
s-pkts-sent | Number of content packets sent by the server to a connected client. The value does not include TCP or UDP packets. This field contains a hyphen (-) in propagated cache/proxy logs and in multicast log files. | 55 | Unicast
c-pkts-received Number of packets from the server (s-pkts-sent) that are received correctly by the client on the first try. Packets that are not received correctly on the first try can be recovered if they are resent through the UDP protocol. Packets that are not recovered through UDP resend are considered lost in the network. You can recover these packets if error correction is enabled. The value does not include TCP or UDP packets. 50 Unicast

Multicast
c-pkts-lost-client Packets lost that were not recovered at the client layer through error correction or at the network layer through UDP resends, during transmission from server to client. These packets are sent by the Windows Media server but never played by the client. The value does not include TCP or UDP packets. 5 Unicast

Multicast
c-pkts-lost-net Number of packets lost on the network layer. You can still recover these packets if error correction is enabled. The value does not include TCP or UDP packets. 2 Unicast

Multicast
c-pkts-lost-cont-net Maximum number of continuously lost packets on the network layer during transmission from server to client. If the value is high, the network conditions were bad, with long periods of time during which the client received no packets. The value does not include TCP or UDP packets. 2 Unicast

Multicast
c-resendreqs Number of client requests to receive new packets. This field contains a zero unless the client is using UDP resend. 5 Unicast

Multicast
c-pkts-recovered-ECC Packets lost in the network (c-pkts-lost-net) that were repaired and recovered at the client layer because error correction was enabled. Error correction is the only means of packet recovery for multicast streams. Packets repaired and recovered at the client layer are equal to the difference between c-pkts-lost-net and c-pkts-lost-client. The value does not include TCP or UDP packets. 3 Unicast

Multicast
c-pkts-recovered-resent Number of packets recovered because they were resent through UDP. The value does not include TCP or UDP packets. This field contains a zero unless the client is using UDP resend. 5 Unicast

Multicast
c-buffercount Number of times the client buffered while playing the stream. 4 Unicast

Multicast
c-totalbuffertime Time (in seconds) the client used to buffer the stream. If the client buffers more than once before a log entry is generated, c-totalbuffertime is the total amount of time the client spent buffering. 6 Unicast

Multicast
c-quality The lowest amount of stream quality reported by the Player during the playback of the stream. 96 Unicast

Multicast
s-ip IP address of the server that received the log file. For multicast log files, this value will be the IP address of the Web server on which Wmsiislog.dll is installed. 224.24.41.189 Unicast

Multicast
s-dns | Domain Name System (DNS) name of the server that received the log file. This field contains a hyphen (-) in multicast log files. | media.server.company.com | Unicast
s-totalclients | Number of clients connected to the server (but not necessarily streaming) at the time the event was logged. This field contains a hyphen (-) in propagated cache/proxy logs and in multicast log files. | 20 | Unicast
s-cpu-util | Average load on the server processor (0 to 100 percent). If multiple processors exist, this value is the average for all processors. This field contains a hyphen (-) in propagated cache/proxy logs and in multicast log files. | 40 | Unicast
cs-username | The user name the client provided during authentication. This field contains a value only if authorization and authentication plug-ins are enabled. If an anonymous authentication method is used, this field will contain a hyphen (-). | JSmith | Unicast
s-sessionid | A session identifier the server uses to track a stream session. This is important for tracking multiple log entries to the same session. Note that if Windows Media Player version 6.4 received content over HTTP, the s-sessionid value will change for each log entry, even if the entries are for the same session. | 123456 | Unicast
s-contentpath The actual content that streamed. A plug-in may resolve a requested path to another path. If the client was redirected, this field represents the location to which the client was redirected. file://C:\WMPub\WMRoot\Encoder_ad.wmv

or

http://www.example.microsoft.com/speech.wma

 Unicast
cs-url The actual URL requested by the client.

For multicast clients, this value is the multicast IP address and port. However, Windows Media Player 9 Series and the Windows Media Player 9 Series ActiveX control multicast clients submit the multicast IP address and port, followed by the IP address of the network interface from which the server broadcasts the multicast.

 mms://microsoft.com/mycontent.wmv

asfm://206.73.118.254:26502

-or- (for Windows Media Player 9 Series clients)

asfm://multicast IP address:port/Server IP address

 Unicast

Multicast
cs-media-name If the client was receiving content from a playlist, the media element the client was receiving. The value is derived from the mediaName attribute of the playlist media element. If the mediaName attribute is not present, the value in this field is derived from the file name value. This field is blank if the client was not receiving content from a playlist.

Alternatively, this entry can be specified in the announcement file in order to classify logs according to user or content.

 /ads/MyAd2.asf Unicast
c-max-bandwidth The maximum bandwidth rate (in bits per second) of the client. This value can be used to determine whether clients have the capacity for higher bandwidth content. The value recorded for this field can have the following types of values:
a) a valid number of bps reported from the client., such as 38400

b) an undetermined amount, logged as 0.

c) a very large amount that cannot be accurately measured but is greater than 1000000 bps but less than 1000000000 bps, logged as a hyphen (-).

d) a hyphen (-), when a file is being played from the local cache and no bandwidth is used.

 384000 Unicast

Multicast
cs-media-role A user-defined value that identifies the role of a media element in a playlist. Typically, this field is used to enable advertisement logging. For more information, see Logging advertising data.

If the media element does not have a role attribute, or if the client was not receiving content from a playlist, this field is blank.

Alternatively, this entry can be specified in the announcement file in order to classify logs according to user or content.

 Ad Unicast
s-proxied | Indicates whether the client connected through a cache/proxy server. A value of "0" indicates no cache/proxy server was involved. A value of "1" indicates a cache/proxy server was involved. | 1 | Unicast

Related topics

  • Log file reference information


Wildcard characters reference

You can add wildcard characters to a log file name if you want to change the name to suit your needs. Wildcard characters must be delimited by the less than (<) and greater than (>) characters. For example, the log file name template WMS_<a><B><Y>.log might correspond to the log file name WMS_MonApril2000.log.

The following table lists and describes the wildcard characters.

Character | Description
a | Abbreviated name for the day of the week (three letters).
A | Full name for the day of the week.
b | Abbreviated month name (three letters).
B | Full name for the month.
c | Date and time representation appropriate for the location of the server generating the log file.
d | Day of month in two-digit format (01 to 31).
H | Hour (24-hour format) in two-digit format (00 to 23).
I | Hour (12-hour format) in two-digit format (01 to 12).
j | Day of year in three-digit format (001 to 366).
m | Month in two-digit format (01 to 12).
M | Minute in two-digit format (00 to 59).
N | A four-digit sequence that starts at 0 and increases every time a new file is needed. The counter resets to 0 when the rest of the file name changes in any way.
p | The indicator for 12-hour format (AM or PM) of the server generating the log file.
S | Seconds in two-digit format (00 to 59).
T | The computer name of the server generating the log file.
U | Week of the year in two-digit format (00 to 53, with Sunday as the first day of week).
V | The name of the publishing point for which data is being logged. If data is being logged for a server, the word "[Global]" is inserted in the log file name. If data is being logged for the default publishing point, the word "[Default]" is inserted in the log file name. If the publishing point name contains a forward slash (/) character, the character will be replaced with an underscore (_) character in the log file name. If the publishing point is renamed, the log file will automatically cycle to reflect the new name.
w | Day of the week in one-digit format (0 to 6, with Sunday as 0).
W | Week of the year in two-digit format (00 to 53, with Monday as the first day of the week).
x | Date representation for the location of the server generating the log file.
X | Time representation for the location of the server generating the log file.
y | Year in two-digit format (00 to 99).
Y | Year in four-digit format.
Z | Time zone name or abbreviation. There are no characters if the time zone is unknown.

Note Image Note

  • You can add environment variables to the log file path. For information about environment variables, see Windows Help and Support.

Related topics

  • Log file reference information


ISAPI properties reference

When you install the Multicast and Advertisement Logging Agent, Windows Media Services creates the following registry keys in the registry of the computer. You can use these registry keys to modify the properties of the Wmsiislog.dll application extension. The following table provides information about the property values, which are stored in the registry key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows Media\Server\ISAPI\Logging.

Setting | Type | Description
LogDirPath | REG_EXPAND_SZ | Provides the path to the log file. By default this value is %systemroot%\System32\LogFiles\WMS_ISAPI.
FreeSpaceQuota | REG_DWORD | Provides the minimum amount of available disk space on the drive to which log files are being written. If the amount of free disk space is not available, the log file will not be written and the multicast logging application will stop.
UseLocalTime | REG_DWORD | Determines the time zone (local or Coordinated Universal Time) to use. A nonzero value indicates that local time is used.
UseUnicode characters (UTF-8) | REG_DWORD | Specifies whether the log file should contain Unicode or ANSI text. A nonzero value indicates that Unicode (UTF-8) is used.

Caution Image Caution

  • Incorrectly editing the registry may severely damage your system. Before making changes to the registry, you should back up any valued data on the computer.

Note Image Notes

  • If you move Wmsiislog.dll to another Web server for logging, you must manually register it on the server by typing regsvr32 wmsiislog.dll at the command prompt. If this application is used on a Web server without being registered, it will use the default values.
  • If you change the default logging directory, you must grant the Multicast and Advertisement Logging Agent permissions to write to that directory. For the statistics to be successfully written to the log file, grant read, write, and modify permissions to the Network Service account and IWAM_HOSTNAME.

Related topics

  • Log file reference information


Understanding event handler plug-ins

You can use event handler plug-ins to customize how the server handles internal events. You can enable event handler plug-ins at both the server and publishing point levels.

This section contains the following topics:

  • WMS WMI Event Handler plug-in
  • WMS Active Script Event Handler plug-in

Related topics

  • Understanding event handler plug-ins


WMS WMI Event Handler plug-in

By enabling this plug-in, you can receive seamless and secure notification of all internal server events through Windows Management Instrumentation (WMI) for either a local or remote computer. With WMI, you can use a single, consistent, standards-based, extensible, and object-oriented interface to manage the Windows operating system.

The WMS WMI Event Handler is enabled at the server level by default.

Note Image Note

  • This plug-in is responsible for communicating event information between the Windows Media Services service and other services and programs. Changing the reported events can cause issues with client programs, including the Windows Media Services snap-in and Windows Media Services Administrator for the Web.

Related topics

  • Understanding event handler plug-ins


WMS Active Script Event Handler plug-in

By enabling this plug-in, you can customize how the server handles internal events, authorizes specific events, or responds to basic plug-in actions, such as enabling or disabling a plug-in by using a scripting language (such as Microsoft JScript®, Microsoft Visual Basic® Scripting Edition, or Perl Script).

Note Image Notes

  • For more information about programming events and scripts, see the Windows Media Services 9 Software Development Kit (SDK) on the Windows Media home page at the Microsoft Web site.
  • The WMS Active Script Event Handler plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Logging data and events
  • To configure the WMS Active Script Event Handler properties
  • To configure the WMS WMI Event Handler properties
  • Understanding event handler plug-ins


Configuring security options

If you are a content provider, one of the most important tasks for you to do is to control access to your content. The following topics provide more detail about implementing security on a server running Windows Media Services:

  • Understanding authentication
  • Understanding authorization
  • Understanding rights
  • Limiting user rights
  • Transferring data securely
  • Understanding Windows Media Rights Manager
  • Enabling system-wide security
  • Using firewalls

Related topics

  • Concepts
  • Control access to content


Understanding authentication

Authentication is a fundamental aspect of security for a server running Windows Media Services. It confirms the identity of any user trying to access resources on your Windows Media server. Windows Media Services includes authentication plug-ins that you can enable in order to validate user credentials. Authentication plug-ins work in conjunction with authorization plug-ins: after users are authenticated, authorization plug-ins control access to content.

Windows Media Services authentication plug-ins fall into the following categories:

  • Anonymous authentication. These are plug-ins that do not exchange challenge and response information between the server and a player, such as the WMS Anonymous User Authentication plug-in.
  • Network authentication. These are plug-ins that validate users based on logon credentials, such as the WMS Negotiate Authentication plug-in.

When a user attempts to access a server or publishing point, the server first attempts to authenticate users through an anonymous authentication plug-in. If more than one anonymous authentication plug-in is enabled, the server only uses the first one listed. If that attempt fails or an anonymous authentication plug-in is not enabled, the server attempts to authenticate the user by using a network authentication plug-in. If more than one network authentication plug-in is enabled, the server attempts to use the first one that is also supported by the client. The order in which the plug-ins are listed in the details pane can be changed using the Server Object Model, which is documented in the Windows Media Services Software Development Kit (SDK).

If you enable all of the default Windows Media Services authentication plug-ins and a player attempts to access the server, the server uses the WMS Anonymous User Authentication plug-in first to validate the user. If the server is unable to provide access to the user based on the anonymous user account specified for the plug-in, the server then tries to authenticate the user by using the WMS Negotiate Authentication plug-in. If this attempt fails, Windows Media Player version 7 and later will continue to attempt to authenticate using this secondary method. Previous versions of the Player will stop after the secondary method has failed once.

If a player is connected through HTTP, the player disconnects from the server each time the user stops, pauses, fast–forwards, or rewinds your content. If the user tries to continue receiving the content, the authentication and authorization process occurs again.

This section contains the following topics:

  • Using the WMS Anonymous User Authentication plug-in
  • Using the WMS Negotiate Authentication plug-in
  • Using the WMS Digest Authentication plug-in

Note Image Notes

  • You can enable multiple authentication plug-ins at the server and publishing point levels. If you enable an authentication plug-in for a server and then enable another authentication plug-in for a publishing point of that server, only the plug-in for the publishing point is used to authenticate users.
  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If either the WMS NTFS ACL Authorization plug-in or the WMS Publishing Points ACL Authorization plug-in is enabled but no authentication plug-in is enabled, unicast clients cannot access the server.
  • The WMS Digest Authentication plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Configuring security options
  • Understanding authorization


Using the WMS Anonymous User Authentication plug-in

If you want users to be able to access content without being prompted for a user name or password, you can enable the WMS Anonymous User Authentication plug-in. When a user attempts to connect to the Windows Media server, the plug-in uses the Windows user account that you specified in the plug-in properties to authenticate the user.

By default, the user account specified in this plug-in is WMUS_servername. If you are using the WMS NTFS ACL Authorization plug-in with the WMS Anonymous User Authentication plug-in, you must provide that the WMUS_servername account with read permissions for any files and folders that will be streamed from a publishing point. If you want to use another anonymous user account that already has the necessary rights and permissions, you can change the user account in this plug-in from the default value to the user account of your choice.

When this plug-in is enabled it allows anonymous users to connect to your server. You can restrict the content that anonymous users can access by enabling an authorization plug-in. The authorization plug-in enables you to set different access control policies for content. For example, you could allow users to access only certain content in a publishing point by using the WMS NTFS ACL Authorization plug-in.

This plug-in can be enabled on a single publishing point on your server. By setting the appropriate access control lists (ACLs) for your content folders, you can ensure that the account used by this plug-in can only access certain content. An example of this situation is an Internet site with both free and subscription-based digital media content.

Note Image Note

  • The authentication and authorization plug-ins work together to grant clients access to digital media content. If either the WMS NTFS ACL Authorization plug-in or the WMS Publishing Points ACL Authorization plug-in is enabled but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • To configure and enable the WMS Anonymous User Authentication plug-in
  • Understanding authentication
  • Understanding authorization


Using the WMS Negotiate Authentication plug-in

If you want users to be able to access content based on their network logon credentials, you can enable the WMS Negotiate Authentication plug-in. This plug-in uses an encrypted challenge/response scheme to authenticate users. It is a secure form of authentication because the user name and password are not sent across the network; the player acknowledges the password by using a cryptographic exchange with the Windows Media server. The WMS Negotiate Authentication plug-in relies upon established user logon credentials that are authenticated using either NTLM or Kerberos authentication.

By using this plug-in, you can authenticate users on a variety of operating systems. NTLM authentication was the default authentication in Microsoft Windows NT Server 4.0. It is retained in Windows Server 2003 for compatibility with computers that are running Windows NT 4.0 and earlier. It can also be used to authenticate users that log on to stand-alone computers that are running Windows 2000 Server or later. Kerberos authentication is the default authentication method used in the Microsoft Windows 2000 Server and Microsoft Windows XP operating systems.

This form of authentication is appropriate for an intranet site that needs to support a variety of Windows clients as well as provide protection for confidential content.

Note Image Note

  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If either the WMS NTFS ACL Authorization plug-in or the WMS Publishing Points ACL Authorization plug-in is enabled but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • To enable the WMS Negotiate Authentication plug-in
  • Understanding authentication


Using the WMS Digest Authentication plug-in

If you want users that connect to your server from the Internet to be able to access content after they provide their user names and passwords, you can enable the WMS Digest Authentication plug-in. This plug-in uses a challenge/response HTTP authentication scheme that does not require a password to be sent over a network. Instead, the plug-in uses a hashed version of a password to authenticate the user. This method is considered to be more secure than basic authentication but not as secure as the NTLM, Kerberos, or other private-key authentication schemes.

The WMS Digest Authentication plug-in is appropriate for situations in which your audience is connecting from an outside network, such as the Internet, and you want to be able to provide minimal user authentication.

This plug-in uses realm identification to authenticate users against Microsoft Active Directory domains. A realm is a logical grouping of resources used to authenticate users and groups. User name and password pairs are associated with realms to allow the same authorization information to be used for multiple resources.

To use the WMS Digest Authentication plug-in, Windows Media Services must be part of a Microsoft Active Directory™ domain. The domain controller for the Active Directory domain must be a computer running Windows Server 2003.

Note Image Notes

  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If either the WMS NTFS ACL Authorization plug-in or the WMS Publishing Points ACL Authorization plug-in is enabled but no authentication plug-in is enabled, unicast clients cannot access the server.
  • Digest authentication is supported by Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control. Users that attempt to connect using a previous version of the Player will not be authenticated and will receive an access denied message.
  • For more information about digest authentication, see RFC 2069 "An Extension to HTTP : Digest Access Authentication."
  • The WMS Digest Authentication plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • To configure and enable the WMS Digest Authentication plug-in
  • Understanding authentication


Understanding authorization

It is important to understand the following distinction between authentication and authorization to understand why connection attempts are either accepted or denied:

  • Authentication is the process of verifying the credentials of client attempting to connect to the server. This process consists of sending the credentials from the client to the server and using an authentication scheme to identify the user.
  • Authorization is the process of verifying that the client is allowed to connect to the server. Authorization occurs after authentication is successful. During the authorization process, the server checks the user against the access permissions set for the resource to which the user is trying to connect.

You can enable authorization plug-ins to control the access to content by authenticated users. If you enable an authorization plug-in, it is required that you also enable an authentication plug-in for users to be able to access your publishing points. However, the WMS IP Address Authorization plug-in does not require an authentication plug-in to authenticate a player.

You can enable authorization plug-ins at both the server and the publishing point levels. If you enable an authorization plug-in for a server and another for a publishing point on the server, both authorization plug-ins are used to authorize a user, but the plug-in for the server is used first. If you enable multiple authorization plug-ins for a server or for a publishing point, all the plug-ins are used in the order they appear on the Properties tab for the server or publishing point. If a user is denied access by any of the plug-ins, the authorization process terminates, and the server checks whether another authentication plug-in is enabled to authenticate the user.

This section contains the following topics:

  • Using the WMS NTFS ACL Authorization plug-in
  • Using the WMS IP Address Authorization plug-in
  • Using the WMS Publishing Points ACL Authorization plug-in

Note Image Note

  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If either the WMS NTFS ACL Authorization plug-in or the WMS Publishing Points ACL Authorization plug-in is enabled but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • Configuring security options
  • Understanding authentication


Using the WMS NTFS ACL Authorization plug-in

If you have set access permissions on files and directories in an NTFS file system, you can enable the WMS NTFS ACL Authorization plug-in to enforce the permissions. This plug-in enforces discretionary access control lists (DACLs) and system access control lists (SACLs) that have been set on files and directories in an NTFS file system. A DACL is a list of user accounts, groups, and computers that are allowed or denied access to an Active Directory object. A SACL defines the events that are audited for a user, group or computer. This plug-in is useful when you want to set different access control policies for your content.

The WMS NTFS ACL Authorization plug-in can be enabled for specific on-demand publishing points or for an entire server. Once this plug-in is enabled, each piece of content streamed from the publishing point or server must be authorized for the user account specified by the authentication plug-in. This means that if you are streaming content from a playlist, the user account must be authorized for every item listed in the playlist. If a user account cannot be authenticated for a certain item in the playlist, that item is skipped and the next item in the playlist for which authentication succeeded is streamed to the client.

Because this plug-in enforces access control policies that you set on files or directories, it is not appropriate for use in the following situations:

  • Broadcasting a live stream. Because a stream from an encoder is not located in a file or directory on an NTFS drive, this plug-in cannot be used for live stream authorization.
  • Proxying a stream. When using a Windows Media server as a proxy server that does not cache content, the WMS NTFS ACL Authorization plug-in does not have a defined set of files or directories against which it can authenticate a user account. Enabling the WMS NTFS ACL Authorization plug-in on the origin server will cause the proxy server to forward the authorization request to the client and transmit the information back to the origin server, which then performs the authorization. If you want to authorize clients that access a proxy server, use the WMS Publishing Points ACL Authorization plug-in instead.

Note Image Notes

  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If either the WMS NTFS ACL Authorization plug-in or the WMS Publishing Points ACL Authorization plug-in is enabled but no authentication plug-in is enabled, unicast clients cannot access the server.
  • This plug-in is dependent on information gathered from the NTFS file system that is accessed by the WMS File Data Source plug-in. The WMS File Data Source plug-in is enabled by default when Windows Media Services is installed. Do not disable the WMS File Data Source plug-in if you are using this authorization plug-in.
  • For more information about creating and managing DACLs and SACLs, see Windows Help and Support.

Related topics

  • To enable the WMS NTFS ACL Authorization plug-in
  • Understanding authorization
  • Using the WMS Publishing Points ACL Authorization plug-in


Using the WMS IP Address Authorization plug-in

You can allow or deny access to content based on specific Internet Protocol (IP) addresses or groups of IP addresses by enabling the WMS IP Address Authorization plug–in. This plug-in is useful if you want to allow access only to users on an intranet and restrict access to all other users. Or, if you believe there is a security violation on a server, you could quickly enable this plug-in to deny access to the IP address that is violating security. The WMS IP Address Authorization plug-in can be enabled for specific publishing points or for an entire server.

Related topics

  • To configure and enable the WMS IP Address Authorization plug-in
  • Understanding authorization


Using the WMS Publishing Points ACL Authorization plug-in

This plug-in allows you to create access control lists (ACLs) for the publishing points on your server. You can assign the following access permissions to users or groups through the properties sheet of this plug-in:

  • Read. Permits a user or application to open, play, fast-forward, or rewind content
  • Write. Permits a user or application to write content to your server.
  • Create. Permits a user or application to create new publishing points on your server, when combined with write permissions.

This plug-in is enabled with the following access permissions by default:

  • Everyone. The Everyone group has read permissions only.
  • BUILTIN\Administrators. The Administrators group has full permissions.

This plug-in is useful when you want to set restrictions on all content on a specific publishing point or server or when the publishing point content is a live stream. If you are using push distribution from an encoder, be sure that the encoder administrator is a member of a group that has both write and create permissions or assign the necessary permissions to the encoder administrator by using this plug-in.

Note Image Note

  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If either the WMS NTFS ACL Authorization plug-in or the WMS Publishing Points ACL Authorization plug-in is enabled but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • To configure and enable the WMS Publishing Points ACL Authorization plug-in
  • Understanding authorization


Understanding rights

Rights are granted to users to define what a particular user is allowed to do on a system and to grant different levels of permission to different users. You can define rights for individual users, computers, and servers on your system. By default, Windows Media Services runs under the Network Service user account. This is a change from Windows Media Services version 4.1 in Windows 2000 Server. In that version, Windows Media Services created its own administrator account with administrator rights and permissions to access system resources.

The Network Service account is a predefined local account that first appeared in the Windows XP operating system. Services that are running under the Network Service account access network resources using the credentials of the computer account. The Network Service account has minimal privileges on the local computer. This prevents someone from using the account to gain access to protected resources on your system. The Network Service account does not have a password associated with it. If you change Windows Media Services to run under a different user account and then change it back to the Network Service account, do not enter a password.

Because Windows Media Services uses the Network Service account credentials to respond to authentication requests from other resources, ensure that the Network Service account has been granted the appropriate permissions in the access control lists of any resource with which it might interact. For example, if you are going to write log file information to a network location that is different from the default location, you must grant the appropriate permissions to the Network Service account for that location for Windows Media Services to write log files successfully.

Some plug-in features cannot interact with the Network Service account. For example, if you are going to use the Microsoft Script Debugger to troubleshoot script that will be run by the WMS Active Script Event Handler plug-in, you must configure Windows Media Services to run under another account.

Windows Server 2003 uses security templates to predefine the rights and permissions granted to users. When you review the security templates for your Windows Media server, be aware of the following:

  • DCOM settings. Microsoft Management Console (MMC) uses distributed component object model (DCOM) to administer Windows Media Services. Each DCOM interface has a discretionary access control list (DACL) that was configured by Windows Media Services during setup to allow the Network Service account to launch, configure, and access files on the server. If you change the account that Windows Media Services uses, make sure to also modify the DCOM configuration. By default, Windows Media Services uses the Packet Privacy authentication level to secure communication between MMC and the service. For more information on modifying DCOM configuration on your server, see Windows Help and Support.
  • File and folder permissions. When Windows Media Services attempts to stream a file to a user, the user must be authenticated against the location of the file. Network Service has the appropriate level of permissions for the default folder WMRoot, meaning that it has been assigned Modify, Read & Execute, List Folder Contents, Read, and Write permissions. Windows Media Services requires those permissions for any activity that requires reading and writing data, for example, logging, modifying playlists, archiving broadcasts, and accessing digital media files. Make sure that Network Service has been added to the access list for any files or folders to which Windows Media Services requires access.

Related topics

  • Configuring security options
  • To provide a user administrative rights to Windows Media Services


Limiting user rights

One way to protect your Windows Media server is to limit the rights of users who have access to the server. For each server user, you should determine the rights required by each and then set the appropriate limits. For example, rather than grant everyone administrator rights and permissions, you can reserve those rights for a few users who need full access to the server, such as information technicians and system managers.

By default, Windows Media Services can only be accessed by users in the Administrators group. In order to limit user rights effectively while still enabling users to administer Windows Media Services, you can remove users from the Administrators group and then add them to Windows Media Services only. To add users directly to Windows Media Services, you must use Component Services to configure access permissions for the Windows Media Services Component Object Model (COM) object.

You can move the majority of your Windows Media server users to a group, such as the USERS user group, that grants them adequate permissions for performing non-administrative tasks on the server. If you grant users access to the Windows Media Services COM object directly, they can perform most functions in the Windows Media Services snap-in and Windows Media Services Administrator for the Web, such as adding publishing points and monitoring client activity. Limiting the number of users with full rights greatly reduces the potential for security lapses.

To make user administration easier, you can create a new user group by using Computer Management. In Component Services, you can then add the new user group to the access list, and then add the non-administrator users to the new group. Grouping users enables you to administer user configurations for the entire server by using Computer Management.

Related topics

  • Configuring security options
  • To provide a user administrative rights to Windows Media Services


Understanding Windows Media Rights Manager

Windows Media Rights Manager is a digital rights management (DRM) platform that can be used by content providers and retailers to distribute digital media files securely over a network, such as the Internet. The Microsoft Windows Media Rights Manager Software Development Kit (SDK) helps protect digital media content (such as songs and videos) by packaging Windows Media files in an encrypted file format. A packaged file contains a version of a "protected" file that was encrypted and locked with a "key" after business usage and distribution rules were added to the content header. This packaged file is also bundled with additional information from the content provider and, optionally, from the distributor. The result is a protected Windows Media file that can only be played by a user who has obtained a license.

The basic Windows Media Rights Manager process is as follows:

  • Protecting. The content owner or content provider adds business usage and distribution rules to the content. (For example, this process could include setting the playback count rights, the license validity duration, or the ability of the distributor to update specific usage rules.) Once the file is protected, it can only be used or opened by specified users. For commercially distributed files, the content owner can include "Anyone" as a user, but can specify that certain distributors can change one or more of the usage rules to meet their business requirements. Typically, the content provider then sends the protected file to the distributor for packaging.
  • Packaging. The distributor packages the digital media file using Windows Media Rights Manager. The packaged file has been encrypted and locked with a "key." This key is stored in an encrypted license, which is distributed separately. Other information is added to the file, such as the URL where the license can be acquired. This protected file is saved in Windows Media Audio format (.wma file name extension) or Windows Media Video format (.wmv file name extension).
  • Distribution. The protected file can be placed on a Web site for download, placed on a server for streaming, distributed on a CD, or e-mailed to users. Windows Media Rights Manager permits users to send copy-protected files to friends, as well. The distribution rules are set by the content owner and the distributor according to their desired business rules.
  • Establishing a license server. The content provider chooses a clearinghouse that stores the specific rights or rules of the license and implements the Windows Media Rights Manager license services. The role of the clearinghouse is to authenticate the customer's request for a license. Files and licenses are distributed and stored separately, making it easier to manage the entire system.
  • License acquisition. To play a protected file, the user must first acquire a license key to unlock the file. The process of acquiring a license begins automatically when the user attempts to acquire the protected content, acquires a predelivered license, or plays the file for the first time. Windows Media Rights Manager either sends the user to a registration page where information is requested or payment is required, or "silently" retrieves a license from a clearinghouse.
  • Playing the file. To play the file, the user needs a player that supports Windows Media Rights Manager. Support for Windows Media Rights Manager was first added to Windows Media Player for Windows XP. Players that were created using the Windows Media Player ActiveX control version 8 or later also support this DRM platform. With the appropriate version of the Player installed, the customer can then play the file according to the rules or rights that are included in the license. Licenses can have different rights, such as start times and dates, duration, and counted operations. For instance, default rights may allow the user to play the file on a specific computer and copy the file to a portable device. Licenses, however, are not transferable. If a customer sends a protected file to a friend, this friend must acquire a different license to play the file. This per-computer licensing scheme ensures that the protected file can only be played by the computer that has been granted the license key for that file.

For more information, see the Digital Rights Management page at the Microsoft Web site.

Related topics

  • Configuring security options


Enabling system-wide security

The security features of Windows Server 2003 provide the means to protect your digital media resources. You can use access control lists (ACLs) or the Active Directory directory service to assign users and resources into groups, enabling a more granular security model within your organization.

Internet Information Services (IIS) provides security against intrusion by unauthenticated Internet users in two ways. It provides authentication methods (Windows Integrated and Digest) that Windows Media Services includes through its authentication plug-ins.

If you have installed Windows Media Services Administrator for the Web or are hosting Web sites to distribute your content, you should consider using Web server permissions in conjunction with the NTFS file system permissions to prevent intruders from gaining access to all or parts of your Web site.

This section contains the following topics:

  • Transferring data securely
  • Using the NTFS file system
  • About Web server permissions
  • Protecting custom plug-ins

Related topics

  • Configuring security options


Transferring data securely

You can use Internet Protocol Security (IPSec) to secure data as it travels over the Internet or an intranet. IPSec is a public standard used to define end-to-end encryption of data at the Open Systems Interconnection (OSI) network layer. The Windows operating system provides several components that you can use to implement IPSec on your Windows Media servers. For more information about IPSec, see Windows Help and Support.

Related topics

  • Enabling system-wide security


Using the NTFS file system

Using the NTFS file system with Windows Media Services increases the security of your Windows Media server and your content for the following reasons:

  • It is more secure from command-line system attack methods.
  • You can configure access control lists (ACLs) to grant or deny various forms of access to user and group accounts.
  • You can use Active Directory to maintain your content and user authentication tables.

Windows Media Services includes the WMS NTFS ACL Authorization plug-in to enforce any ACLs that are already set up for your network resources. For more information about the NTFS file system and permission, see Windows Help and Support.

Related topics

  • Enabling system-wide security
  • Using the WMS NTFS ACL Authorization plug-in


About Web server permissions

If you have installed Windows Media Services Administrator for the Web or are hosting Web sites to distribute your content, you should consider using Web server permissions. Permissions set on your Internet Information Services (IIS) Web server apply to all users accessing your Web sites; whereas, NTFS file system permissions apply only to a specific user or group of users with a valid Windows-based account. IIS permissions enable you to control access to virtual directories on your Web site in the same manner that the NTFS file system permissions control access to folders on your server.

When users access your Web site by using anonymous authentication, they use the IUSR_computername account. By default, they receive NTFS file system permissions for the folders and files on your Web site, which you can change by using Web server permissions.

For more information about Web server permissions, see IIS Help.

Related topics

  • Enabling system-wide security


Protecting custom plug-ins

After creating or obtaining custom plug-ins for use with your Windows Media server, you should protect those plug-ins from tampering by placing them in a protected directory. After a custom or third-party plug-in has been installed and registered, it could be overwritten or modified in ways that could render it ineffective or malicious to the server. Place the plug-ins in a directory that denies write permissions to unauthorized users. Ensure that Windows Media Services has read permissions to the directory that contains the plug-ins or they cannot be used.

Related topics

  • Enabling system-wide security


Using firewalls

If you plan to stream content from a Windows Media server on a network to players on the Internet, you may need to open additional ports in your firewall to prevent players from having problems receiving the content. This section provides an overview of firewalls and how Windows Media Services interacts with firewalls.

This section contains the following topics:

  • Understanding firewalls and protocols
  • Configuring firewalls for unicast streaming
  • Configuring firewalls for multicast streaming
  • Enabling access to an encoder outside a firewall

Related topics

  • Configuring security options


Understanding firewalls and protocols

A firewall is a piece of hardware or software that prevents data packets from either entering or leaving a specified network. To control the flow of traffic, numbered ports in the firewall are either opened or closed to specific types of packets. The firewall reviews two pieces of information in each arriving or departing packet: the protocol through which the packet is being delivered, and the port number to which it is being sent. If the firewall is configured to accept the specified protocol through the targeted port, the packet is allowed through.

You can configure each control protocol plug-in (MMS, RTSP, and HTTP) to use a specific port to make firewall configuration easier. Therefore, if your network administrator has already opened a series of ports for use by your Windows Media servers, you can allocate those ports to the control protocols accordingly. If not, you can request that the default ports for each protocol be opened. If opening ports on your firewall is not possible, Windows Media Services can stream content by using the HTTP protocol over port 80.

Note Image Notes

  • Using HTTP to stream content is disabled by default.
  • Windows Media Services was formerly known as Microsoft NetShow Services; some firewalls have a preconfigured NetShow setting, which may work for Windows Media Services.

Related topics

  • Using firewalls
  • Using the MMS protocol
  • Using the RTSP protocol
  • Using the HTTP protocol


Configuring firewalls for unicast streaming

To configure a firewall for unicast streaming, you must open the ports on the firewall that are required for the connection protocols enabled on your server. If you are streaming content by using either the MMS or RTSP protocols, you need to support both the User Datagram Protocol (UDP) and Transmission Control Protocol (TCP).

To enable Windows Media Player and other clients to use the HTTP, RTSP, or MMS protocols to connect to a Windows Media server that is behind a firewall, open the following ports.

Ports | Description
In: TCP on port 80, 554, 1755 | The Windows Media server uses the TCP In ports to accept an incoming HTTP connection (port 80), RTSP connection (port 554), or MMS connection (port 1755) from Windows Media Player and other clients.
In: UDP on port 1755, 5005 | The Windows Media server uses UDP In port 1755 to receive resend requests from clients streaming by using MMSU and UDP In port 5005 to receive resend requests from clients streaming by using RTSPU.
Out: UDP between ports 1024-5000. | The Windows Media server uses UDP Out ports 1024-5000 to send data to Windows Media Player and other clients.

To enable a distribution server that is behind a firewall to use the HTTP or RTSP protocols to stream content from an origin server outside the firewall, open the following ports.

Ports | Description
In: UDP between ports 1024-5000 | The Windows Media server uses UDP In ports 1024-5000 to receive data from another server.
Out: TCP on port 80, 554 | The Windows Media server uses the TCP Out ports to establish an HTTP connection (port 80) or RTSP connection (port 554) to another server or encoder.
Out: UDP on port 5005 | When RTSPU distribution is used, the Windows Media server uses UDP Out port 5005 to send resend requests to another server.

Note Image Note

  • If it is not possible to open all the UDP Out ports on a firewall, UDP packets sent by a Windows Media server may be blocked by the firewall and may not be able to reach the clients on the other side of the firewall. If this is the case, clients may still be able to receive a stream by automatically rolling over to a TCP-based protocol, such as HTTP or RTSPT. However, the rollover will cause a delay for the client receiving the stream. If you know you will not be able to support UDP streaming through a firewall, you can decrease the rollover delay by clearing the UDP check box in the Unicast Data Writer plug-in Properties dialog box. For more information, see To configure the WMS Unicast Data Writer plug-in.

Related topics

  • Using firewalls


Configuring firewalls for multicast streaming

If you distribute content using multicast streaming, network traffic is directed through the standard Class D IP addresses (224.0.0.0 through 239.255.255.255). To multicast, you must have enabled multicast-forwarding on your network. The Internet Group Management Protocol (IGMP), supported by Windows Media Services, ensures that multicast traffic passes through your network only when a player requests a multicast connection, so enabling multicast on your routers does not flood your network.

The following firewall configuration enables multicast packets to traverse your firewall:

IP multicast address range: 224.0.0.1 to 239.255.255.255

To enable IP multicasting, you must allow packets sent to the standard IP multicast address range to come through your firewall. This IP multicast address range must be enabled on both the player and server sides, as well as on every router in between.

Related topics

  • Using firewalls


Enabling access to an encoder outside a firewall

Encoders use HTTP to connect to a server running Windows Media Services. By default, Windows Media Encoder uses port 8080 for HTTP connections; however, the encoder administrator can specify a different port. If a different port is used, you must specify the same port when you identify the encoder connection URL for the Windows Media server and when opening the port on your firewall.

The following example firewall configuration allows a computer running Windows Media Encoder outside of a firewall to access a Windows Media server behind a firewall by using HTTP. The In port is the port through which the server accepts connections. The Out port is the port through which the server sends data to clients:

In/Out: TCP on port 8080.

Related topics

  • Using firewalls


Securing the Windows Media Administration site

Windows Media Services Administrator for the Web provides you with full access to Windows Media servers from a remote computer by using a Web browser. By using Windows Media Services Administrator for the Web, you can access the local Windows Media server (the server on which the Windows Media Administration Web site is located) and other Windows Media servers on your network. To enable this level of control, configuration and authentication data is sent over the network between the remote computer and the local Windows Media server computer. As the data is being sent, it is vulnerable to unauthorized access.

This section describes three security measures available in IIS you can add to your site that provide different levels of protection. Most of the configuration is performed by changing the security settings in the Windows Media Administration site properties in IIS. Secure Sockets Layer (SSL) also requires that you obtain a certificate from a certification authority or create a certificate yourself by using Microsoft Certificate Services. For more complete setup information, see Internet Information Services Help.

This section contains the following topics:

  • Using Secure Sockets Layer
  • Using integrated Windows authentication
  • Using basic authentication

Related topics

  • Manage servers


Using Secure Sockets Layer

Secure Sockets Layer (SSL) is the recommended security method for running the Windows Media Administration site. SSL provides the highest level of security by encrypting data before it is sent over a network. Authentication is handled using certificates, which are digital authentication documents that allow both servers and clients to authenticate each other. You can create a certificate using Microsoft Certificate Services, or you can obtain one from a mutually trusted, third-party organization called a certification authority (CA). With SSL, a password is not necessary because the certificate handles the authentication.

SSL provides a secure connection for administering the local Windows Media server. However, SSL must be used in conjunction with an authentication method that allows delegation if you want to allow the remote administration of multiple Windows Media servers. Delegation allows a service to act as a user account to access resources throughout the network. Methods that allow delegation, such as Kerberos, Basic, and Digest authentication, require that the user have an authenticated user name and password. If one of these methods is not used with SSL, a user will only be able to remotely administer the local server.

Each of the delegation methods has associated security risks. For more information about authentication methods and SSL, see Internet Information Services Help.

Related topics

  • To configure SSL
  • Using basic authentication
  • Securing the Windows Media Administration site


Using integrated Windows authentication

Integrated Windows authentication provides a means of authorizing users of the administration site, but does not allow credentials to be transmitted over the network. When you enable integrated Windows authentication, the browser running the administrative interface initiates a cryptographic exchange with the Web server using either NTLM or Kerberos authentication to validate the user. This method provides a great deal of security, but does not allow Internet Information Services (IIS) to delegate user names and passwords to remote servers. Therefore, you can administer the local Windows Media server only when integrated Windows authentication is enabled.

Integrated Windows authentication does not initially prompt the user for a user name and password. The Windows user account information on the client computer is used for authentication. However, if the authentication exchange fails to identify the user, the browser prompts the user for authentication information. Internet Explorer 2.0 or later is required, and integrated Windows authentication does not work across proxy servers or other firewall applications. For more information, see Internet Information Services Help.

Related topics

  • To configure integrated Windows authentication
  • Securing the Windows Media Administration site


Using basic authentication

When you secure the Windows Media Administration site using basic authentication, a user must supply a user name and password. If the user information corresponds to a valid Windows user account, a connection is established.

Basic authentication is widely used on networks for collecting user credential information. The advantage of basic authentication is that it is simple to use and works with most browsers, proxy servers, and firewalls. The main disadvantage is that basic authentication provides a low level of security because credentials are not encrypted before they are sent across a network. Someone attempting to compromise your system security could use a protocol analyzer to examine user passwords during the authentication process.

Because user credentials are obtained during the logon process, Windows Media Services Administrator for the Web enables you to administer the local server and other servers on the network. Keep in mind, however, that basic authentication is not recommended for administering multiple servers because of the low level of protection. You should use basic authentication with care, and preferably only on local area networks (LANs) known to be secure. To improve security for managing multiple servers, use basic authentication in conjunction with Secure Sockets Layer (SSL).

For more information, see Internet Information Services Help.

Related topics

  • To configure basic authentication
  • Using Secure Sockets Layer
  • Securing the Windows Media Administration site


Caching and proxying content

You can add a third-party cache/proxy plug-in to your server to provide cache and proxy server support for other Windows Media servers. Using a cache/proxy plug-in is an easy way to conserve bandwidth, decrease network-imposed latency, and offset the load on the origin server. Network bandwidth is minimized because only one connection from the origin server is required to upload content to and receive information from the cache. Network latency is decreased because a client can receive content from a nearby cache/proxy server more quickly than it could if it had to traverse the network or the Internet to receive content from the origin server. Additionally, the load on the origin server is offset because fewer clients are connecting directly to the origin server. These three factors result in a better viewing experience for users and operating cost reduction.

To view a list of partners that provide cache/proxy plug-ins for Windows Media Services 9 Series, see the Windows Media Technologies Partner Center at the Microsoft Web site. You can also create custom cache plug-ins by using the Windows Media Services 9 Series Software Development Kit (SDK), available for download from the Microsoft Web site.

This section includes the following topics:

  • Caching and streaming on-demand content
  • Proxying a live stream
  • Understanding reverse proxy

Note Image Notes

  • Custom or third-party plug-ins should be located in a protected directory to prevent tampering. A protected directory can be any directory that has been configured to deny write permissions to unauthorized users. For more information about restricting directory access, see the Windows Help and Support Center.
  • Cache/proxy services are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Concepts


Caching and streaming on-demand content

This topic discusses a type of behavior that a cache/proxy plug-in could provide when used with Windows Media Services. The cache/proxy plug-in you obtain or create may behave differently.

After a cache/proxy plug-in is installed on a Windows Media server it can provide support for caching on-demand content from another Windows Media server. When a client requests on-demand content, the cache/proxy plug-in verifies that the content is cached locally and is current. To do this, the plug-in first checks the cache expiration property of the content. If the content is set to expire after a certain time that has already passed, the plug-in then requests that the cache/proxy server open a connection to the origin server and verifies that the content in the cache matches the content on the origin server. A cache hit occurs if the content matches; a cache miss occurs if the content does not match. If the origin server is unavailable or cannot provide the requested content, the server returns an error message to the client stating that the content cannot be found.

If a cache hit occurs, the plug-in requests that the cache/proxy server stream the content from its cache to the client.

If a cache miss occurs, the content is purged from the cache, and the cache/proxy server downloads the updated content from the origin server. The cache/proxy server initiates another connection to the origin server to act as a proxy server to deliver the content to the client.

If a cache miss occurs when the cache/proxy server attempts to stream multiple-bit-rate (MBR) content, the cache/proxy server will attempt to download all of the different bit rate streams from the origin server at once. If you have set a bandwidth limit for outgoing distribution streams on the origin server or a limit on the incoming bandwidth for the cache/proxy server, the aggregate bandwidth of the multiple-bit-rate stream may exceed these limits. If so, the cache/proxy server will not be able to download the content to its cache and will only stream the content at the bandwidth requested by the client.

If content was moved to a different location on the origin server, the cache/proxy plug-in can transfer client requests to the new location. For example, if the cache/proxy plug-in receives an HTTP code 301 or 302 when checking whether content is current, the plug-in updates its internal database to recognize requests for the new location.

Note Image Notes

  • To view a list of partners that provide cache/proxy plug-ins for Windows Media Services 9 Series, see the Windows Media Technologies Partner Center at the Microsoft Web site.
  • Cache/proxy services are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Caching and proxying content


Proxying a live stream

This topic discusses a type of behavior that a cache/proxy plug-in could provide when used with Windows Media Services. The cache/proxy plug-in you obtain or create may behave differently.

After a cache/proxy plug-in is installed on a Windows Media server it can provide the ability for your server to proxy a live stream from an origin server through another Windows Media server. When a client requests a live stream, the cache/proxy plug-in checks whether the cache/proxy server is already proxying the stream. If the server is not proxying the stream, the plug-in requests that the cache/proxy server open a connection to the origin server. After establishing a connection to the origin server, the cache/proxy server streams the content from the origin server to the client. If the cache/proxy server is already proxying the stream, the plug-in requests that the server split the stream so that all requesting clients can receive the content. In this way, there is only one connection between the cache/proxy server and the origin server. The content is not cached because a live stream does not have a file associated with it.

Live broadcast from a cache/proxy server

Note Image Notes

  • To view a list of partners that provide cache/proxy plug-ins for Windows Media Services 9 Series, see the Windows Media Technologies Partner Center at the Microsoft Web site.
  • Cache/proxy services are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Caching and proxying content


Understanding reverse proxy

A reverse proxy server is a proxy server configured to be responsible for servicing all client requests. For unicast broadcasts, a reverse proxy server can reduce the load on the origin server by streaming multiple unicast streams while receiving only one stream from the origin server. For on-demand content, a reverse proxy server can reduce the load on the origin server by caching the content from the origin server and streaming it to clients from its cache.

To the client, the reverse proxy server appears to be the origin server. This enables you to isolate your origin server from your clients. A reverse proxy server can increase the security of your streaming media system because the client never connects to the origin server directly.

Reverse proxy distribution.

Authentication for reverse proxy servers also differs from that of conventional cache/proxy servers. When the client submits a request for content and authentication is enabled, the content must first be authenticated by the reverse proxy server. Once the client is authenticated, the reverse proxy server submits a content request to the origin server and must be authenticated by the origin server before it can begin proxying the content to the client.

Reverse proxy authentication

A large number of unicast streams can place an enormous burden on an origin server. You can further increase the reliability of your streaming media system by caching and delivering content from multiple reverse proxy servers. If only one reverse proxy server is used, there is the potential for a single point of failure in that system. The use of two or more reverse proxy servers greatly reduces the chance that the system will fail due to a reverse proxy server fault.

Note Image Notes

  • To view a list of partners that provide cache/proxy plug-ins for Windows Media Services 9 Series, see the Windows Media Technologies Partner Center at the Microsoft Web site.
  • Cache/proxy services are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Caching and proxying content
  • Performing load balancing and clustering
  • To set authentication credentials for a reverse proxy server


How to…

This section contains the following topics:

  • Quick starts. Contains procedures for common streaming media tasks performed using Windows Media Services.
  • Manage servers. Contains procedures that explain how to start or stop Windows Media Services on a server, add or remove a server by using an administrative interface, and control client connections to a server.
  • Work with groups of servers. Contains procedures that explain how to manage groups of Windows Media servers using the Windows Media Services snap-in.
  • Work with plug-ins. Contains procedures that explain how to use plug-ins with Windows Media Services.
  • Work with publishing points. Contains procedures that explain how to add or remove a publishing point, control client connections to a publishing point, and set up archiving for a broadcast publishing point.
  • Set up content to stream. Contains procedures that explain how to create and use playlists and how to set up and stream content such as files, an encoder stream, and a stream from a remote publishing point.
  • Monitor and set limits. Contains procedures that explain how to set limits in order to manage server and network resources and how to monitor performance for a server or publishing point.
  • Log data about clients. Contains procedures that explain how to log data about clients that are receiving content as either a unicast or multicast stream and how to configure the event handler plug-ins.
  • Control access to content. Contains procedures that explain how to configure the authentication and authorization plug-ins.
  • Secure the Windows Media Administration site. Contains procedures that explain how to configure Internet Information Services (IIS) to add security to the Windows Media Administration site.
  • Implement streaming scenarios. Contains procedures for implementing the scenarios described in the Scenarios section.

Related topics

  • Windows Media Services


Quick starts

This section contains end-to-end procedures for common server management tasks to help you get started quickly using Windows Media Services.

This section contains the following topics:

  • Stream Windows Media files on demand
  • Use your server to publish live content from Windows Media Encoder
  • Use your server to broadcast a stream published by Windows Media Encoder
  • Use a playlist with on-demand Windows Media files
  • Alternate between live and prerecorded content in your broadcast
  • Include interstitial advertising in your on-demand playlist
  • Use wrappers to provide advertising with your live broadcast


Stream Windows Media files on demand

This quick start demonstrates how to use Windows Media Services to stream a single file from your server when a user requests it, also known as on-demand streaming. Users can start, stop, pause, fast-forward, and rewind the content they request by using controls on the player. From a user's perspective, on-demand streaming is similar to playing content on a DVD or CD player.

Windows Media Services requires no additional configuration and is ready for on-demand streaming. All you need to do is place the file that you want to stream in the default Windows Media Services content directory. The file can be either a Windows Media file or an .mp3 file.

  1. Double-click the My Computer icon, and then locate the file you want to stream.
  2. Copy the file to the %systemdrive%\Wmpub\WMRoot folder on your Windows Media server.

    Your server is now ready to stream the file.

For more information about testing your streaming content, see Testing a stream.

Note Image Note

  • You can use announcements to direct users to your content. Announcements are metafiles that automatically open Windows Media Player and direct the Player to the content on a publishing point. For more information about announcements, see Working with the announcement wizards.

Related topics

  • Quick starts
  • Understanding streaming media


Use your server to publish live content from Windows Media Encoder

This quick start demonstrates how to use Windows Media Services to stream live content that it pulls from a computer running Windows Media Encoder. The user experience is similar to watching a traditional television program or tuning into a radio broadcast. The user can watch or listen to the content, but does not have the ability to pause, fast-forward, or rewind it.

For this task, you must have a separate computer running Windows Media Encoder that has an audio or video capture card. The live stream is encoded from an attached video camera, VCR, or microphone. You can download Windows Media Encoder from the Windows Media home page at the Microsoft Web site.

  1. On the computer running Windows Media Encoder, start encoding your live content by doing the following:
    • Start Windows Media Encoder and create a new broadcast session.
    • Begin encoding the session and note the connection URL for the encoder. The connection URL has the following syntax: connection protocol://encoder_name:port (for example, http://encoder1:8080). This is the URL that the Windows Media server uses to connect to the encoder. For more information about setting up the encoder for a live broadcast, see Windows Media Encoder Help.
  2. Create a new broadcast publishing point on the Windows Media server by using the Add Publishing Point Wizard:
    • In the console tree, expand the server from which you want to stream the content, and then click the Publishing Points item.
    • On the Action menu, click Add Publishing Point (Wizard).
  3. In the Add Publishing Point Wizard, do the following:
    • On the welcome page, click Next.
    • On the Publishing Point Name page, type a name for the new publishing point.
    • On the Content Type page, click Encoder.
    • On the Publishing Point Type page, click Broadcast publishing point.
    • On the Delivery Options for Broadcast Publishing Points page, click Unicast.
  4. Using the wizard, configure the following settings to enable the publishing point to receive content from the encoder:
    • On the Encoder URL page, type the encoder URL using the following syntax: http://encoder_name:port.
    • On the Unicast Logging page, select the check box if you want to log data about your clients.
    • On the Publishing Point Summary page, verify that the settings for the new publishing point are correct.
    • On the Completing the Add Publishing Point Wizard page, select the Start publishing point when wizard finishes check box, clear the After this wizard finishes check box, and then click Finish.

Users can now connect to the live encoder stream by using the URL of your publishing point. The URL of a broadcast publishing point uses the following syntax:
connection protocol://server_name/publishing_point_name (for example, mms://server1/my broadcast).

For more information about testing your streaming content, see Testing a stream.

Note Image Notes

  • You can use announcements to direct users to your content. Announcements are metafiles that automatically open Windows Media Player and direct the Player to the content on a publishing point. For more information about announcements, see Working with the announcement wizards.
  • For a detailed description of how to set up Windows Media Encoder, see Windows Media Encoder Help.

Related topics

  • Quick starts
  • Sourcing from an encoder


Use your server to broadcast a stream published by Windows Media Encoder

This quick start demonstrates how to publish a broadcast from a computer running Windows Media Encoder through a Windows Media server, also known as push distribution. This technique is ideal for broadcasting company meetings or live presentations. For this task, you must have a separate computer running Windows Media Encoder that has a sound card or video capture card and the appropriate input devices. Also, be sure that the person operating the encoder has administrator rights and privileges for the Windows Media server and can connect to Windows Media Services.

  1. Prepare Windows Media Services to receive content from the encoder by doing the following:
    • In Windows Media Services, in the console tree, click the server from which you want to stream.
    • In the details pane, click the Properties tab, and then in Category, click Control protocol.
    • Click WMS HTTP Server Control Protocol, and then click the Enable button. Windows Media Encoder uses the HTTP control protocol to send the encoded stream to the Windows Media server. For more information about the HTTP control protocol, see Using the HTTP protocol.
    • On the computer running Windows Media Encoder, set up a new encoding session to broadcast a live event.
  2. Configure the encoder to create a new publishing point on your server by choosing the appropriate broadcast method.
  3. You need to supply the following information to the encoder to enable it to create a publishing point successfully:
    • The name of your Windows Media server.
    • The name of the publishing point from which the content will be broadcast. The encoder will create this publishing point on your server if it does not already exist.
    • The name of an existing publishing point on the Windows Media server that has the settings that you want to use as a template for your new publishing point. The encoder administrator must have write and create permissions for the publishing point to use it as a template. If there is not an existing publishing point that you want to duplicate, the encoder will use the default publishing point configuration. For more information about setting publishing point permissions, see WMS Publishing Points ACL Authorization - general properties.

Once Windows Media Encoder creates a broadcast publishing point on the Windows Media server and begins streaming live content to it, clients can connect to the broadcast by using the publishing point URL or an announcement file,

For more information about testing your streaming content, see Testing a stream.

Note Image Notes

  • Windows Media Services does not include a logging plug-in for encoder push scenarios. You can log encoder push broadcast data by creating an active script logging plug-in to use on your Windows Media server. For more information about creating a custom plug-in, see the Windows Media Services Software Development Kit (SDK), which can be downloaded from the Windows Media home page at the Microsoft Web site.
  • For a detailed description of how to set up Windows Media Encoder, see Windows Media Encoder Help.

Related topics

  • Quick starts
  • Sourcing from an encoder


Use a playlist with on-demand Windows Media files

This quick start demonstrates how to stream a set of files in the order you specify. This streaming scenario is ideal for providing online training or a series of on-demand presentations. To set up this task, you need to identify a set of Windows Media files that you intend to stream as a playlist, and then use the following steps to accomplish the task:

  1. Use the Add Publishing Point Wizard to create a new on-demand publishing point by right-clicking the server from which you want to stream a playlist and then clicking Add Publishing Point (Wizard). Proceed through the wizard pages making the following choices:
    • On the Publishing Point Name page, type a name for the new publishing point.
    • On the Content Type page, click Playlist.
    • On the Publishing Point Type page, click On-demand publishing point.
    • On the Existing Publishing Point page, click Add a new publishing point.
    • On the File Location page, click New Playlist.
  2. Use the wizard to create a new playlist by doing the following:
    • On the New Playlist page, click the Add Media button. The Add Media Elements dialog box appears.
    • In Location of content, type the location of the content or click the Browse button to locate the content. Click OK.
    • Repeat the previous step as necessary to add all of the files to the playlist.
    • On the New Playlist page, adjust the sequence of the files in the playlist by clicking a file and then clicking the Move Up or Move Down buttons.
    • On the Save Playlist File page, type a unique file name and location for your playlist.
  3. Use the wizard to enable and configure the following plug-ins:
    • WMS Playlist Transform plug-in
      On the Content Playback page, select the appropriate check box if you want to loop or shuffle your playlist content. Select both check boxes for continuous, random playback.
    • WMS Client Logging plug-in
      On the Unicast Logging page, select the check box if you want to log data about your clients.
  4. Verify that your wizard settings are correct and complete:
    • On the Publishing Point Summary page, verify that the settings for the new publishing point are correct.
    • On the Completing the Add Publishing Point Wizard page, clear all of the check boxes and then click Finish.

Users can now receive the content in the playlist by using the URL of your publishing point. The URL of a publishing point uses the following syntax:
connection protocol://server_name/publishing_point_name (for example, mms://server1/my playlist).

For more information about testing your streaming content, see Testing a stream.

Note Image Notes

  • You can use announcements to direct users to your content. Announcements are metafiles that automatically open Windows Media Player and direct the Player to the content on a publishing point. For more information about announcements, see Working with the announcement wizards.
  • You can change the properties for a file in a playlist by modifying the properties area in the Playlist Editor or by using the Source tab. For more information about modifying playlist elements and attributes, see the Playlist reference or the Windows Media Services 9 Series Software Development Kit (SDK) available on the Windows Media home page at the Microsoft Web site.

Related topics

  • Quick starts
  • Understanding playlists


Alternate between live and prerecorded content in your broadcast

This quick start demonstrates how to use Windows Media Services to stream both live and prerecorded (stored) content. Despite the inclusion of stored content, users do not have the ability to pause, fast-forward, or rewind the broadcast. The user has the option of starting, stopping, and resuming the broadcast stream, creating a user experience similar to tuning in to a radio or television broadcast.

This quick start is an example of how versatile server-side playlists can be and how they are used to manipulate the playback at the client computer. For this task, you must be streaming live content from a computer running an encoder and you must have prerecorded content, such as an advertisement, in a Windows Media file. In the following procedure, the client receives five minutes of live content, which is then is interrupted for an advertisement. When the advertisement ends, the live content resumes for another five minutes.

  1. In Windows Media Services, in the console tree, click Publishing Points. In the details pane, click the View playlist editor button. The Windows Media Playlist Editor opens.
  2. Add container elements to the playlist to control how different playlist elements are played back with respect to each other. In this quick start, the publishing point will pause the content when one element interrupts another. To specify this behavior do the following:
    • In the Windows Media Playlist Editor, click the Add element arrow on the toolbar and then click Exclusive. An excl element appears in the playlist tree.
    • Click the excl element that you just created. Click the Add element arrow on the toolbar and then click PriorityClass. A priorityClass element appears in the below the excl element.
    • Click the priorityClass element that you just created. In the properties area, click the peers attribute and then type Pause in the text box. Press ENTER. This setting instructs the publishing point to pause this content whenever it switches to another media element.
  3. Add live content to the playlist by doing the following:
    • In the Windows Media Playlist Editor, click the Add element button on the toolbar. The Add Media Elements dialog box appears.
    • Type the URL of the encoder stream by using the following syntax: http://encoder_name:port. Select the Add as a child element check box and then click OK. The media element appears in the playlist tree beneath the priorityClass element and displays the URL of the encoder.
  4. In the Windows Media Playlist Editor, set the following values to define how the live content should be played back. In this example, the content will start immediately and stream for 10 minutes:
    • In the playlist tree, click the media element that you added in the previous step.
    • Click the begin attribute in the properties area and then type 0 in the text box. Press ENTER. This setting instructs the publishing point to begin streaming the live content as soon as the publishing point starts.
    • Click the dur attribute in the properties area and then type 10min in the text box. Press ENTER. This setting instructs the publishing point to stream the live content for a total of 10 minutes.
  5. To provide a unique identifier for the live content, click the id attribute in the properties area and then type a name for the media element, such as M1, in the text box. Press ENTER. This setting provides this media element with a name that can be referenced by other elements in the playlist.
  6. Add prerecorded content to the playlist by performing the following steps. In this example, the prerecorded content is an advertisement:
    • In Windows Media Playlist Editor, click the priorityClass element in the playlist tree.
    • Click the Add element button on the toolbar. The Add Media Elements dialog box appears.
    • Type the name and location of the advertisement that you want to add. Select the Add as a child element check box and then click OK.
  7. Define how the advertisement should be played back by doing the following. In this example, the advertisement starts five minutes after the content starts:
    • In the playlist tree, click the advertisement media element that you just added.
    • Click the begin attribute in the properties area and then type M1.begin + 5min, for example, in the text box. Press ENTER. This instructs the publishing point to wait until the live content has played for five minutes and then play the advertisement.
  8. Provide a unique identifier for the advertisement by clicking the id attribute in the properties area. Type a name for the advertisement, such as M2, in the text box. Press ENTER. This provides this media element with a name that can be referenced by other elements in the playlist.
  9. Save the playlist and then close the Windows Media Playlist Editor.
  10. Use the Add Publishing Point Wizard to create a new broadcast publishing point by doing the following:
    • On the Action menu, click Add Publishing Point (Wizard). The Add Publishing Point Wizard appears.
    • On the welcome page, click Next.
    • On the Publishing Point Name page, type a name for the new publishing point.
    • On the Content Type page, click Playlist.
    • On the Publishing Point Type page, click Broadcast Publishing Point.
    • On the Delivery Options for Broadcast Publishing Points page, click Unicast.
  11. Use the wizard to reference the playlist that you created in steps 1 through 9 by using the following settings:
    • On the File Location page, click Existing playlist. In File name, type the name and location of the new playlist.
    • On the Unicast Logging page, select the check box if you want to log data about your clients.
    • On the Publishing Point Summary page, verify that the settings for the new publishing point are correct.
    • On the Completing the Add Publishing Point Wizard page, clear all of the check boxes, and then click Finish.
  12. Configure the following publishing point settings to have the publishing point start when the first client connects:
    • In the console tree, click the publishing point you just created. In the details pane, click the Properties tab. In Category, click General.
    • Click the Start publishing point when first client connects property and then click the Enable button.

Users can now receive the content in the playlist by typing the URL of your publishing point in their player. The URL to a publishing point uses the following syntax: connection protocol://server_name/publishing_point_name (for example, mms://server1/my publishing point).

For more information about testing your streaming content, see Testing a stream.

Related topics

  • Playlist reference
  • Quick starts


Include interstitial advertising in your on-demand playlist

This quick start demonstrates how to stream a playlist that contains prerecorded (stored) content and advertising. You can stream advertising content from either a locally stored file or from a participating advertiser's server.

When receiving the stream, users have full control over the playback of the prerecorded content, but they cannot skip the advertising content. This quick start assumes that you have several prerecorded content files as well as some sort of advertising content available for streaming.

  1. Use the Add Publishing Point Wizard to create a new on-demand publishing point by doing the following:
    • In Windows Media Services, in the console tree, expand the server from which you want to stream content.
    • On the Action menu, click Add Publishing Point (Wizard).
    • On the welcome page of the Add Publishing Point Wizard, click Next.
    • On the Publishing Point Name page, type a name for the new publishing point.
    • On the Content Type page, click Playlist.
    • On the Publishing Point Type page, click On-demand Publishing Point.
  2. To use the wizard to create a new playlist, do the following:
    • On the New Playlist page, click the Add Media button. The Add Media Elements dialog box appears.
    • In Location of content, type the location of the digital media content or click the Browse button to locate the content. Click OK.
    • Repeat the previous steps as necessary to add all of the content to the playlist.
    • On the New Playlist page, adjust the sequence of the files in the playlist by clicking a file and then clicking the Move Up or Move Down buttons.
  3. Use the wizard to add advertising content to the playlist by doing the following:
    • On the New Playlist page, click the Add Advertisement button. The Add Advertisement dialog box appears.
    • Type the location of the advertising content or click the Browse button to locate the advertisements. Click OK.
    • Repeat the previous steps as necessary to add all of the advertisements to the playlist.
    • On the New Playlist page, adjust the sequence of the files in the playlist by clicking a file and then clicking the Move Up or Move Down buttons.
    • On the Save Playlist File page, type a unique file name and location for your playlist.
  4. Use the wizard to configure the following playback options:
    • On the Content Playback page, select the appropriate check box.
    • On the Unicast Logging page, select the check box if you want to log data about your clients.
    • On the Publishing Point Summary page, verify that the settings for the new publishing point are correct.
    • On the Completing the Add Publishing Point Wizard page, clear the After this wizard finishes check box, and then click Finish.

Users can now receive the content in the playlist by typing the URL of your publishing point in their players. The URL of a publishing point uses the following syntax:
connection protocol://server_name/publishing_point_name (for example, mms://server1/my publishing point).

For more information about testing your streaming content, see Testing a stream.

To see how many advertisements have been served by this publishing point at any time, in the details pane, click the Advertising tab. In the Advertisements served by area, click the Reset button to restart the count at zero.

Related topics

  • Quick starts
  • Understanding advertising


Use wrappers to provide advertising with your live broadcast

This quick start demonstrates how to append advertising to the beginning and end of a live broadcast using wrappers. Wrappers are a special type of playlist that can be used to reference ads and other content that precede or follow user-requested content, or both. Wrappers commonly include introductory pages that generate custom playlists, site branding, and sponsor identification. Wrappers are especially effective when used with live streaming because they ensure that the audience will view the advertising content no matter when they join the broadcast. The source of advertising content can be either a locally stored file or a link to a participating advertiser's server.

You have the option of starting, stopping, and resuming the broadcast stream based on one or more user connections, but the user experience will be similar to tuning in to a radio or television broadcast. Live content viewers do not have the ability to pause, fast-forward, or rewind the content of a broadcast and will join the broadcast in process.

In this quick start, it is assumed that you have another computer running Windows Media Encoder that is broadcasting a live stream and that you have prerecorded advertising content available. This quick start uses the Create Wrapper Wizard to create a wrapper that streams the prerecorded advertising content before and after the live broadcast. It does not specifically address setting up a live stream. For a detailed description of how to set up Windows Media Encoder, see Windows Media Encoder Help.

  1. Do the following to start the Create Wrapper Wizard:
    • In Windows Media Services, in the console tree, expand the server from which you want to stream content, and then expand Publishing Points.
    • Click the broadcast publishing point in which you want to include a wrapper. In the details pane, click the Advertising tab.
    • Click the Wrapper Editor button to open the Wrapper Playlist Editor Options dialog box.
    • Click Create playlist file, and then select the Use the Create Wrapper Wizard check box. The Create Wrapper Wizard appears.
  2. Use the following settings in the Create Wrapper Wizard to add advertising content to your wrapper playlist:
    • On the welcome page, click Next.
    • On the Wrapper Playlist File page, click the Add Advertisement button. The Add Advertisement dialog box appears.
    • Type the location of the advertising content or click the Browse button to locate the advertisements. Click OK.
    • Repeat the previous steps as necessary to add all of the desired wrapper advertisements.
    • Change the location of the wrapper ads before by clicking an individual item and then clicking the Move Up or Move Down buttons.
    • On the Save Wrapper Playlist File page, type a unique file name and location for your wrapper playlist.
    • Select the Start publishing point when wizard finishes check box to reset the publishing point, allowing all enabled wrappers to play as scheduled.
    • Select the Enable wrapper playlist when wizard finishes check box to use the new wrapper playlist immediately, and then click Finish.

For more information about testing your streaming content, see Testing a stream.

Related topics

  • About wrapper playlists
  • Quick starts
  • Working with the Create Wrapper Wizard


Manage servers

This section contains tasks specific to managing Windows Media servers:

  • To install and use Windows Media Services Administrator for the Web
  • To provide a user administrative rights to Windows Media Services
  • To start Windows Media Services on a server
  • To stop Windows Media Services on a server
  • To add a server
  • To remove a server
  • To deny unicast connections to a server
  • To allow unicast connections to a server
  • To view troubleshooting information for a server
  • To configure troubleshooting options for a server
  • To enable HTTP streaming
  • To change the port Windows Media Services uses for HTTP streaming
  • To add IP addresses to resolve port 80 conflicts
  • To set authentication credentials for a reverse proxy server
  • To access content on a computer running Windows 2000 Server
  • To import a console configuration
  • To export a console configuration

Related topics

  • How to…
  • Managing your Windows Media server


To install and use Windows Media Services Administrator for the Web

  1. Install Windows Media Services Administrator for the Web by doing the following:
    • On the taskbar, click the Start button, point to Control Panel, and then click Add or Remove Programs.
    • Click Add/Remove Windows Components. Windows Setup starts and the Windows Components Wizard opens.
    • In the components list, click Windows Media Services, and then click the Details button.
    • Select the Windows Media Services Administrator for the Web check box and then click OK. A message appears, informing you that this component requires Internet Information Services (IIS) 6.0 and that installing this component will install IIS 6.0 with the Active Service Pages and Server Side Includes features enabled. Click OK to close the message and continue with the installation.
    • Click OK to close the Windows Media Services dialog box.
    • Click Next to install Windows Media Services Administrator for the Web.
  2. To use Windows Media Services Administrator for the Web from the local server, click the Start button, point to Programs, point to Administrative Tools, and then click Windows Media Services (Web).

-or-

To connect to Windows Media Services Administrator for the Web from a remote location, make sure the Web services are running on the Windows Media Administration Web site, and then type the URL to the Windows Media Administration site into your Web browser. By default this URL is http://server_name:8080/default.asp.

  3. Windows Server 2003 has an increased level of security that prevents some controls from running on non-trusted Web sites. Because the Windows Media Services Administrator for the Web runs from a Web site on the Windows Media server, if JavaScript and Meta-Refresh are not enabled for the Internet zone in the Security settings, you must make the Windows Media server a trusted site before you can administer the server remotely. To make it a trusted site, do the following:
    • On the taskbar, click Start, point to Control Panel, and click Internet Options.
    • Click the Security tab. In the list of Web content zones, click Trusted sites, and then click Sites.
    • In the Add the Web site to the zone dialog box, type the URL to the Windows Media server (for example, http://servername:8080), and then click Add.

      The address is added to the list of trusted Web sites.

    • On the Windows Media server, press F5 to refresh Windows Media Services Administrator for the Web.

  4. If you have not run the Web Server Security Lockdown Wizard in Internet Information Services (IIS), the Security Settings page opens. Do one of the following:
    • Click the link to learn more about securing the Windows Media Administration site. If you decide to use Secure Sockets Layer (SSL) to secure the Windows Media Administration site, you must reconnect to Windows Media Services Administrator for the Web.
    • Click Administer the local Windows Media Server to open Windows Media Services Administrator for the Web without enabling SSL.
    • Click Administer a list of Windows Media Servers to open the server list page and select which Windows Media server to administer.

Note Image Note

  • You can also manage the server using a Microsoft Management Console (MMC) snap-in. You can use the default snap-in configuration that was created when Windows Media Services was installed, which may be accessed in the Administrative Tools submenu, or you can add the Windows Media Services snap-in to Microsoft Management Console. For more information about adding a snap-in to an MMC console, see Microsoft Management Console Help.

Related topics

  • Administering Windows Media Services
  • Manage servers
  • Secure the Windows Media Administration site
  • To add a server


To provide a user administrative rights to Windows Media Services

  1. On your server start the DCOM config utility. For more information about DCOM configuration, see Windows Help and Support.
  2. Locate Windows Media Services in the list, and open its properties.
  3. On the Security tab, edit the access permissions.

    The Access Permissions list shows the users and user groups that can administer Windows Media Services.

  4. Add the users or groups that you want to be able to administer Windows Media Services, and then close the dialog boxes.

The new settings will take effect when you restart Windows Media Services.

Note Image Notes

  • By default, members of the Administrator group on the server have administrative rights and permissions to Windows Media Services. This procedure is provided to inform you how to grant administrative rights and permissions to Windows Media Services to users who are not system administrators. This is can be useful in cases where Windows Media Services is being administered remotely through another program, such as Windows Media Encoder.
  • To make user administration easier, you can create a new user group by using Computer Management and add the group to the Windows Media Services access permissions list. Then you can use Computer Management to add or remove users from the group, rather than doing so with DCOM config. By creating a new group, you can add or remove users without having to restart Windows Media Services. Groups also enable you to manage user privileges for the whole server at the same time.

Related topics

  • Limiting user rights
  • Understanding rights


To start Windows Media Services on a server

  1. Click the server on which you want to start Windows Media Services.
  2. In the Windows Media Services snap-in, on the Action menu, click Start.

-or-

In Windows Media Services Administrator for the Web, on the Service Stopped page, click the Start Service button.

Once the Windows Media Services service starts, the details pane displays the Monitor tab information for the server.

Related topics

  • Manage servers


To stop Windows Media Services on a server

  1. In the console tree, click the server on which you want to stop Windows Media Services.
  2. In the details pane, click the Monitor tab, and then click the Stop button.

A confirmation dialog box appears. Once you confirm that you want to stop the server, the interface indicates that the server has been stopped.

Related topics

  • Manage servers


To add a server

  1. In the console tree, click Windows Media Services.
  2. On the Action menu, click Add Server.

The Add Server dialog box appears.

  3. In Server name or IP address, type the name or IP address of the server you want to add, and then click OK.

The new server name appears in the console tree. After you have added the server, you can set limits, control access to content, and set up logging for it.

Web administration feature For Windows Media Services Administrator for the Web

  1. On the server list page, click the Add Server button.

    The Add Server page opens.

  2. In Server name or IP address, type the name or IP address of the server you want to add, and then click Add.

    The new server name appears in the server list.

    To administer the server, click the server name on the server list page. After you open the server administrative interface, you can set limits, control access to content, and set up logging for it.

Related topics

  • Control access to content
  • Log data about clients
  • Manage servers
  • Managing your Windows Media server
  • Monitor and set limits


To remove a server

  1. In the console tree, click the server you want to remove.
  2. On the Action menu, click Remove.

A confirmation dialog box appears.

  3. Click Yes to confirm that you want to remove the selected server from the console tree.

Web administration feature For Windows Media Services Administrator for the Web

  1. On the server list page, click the server you want to remove.
  2. Click the Remove Server button.
  3. Click OK to confirm that you want to remove the selected server from the server list.

Related topics

  • Manage servers


To deny unicast connections to a server

  1. Click the server that you want to deny unicast connections to.
  2. In the Windows Media Services snap-in, on the Action menu, click Deny New Connections.

-or-

In Windows Media Services Administrator for the Web, click the Deny button.

New requests for unicast streams will be denied.

Note Image Note

  • If you are delivering the content as both unicast and multicast streams from a broadcast publishing point, players will still be able to receive multicast streams from the server after you deny unicast connections. You must stop either the server or the publishing point if you do not want players to receive the multicast stream.

Related topics

  • Allowing or denying unicast client connections
  • Manage servers
  • Monitoring performance
  • To stop a broadcast publishing point
  • To stop Windows Media Services on a server


To allow unicast connections to a server

  1. Click the server to which you want to allow unicast connections.
  2. In the details pane, click the Monitor tab, and then click the Allow button.

New requests for unicast streams will be allowed.

Related topics

  • Allowing or denying unicast client connections
  • Manage servers
  • Monitoring performance


To view troubleshooting information for a server

  1. In the console tree, expand the server for which you want to view troubleshooting information.
  2. In the console tree, click Troubleshooting.

    The list of events associated with the server is displayed in the details pane.

  3. In the Windows Media Services snap-in, click an event and then click View error details to view more information about an event in the list.

    The Error Details dialog box appears with detailed information about the event.

Related topics

  • Manage servers
  • To configure troubleshooting options for a server


To configure troubleshooting options for a server

  1. In the Windows Media Services snap-in, do the following:
    • In the console tree, expand the server for which you want to configure troubleshooting options, and then click Troubleshooting.
    • In the details pane, click the View options button.

      The Troubleshooting Options dialog box appears.

-or-

In Windows Media Services Administrator for the Web, do the following:

  • In the console tree, click Troubleshooting.

    The Troubleshooting page displays a list of errors and the troubleshooting options settings.

  2. In Number of events server stores, type the maximum number of events you want to appear in the troubleshooting events list. The minimum allowable entry is 100 and the maximum is 2000. The default is 200.
  3. In Filter events, you can choose which events are displayed in the troubleshooting events list by selecting the corresponding check box:
    • Display limit hits. Select this check box to display events when a server or publishing point reaches its set limits. When the limits are reached, new clients are not able to connect to your server. To stop displaying limit-hit events, clear the Display limit hits check box.
    • Display server warnings. Select this check box to display warnings related to the Windows Media Services service. To stop displaying server warnings, clear the Display server warnings check box.
    • Display server errors. Select this check box to display errors related to the Windows Media Services service. To stop displaying server errors, clear the Display server errors check box.
    • Display plug-in warnings. Select this check box to display plug-in warnings, which indicate that the plug-in is not able to function as configured. To stop displaying plug-in warnings, clear the Display plug-in warnings check box.
    • Display plug-in errors. Select this check box to display plug-in errors, which indicate that a plug-in is not functioning and should be disabled or reconfigured. A plug-in may need to be reinstalled to resolve an error event. To stop displaying plug-in errors, clear the Display plug-in errors check box.

Note Image Note

  • All events are selected by default.

Related topics

  • Manage servers


To enable HTTP streaming

  1. Click the server for which you want to enable HTTP streaming.
  2. In the details pane, click the Properties tab.
  3. In Category, click Control protocol.
  4. In Plug-in, click WMS HTTP Server Control Protocol.
  5. Click the Enable button.

Note Image Note

  • If Windows Media Services and Internet Information Services (IIS) are installed on the same computer, be sure each service has been allocated a unique HTTP port. By default, both services will attempt to bind to port 80, which causes a port conflict. You can resolve the port conflict by either adding IP addresses to your server or by changing the port that Windows Media Services uses for HTTP streaming.

Related topics

  • Manage servers
  • To add IP addresses to resolve port 80 conflicts
  • To change the port Windows Media Services uses for HTTP streaming
  • Using the HTTP protocol


To change the port Windows Media Services uses for HTTP streaming

  1. Click the server for which you want to change the port allocated for HTTP streaming.
  2. In the details pane, click the Properties tab.
  3. In Category, click Control protocol.
  4. In Plug-in, click WMS HTTP Server Control Protocol, and then click Properties.
  5. If you have more than one IP address available on your server, in IP address, click Allow selected IP addresses to use this protocol, and then click the specific IP addresses you want to use from the list.
  6. In Port selection, click Use other port, and then type the port number you want to use in the space provided. HTTP port numbers can range from 1 to 65535.
  7. Click OK to apply the change.
  8. In the details pane, in Plug-in, click WMS HTTP Server Control Protocol. Click Enable to make the HTTP protocol available for streaming content from your server.

Note Image Notes

  • Windows Media Services attempts to use port 80 by default, but that port is also commonly reserved for use by Web servers. To avoid port conflict, use a port other than 80 for HTTP streaming. If you do not use the default port, the URL that a player uses to connect to the publishing point must include the new port number. For example, if you change the HTTP port to port 1450, the connection URL would be http://server_name:1450/publishing_point_name.
  • To provide more than one port 80 on your server, you can install additional network interface cards, or you can use the networking features of the operating system to add additional IP addresses to a single network interface card. After creating additional IP address/port 80 combinations, you must configure Windows Media Services and your Web server to utilize separate ports.

Related topics

  • Manage servers
  • To add IP addresses to resolve port 80 conflicts
  • Using the HTTP protocol


To add IP addresses to resolve port 80 conflicts

  1. In Windows Explorer, navigate to %systemroot%\System32\Windows Media\Server\Admin\MMC.
  2. Double click WMSHttpSysCfg.exe.

The Windows Media Services HTTP Sys Configuration dialog box appears.

  3. In IP Address, type the IP address you want the HTTP.sys driver to use and click Add.
  4. Repeat step 3 to add any additional IP addresses.
  5. Restart HTTP.sys and Internet Information Services (IIS) by either restarting the computer or typing the following at the command prompt:

net stop http /y && iisreset

  6. To verify that IIS only binds to the newly added IP addresses, type the following at the command prompt:

netstat

  7. Start the Windows Media Services snap-in.
  8. In the console tree, click the server for which you want to enable HTTP streaming.
  9. In the details pane, click the Properties tab.
  10. In Category, click Control protocol.
  11. In Plug-in, click WMS HTTP Server Control Protocol, and then click Properties.
  12. In IP address, click Allow selected IP addresses to use this protocol, and then click the specific IP addresses you want to use from the list. Do not select the addresses that were added in step 3.
  13. Click OK to apply the change.
  14. In the details pane, in Plug-in, click WMS HTTP Server Control Protocol. Click Enable to make the HTTP protocol available for streaming content from your server.

Related topics

  • Manage servers
  • Using HTTP streaming and other services on the same computer


To set authentication credentials for a reverse proxy server

  1. On the reverse proxy server, run the following script. In this script, password is the password and user_name is the user name you want to use to authenticate the origin server:
    Dim server
Set server = CreateObject("WMSserver.Server")
Dim pp1
Set pp1 = server.PublishingPoints.Item("Cache/Proxy Broadcast")
pp1.DistributionPassword = "password"
pp1.DistributionUserName = "user_name"

  2. On the origin server, configure the appropriate authentication plug-in to accept these values.

Related topics

  • Manage servers
  • Understanding reverse proxy


To access content on a computer running Windows 2000 Server

  1. If the computer running Windows 2000 Server and the computer running Windows Media Services are members of the same workgroup, but do not belong to the same domain, create a new user account and password on the computer running Windows 2000 Server. This user account should not have administrator rights and permissions.
  2. Create an identical user account and password on the computer running Windows Media Services. You can create new user accounts by using the Computer Management console. Grant the new user account all of the same permissions and rights as the Network Service account.
  3. Configure Windows Media Services to log on using the new account when it starts. You can change the account the Windows Media Services Service uses to log on to the computer during startup through the Windows control panel.

For more information about creating and configuring accounts, passwords, and privileges, see Windows Help and Support.

Related topics

  • Manage servers


To import a console configuration

  1. In the console tree, click Windows Media Services.
  2. On the Action menu, click Import console configuration.
  3. In the Open dialog box, select the console configuration file that contains the configuration data you want to use and then click Open. The console configuration file has an .xml file name extension.

The console configuration of servers and groups will be applied to the Windows Media Services snap-in.

Note Image Note

  • This information only applies to the Windows Media Services snap-in.

Related topics

  • Manage servers
  • To export a console configuration


To export a console configuration

  1. In the console tree, click Windows Media Services.
  2. On the Action menu, click Export console configuration.
  3. In the Save As dialog box, enter a name for the console configuration and then click Save. The console configuration file must be saved with an .xml file name extension. By default, the file is saved to %HOMEPATH%\My Documents.

Server and group data for the current console will be stored in the file.

Note Image Note

  • This information only applies to the Windows Media Services snap-in.

Related topics

  • Manage servers
  • To import a console configuration


Work with groups of servers

This section contains the following topics:

  • To add a group
  • To add a server to a group
  • To remove a server from a group
  • To modify group properties
  • To refresh the statistics in the server list for a group
  • To remove a group

Note Image Note

  • These procedures only apply to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • How to…
  • Managing your Windows Media server


To add a group

  1. In the console tree, click Windows Media Services.
  2. On the Action menu, click Add Group.

    The Add Group dialog box appears.

  3. In Group name, type a unique name for the group you are adding.
  4. Click OK to add the group.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • Manage servers
  • To add a server to a group
  • Using groups
  • Work with groups of servers


To add a server to a group

  1. In the console tree, click the group to which you want to add a server.
  2. On the Action menu, click Add Server.

    The Add Server dialog box appears.

  3. In Server name or IP address, type the name or IP address of the Windows Media server you want to add to the group, and then click OK.

    The server name appears in the console tree under the group name.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • Manage servers
  • Using groups
  • Work with groups of servers


To remove a server from a group

  1. In the console tree, expand the group from which you want to remove a server, and then click the server that you want to remove from the group.
  2. On the Action menu, click Remove.
  3. A confirmation dialog box appears. Click the Yes button.

    The server is removed from the list.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • Manage servers
  • Using groups
  • Work with groups of servers


To modify group properties

  1. In the console tree, click the group you want to modify.

    A list of the servers that are members of the selected group appears in the details pane.

  2. In the details pane, click the View properties button.

    The properties sheet for the selected group is displayed.

  3. To change the name of the group, in Group name, type the new name.
  4. To change how often the statistics displayed in the server list are updated, in Refresh rate, use the drop-down list to select the desired number of seconds between updates.
  5. Click OK to apply the properties to the group.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • Manage servers
  • Using groups
  • Work with groups of servers


To refresh the statistics in the server list for a group

  1. In the console tree, click the group whose statistics you want to refresh.

    A list of the servers that are members of the selected group appears in the details pane.

  2. In the details pane, click Refresh list.

    The statistics displayed are updated to show the most current information.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • Manage servers
  • Using groups
  • Work with groups of servers


To remove a group

  1. In the console tree, click the group you want to remove.
  2. On the Action menu, click Remove.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in. Group management is not supported in Windows Media Services Administrator for the Web.

Related topics

  • Manage servers
  • Work with groups of servers


Work with plug-ins

This section contains the following topics:

  • To enable a plug-in
  • To disable a plug-in
  • To configure plug-in properties
  • To rename a plug-in
  • To duplicate a plug-in
  • To remove a plug-in
  • To configure the WMS Network Data Source plug-in
  • To configure the WMS Archive Data Writer plug-in
  • To configure the WMS HTTP Server Control Protocol plug-in
  • To configure the WMS MMS Server Control Protocol plug-in
  • To configure the WMS RTSP Server Control Protocol plug-in
  • To configure the WMS Unicast Data Writer plug-in
  • To configure the WMS Playlist Transform plug-in
  • To configure the WMS Multicast Data Writer plug-in

Related topics

  • How to…
  • Managing your Windows Media server


To enable a plug-in

  1. Click the server or publishing point for which you want to enable a plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click the plug-in category.
  4. In Plug-in, click the plug-in you want to enable, and then click Enable.

Related topics

  • Work with plug-ins


To disable a plug-in

  1. Click the server or publishing point for which you want to disable a plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click the plug-in category.
  4. In Plug-in, click the plug-in you want to disable, and then click Disable.

Related topics

  • Work with plug-ins


To configure plug-in properties

  1. Click the server or publishing point for which you want to configure the plug-in properties.
  2. In the details pane, click the Properties tab.
  3. In Category, click the plug-in category.
  4. In Plug-in, click the plug-in you want to configure, and then click Properties. The Properties button is unavailable if a plug-in does not have configurable properties.

Related topics

  • Work with plug-ins


To rename a plug-in

  1. Click the server or publishing point for which you want to rename the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click the plug-in category.
  4. In the Windows Media Services snap-in, right-click the plug-in name, click Rename, type the new name.

    -or-

    In Windows Media Services Administrator for the Web, click the Rename button, type the new name, and then click OK.

Note Image Note

  • The following characters are reserved and cannot be used as part of the plug-in name: &"'<>\.

Related topics

  • Work with plug-ins


To duplicate a plug-in

  1. Click the server or publishing point for which you want to duplicate a plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click the plug-in category.
  4. In Plug-in, click the plug-in that you want to duplicate.
  5. Click the Duplicate button.
  6. In Plug-in name, type a name for the duplicated plug-in or accept the default, which is "Copy of plug-in name". The new plug-in will appear in the list.

Related topics

  • Work with plug-ins


To remove a plug-in

  1. Click the server or publishing point from which you want to remove a plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click the plug-in category.
  4. In Plug-in, select the plug-in that you want to remove.
  5. Click the Remove button.

    The plug-in status will change to Disabled-Pending Removal. The plug-in will be removed from the list after Windows Media Services service has been stopped and restarted.

Note Image Note

  • You cannot remove the last instance of a system plug-in. If you attempt to do so, a message is displayed, and you can choose to disable the plug-in instead. Disabling a system plug-in removes features and can affect the ability to stream content from the server.

Related topics

  • Work with plug-ins


To configure the WMS Network Data Source plug-in

  1. Click the server for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab, and then select the Show all plug-in categories check box.
  3. In Category, click Data source.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS Network Data Source, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS Network Data Source.

    WMS Network Data Source Properties appears.

  5. On the General tab, in Protocols, select the check boxes of to the protocols you want to use when connecting to network data sources through RTSP.
  6. If you are connecting to a network data source through a proxy server, in Proxy settings, click the protocol used to connect to the proxy server, and then click the Configure button.
  7. Enter the appropriate information for your proxy server, and then click OK.

Note Image Note

  • Windows Media Services supports Internet Protocol version 6 (IPv6). IPv6 is the newest version of the Internet Protocol and was designed to accommodate increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use IPv6 when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.

Related topics

  • WMS Network Data Source - configure protocol properties
  • WMS Network Data Source - general properties
  • Work with plug-ins


To configure the WMS Archive Data Writer plug-in

  1. In the console tree, click the broadcast publishing point for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Archiving.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS Archive Data Writer, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS Archive Data Writer.

    WMS Archive Data Writer Properties appears.

  5. If you want to automatically begin archiving when the publishing point starts, select the Start archiving when publishing point starts check box.
  6. Type a location and a name for the archive file, and then click OK. For more information about the wildcard characters that can be used in an archive file name, see Archive wildcard characters reference.
  7. In the details pane, click Enable.

Note Image Notes

  • To change the archive file path after archiving has started, you must stop archiving, change the path, and then restart archiving. You can manually start and stop archiving on the Source tab of the publishing point.
  • The WMS Archive Data Writer plug-in cannot be enabled or disabled while the publishing point is streaming content. If you want to archive your broadcast, you must enable the archiving plug-in before you start your publishing point.
  • If you archive your streamed content by using the default name and the default directory, the content may be vulnerable to unauthorized access. To protect your archived content, save it to a location that is outside the Wmroot directory structure or implement additional network security measures.

Related topics

  • To archive content
  • Work with plug-ins


To configure the WMS HTTP Server Control Protocol plug-in

  1. In the console tree, click the server for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Control protocol.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS HTTP Server Control Protocol, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS HTTP Server Control Protocol.

    WMS HTTP Server Control Protocol Properties appears.

  5. Do one of the following:
    To | Do this
    Allow all of the IP addresses on your server to use HTTP when streaming content | Click Allow all IP addresses to use this protocol.
    Allow only those IP addresses you select in the IP address list to use HTTP when streaming content | Click Allow selected IP addresses to use this protocol, and then in the IP address list, click the IP addresses that will use the HTTP protocol.
  6. Do one of the following:
    To | Do this
    Use the default HTTP port | Click Use default port (80).
    Specify a different port to use with HTTP | Click Use other port (1-65535), and then type the port you want to use in the space provided.
  7. In the details pane, click Enable.

Note Image Notes

  • Changes made to this plug-in are applied to new client connection requests only. Clients that are already connected to the server are not affected.
  • Attempting to use Windows Media Services and a Web service such as Microsoft Internet Information Services (IIS) concurrently on a server can cause conflicts because both services attempt to bind to port 80 by default. You can avoid port conflicts by assigning Windows Media Services to a different port or by creating additional IP addresses so that each service can use port 80 on a separate IP address.
  • Windows Media Services supports Internet Protocol version 6 (IPv6). IPv6 is the newest version of the Internet Protocol and was designed to accommodate increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use IPv6 when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.

Related topics

  • To add IP addresses to resolve port 80 conflicts
  • To enable HTTP streaming
  • Using the HTTP protocol
  • Work with plug-ins


To configure the WMS MMS Server Control Protocol plug-in

  1. In the console tree, click the server for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Control protocol.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS MMS Server Control Protocol, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS MMS Server Control Protocol.

    WMS MMS Server Control Protocol Properties appears.

  5. Do one of the following:
    To | Do this
    Allow all of the IP addresses on your server to use MMS when streaming content | Click Allow all IP addresses to use this protocol.
    Allow only those IP addresses you select in the IP address list to use MMS when streaming content | Click Allow selected IP addresses to use this protocol, and then in the IP address list, select the IP addresses that will use the MMS protocol.
  6. Do one of the following:
    To | Do this
    Use the default MMS port | Click Use default port (1755).
    Specify a different port to use with MMS | Click Use other port (1-65535), and then type the port you want to use in the space provided.
  7. In the details pane, click Enable.

Note Image Notes

  • Changes made to this plug-in are applied to new client connection requests only. Clients that are already connected to the server are not affected.
  • Windows Media Services supports Internet Protocol version 6 (IPv6). IPv6 is the newest version of the Internet Protocol and was designed to accommodate increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use IPv6 when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.

Related topics

  • Using the MMS protocol
  • Work with plug-ins


To configure the WMS RTSP Server Control Protocol plug-in

  1. In the console tree, click the server for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Control protocol.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS RTSP Server Control Protocol, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS RTSP Server Control Protocol.

    WMS RTSP Server Control Protocol Properties appears.

  5. Do one of the following:
    To | Do this
    Allow all of the IP addresses on your server to use RTSP when streaming content | Click Allow all IP addresses to use this protocol.
    Allow only those IP addresses you select in the IP address list to use RTSP when streaming content. | Click Allow selected IP addresses to use this protocol, and then in the IP address list, select the IP addresses that will use the RTSP protocol.
  6. Do one of the following:
    To | Do this
    Use the default RTSP port | Click Use default port (554).
    Specify a different port to use with RTSP | Click Use other port (1-65535), and then type the port you want to use in the space provided.
  7. In the details pane, click Enable.

Note Image Notes

  • Changes made to this plug-in are applied to new client connection requests only. Clients that are already connected to the server are not affected.
  • Windows Media Services supports Internet Protocol version 6 (IPv6). IPv6 is the newest version of the Internet Protocol and was designed to accommodate increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use IPv6 when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.

Related topics

  • Using the RTSP protocol
  • Work with plug-ins


To configure the WMS Unicast Data Writer plug-in

  1. Click the server for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Unicast streaming.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS Unicast Data Writer, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS Unicast Data Writer.

    WMS Unicast Data Writer Properties appears.

  5. Do any of the following:
    To | Do this
    Allow unicast transmission of data using MMS and RTSP protocols through UDP | Select the UDP check box.
    Allow unicast transmission of data using RTSP and HTTP through TCP | Select the TCP check box.
  6. Do one of the following:
    To | Do this
    To have the content stream determine the optimum packet size for streaming | Click Use default packet size from content.
    To specify the number of bytes that each streaming packet should contain | Click Use maximum packet size (in bytes), and then type a packet size value in the space provided. The default is 1452 bytes.
  7. In the details pane, click Enable.

Note Image Notes

  • Setting the RTP packet size to too small a value may prevent the Windows Media server from streaming.
  • If the Windows Media server or any clients are behind a firewall or a proxy server that cannot pass UDP packets, you should disable UDP packet transmission for the WMS Unicast Data Writer plug-in. Clients that attempt to receive UDP transmissions through network components that are not UDP-enabled may experience latency during the protocol rollover process. For more information about protocol rollover, see How protocol rollover works.

Related topics

  • Delivering content as a unicast stream
  • How unicast works
  • Work with plug-ins


To configure the WMS Playlist Transform plug-in

  1. In the console tree, click the publishing point for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Playlist transform.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS Playlist Transform, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS Playlist Transform.

    WMS Playlist Transform Properties appears.

  5. Do any of the following:
    To | Do this
    Repeat the sequence of your directory or playlist until stopped by an administrator | Select the Loop check box.
    Play back the contents of your directory or playlist in random order | Select the Shuffle check box.
  6. In the details pane, click Enable.

Related topics

  • Work with plug-ins


To configure the WMS Multicast Data Writer plug-in

  1. In the console tree, click the broadcast publishing point for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Multicast streaming.
  4. In the Windows Media Services snap-in, in Plug-in, click WMS Multicast Data Writer, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS Multicast Data Writer.

    WMS Multicast Data Writer Properties appears.

  5. On the General tab, in IP address, type the multicast IP address, and then in Port, type the port number from which you want to multicast.
  6. In Time-to-live (TTL), enter the number of routers that your multicast can pass through (also known as the number of "hops") before expiring on the network.
  7. If you want to enable players to automatically switch to a unicast stream if they cannot receive the stream through multicast, select the Enable unicast rollover check box.
  8. Do one of the following:
    To | Do this
    Allow the current publishing point to stream content by using the Unicast Data Writer plug-in | Click Use this local publishing point.
    Redirect unicast connection requests to an alternate publishing point | Click Use other publishing point, and then type the URL of the publishing point.
  9. In the Windows Media Services snap-in, you must click the Advanced tab to perform the following steps.
  10. In IP address of the network interface card to multicast from enter the IP address for the network interface card on your server that can multicast content
  11. In Logging URL, type the URL to the Multicast and Advertisement Logging Agent, for example, http://server_name/folder/wmsiislog.dll.
  12. Click OK to close the properties sheet.
  13. In the details pane, click Enable.

Note Image Notes

  • Windows Media Services supports Internet Protocol version 6 (IPv6). IPv6 is the newest version of the Internet Protocol and was designed to accommodate increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use IPv6 when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Delivering content as a multicast stream
  • How multicast works
  • To install the Multicast and Advertisement Logging Agent
  • Work with plug-ins


Work with publishing points

This section contains the following topics:

  • Setting up a publishing point
  • Managing connections to a publishing point
  • Testing a stream
  • Configuring publishing point properties

Related topics

  • How to…
  • Set up content to stream
  • Understanding publishing points


Setting up a publishing point

This section contains the following topics:

  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To duplicate a publishing point
  • To remove a publishing point
  • To rename a publishing point
  • To assign a publishing point as the Default publishing point
  • To archive content

Related topics

  • Set up content to stream
  • Understanding publishing points
  • Work with publishing points


To access the Add Publishing Point Wizard

  1. In the console tree, expand the server to which you want to add the publishing point, and then click Publishing Points.
  2. On the Action menu, click Add Publishing Point (Wizard).

    The Add Publishing Point Wizard appears.

  3. Follow the instructions in the wizard to add a publishing point.

Note Image Notes

  • This procedure only applies to the Windows Media Services snap-in.
  • The Add Publishing Point Wizard does not support creating a publishing point that obtains content from a remote publishing point or from a dynamic playlist generated by an ASP page or Common Gateway Interface (CGI) script. To add a new publishing point that uses those content sources, use the Add Publishing Point (Advanced) command to configure the publishing point properties manually.

Related topics

  • Adding publishing points
  • Setting up a publishing point
  • To add a publishing point using the advanced method
  • Working with the Add Publishing Point Wizard


To add a publishing point using the advanced method

  1. In the console tree, expand the server to which you want to add the publishing point, and then click Publishing Points.
  2. On the Action menu, click Add Publishing Point (Advanced).
  3. Select the type of publishing point you want to add: on-demand or broadcast.
  4. In Publishing point name, type a unique name for the publishing point.
  5. In Location of content, enter the path to the content of the publishing point, and then click OK. The following are examples of paths you can enter:
    • For a playlist: C:\Directory\Playlist.wsx
    • For a file: C:\Directory\File_name.wmv
    • For a directory: C:\Directory\*
    • For an encoder: http://encoder:port
    • For a multicast stream: MCast://C:\Wmpub\Wmroot\File.nsc or MCast://\\MachineName\Inetpub\Wwwroot\File.nsc
    • For a publishing point on a remote computer: http://server/publishingpoint

    If you want to select a playlist, file, or directory as the content source, you can click Browse to browse to the file location.

  6. Click OK to add the publishing point to your server.

Web administration feature For Windows Media Services Administrator for the Web

  1. In the console tree, click Publishing Points, and then in the details pane, click the Add button.
  2. Select the type of publishing point you want to add: on-demand or broadcast.
  3. Type a unique name for the publishing point.
  4. In Content type and location, enter the path to the content of the publishing point. The following are examples of paths you can enter:
    • For a playlist: C:\Directory\Playlist.wsx
    • For a file: C:\Directory\File_name.wmv
    • For a directory: C:\Directory\*
    • For an encoder: http://encoder:port
    • For a publishing point on a remote computer: http://server/publishingpoint
  5. Click OK to add the publishing point to your server.

Note Image Notes

  • After you add the publishing point, you can set limits, control access to content, and set up logging for it.
  • If you chose to publish content from a directory, you can stream the content of the entire directory in sequence to users by enabling the Enable access to directory content using wildcards property on the Properties tab of the publishing point.
  • If you add a broadcast publishing point, and you want to deliver content as a multicast stream, you must also configure and enable a multicast data writer plug-in.
  • When you are using a multicast stream as a content source, the location of the content is the address of the multicast information file (the file with the .nsc file name extension). Windows Media Services can access an .nsc file that is stored on a local or network shared drive. Windows Media Services cannot use a URL address to access an .nsc file.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.
  • When naming a publishing point, you should avoid using names that are identical to those of directories or subdirectories on the Windows Media server. A publishing point with the same name as a directory may interfere with another publishing point that sources from that directory.

Related topics

  • Adding publishing points
  • Control access to content
  • Delivering content as a multicast stream
  • Log data about clients
  • Monitor and set limits
  • Reference for content sources
  • Set up content to stream
  • Setting up a publishing point
  • To access the Add Publishing Point Wizard


To duplicate a publishing point

  1. In the console tree, click the publishing point you want to duplicate.
  2. On the Action menu, click Duplicate.

    The Duplicate Publishing Point dialog box appears.

  3. In Publishing point name, type the name for the new publishing point, and then click OK.

Web administration feature For Windows Media Services Administrator for the Web

  1. In the console tree, click Publishing Points.
  2. Click the publishing point you want to duplicate, and then click the Duplicate button.
  3. Type the name for the new publishing point, and then click OK.

Note Image Notes

  • Any configurations you made to the properties of the original publishing point are copied to the properties of the new publishing point.
  • When naming a publishing point, you should avoid using names that are identical to those of directories or subdirectories on the Windows Media server. A publishing point with the same name as a directory may interfere with another publishing point that sources from that directory.

Related topics

  • Adding publishing points
  • Setting up a publishing point


To remove a publishing point

  1. In the console tree, click the publishing point you want to remove.
  2. On the Action menu, click Remove.
  3. In the Remove Publishing Point dialog box, click Yes.

Web administration feature For Windows Media Services Administrator for the Web

  1. In the console tree, click Publishing Points.
  2. Select the publishing point you want to remove, and then click the Remove button.

Related topics

  • Setting up a publishing point


To rename a publishing point

  1. In the console tree, click the publishing point that you want to rename.
  2. On the Action menu, click Rename.
  3. In Publishing point name, type a name for the publishing point, and then click OK.

Web administration feature For Windows Media Services Administrator for the Web

  1. In the console tree, click Publishing Points.
  2. Click the publishing point you want to rename, and then click the Rename button.
  3. Type a name for the publishing point, and then click OK.

Note Image Note

  • When naming a publishing point, you should avoid using names that are identical to those of directories or subdirectories on the Windows Media server. A publishing point with the same name as a directory may interfere with another publishing point that sources from that directory.

Related topics

  • Setting up a publishing point


To assign a publishing point as the Default publishing point

  1. To assign or create a new Default publishing point, remove or rename the existing Default publishing point.
  2. In the console tree, click the publishing point that you want to assign as the default.

-or-

Create a new publishing point using the Add Publishing Point Wizard or the advanced method.

  3. On the Action menu, click Rename.
  4. In Publishing Point Name, replace the existing name with a forward slash (/) and then click OK.

    The publishing point will change to display <Default> (Broadcast) or <Default> (On-demand), depending on the type of publishing point you used.

Web administration feature For Windows Media Services Administrator for the Web

  1. To assign or create a new Default publishing point, remove or rename the existing Default publishing point.
  2. In the console tree, click Publishing Points.
  3. Click the publishing point that you want to assign as the default.

-or-

Click the Add button to create a new publishing point.

  4. Click the Rename button.
  5. In Publishing point name, replace the existing name with a forward slash (/), and then click OK.

    The publishing point will change to display <Default>.

Related topics

  • Setting up a publishing point
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To remove a publishing point
  • To rename a publishing point


To archive content

  1. In the console tree, click the broadcast publishing point for which you want to archive content.
  2. Click the Properties tab.
  3. In Category, click Archiving.
  4. If you have not already done so, configure and enable the WMS Archive Data Writer plug-in. For more information, see To configure the WMS Archive Data Writer plug-in.
  5. To start archiving manually, in the details pane, click the Source tab, and then click the Start archiving button.

Note Image Notes

  • The WMS Archive Data Writer plug-in cannot be enabled or disabled while the publishing point is streaming content. If you want to archive your broadcast, you must enable the archiving plug-in before you start your publishing point.
  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are saving files to a location other than C:\WMPub and its subdirectories, make sure that the folder is shared and that the Network Service account has read and write permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to save files to it. For more information about rights and permissions, see Understanding rights.

Related topics

  • Setting up a publishing point
  • Streaming entertainment programming and advertising


Managing connections to a publishing point

This section contains the following topics:

  • To start a broadcast publishing point
  • To stop a broadcast publishing point
  • To deny unicast connections to a publishing point
  • To allow unicast connections to a publishing point
  • To disconnect clients from a publishing point
  • To announce publishing point content

Related topics

  • Controlling unicast connections to a publishing point
  • Work with publishing points


To start a broadcast publishing point

  1. In the console tree, click the broadcast publishing point you want to start.
  2. In the Windows Media Services snap-in, on the Action menu, click Start.

    -or-

    In Windows Media Services Administrator for the Web, click the Start button.

Note Image Notes

  • Broadcast publishing points can be configured to start automatically when the first player requests a connection. For more information about this feature, see To enable the Start publishing point when first client connects property.
  • Manually starting a broadcast publishing point may interfere with the Start publishing point when first client connects property. If you want your broadcast publishing point to start and stop automatically based on client connections, do not manually start the publishing point.

Related topics

  • Controlling unicast connections to a publishing point
  • Managing connections to a publishing point


To stop a broadcast publishing point

  1. In the console tree, click the broadcast publishing point you want to stop.
  2. In the Windows Media Services snap-in, on the Action menu, click Stop.

    -or-

    In Windows Media Services Administrator for the Web, click the Stop button.

Related topics

  • Controlling unicast connections to a publishing point
  • Managing connections to a publishing point


To deny unicast connections to a publishing point

  1. In the console tree, click the publishing point that you want to deny unicast connections to.
  2. In the Windows Media Services snap-in, on the Action menu, click Deny New Connections.

    -or-

    In Windows Media Services Administrator for the Web, click the Deny button.

New requests for unicast streams from the server will be denied.

Note Image Note

  • If you are delivering the content as both unicast and multicast streams from a broadcast publishing point, players will still be able to receive multicast streams from the server. You must stop either the server or the publishing point if you do not want players to receive the multicast stream.

Related topics

  • Controlling unicast connections to a publishing point
  • Managing connections to a publishing point
  • To deny unicast connections to a server


To allow unicast connections to a publishing point

  1. In the console tree, click the publishing point that you want to allow unicast connections to.
  2. In the Windows Media Services snap-in, on the Action menu, click Allow New Connections.

    -or-

    In Windows Media Services Administrator for the Web, click the Allow button.

Note Image Note

  • New requests for a unicast stream from the publishing point will be allowed as long as the server is also allowing unicast connections.

Related topics

  • Controlling unicast connections to a publishing point
  • Managing connections to a publishing point
  • To allow unicast connections to a server


To disconnect clients from a publishing point

  1. In the console tree, click the publishing point from which you want to disconnect clients.
  2. In the details pane, on the Monitor tab, click the Disconnect All button.

Related topics

  • Controlling unicast connections to a publishing point
  • Managing connections to a publishing point


To announce publishing point content

  1. In the console tree, select the publishing point that contains the content you want to announce.
  2. In the details pane, click the Announce tab.
  3. Click Unicast Announcement Wizard, and then follow the steps in the wizard.

Note Image Notes

  • This procedure only applies to the Windows Media Services snap-in.
  • For a broadcast publishing point, you can announce your content by clicking either Unicast Announcement Wizard (for a unicast stream) or Multicast Announcement Wizard (for a multicast stream) and then following the steps in the wizard.
  • If you change the list of stream formats after the creation of the multicast information file, the existing file is invalid. You must run the announcement wizard again to update the file. You are not required to create a new announcement.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Managing connections to a publishing point
  • Announcing content
  • Working with the Multicast Announcement Wizard
  • Working with the Unicast Announcement Wizard


Testing a stream

This section contains the following topics:

  • To test a stream using the Stream Test utility
  • To test a stream using Windows Media Player
  • To test a stream pulled from an encoder


To test a stream using the Stream Test utility

  1. In the console tree, click the publishing point that is associated with the stream you want to test.
  2. In the details pane, click the Source tab, and then click the Test stream button.

    The Stream Test utility opens, and the publishing point starts if it has not already started.

  3. In Client and protocol, verify that the URL of the content is correct.
  4. Verify that Windows Media Player starts and the content stream starts playing.
  5. Using the Player controls, test the control functionality of the content stream. Broadcast streams can make use of the Start and Stop commands. On-demand streams can make use of the Start, Stop, and Pause commands, as well as the Seek bar.
  6. Test all of the available streaming protocols. The Test Stream utility typically opens unicast streams using the MMS protocol. In Client and protocol, click a different protocol, and then click the OK button. The HTTP protocol will not be active unless the WMS HTTP Server Control Protocol plug-in is enabled. For more information about protocols, see Protocol overview.
  7. Allow the stream to play for a representative period of time and check the stream statistics for excessive numbers of skipped frames and lost packets.
  8. Click Exit to close the Test Stream utility.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in.

Related topics

  • Testing a stream
  • Work with publishing points


To test a stream using Windows Media Player

  1. In the console tree, click the publishing point that hosts the stream you want to test.
  2. In the details pane, click the Announce tab, and then, in Unicast streams, make note of the value in URL that clients may use to your content.
  3. Start Windows Media Player on a computer that should have access to the stream, and enter the URL that you noted in the previous step.
  4. Using the Player controls, test the control functionality of the content stream. Broadcast streams can make use of the Start and Stop commands. On-demand streams can make use of the Start, Stop, and Pause commands, as well as the Seek bar.
  5. Test all of the available streaming protocols. A unicast stream will attempt to connect using the MMS protocol, but will switch to the RTSP protocol if network conditions or the Player version requires it. The HTTP protocol will not be active unless the WMS HTTP Server Control Protocol plug-in is enabled. For more information about protocols, see Protocol overview.
  6. Allow the stream to play for a representative period of time and check that the stream quality is sufficient for the type of content and the capabilities of the equipment.

Note Image Notes

  • This procedure only applies to the Windows Media Services snap-in.
  • A true test of stream availability requires a Windows Media Player session on a computer under the most adverse connection circumstances. For instance, if some members of your expected audience will access the stream from a dial-up connection outside a network firewall, your testing scenario should include that condition.
  • If you are streaming by using a multicast transmission, use the Multicast Announcement Wizard to create a Web page that your test computers can connect to and test the stream.

Related topics

  • Testing a stream


To test a stream pulled from an encoder

  1. After the encoder has started an encoding session, obtain the connection URL of the encoder. The URL uses the following syntax: connection_protocol://computer_name:port (for example, http://encoder1:8080). This is the URL that you will use to connect the Windows Media server to the encoder.
  2. Start Windows Media Player on the computer running Windows Media Services, and then enter the URL that you noted in the previous step.
  3. Check that the encoded content is reproduced accurately in the Player. Poor reproduction quality could indicate network problems or an improper encoder setting.

Related topics

  • Testing a stream


Configuring publishing point properties

This section contains the following topics:

  • To enable the Start publishing point when first client connects property
  • To configure the Enable forward error correction property
  • To configure the Cache expiration property
  • To configure the Specify distribution credentials property
  • To configure the Enable buffering property

Related topics

  • Work with publishing points


To enable the Start publishing point when first client connects property

  1. In the console tree, click the broadcast publishing point for which you want to enable the Start publishing point when first client connects property.
  2. In the details pane, click the Properties tab.
  3. In Category, click General.
  4. In Property, click Start publishing point when first client connects, and then click Enable.

Related topics

  • Configuring publishing point properties
  • Start publishing point when first client connects


To configure the Enable forward error correction property

  1. In the console tree, click the publishing point for which you want to configure the Enable forward error correction property.
  2. In the details pane, click the Properties tab.
  3. In Category, click Wireless.
  4. In Property, click Enable forward error correction, and then click the Properties button.

    The Forward Error Correction Properties dialog box appears.

  5. To adjust the number of redundant data packets sent with each piece of content, in FEC packets per span, enter a value from 0 to 24. A value of 0 disables Forward Error Correction.
  6. In the details pane, click Enable.

Note Image Note

  • Forward error correction is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Configuring publishing point properties
  • Forward Error Correction - general properties
  • Understanding Fast Recovery


To configure the Cache expiration property

  1. In the console tree, click the publishing point for which you want to configure the Cache expiration property.
  2. In the details pane, click the Properties tab.
  3. In Category, click Cache/Proxy.
  4. In Property, click Cache expiration, and then click the Properties button.

    The Cache Expiration Properties dialog box appears.

  5. Do one of the following:
    To | Do this
    Renew the content from the origin server after a specified number of seconds has passed | Click After (seconds), and then enter a value.
    Renew the content from the origin server each time a client requests the content from the cache/proxy server | Click Immediately.
    Never renew the content from the origin server | Click Never.
  6. In the details pane, click Enable.

Related topics

  • Configuring publishing point properties


To configure the Specify distribution credentials property

  1. In the console tree, click the publishing point for which you want to configure the Specify distribution credentials property.
  2. In the details pane, click the Properties tab.
  3. In Category, click Credentials.
  4. In Property, click Specify distribution credentials, and then click the Properties button.

    The Credentials Properties dialog box appears.

  5. In User Name, type the user name that you want this server to use on the network.
  6. In Password, type the password that will authenticate the server on the network.
  7. In Confirm Password, type the password again to be sure that you have specified it correctly.
  8. In the details pane, click Enable.

Related topics

  • Configuring publishing point properties


To configure the Enable buffering property

  1. In the console tree, click the publishing point for which you want to configure the Enable buffering property.
  2. In the details pane, click the Properties tab.
  3. In Category, click Networking.
  4. In Property, click Enable buffering, and then click the Properties button.

    The Enable buffering Properties dialog box appears.

  5. Do one of the following:
    To | Do this
    Reduce client startup latency by buffering data in the server cache before streaming it to clients | Click Buffer content.
    Keep the content stream closely synchronized with the client connections. | Click Disable buffering.
  6. In the details pane, click Enable.

Related topics

  • Configuring publishing point properties


Set up content to stream

This section contains the following topics:

  • Creating and editing offline playlists
  • Editing online playlists
  • Setting up files to stream
  • Setting up a broadcast

Related topics

  • How to…
  • Sourcing from playlists, files, and encoders
  • Understanding publishing points


Creating and editing offline playlists

This section contains the following topics:

  • To create a playlist using the Windows Media Playlist Editor
  • To open an existing playlist from the Source tab
  • To start the Create Wrapper Wizard
  • To create a wrapper playlist by using the Windows Media Playlist Editor
  • To open an existing wrapper playlist
  • To add a media element to a playlist
  • To add an advertisement to a playlist
  • To add a container to a playlist
  • To add a clientData element to a playlist
  • To delete an element from a playlist
  • To change the value of an offline playlist attribute
  • To use a wrapper playlist with a publishing point
  • To stop using a wrapper playlist with a publishing point

Related topics

  • Editing online playlists
  • Playlist reference
  • Set up content to stream
  • Understanding playlists


To create a playlist using the Windows Media Playlist Editor

  1. Start the Windows Media Playlist Editor.

    The Windows Media Playlist Editor dialog box appears.

  2. On the toolbar, click the Add element button to add a media element to the playlist.

The Add Media Elements dialog box appears.

  3. Specify the name and location of the content you want to add to the playlist. Repeat this step until you have added all of the content to your playlist.
  4. On the toolbar, click the Save playlist button, and then specify the name and location of the playlist file. The playlist file must use a .wsx file name extension.

Note Image Notes

  • The Windows Media Playlist Editor can be started from the Windows Media Services snap-in by clicking the View playlist editor button on the Getting Started tab of the server, the Summary Tab of the Publishing Points item, or the Source tab of a specific publishing point.
  • The Windows Media Playlist Editor can also be started as a stand-alone program by double-clicking the Wmseditor.exe file, which can be found in the folder in which you installed the Windows Media Services snap-in. By default, this is %systemroot%\System32\Windows Media\Server\Admin\MMC.
  • After you have created your playlist, it may be used by any publishing point. To use your playlist with a publishing point, click the Change button on the Source tab of the publishing point.
  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.
  • If you want to save your playlist files on another computer or network drive, you must first grant share permissions to the Windows Media server. The Windows Media server cannot write files to a remote network drive if the server has not been granted permissions. For more information about drive sharing and permissions, see Windows Help and Support.
  • If your playlist includes JPEG image files, do not include any syntax in your playlist that causes the image to pause while being rendered by the player. Pausing a JPEG image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • If your playlist includes JPEG image files and you are using the playlist file with a broadcast publishing point, be aware that users who connect to the broadcast while the JPEG image is being streamed will not receive the image. They will instead see a black screen. Once the playlist continues on to the next item, playback will continue as expected. If you want a JPEG image to be displayed for a certain period of time, you should use the repeatCount attribute to repeat the image for short durations that together equal the amount of time that the image is to be displayed. That way, players that connect while the image is being streamed can receive the image when it repeats. For example, if a JPEG image is to be displayed for 60 seconds, you could set a dur attribute value of five seconds and a repeatCount attribute value of 12. If a user connects two seconds into the broadcast, the image would be displayed after three seconds. If the repeatCount and dur attribute values were not used, the user would see a black screen for 58 seconds.

Related topics

  • Creating and editing offline playlists
  • Playlist reference


To open an existing playlist from the Source tab

  1. On the Source tab of the publishing point, click View playlist editor.

    The Playlist dialog box appears.

  2. Click Open an existing playlist.
  3. In File name, type the path to the playlist file you want to open or click Browse to select the file.
  4. Click OK. The Windows Media Playlist Editor opens the selected playlist.

Note image Notes

  • Existing playlist files can also be opened from the Windows Media Playlist Editor menu by clicking File, and then clicking Open. This opens the Windows Media Browse dialog box in which you can locate the playlist file.
  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.

Related topics

  • Creating and editing offline playlists
  • Playlist reference


To start the Create Wrapper Wizard

  1. In the console tree, click the publishing point to which you want to add a wrapper.
  2. Click the Advertising tab, and then click Wrapper Editor.
  3. Click Create playlist file, and then select the Use the Create Wrapper Wizard check box.
  4. Follow the instructions in the Create Wrapper Wizard to create a wrapper playlist file.

Note Image Note

  • Wrapper playlists can use the same elements and attributes as standard playlists and can be created using the Windows Media Playlist Editor.

Related topics

  • About wrapper playlists
  • Creating and editing offline playlists
  • Playlist reference
  • To create a wrapper playlist by using the Windows Media Playlist Editor


To create a wrapper playlist by using the Windows Media Playlist Editor

  1. In the console tree, click the publishing point to which you want to add a wrapper.
  2. Click the Advertising tab, and then click Wrapper Editor.
  3. Click Create playlist file, and then clear the Use the Create Wrapper Wizard check box.
  4. On the toolbar, click the Add element button to add a media element to the wrapper playlist.

The Add Media Elements dialog box appears.

  5. Specify the name and location of the content you want to add to the wrapper playlist. You can arrange the playback order by dragging elements in the playlist tree.

    The %RequestURL% element is already a part of your playlist. It represents the content that the user requests from the publishing point. Playlist elements placed in front of the %RequestURL% element play before the publishing point content, while items placed after it play after the publishing point content ends.

  6. Repeat steps 4 and 5 until you have added all of the content to your wrapper playlist.
  7. On the toolbar, click Save playlist, and then specify the name and location of the wrapper playlist file. The wrapper playlist file must use a .wsx file name extension.

Note Image Notes

  • You can also create a wrapper playlist by using the Windows Media Playlist Editor on the Source tab. To create a new wrapper playlist in the Playlist Editor, on the File menu, point to New, and then click Wrapper Playlist. The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.
  • If your playlist includes JPEG image files, do not include any syntax in your playlist that causes the image to pause while being rendered by the player. Pausing a JPEG image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.

Related topics

  • About wrapper playlists
  • Creating and editing offline playlists
  • Playlist reference
  • To start the Create Wrapper Wizard


To open an existing wrapper playlist

  1. In the console tree, click the publishing point for which you want to open the wrapper playlist.
  2. Click the Advertising tab, and then click Wrapper Editor.
  3. Click Edit existing playlist file.
  4. In File name, type the path to the wrapper playlist file, or click Browse to locate the wrapper playlist file, and then click OK.

Related topics

  • Creating and editing offline playlists
  • Playlist reference


To add a media element to a playlist

  1. In the Windows Media Playlist Editor, expand the playlist, and then expand the smil element to show the elements in the playlist.
  2. Click the element after which you want to add a media element.

    -or-

    Click the seq, switch, excl, or priorityClass element inside which you want to add a media element.

  3. On the toolbar, click the Add element button.

    The Add Media Elements dialog box appears.

  4. In Location of content, type the path to the media element you want to include in the playlist.

    The Content type examples area displays list of valid content types.

  5. If you want to put this element inside an existing seq, switch, excl, or priorityClass element in the list, select the Add as a child element check box.
  6. To add the selected media element to the playlist, click Add. When you are finished adding media elements to the playlist, click OK.

Note Image Notes

  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.
  • If your playlist includes JPEG image files, do not include any syntax in your playlist that causes the image to pause while being rendered by the player. Pausing a JPEG image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • If your playlist includes JPEG image files and you are using the playlist file with a broadcast publishing point, be aware that users who connect to the broadcast while the JPEG image is being streamed will not receive the image. They will instead see a black screen. Once the playlist continues on to the next item, playback will continue as expected. If you want a JPEG image to be displayed for a certain period of time, you should use the repeatCount attribute to repeat the image for short durations that together equal the amount of time that the image is to be displayed. That way, players that connect while the image is being streamed can receive the image when it repeats. For example, if a JPEG image is to be displayed for 60 seconds, you could set a dur attribute value of five seconds and a repeatCount attribute value of 12. If a user connects two seconds into the broadcast, the image would be displayed after three seconds. If the repeatCount and dur attribute values were not used, the user would see a black screen for 58 seconds.

Related topics

  • Creating and editing offline playlists
  • Playlist reference
  • To change the value of an offline playlist attribute


To add an advertisement to a playlist

  1. In the Windows Media Playlist Editor, expand the playlist, and then expand the smil element to show the elements in the playlist.
  2. Click the element after which you want to add an advertisement.
  3. On the toolbar, click the Add element arrow, and then click Advertisement.

    The Add Advertisement dialog box appears.

  4. Type the location of the advertisement you want to add.
  5. Click OK to add the selected advertisement to the playlist.

Note Image Notes

  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.

Related topics

  • Creating and editing offline playlists
  • Playlist reference


To add a container to a playlist

  1. In the Windows Media Playlist Editor, expand the playlist, and then expand the smil element to show the elements in the playlist.
  2. Click the element after which you want to add a container.
  3. On the toolbar, click the Add element arrow.
  4. Do one of the following:
    Click this | To do this
    Sequence | Add a seq element to the playlist. A seq element is a container for content items, which are played in the order in which they are listed. For more information, see seq element.
    Switch | Add a switch element to the playlist. A switch element provides alternate content in case a user is unable to access the intended content. For more information, see switch element.
    Exclusive | Add an excl element to the playlist. An excl element is a container for content items that are played only if they are triggered by an event or if a begin attribute is specified and its criteria is met. For more information, see excl element.
    priorityClass | Add a priorityClass element to the playlist. A priorityClass element must be an immediate child of an excl element. A priorityClass element enables you to specify what happens when one media element interrupts playback of another. For more information, see priorityClass element.

Note Image Note

  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.

Related topics

  • Creating and editing offline playlists
  • Playlist reference
  • To change the value of an offline playlist attribute


To add a clientData element to a playlist

  1. In the Windows Media Playlist Editor, expand the playlist, and then expand the smil element to show the elements in the playlist.
  2. Click the element after which you want to add a clientData element.
  3. On the toolbar, click the Add element arrow.
  4. Click ClientData.

    A clientData element is added to the playlist.

  5. Click the new clientData element. If the clientData element was added after a media element, you may have to expand the media element.

Note Image Notes

  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.
  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.

Related topics

  • clientData element
  • Creating and editing offline playlists
  • Playlist reference
  • To change the value of an offline playlist attribute


To delete an element from a playlist

  1. In the Windows Media Playlist Editor, expand the playlist, and then expand the smil element to show the elements in the playlist.
  2. Click the element you want to delete.
  3. On the toolbar, click Remove element.

Note Image Note

  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.

Related topics

  • Creating and editing offline playlists
  • Playlist reference


To change the value of an offline playlist attribute

  1. In the Windows Media Playlist Editor, on the File menu, click Open.
  2. In File name, type the name of the playlist file that you want to modify or locate the file in the file list. Click Select File.
  3. In the playlist tree, expand the playlist, and then expand the smil element to show the elements in the playlist.
  4. Click the element you want to modify.

    The available attributes and their associated values are visible in the properties attributes list.

  5. To change the value of an attribute, click the attribute.

    A text box appears in Value.

  6. In the text box, type the value you want for the attribute, and then press ENTER.
  7. To save the changes made to your playlist, click the Save playlist button.

Note Image Note

  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.

Related topics

  • Creating and editing offline playlists
  • Playlist attributes
  • Playlist reference


To use a wrapper playlist with a publishing point

  1. In the console tree, click the publishing point to which you want to add a wrapper playlist.
  2. In the details pane, click the Advertising tab, and then click Change.
  3. In Location, type the path to the wrapper playlist file, or click Browse to locate the file.
  4. Click OK.
  5. Select the Use a wrapper with this publishing point check box.

    The wrapper playlist is applied to the publishing point

Note Image Notes

  • You can use a single wrapper playlist file on multiple publishing points.
  • File system browsing is only available in the Windows Media Services snap-in.

Related topics

  • About wrapper playlists
  • Creating and editing offline playlists
  • Playlist reference


To stop using a wrapper playlist with a publishing point

  1. In the console tree, click the publishing point on which you want to stop using a wrapper playlist.
  2. In the details pane, click the Advertising tab.
  3. Clear the Use a wrapper with this publishing point check box.

    The wrapper playlist is no longer applied to the publishing point.

Related topics

  • About wrapper playlists
  • Creating and editing offline playlists
  • Playlist reference


Editing online playlists

This section contains the following topics:

  • To edit an online on-demand playlist
  • To edit an online broadcast playlist
  • To change the value of an online playlist element

Related topics

  • Creating and editing offline playlists
  • Playlist reference
  • Understanding playlists


To edit an online on-demand playlist

  1. In the console tree, click the on-demand publishing point associated with the playlist you want to edit.
  2. In the details pane, click the Source tab.

    The path and file name in Location correspond to the playlist that is currently online.

  3. In the playlist tree, expand the playlist, and then expand the smil element to show the elements in the playlist.
  4. Click the element you want to modify.
  5. Use the toolbar above the playlist to perform any of the following steps:
    • To add a container, click the Add Element arrow, and then do one of the following:
    Click this | To do this
    Sequence | Add a seq element to the playlist. A seq element is a container for content items, which are played in the order in which they are listed. For more information, see seq element.
    Switch | Add a switch element to the playlist. A switch element provides alternate content in case a user is unable to access the intended content. For more information, see switch element.
    Exclusive | Add an excl element to the playlist. An excl element is a container for content items that are played only if they are triggered by an event or if a begin attribute is specified and its criteria is met. For more information, see excl element.
    priorityClass | Add a priorityClass element to the playlist. A priorityClass element must be an immediate child of an excl element. A priorityClass element enables you to specify what happens when one media element interrupts playback of another. For more information, see priorityClass element.

    • To delete an element, click the Remove element button.
  6. If you have enabled the WMS Playlist Transform plug-in, you can change the way the playlist is streamed by clicking the following toolbar buttons:
    • To have the playlist repeat its content until the publishing point is stopped, click the Loop button.
    • To have the playlist stream its content in random order, click the Shuffle button.

Note Image Notes

  • The Windows Media Playlist Editor is only available in the Windows Media Services snap-in.
  • To move an element up or down in the playlist, click the element you want to move, and then drag it to a new location.
  • Windows Media Services server-side playlists are Extensible Markup Language (XML) documents that are compliant with the Synchronized Multimedia Integration Language (SMIL) 2.0 language specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.

Related topics

  • Editing online playlists
  • Playlist reference
  • Understanding playlists


To edit an online broadcast playlist

  1. In the console tree, click the broadcast publishing point associated with the playlist that you want to edit.
  2. In the details pane, click the Source tab.

    The path and file name in Location correspond to the playlist that is currently online.

  3. In the playlist tree, expand the playlist, and then expand the smil element to show the elements in the playlist.
  4. Click the element you want to modify.
  5. Use the toolbar above the list to perform any of the following steps:
    • To add a container, click the Add Element arrow, and then do one of the following:
    Click this | To do this
    Sequence | Add a seq element to the playlist. A seq element is a container for content items, which are played in the order in which they are listed. For more information, see seq element.
    Switch | Add a switch element to the playlist. A switch element provides alternate content in case a user is unable to access the intended content. For more information, see switch element.
    Exclusive | Add an excl element to the playlist. An excl element is a container for content items that are played only if they are triggered by an event or if a begin attribute is specified and its criteria is met. For more information, see excl element.
    priorityClass | Add a priorityClass element to the playlist. A priorityClass element must be an immediate child of an excl element. A priorityClass element enables you to specify what happens when one media element interrupts playback of another. For more information, see priorityClass element.

    • To delete an element, click the Remove element button.
  6. While the playlist is running, you can do one of the following:
    • To reduce the latency between the element that is currently playing and an upcoming element, click the upcoming element, and then click Cue element. The first few seconds of the upcoming element are saved in a buffer on the server.
    • To have the playlist stop playing the current element and start playing another element in the list, click the next element, and then click Jump to element.
  7. If the publishing point is stopped and you have enabled the WMS Playlist Transform plug-in, you can change the way the playlist is streamed by using the following toolbar buttons:
    • To have the playlist repeat its content until the publishing point is stopped, click the Loop button.
    • To have the playlist stream its content in random order, click the Shuffle button.
  8. To save your changes to the playlist, click the Save button on the toolbar.

Note Image Notes

  • Online playlist editing is only available in the Windows Media Services snap-in.
  • To move an element up or down in the playlist, click the element you want to move and then drag it to a new location.
  • Windows Media Services server-side playlists are Extensible Markup Language (XML) documents that are compliant with the Synchronized Multimedia Integration Language (SMIL) 2.0 language specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.

Related topics

  • Editing online playlists
  • Playlist reference
  • Understanding playlists


To change the value of an online playlist element

  1. In the console tree, click the publishing point associated with the playlist you want to edit.
  2. Click the Source tab.

    The path and file name in Location correspond to the playlist that is currently online.

  3. In the playlist tree, expand the playlist, and then expand the smil element to show the elements in the playlist.
  4. Click the element you want to modify.
  5. To change the value of an attribute, click the name of the attribute, and then type a new value.
  6. To save your changes to the playlist, click the Save playlist button.

Note Image Notes

  • Online playlist editing is only available in the Windows Media Services snap-in.
  • More information about playlist elements and attributes is available in the Playlist reference and in the Windows Media Services Software Development Kit (SDK).
  • Windows Media Services server-side playlists are Extensible Markup Language (XML) documents that are compliant with the Synchronized Multimedia Integration Language (SMIL) 2.0 language specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • Items that are cued or currently playing cannot be edited.

Related topics

  • Editing online playlists
  • Playlist reference
  • Understanding playlists


Setting up files to stream

This section contains the following topics:

  • To stream a Windows Media file from an on-demand publishing point
  • To stream a directory of files


To stream a Windows Media file from an on-demand publishing point

  1. In the console tree, click the on-demand publishing point from which you want to stream content.
  2. In the details pane, click the Source tab.
  3. In the Content Source area, be sure the Location path is the same as the location of the Windows Media file you want to stream.

    If it is not, click Change and type the path to the content, or click Browse to locate the file.

Note Image Notes

  • If you choose, you can move the Windows Media file to the directory specified in the Location path instead.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.

Related topics

  • Reference for content sources
  • Setting up files to stream
  • Sourcing from files
  • Testing a stream


To stream a directory of files

  1. In the console tree, click the on-demand or broadcast publishing point from which you want to stream files.
  2. In the details pane, click the Source tab.
  3. In the Content Source area, be sure the Location path is the same as the location of the Windows Media file you want to stream.

    If it is not, click Change and type the path to the content, or click Browse to locate the file.

    If you choose, you can move the Windows Media file to the directory specified in the Location path instead.

  4. If you are streaming from an on-demand publishing point, click the Properties tab, and click the General category. Click the Enable access to directory content using wildcards property, and then click the Enable button.
  5. To provide a shortcut to your content, click the Announce tab, click the Run Unicast Announcement Wizard button, and then follow the steps in the Unicast Announcement Wizard to create an announcement.

Note Image Notes

  • The Enable access to directory content using wildcards property enables you to use wildcard characters in the URL to the publishing point. For example, a Web page could link to all the video files in a specified directory by referencing the URL mms://server_name/publishing_point_name/*.wmv, or to all the audio files in the directory by using the URL mms://server_name/publishing_point_name/*.wma.
  • If you are using a broadcast publishing point, you can use a wrapper playlist to provide an introduction to the content. For more information, see About wrapper playlists.
  • Content streamed by Windows Media Services must meet the minimum supported content length of the player to ensure reliable playback. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.

Related topics

  • Reference for content sources
  • Setting up files to stream
  • Sourcing from a directory
  • Testing a stream


Setting up a broadcast

This section contains the following topics:

  • To broadcast a stream pulled from an encoder
  • To broadcast content pushed from an encoder
  • To use a multicast stream as a content source
  • To enable content rollover in case of encoder failure
  • To rebroadcast archived content
  • To configure a multicast stream from a broadcast publishing point
  • To simulate a wrapper for a multicast publishing point
  • To embed the Player control in a Web page


To broadcast a stream pulled from an encoder

  1. Start the encoder and note the URL from which the encoder is streaming.
  2. In the console tree, click the broadcast publishing point that you want to use to pull content from the encoder.
  3. In the details pane, click the Source tab, and then click the Change button.

The Change <publishing point> content source dialog box appears.

  4. In Location, type the encoder URL.
  5. Click the Start button.

Related topics

  • Setting up a broadcast
  • Testing a stream
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • Understanding publishing points


To broadcast content pushed from an encoder

  1. Start the encoder, and then configure it to broadcast the encoded stream to your Windows Media server. During the encoder session configuration wizard, the following information is required:
    • The name of the Windows Media server. This can be an alias, a fully qualified domain name, or an IP address.
    • The name of the publishing point. This is the name of the publishing point on your server through which the encoded stream will be broadcast. This publishing point can already exist on the Windows Media server or it can be created by the encoder during the configuration process
    • Whether to remove the publishing point when the broadcast has ended. This prevents older publishing points that are no longer needed from accumulating on your Windows Media server.
  2. On the Windows Media server, in the console tree, click the server that you want to use for this stream.
  3. In the details pane, click the Properties tab.
  4. In Category, click Control protocol.
  5. Enable the WMS HTTP Server Control Protocol plug-in. The encoder must use the HTTP protocol to send the encoded stream to the server.

Note Image Notes

  • To push content from an encoder to Windows Media Services, you must use Windows Media Encoder or an encoder based on the Windows Media Encoder SDK.
  • A publishing point that is streaming content pushed from an encoder can be managed from the Windows Media Services snap-in or Windows Media Services Administrator for the Web. The same properties and plug-ins can be configured from either interface, including authentication and authorization properties, limits, and announcements.
  • When the WMS Publishing Points ACL Authorization plug-in is enabled, you must grant certain permissions at the server level and publishing point level for the encoder administrator to be able to create a new publishing point on your server. You must configure the plug-in to grant the user or group both write and create permissions. For more information about the WMS Publishing Points ACL Authorization plug-in and server and publishing point permissions, see WMS Publishing Points ACL Authorization - general properties.
  • For information about setting up the encoder, see Windows Media Encoder Help.

Related topics

  • Setting up a broadcast
  • Testing a stream
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • Understanding publishing points


To use a multicast stream as a content source

  1. In the console tree, click the broadcast publishing point you want to use to broadcast the multicast stream.
  2. In the details pane, click the Source tab.
  3. Click the Change button.

    The Change <publishing point> content source dialog box appears.

  4. In Location, type the directory path to the multicast information file (which has a .nsc file name extension). Windows Media Services can access an .nsc file that is stored on a local drive or on a network shared drive. The path should be in the following format:

    MCast://%systemdrive%\Wmpub\Wmroot\File.nsc

    -or-

    MCast://\\MachineName\Inetpub\Wwwroot\File.nsc

Note Image Notes

  • Using a multicast stream as a content source in a playlist is only available in the Windows Media Services snap-in.
  • You can include a multicast stream as a content source in a server-side playlist by specifying the URL to the multicast information file as a src attribute of a media element. To do this, the playlist that references the multicast stream must already be assigned to a broadcast publishing point. Then, using the playlist editing control on the Source tab in the Windows Media Services snap-in, add a media element for the multicast stream. You cannot add a multicast stream to a playlist using the Playlist Editor. When adding the URL to the multicast information file, you must specify an absolute path, such as MCast://C:\Wmpub\Wmroot\File.nsc or MCast://\\MachineName\Inetpub\Wwwroot\File.nsc.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Setting up a broadcast


To enable content rollover in case of encoder failure

  1. In the Windows Media Playlist Editor, expand the playlist, and then expand the smil element to show the elements in the playlist.
  2. On the toolbar, click the Add element button.

    The Add Media Elements dialog box appears.

  3. In Location of content, specify the URL of the encoder that will be the primary source of content for the broadcast.
  4. Repeat steps 2 and 3 to specify the location of the alternate content source for the broadcast. This content will be streamed when the encoder session ends or if there is an interruption in the encoder stream. The alternate content source can be another encoder, an advertisement, a remote publishing point, a playlist, or a digital media file or files.
  5. You can change the value of the repeatCount attribute of the smil element to Indefinite if you want the server to switch back to the original encoder in the case of secondary content source failure. For more information about changing attribute settings, see To change the value of an offline playlist attribute.
  6. Name and save the new playlist.
  7. In the console tree, click the broadcast publishing point for which you want to enable content rollover.
  8. In the details pane, click the Source tab.
  9. In Content source, click Change.

    Change <publishing point> content source on <server> appears.

  10. In Location, type the name and location of the playlist you created in the first five steps.

Note Image Note

  • By using redundant encoders and a rollover playlist, you can greatly improve the reliability of your broadcast stream. You can further increase reliability by using load balancing techniques.

Related topics

  • Performing load balancing and clustering
  • Setting up a broadcast
  • To create a playlist using the Windows Media Playlist Editor


To rebroadcast archived content

  1. In the console tree, click the broadcast publishing point you want to use to rebroadcast archived content.
  2. In the details pane, click the Source tab.
  3. In the Content source section, click Change to locate the archive file of your broadcast.
  4. To announce the publication of your content, click the Announce tab, and then click Unicast Announce Wizard.

Note Image Note

  • Archive files can be created by either Windows Media Encoder, an encoder based on the Windows Media Encoder SDK, or Windows Media Services. If the archive file was created by Windows Media Services, you can determine the archive file name from the archive data writer plug-in associated with the original broadcast publishing point.

Related topics

  • Archive wildcard characters reference
  • Archiving content
  • Setting up a broadcast


To configure a multicast stream from a broadcast publishing point

  1. In the console tree, click the broadcast publishing point from which you want to multicast content. If the publishing point is started, click Stop.
  2. In the details pane, click the Properties tab.
  3. In Category, click Multicast streaming.
  4. In Plug-in, click WMS Multicast Data Writer, and then click the Properties button.

    The WMS Multicast Data Writer Properties dialog box appears.

  5. In Destination multicast IP address and port, specify the parameters for the multicast distribution by using the following settings:
    • IP address. Type the multicast IP address.
    • Port. Type the port on the Windows Media server through which the multicast will be streamed.
    • Time-to-live (TTL). Enter the number of routers that your multicast can pass through (sometimes referred to as the number of "hops") before expiring on the network.
  6. Select the Enable unicast rollover check box to allow clients to connect to a server to receive the content, and then do one of the following:
    • To allow this publishing point to stream its content by using the Unicast Data Writer plug-in, click Use this publishing point.
    • To redirect unicast client connection requests to an alternate publishing point, click Use other publishing point, and then type the URL of the publishing point; for example, rtsp://unicast_server/publishing_point.
  7. Click the Advanced tab. If you have multiple network interface cards on your server, in IP address of the network interface card to multicast from, click the appropriate card.
  8. In Logging URL, type the URL to the Internet Server Application Programming Interface (ISAPI) directory; for example, http://server_name/scripts/wmsiislog.dll, where server_name is the name of the Internet Information Services (IIS) computer.
  9. Click OK to apply your configuration to the plug-in, and then click the Enable button to use the plug-in on the publishing point.
  10. To create a multicast announcement, click the Announce tab, and then click Run Multicast Announcement Wizard.
  11. To start your publishing point, in the console tree, click the publishing point. In the details pane, click the Monitor tab, and then click Start.

Note Image Notes

  • If you selected the Enable unicast rollover check box, verify that the publishing point you are rolling over to is set to Allow New Connections.
  • If you specified a logging URL, you are not required to have the wmsiislog.dll file on the same computer as the Windows Media server; however, wmsiislog.dll must be installed in a directory that can be accessed from the Web
  • Clients must use an announcement to connect to a multicast stream. If clients use a URL, they are connecting by using unicast.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About publishing point types
  • Controlling unicast connections to a publishing point
  • Announcing content
  • Setting up a broadcast
  • Testing a stream
  • To allow unicast connections to a publishing point


To simulate a wrapper for a multicast publishing point

  1. Select the broadcast publishing point that you want to use for the multicast.
  2. If you have not already done so, run the Multicast Announcement Wizard to create an announcement file (with an .asx file name extension) for the publishing point. Note the location of the announcement file.
  3. Identify the URL of the content you want users to receive before connecting to the multicast. The location of the wrapper content is determined by the type of content you are using:
    • If you want the wrapper content to be streamed from a Windows Media server, it must be associated with an on-demand publishing point.
    • If you want the wrapper content to be downloaded from a Web server, it must be associated with an appropriate Web folder.
  4. Using a text editor, such as Microsoft Notepad, open the .asx file associated with the broadcast publishing point mentioned in step 2.
  5. Do the following:
    • Find the first entry in the announcement file:
      <asx version = "3.0">
    • After this line, type the following:
        <entry>
    <ref href = "protocol://servername/filename"/>
  </entry>

      Replace protocol with an appropriate protocol type—either mms if the content is on a Windows Media server or http if the content is on a Web server.

      Replace servername with the DNS name or IP address of the server that contains the content.

      Replace filename with the name of the content that you want to stream to users prior to the multicast content.

    The multicast content requested by the user will continue streaming while the on-demand wrapper content plays. Consider keeping the length of the wrapper content short so that the user misses as little of the requested content as possible.

  6. Save your changes to the announcement file.

    Users that connect to your multicast will receive the content specified in step 5 before being connected to the multicast content.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About publishing point types
  • Announcing content
  • Setting up a broadcast


To embed the Player control in a Web page

  1. In the console tree, select the publishing point that contains the content you want to stream in an embedded Windows Media Player ActiveX control.
  2. In the details pane, click the Announce tab.
  3. Click Run Unicast Announcement Wizard if your content is being streamed using unicast transmission. Click Run Multicast Announcement Wizard if your content is being streamed using multicast transmission.
  4. For a unicast stream, follow the steps in the Unicast Announcement Wizard, making sure to select the following options:
    • On the Save Announcement Options page, select the Create a Web page (.htm) with embedded player and a link to the content check box and then specify a file name and location for the HTML file created by the wizard.

      -or-

      Select the Copy the syntax for embedding a player in a Web page to the clipboard check box to be able to program the commands directly into your Web page source code.

  5. For a multicast stream, follow the steps in the Multicast Announcement Wizard, making sure to select the following options:
    • On the File Options page, select the Automatically create a Web page check box.
    • On the Save Multicast Information File page, in Web page (.htm) with embedded player, specify a file name and location for the HTML file created by the wizard.
  6. Modify the Web pages created by the announcement wizard to suit your Web site. Provide a link to your site so that your clients can view it.

Related topics

  • Setting up a broadcast
  • Embedding the Player in a Web page


Monitor and set limits

This section contains the following topics:

  • To monitor performance for a server or publishing point
  • To reset peaks for a server or publishing point
  • To register Windows Media Services SNMP objects for SNMP monitoring
  • To set limits for a server or publishing point

Related topics

  • About the Windows Media SNMP objects
  • How to…
  • Monitoring performance
  • Setting publishing point limits
  • Setting server limits


To monitor performance for a server or publishing point

  1. In the console tree, click the server or publishing point you want to view the statistics for.
  2. In the details pane, click the Monitor tab.

    The Monitor tab displays statistics about a server or publishing point, including the total number of connected players, the total bandwidth usage, and the total CPU usage.

Related topics

  • Monitor and set limits
  • Monitoring performance


To reset peaks for a server or publishing point

  1. In the console tree, click the server or publishing point for which you want to reset peaks.
  2. In the details pane, click the Monitor tab.
  3. Click Reset.

    The peaks are reset to zero.

Related topics

  • Monitor and set limits
  • Monitoring performance


To register Windows Media Services SNMP objects for SNMP monitoring

  1. On the taskbar, click Start, and then click Run.
  2. Type the following in the Run dialog box:
    regsvr32 "%systemroot%\system32\windows media\server\wmssnmp.dll"

    A message box displays once the DLL registration has completed.

  3. Click OK to close the message box.

Note Image Notes

  • After registering Wmssnmp.dll, you should configure your server to use Internet Protocol security (IPSec) for Simple Network Management Protocol (SNMP) data transfers. SNMP transfers data in clear text, which means that the data could be intercepted and decoded by network analyzers. IPSec encrypts data and communications between the SNMP agent and management stations, so the information is safer from interception.
  • For more information on creating IP Security policies, see Windows Help and Support.

Related topics

  • About the Windows Media SNMP objects


To set limits for a server or publishing point

  1. In the console tree, click the server or publishing point for which you want to set limits.
  2. In the details pane, click the Properties tab.
  3. In Category, click Limits.
  4. Select the check box for the limit you want to set.

A text box appears to the right of the check box.

  5. Type a value for the limit in the text box.
  6. Repeat steps 3 and 4 for each limit you want to set.
  7. To restore the default value for any limit, clear the check box.

Note Image Note

  • If limits set for a publishing point exceed the limits set for a server, the server limits override the publishing point limits.

Related topics

  • Setting publishing point limits
  • Setting server limits
  • Monitor and set limits


Log data about clients

This section contains the following topics:

  • To configure and enable unicast logging
  • To install the Multicast and Advertisement Logging Agent
  • To configure and enable multicast logging
  • To configure the WMS WMI Event Handler properties
  • To configure the WMS Active Script Event Handler properties

Related topics

  • How to…
  • Logging data and events


To configure and enable unicast logging

  1. In the console tree, click the server or publishing point that you want to log data to.
  2. In the details pane, click the Properties tab.
  3. In Category, click Logging.
  4. In the Windows Media Services snap-in, click WMS Client Logging, and then click Properties.

    -or-

    In Windows Media Services Administrator for the Web, click WMS Client Logging. WMS Client Logging Properties appears.

  5. In both interfaces, you can configure the following settings in WMS Client Logging Properties. In the Windows Media Services snap-in, you must change tabs to see different settings; in Windows Media Administrator for the Web, all of the settings are listed on a single page:
    • In Directory, enter the path and name for the log file. If you used wildcard characters or system variables to create a name template, you can click Expand to view the expanded path and name. For more information on wildcard characters, see Wildcard characters reference.
    • To change how often a new log file is created:

      In the Windows Media Services snap-in, in Log cycle period, click Modify, and then click the cycle period you want to use.

      -or-

      In Windows Media Services Administrator for the Web, in Log cycle period, click the cycle period you want to use.

  6. In the Windows Media Services snap-in, you must click the Advanced tab to modify the following settings:
    • Time format. Click the time format you want to use for recording entries. The default is Use Coordinated Universal Time (UTC).
    • Buffer. To write entries to a log file immediately, click Write log entries to file immediately. By default, log file entries are buffered before they are written to the log file. This improves performance.
    • File format. Click the output format you want for the log file. The default is Use Unicode characters (UTF-8).
    • Log format. Click the type of log file you want the logging plug-in to create. The default is Windows Media Services Format. Click Legacy if you have custom log analysis tools that are based on the log format from the previous version of Windows Media Services.
  7. In the Windows Media Services snap-in, you must click the Log Entries tab to modify the following settings:
    • Log entries. Select the check boxes for the types of clients you want to log data about.
    • Filter options. Select the check boxes for the types of events you want to record in your log file.
  8. Click OK to close WMS Client Logging Properties.
  9. In the details pane, click the Enable button.

    Logging is now enabled on the server or publishing point.

Note Image Notes

  • Windows Media Services does not include a logging plug-in that works with encoder push scenarios. You can log encoder push broadcast data by creating an active script logging plug-in. For more information about creating a custom plug-in, see the Windows Media Services Software Development Kit (SDK), which can be downloaded from the Windows Media home page at the Microsoft Web site.
  • If you want to save log files on another computer or network drive, you must first grant read, write, and create permissions to the Web server account. The Multicast and Advertisement Logging agent cannot write files to a remote network drive if the Web server has not been granted permissions. For more information about Web server permissions, see Internet Information Services Help.
  • For more information on log cycle periods, see WMS Client Logging - general properties.

Related topics

  • Log data about clients
  • Logging data and events


To install the Multicast and Advertisement Logging Agent

  1. In Add or Remove Programs, click Add/Remove Windows Components.
  2. In the Windows Components Wizard, select Windows Media Services and then click Details.
  3. Select the Multicast and Advertisement Logging Agent check box and then click OK.

    The Wmsiislog.dll file is placed in the %systemdrive%\WMPub\WMIISlog directory, and the default multicast logging properties are set in the registry.

  4. In Internet Information Services (IIS), create a virtual directory that references the %systemdrive%\WMPub\WMIISlog directory and then assign it read, run, and execute permissions. For more information about configuring IIS to use application extension, see IIS Help.

    You may now use the URL to the Wmsiislog.dll as the URL for any field that can use a logURL attribute, such as an announcement file, the Multicast Data Writer plug-in, a multicast information file, or clientData elements in a server-side playlist file. The logURL is specified as http://web_server_name/virtual_directory/wmsiislog.dll.

Note Image Notes

  • The Multicast and Advertisement Logging Agent is dependent on Internet Information Services (IIS) version 6.0. If IIS version 6.0 is not installed on your server, selecting this component will also install IIS 6.0. However, removing this component does not remove IIS from your server. For more information about Internet Information Services, see IIS Help.
  • It is recommended that you do not install the Multicast and Advertisement Logging Agent on the same computer that is running Windows Media Services. The Multicast and Advertisement Logging Agent uses Internet Information Services (IIS) to receive log files. By default, both Windows Media Services and IIS will attempt to bind to port 80, which causes a port conflict. If Windows Media Services and IIS are installed on the same computer, be sure each service has been allocated a unique HTTP port.
  • If you change the default logging directory, you must grant the Multicast and Advertisement Logging Agent permissions to write to that directory. For the statistics to be successfully written to the log file, grant read and write permissions to the Network Service account and IWAM_HOSTNAME.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Log data about clients
  • Logging data about multicast streams
  • Logging data and events
  • To add IP addresses to resolve port 80 conflicts


To configure and enable multicast logging

  1. In the console tree, click the broadcast publishing point you want to log multicast information for. If it is started, stop the publishing point.
  2. In the details pane, click the Properties tab.
  3. In Category, click Multicast streaming.
  4. In Plug-in, click WMS Multicast Data Writer, and then click Properties.
  5. WMS Multicast Data Writer Properties appears.
  6. In the Windows Media Services snap-in, click the Advanced tab.
  7. Configure the following setting:
    • Logging URL. Type the URL of the Wmsiislog.dll file on your Web server, such as http://web_server_name/virtual_directory/wmsiislog.dll.
  8. Click OK to apply the new setting to the plug-in.
  9. In the details pane, on the Properties tab, in Category, click Multicast streaming, iIn Plug-in, click the WMS Multicast Data Writer plug-in, and then click the Enable button.
  10. Run the Multicast Announcement Wizard to create a new multicast information file (.nsc file) for your multicast.

Note Image Notes

  • This procedure requires that your Web server running Internet Information Services (IIS) has a virtual directory that references the %systemdrive%\WMPub\WMIISlog directory and that the Wmsiislog.dll has been granted executable permissions on the virtual root. For more information about using executable ISAPI filters and Web service extensions, see Internet Information Services Help.
  • If you want to change the log file recycling period, you can change the setting in Internet Information Services (IIS). For more information about log file settings, see IIS Help.
  • A client sends logging information to the IIS server after the client stops streaming a multicast. After the server receives logging information from a client, it may take several minutes before that information is added to the log file.
  • If you change the settings of the WMS Multicast Data Writer plug-in, you must create a new multicast information file for clients to be able to receive to the multicast stream. You can create the multicast information file by using the Multicast Announcement Wizard available in the Windows Media Services snap-in.
  • Windows Media Services does not include a logging plug-in that works with encoder push scenarios. You can log encoder push broadcast data by creating an active script logging plug-in. For more information about creating a custom plug-in, see the Windows Media Services Software Development Kit (SDK), which can be downloaded from the Windows Media home page at the Microsoft Web site.
  • The default location of the multicast log files created by the Multicast and Advertisement Logging Agent is %systemroot%\System32\LogFiles\WMS_ISAPI. The log file name is WMS_yyyymmdd.log, where yyyymmdd is the year, month, and day when the log file is created. If more than one log file is generated in a day, an incremented number is added to the file name, using the format WMS_yyyymmdd_iiii.log. For example, if the first log is named WMS_20040304.log, the second log on that day is named WMS_20040304_0001.log, and so forth.
  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are writing log files to a location other than C:\WMPub and its subdirectories, make sure that the folder is shared and that the Network Service account has read and write permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to write log files to it. For more information about rights and permissions, see Understanding rights.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Log data about clients
  • Logging data about multicast streams
  • Logging data and events
  • To install the Multicast and Advertisement Logging Agent
  • Working with the Multicast Announcement Wizard


To configure the WMS WMI Event Handler properties

  1. In the console tree, click the server or publishing point you want to report Windows Management Instrumentation (WMI) events about.
  2. In the details pane, click the Properties tab.
  3. In Category, click Event notification.
  4. Click WMS WMI Event Handler, and then click Properties.
  5. Configure the following setting in WMS WMI Event Handler Properties:
    • Classes. Select the check box for each event you want to report. For more information on the event classes, see WMS WMI Event Handler - general properties.

Note Image Note

  • WMI events are used to pass information between Windows Media Services and other services and programs. Changing the reported events can cause issues with some client programs.

Related topics

  • Log data about clients
  • Understanding event handler plug-ins


To configure the WMS Active Script Event Handler properties

  1. In the console tree, click the server or publishing point on which you want to configure the WMS Active Script Event Handler.
  2. In the details pane, click the Properties tab.
  3. In Category, click Event notification.
  4. Click WMS Active Script Event Handler, and then click Properties.

    WMS Active Script Handler Properties appears.

  5. In the Windows Media Services snap-in, click the General tab.
  6. In File name of script to run, type the name of the script file that you want to run. In the Windows Media Services snap-in, you can also click Browse to locate the file.
  7. If you want to attach the Microsoft Script Debugger to your script file, select the Enable script debugging check box. If an error is encountered while running the script, the debugger stops the script, traps the error, and presents the error in a dialog box.
  8. In the Last script error information area, you can view information about the latest error encountered.
  9. Click OK to close the dialog box and run the script after the plug-in is enabled.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Log data about clients
  • Understanding event handler plug-ins


Control access to content

This section contains the following topics:

  • To configure and enable the WMS Anonymous User Authentication plug-in
  • To enable the WMS Negotiate Authentication plug-in
  • To enable the WMS NTFS ACL Authorization plug-in
  • To configure and enable the WMS IP Address Authorization plug-in
  • To configure and enable the WMS Publishing Points ACL Authorization plug-in
  • To configure and enable the WMS Digest Authentication plug-in
  • To protect the Default publishing point

Related topics

  • Configuring security options
  • How to…
  • Understanding authentication
  • Understanding authorization


To configure and enable the WMS Anonymous User Authentication plug-in

  1. In the console tree, click the server or publishing point for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Authentication.
  4. In Plug-in, select WMS Anonymous User Authentication, and then click the Properties button.
  5. In User name, type the user name you want anonymous users to use when accessing content.
  6. In Password, type the password for the anonymous user account.
  7. In Confirm password, type the password again to verify that you entered it correctly.
  8. In the details pane, click the Enable button.

Note Image Notes

  • By default, the Windows user account WMUS_computername is assigned to anonymous users, where computername is the name of the server on which Windows Media Services is running.
  • The password is used only within the Windows operating system; anonymous users do not log on by using a password. During Setup, a password is randomly generated for the WMUS_computername user account, where computername is the name of the server on which Windows Media Services is running. If you change the password for the anonymous user account in the operating system, you must update that password here in order to allow anonymous users access to your content. Passwords are case-sensitive.
  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If an authorization plug-in is enabled, but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • Configuring security options
  • Control access to content
  • Using the WMS Anonymous User Authentication plug-in


To enable the WMS Negotiate Authentication plug-in

  1. In the console tree, click the server or publishing point for which you want to enable the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Authentication.
  4. In Plug-in, click WMS Negotiate Authentication, and then click the Enable button.

Note Image Note

  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If an authorization plug-in is enabled, but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • Configuring security options
  • Control access to content
  • To configure and enable the WMS Anonymous User Authentication plug-in
  • Using the WMS Negotiate Authentication plug-in


To enable the WMS NTFS ACL Authorization plug-in

  1. In the console tree, click the server or publishing point for which you want to enable the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Authorization.
  4. In Plug-in, click WMS NTFS ACL Authorization, and then click the Enable button.

Note Image Note

  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If an authorization plug-in is enabled, but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • Configuring security options
  • Control access to content
  • To configure and enable the WMS IP Address Authorization plug-in
  • To configure and enable the WMS Publishing Points ACL Authorization plug-in
  • Using the WMS NTFS ACL Authorization plug-in


To configure and enable the WMS IP Address Authorization plug-in

  1. In the console tree, click the server or publishing point for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Authorization.
  4. In Plug-in, click WMS IP Address Authorization, and then click the Properties button.

    The WMS IP Address Authorization Properties dialog box appears.

  5. Do one of the following:
    To Do this
    Deny specific IP addresses access to your content
    • Click Allow all except those in the deny list.
    • In the Deny list, click the Add IP button.
    • Select the appropriate option, and then type the IP or subnet address.
    • Repeat this step to deny additional IP addresses.
    Allow specific IP addresses access to your content
    • Click Deny all except those in the Allow list.
    • In the Allow list, click the Add IP button.
    • Click the appropriate option, and then type the IP or subnet address.
    • Repeat this step to allow additional IP addresses.
    Allow and deny specific IP addresses access to your content
    • Click Restrict as specified in the following lists.
    • In the Allow list, click the Add IP button.
    • Click the appropriate option, and then type the IP or subnet address.
    • Repeat this step to allow additional IP addresses.
    • In the Deny list, click the Add IP button.
    • Click the appropriate option, and then type the IP or subnet address.
    • Repeat this step to deny additional IP addresses.

  6. To edit an address in either the Allow list or the Deny list, click the entry you want to edit, and then click the Edit button.
  7. To remove an address in either the Allow list or the Deny list, click the entry you want to delete, and then click the Remove button.
  8. When the lists contain the appropriate IP addresses, click Apply, and then click OK.
  9. In the details pane, click the Enable button.

Note Image Notes

  • Properties for this plug-in cannot be configured in Windows Media Services Administrator for the Web.
  • Windows Media Services is Internet Protocol version 6 (IPv6) enabled. IPv6 is the newest version of the Internet Protocol and was designed to accommodate the rapidly increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a much greater number of addressable nodes. Not all networks are configured to use IPv6, so Windows Media Services will automatically use it when it is available. For more information about IPv6, refer to the IPv6 page on the Microsoft Web site.

Related topics

  • Configuring security options
  • Control access to content
  • To configure and enable the WMS Publishing Points ACL Authorization plug-in
  • To enable the WMS NTFS ACL Authorization plug-in
  • Using the WMS IP Address Authorization plug-in


To configure and enable the WMS Publishing Points ACL Authorization plug-in

  1. In the console tree, click the server or publishing point for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Authorization.
  4. In Plug-in, click WMS Publishing Points ACL Authorization, and then click the Properties button.
  5. Do one of the following:
    To Do this
    Set permissions for a new user or group
    • Click Add.
    • In the Select Users, Computers, or Groups dialog box, click the Object Types button and select the types of objects you are trying to locate.
    • Click the Locations button, and then click the domain that you want to search.
    • Type the name of the user, computer, or group for which you want to set permissions, and then click the Check Names button.
    • Select the appropriate entries from the list. By default, new users and groups are granted read permission and denied write permission.
    Remove permissions for a user or group
    • In the Name list, click the appropriate user or group, and then click Remove.
    Change permissions for an existing user or group
    • In the Name list, click the appropriate user or group.
    • In Permissions, modify the read and write permissions accordingly.
  6. Click Apply, and then click OK.
  7. In the details pane, click the Enable button.

Note Image Notes

  • A user or group must have been granted both write and create permissions to be able to create a publishing point. Create permissions alone are not sufficient to create a new publishing point.
  • Properties for this plug-in cannot be configured in Windows Media Services Administrator for the Web.
  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If an authorization plug-in is enabled, but no authentication plug-in is enabled, unicast clients cannot access the server.

Related topics

  • Configuring security options
  • Control access to content
  • To enable the WMS NTFS ACL Authorization plug-in
  • To configure and enable the WMS IP Address Authorization plug-in
  • Using the WMS Publishing Points ACL Authorization plug-in


To configure and enable the WMS Digest Authentication plug-in

  1. In the console tree, click the server or publishing point for which you want to configure the plug-in.
  2. In the details pane, click the Properties tab.
  3. In Category, click Authentication.
  4. In Plug-in, select WMS Digest Authentication, and then click Properties.
  5. In Realm, type the domain or other operating system authentication to which the publishing point or server belongs.
  6. In the details pane, click the Enable button.

Note Image Notes

  • If the realm is not specified, you must provide the fully qualified domain name and the user name in order to obtain access to the server.
  • The authentication and authorization plug-ins work together to grant clients access to streaming media content. If an authorization plug-in is enabled, but no authentication plug-in is enabled, unicast clients cannot access the server.
  • The WMS Digest Authentication plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Configuring security options
  • Control access to content
  • Using the WMS Digest Authentication plug-in


To protect the Default publishing point

  1. Click the Default (on-demand) publishing point.
  2. In the details pane, click the Monitor tab.
  3. In the Windows Media Services snap-in, on the Action menu, click Deny New Connections.

    -or-

    In Windows Media Services Administrator for the Web, click the Deny button.

    Requests for streams from the default publishing point will be denied.

Related topics

  • Protecting the Default publishing point
  • Configuring security options


Secure the Windows Media Administration site

This section describes how to configure three types of Internet Information Services (IIS) security for the Windows Media Administration site: Secure Sockets Layer (SSL), integrated Windows authentication, and basic authentication. For more information about adding Web site security, see Internet Information Services Help.

This section contains the following topics:

  • To configure SSL
  • To configure integrated Windows authentication
  • To configure basic authentication

Related topics

  • Securing the Windows Media Administration site


To configure SSL

  1. Start Microsoft Management Console (MMC).
  2. If you have not added a certificates snap-in already, add one to MMC.
  3. Request a new certificate. You may either use an existing certification authority (CA) on your network or install Certification Services and create your own certificate.
  4. Start Internet Information Services (IIS).
  5. Assign the certificate you obtained to the Windows Media Administration Site.
  6. In IIS, configure the security properties for the Windows Media Administration site to require a secure channel. Assign an SSL port number for the site to use. The default SSL port is 443.
  7. To access the site, open a browser that supports SSL, such as Microsoft Internet Explorer or Netscape Navigator. Enter the URL of the secure site by using the HTTPS protocol, server name and path, and the SSL port number you specified. For example: https://myserver:902.

Note Image Note

  • For more information about configuring SSL, see Internet Information Services Help.

Related topics

  • Securing the Windows Media Administration site
  • Using Secure Sockets Layer


To configure integrated Windows authentication

  1. Start Internet Information Services (IIS).
  2. Prevent anonymous users from accessing the Windows Media Services Administration site by disabling any anonymous access settings.
  3. Enable IIS to use the Windows operating system's authentication methods in order to authenticate users that attempt to access the Windows Media Administration site.

Note Image Note

  • This procedure requires that you configure IIS security properties. For more information about IIS security properties, see Internet Information Services Help.

Related topics

  • Securing the Windows Media Administration site
  • Using integrated Windows authentication


To configure basic authentication

  1. Start Internet Information Services (IIS).
  2. Prevent anonymous users from accessing the Windows Media Services Administration site by disabling any anonymous access settings.
  3. Enable IIS to use basic authentication methods in order to authenticate users that attempt to access the Windows Media Administration site.

Note Image Notes

  • Basic authentication sends passwords over a network in clear text, so be aware that there is an inherent security risk involved in enabling this authentication method. However, when it is being used in combination with Secure Sockets Layer (SSL), the security risk associated with basic authentication is mitigated. It is recommended that you do not enable basic authentication unless you are using SSL with your Web site.
  • This procedure requires that you configure IIS security properties. For more information about IIS security properties, see Internet Information Services Help.

Related topics

  • Securing the Windows Media Administration site
  • Using basic authentication


Implement streaming scenarios

This section contains the following topics:

  • To create a streaming radio station
  • To broadcast a live presentation
  • To broadcast a recorded presentation
  • To provide an on-demand training seminar
  • To add a banner advertisement to a stream
  • To add an interstitial advertisement to a stream
  • To add a wrapper advertisement to a stream
  • To provide video on demand
  • To replace advertisements in a live stream

Related topics

  • Scenarios
  • Work with publishing points


To create a streaming radio station

  1. In the console tree, click Publishing Points.
  2. On the Action menu, click Add Publishing Point (Wizard).
  3. Complete the steps in the wizard, making sure to select the following options:
    • On the Content Type page, do one of the following: If you want to create a radio station by using preexisting digital media files, click Playlist; or, if you want to broadcast a live radio program by using Windows Media Services, click Encoder.
    • On the Publishing Point Type page, click Broadcast publishing point.
    • If you are using a playlist, on the Content Playback page, select the Loop check box to have the playlist play continuously and the Shuffle check box to have the content play in random order. You must have more than one entry in your playlist to use the shuffle and loop features.
  4. For unicast broadcasts, on the Completing the Add Publishing Point Wizard page, you can select the following options:
    • Start publishing point when wizard finishes. Select this check box to start broadcasting the content from your publishing point immediately after the wizard finishes. If you need to configure the publishing point or the encoder, you should clear this check box.
    • Start archiving when publishing point starts. Select this check box to begin recording your broadcast to an archive file when the publishing point is activated. This option is useful if you want to broadcast a live program from an encoder because it creates a digital media file of the broadcast that you can rebroadcast later. If you are streaming digital media files instead of an encoder stream, you do not need to create an archive file.
  5. Also on the Completing the Add Publishing Point Wizard page, you can start other wizards to help you create announcements and wrappers:
    • Create an .asx or .htm file. Click this option if you want to provide users with an announcement file that they can use to receive your radio station broadcast. The Unicast Announcement Wizard or the Multicast Announcement Wizard will start.
    • Create a .wsx file. Click this option if you want to play certain content to users before they receive the content being streamed from your radio station. This option is useful for providing station identification, advertisements, or legal notices. You can also specify content to be played at the end of your radio station content, but users will not receive that content if they close their players before the end of the broadcast. The Create Wrapper Wizard will start.
    • Create both a .wsx file then .asx file. Click this option if you want to use the wizards to create both a wrapper playlist and an announcement.

Note Image Notes

  • This procedure only applies to the Windows Media Services snap-in.
  • The Add Publishing Point Wizard only supports the creation of simple playlists that contain digital media files and advertisements. If you want to include other elements in your playlist, you can create the playlist before running the Add Publishing Point Wizard. For more information about the playlist elements available for use with Windows Media Services, see Playlist elements.
  • If you are using multicast delivery with your radio station, you must run the Multicast Announcement Wizard for players to connect to your stream. A URL connection is not available for multicast delivery. In addition, wrapper playlists cannot be used with multicast delivery.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About wrapper playlists
  • Broadcasting programmed content
  • Implement streaming scenarios
  • Announcing content
  • Testing a stream
  • Working with the announcement wizards


To broadcast a live presentation

  1. Start the encoding software and create a new broadcast session. Begin encoding the session and note the connection URL for the encoder.
  2. In the Windows Media Services console tree, click Publishing Points.
  3. On the Action menu, click Add Publishing Point (Wizard).
  4. Complete the steps in the wizard, making sure to select the following options:
    • On the Content Type page, click Encoder.
    • On the Delivery Options for Broadcast Publishing Points page, if you want to stream the presentation using multicast, select the Multicast check box. If you want to stream the presentation using unicast, select the Unicast check box
  5. For unicast broadcasts, on the Completing the Add Publishing Point Wizard page, you can select the Start archiving when publishing point starts check box to begin recording your broadcast to an archive file when the publishing point is activated. This option is useful if you want to broadcast a live program from an encoder because it creates a digital media file of the broadcast that you can rebroadcast later.
  6. Also on the Completing the Add Publishing Point Wizard page, you can start other wizards to help you create announcements and wrappers:
    • Create an .asx or .htm file. Click this option if you want to provide users with an announcement file that they can use to receive your live broadcast. The Unicast Announcement Wizard or the Multicast Announcement Wizard will start.
    • Create a .wsx file. Click this option if you want to play certain content to users before they receive the live broadcast. This option is useful for providing speaker identification, introductory comments, or legal notices. You can also specify content to be played at the end of your live broadcast, but users will not receive that content if they close their players before the end of the broadcast. The Create Wrapper Wizard will start.
    • Create both a .wsx file then .asx file. Click this option if you want to use the wizards to create both a wrapper playlist and an announcement.

Note Image Notes

  • This procedure only applies to the Windows Media Services snap-in.
  • If you are using multicast delivery with your live presentation, you must run the Multicast Announcement Wizard for players to connect to your stream. A URL connection is not available for multicast delivery. In addition, wrapper playlists cannot be used with multicast delivery.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Implement streaming scenarios
  • Testing a stream
  • Announcing content
  • About wrapper playlists
  • Working with the announcement wizards.
  • Broadcasting executive speeches


To broadcast a recorded presentation

  1. In the Windows Media Services console tree, click Publishing Points.
  2. On the Action menu, click Add Publishing Point (Wizard).
  3. Complete the steps in the wizard, making sure to select the following options:
    • On the Content Type page, click One file.
    • On the Publishing Point Type page, click Broadcast publishing point.
    • On the Delivery Options for Broadcast Publishing Points page, if you want to stream the presentation using multicast, select the Multicast check box. If you want to stream the presentation using unicast, select the Unicast check box.
  4. For unicast broadcasts, on the Completing the Add Publishing Point Wizard page, you can select the Start publishing point when wizard finishes check box to start broadcasting the content from your publishing point immediately after the wizard finishes. If you need to configure the publishing point, you should clear this check box.
  5. Also on the Completing the Add Publishing Point Wizard page, you can start other wizards to help you create announcements and wrappers:
    • Create an .asx or .htm file. Click this option if you want to provide users with an announcement file that they can use to receive your broadcast. The Unicast Announcement Wizard or the Multicast Announcement Wizard will start.
    • Create a .wsx file. Click this option if you want to play certain content to users before they receive the broadcast. This option is useful for providing distributor identification, disclaimers, or legal notices. You can also specify content to be played at the end of your broadcast, but users will not receive that content if they close their players before the end of the broadcast. The Create Wrapper Wizard will start.
    • Create both a .wsx file then .asx file. Click this option if you want to use the wizards to create both a wrapper playlist and an announcement.

Note Image Notes

  • This procedure only applies to the Windows Media Services snap-in.
  • If you are using multicast delivery with your recorded presentation, you must run the Multicast Announcement Wizard for players to connect to your stream. A URL connection is not available for multicast delivery. In addition, wrapper playlists cannot be used with multicast delivery.

Related topics

  • About wrapper playlists
  • Holding financial briefings
  • Implement streaming scenarios
  • Announcing content
  • Testing a stream
  • Working with the announcement wizards.


To provide an on-demand training seminar

  1. In the console tree, click Publishing Points.
  2. On the Action menu, click Add Publishing Point (Wizard).
  3. Complete the steps in the wizard, making sure to select the following options:
    • On the Content Type page, click Files (digital media or playlists) in a directory.
    • On the Publishing Point Type page, click On-demand publishing point.
    • On the Directory Location page, type the location of the training content. Make sure the content files are in the order that you want them to be viewed.
    • On the Content Playback page, if it is important that your training is viewed in a specific order, make sure that the Loop and Shuffle check boxes are cleared.
  4. On the Completing the Add Publishing Point Wizard page, you can start other wizards to help you create announcements and wrappers:
    • Create an .asx or .htm file. Click this option if you want to provide users with an announcement file that they can use to connect to your training seminar. The Unicast Announcement Wizard or the Multicast Announcement Wizard will start.
    • Create a .wsx file. Click this option if you want to play certain content to users before they connect to the training seminar. This option is useful for providing curriculum identification, course provider information, or legal notices. You can also specify content to be played at the end of your training seminar, but users will not receive that content if they close their players before the end of the session. The Create Wrapper Wizard will start.
    • Create both a .wsx file then .asx file. Click this option if you want to use the wizards to create both a wrapper playlist and an announcement.
  5. In the console tree, click the publishing point you have created.
  6. In the details pane, click the Properties tab.
  7. In Category, click General.
  8. If you want clients to be able to use a single link to access all of the content, enable the Enable access to directory content using wildcards property. If you want clients to be able to access the content files individually, make sure the Enable access to directory content using wildcards property is disabled, and then use the Unicast Announcement Wizard to create individual announcement files for each content file.

Note Image Notes

  • You can combine your presentation with a Web site that contains background information and links to additional resources. Reference the announcement files within the Web site to give visitors easy access to your content.
  • You can use a digital media presentation program such as Microsoft Producer for PowerPoint 2002 to integrate video, audio, slides, HTML, and custom backgrounds into a presentation. Presentations created using Microsoft Producer can be streamed using Windows Media Services.
  • This procedure only applies to the Windows Media Services snap-in.

Related topics

  • About wrapper playlists
  • Implement streaming scenarios
  • Presenting training seminars
  • Announcing content
  • Testing a stream
  • Working with the announcement wizards


To add a banner advertisement to a stream

  1. Create a banner graphic to be displayed in the player during the broadcast.
  2. In the console tree, click the publishing point to which you want to add the banner advertisement.
  3. Click the Source tab.

In the Content source area, be sure that the Location path and file name correspond to the playlist that is currently online.

  4. In the playlist tree, expand the playlist, and then expand the smil element to show the elements in the playlist.
  5. Click the Media element that you want to add a banner advertisement to.
  6. On the toolbar, click the Add Element arrow, and then click ClientData.

A ClientData element is added to the Media element.

  7. Click the new ClientData element.

The Source details area displays the properties for the ClientData element.

  8. Click the bannerAbstract attribute and type the ToolTip text for the banner graphic. For example:

    Download more albums from this artist at our Web site.

  9. Click the bannerInfoURL attribute and type the URL that is associated with this banner graphic. If the user clicks the banner graphic during playback, it opens this URL. For example:

    http://www.microsoft.com

  10. Click the bannerURL attribute and type the location of the banner graphic file. For example:

    http://server/folder/image.jpg

  11. On the toolbar, click the Save button.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in.

Related topics

  • Displaying banner ads
  • Implement streaming scenarios


To add an interstitial advertisement to a stream

  1. In the console tree, click the publishing point to which you want to add an interstitial advertisement.
  2. Click the Source tab.

In the Content source area, be sure that the Location path and file name correspond to the playlist that is currently online.

  3. In the playlist tree, expand the playlist, and then expand the smil element to show the elements in the playlist.
  4. Click the Media element you want to add an interstitial advertisement after.
  5. On the toolbar, click the Add Element arrow, and then click Advertisement.

    The Add Advertisement dialog box appears.

  6. Type the location of your advertising content. You can specify advertising content stored locally on the network or dynamic content provided by an advertising partner.

Note Image Notes

  • If you do not have an advertising partner, you can visit the Partner Center at the Microsoft Web site.
  • This procedure only applies to the Windows Media Services snap-in.

Related topics

  • Displaying interstitial ads
  • Implement streaming scenarios


To add a wrapper advertisement to a stream

  1. In the console tree, click the publishing point to which you want to add a wrapper playlist.
  2. Click the Advertising tab, and then click the Wrapper Editor button.

The Wrapper Playlist Editor Options dialog box opens.

  3. Click Create playlist file, and then select the Use the Create Wrapper Wizard check box.
  4. Follow the instructions in the Create Wrapper Wizard to create a wrapper playlist file.
  5. On the Advertising tab, click the Change button.
  6. In Location, type the path to the wrapper playlist file, or click Browse to locate the file.
  7. Click OK.
  8. Select the Use a wrapper with this publishing point check box.

    The wrapper playlist is applied to the publishing point.

Note Image Note

  • This procedure only applies to the Windows Media Services snap-in.

Related topics

  • Implement streaming scenarios
  • Working with wrapper ads


To provide video on demand

  1. Obtain the video content you want to stream. You can create the content yourself, or purchase or license the content as necessary. The recording should be high quality and in a format that is convenient for encoding.
  2. Prepare the content for streaming. If necessary, edit the video to achieve the desired playing time, arrangement, and tone. Encode the video and save it as a Windows Media file. Windows Media Encoder includes several broadband encoding profiles that you can use to achieve a specific result. For example, if you intend to include interstitial advertisements in your content, consider encoding the video as several sequential video files. Store the content files either on the Windows Media server or in a location on your network. For more information about encoding content, see Windows Media Encoder Help.
  3. Reference the video content in your on-demand publishing point:
    • In the console tree, click the on-demand publishing point from which you want to stream content.
    • In the details pane, click the Source tab.
    • In the Content Source area, be sure the Location path is the same as the location of the Windows Media file you want to stream.
    • If it is not, click Change and type the path to the content, or click Browse to locate the file.
  4. Choose a method to generate revenue from your content. The Windows Media Rights Manager Software Development Kit (SDK) provides you with several commercial access options, such as pay-per-view or subscription services, depending on your business model. For more information about the methods for streaming protected Windows Media-based content, see the Windows Media Rights Manager SDK.
  5. Protect your content from unauthorized access. Configure and enable the authentication and authorization plug-ins that you want to use to control access to your content. For more information about authentication and authorization, see Understanding authentication and Understanding authorization.
  6. You can configure and enable a logging plug-in to collect client usage data and publishing point performance information. Using data from the log files, you can create reports to verify that your system is performing as expected. Additional logs can be generated to record the performance of specific advertisements within the broadcast. You can then give these specialized logs to your advertisers. For more information about logging, see Understanding logging.
  7. Use the Unicast Announcement Wizard to create an announcement file that you can add to a Web page or provide to users as a network share location.
    • In the console tree, select the publishing point that contains the content you want to announce.
    • In the details pane, click the Announce tab.
    • Click Run Unicast Announcement Wizard, and then follow the steps in the wizard.

      Using the Unicast Announcement Wizard, you can also create a basic Web page with an embedded link to your content. After creating this page, you can then personalize it and add it to your site.

Related topics

  • About announcements
  • Configuring security options
  • Implement streaming scenarios
  • Obtaining content
  • Prerecorded content
  • Stream Windows Media files on demand
  • Understanding encoding
  • Understanding logging


To replace advertisements in a live stream

  1. Configure the encoder to transmit script commands that signal the start of an advertising break.
    • Based on the connection speed of your clients, determine the pre-buffering time necessary to transition smoothly to the replacement advertisement.
    • Configure the encoder to transmit a CUE_EVENT script command before the advertising break.
    • Configure the encoder to transmit a Fire_Event script command at the beginning of the advertising break.
  2. Create a playlist that alternates between primary and secondary digital media sources according to script commands received from the encoder.
    • Open the Windows Media Playlist Editor.
    • Click the smil element.
    • On the toolbar, click the Add Element arrow, and then click Exclusive.
    • An excl element is added to the playlist under the smil element.
    • Click the excl element.
    • On the toolbar, click the Add Element arrow, and then click PriorityClass.
    • A priorityClass element is added to the playlist under the excl element.
    • Click the priorityClass element, and then in peers, type pause.
    • On the toolbar, click Add Element.
    • The Add Media Elements dialog box opens.
    • Specify the name and location of the encoder. Repeat this step and specify the name and location of the alternate advertising source. Repeat this step again for any additional sources of advertising.
    • On the toolbar, click the Save playlist button.
    • Specify the name and location of the playlist file. The playlist file must use a .wsx file name extension.
  3. Create or edit a publishing point that uses the playlist you created in the previous section as its content source.
  4. Start the encoder and begin streaming your live broadcast. Check that the replacement advertisement transitions are smooth and timed correctly. If the player needs more pre-buffering time to avoid gaps and overlap, make the appropriate changes in the encoder configuration.

Related topics

  • About announcements
  • Configuring security options
  • Implement streaming scenarios
  • Obtaining content
  • Prerecorded content
  • Replacing ads
  • Understanding encoding
  • Understanding logging


Administration

This section explains the features and functions of the Windows Media Services administrative interfaces. This section contains the following topics:

  • Working with the administrative interfaces. Provides a general overview of the user interfaces for the Windows Media Services snap-in and Windows Media Services Administrator for the Web.
  • Working with the Add Publishing Point Wizard. Provides information to assist you in completing the Add Publishing Point Wizard.
  • Working with the Create Wrapper Wizard. Provides information to assist you in completing the Create Wrapper Wizard.
  • Working with the announcement wizards. Provides information to assist you in completing the unicast and multicast announcement wizards.

Related topics

  • Windows Media Services


Working with the administrative interfaces

There are two administrative interfaces for Windows Media Services: the Windows Media Services snap-in for Microsoft Management Console (MMC) and Windows Media Services Administrator for the Web, a Web-based administration interface that uses Active Server Pages (ASP) hosted by Microsoft Internet Information Services (IIS).

The Windows Media Services user interfaces are divided into two parts: the console tree on the left and the details pane on the right. The console tree is organized as a hierarchy composed of group, server, and publishing point items. The information displayed in the details pane changes based on the item you click in the console tree.

If you click a server or a publishing point in the console tree, the details pane displays tabs that enable you to monitor and configure your server or publishing point. If you click a group or the Troubleshooting item in the console tree, the details pane shows a summary of relevant statistics for that item. The details pane has a row of buttons at the bottom that you can use to perform administrative tasks.

In addition to the console tree and details pane, the Windows Media Services snap-in also has four wizards to help you create publishing points, wrapper playlists, and announcement files.

Working with the console tree

The console tree can contain the following items:

  • Servers. When you install Windows Media Services, your computer becomes the default Windows Media server. If you want to administer more than one Windows Media server using Windows Media Services, you can add additional servers to the console tree.
  • Groups. If you are administering several Windows Media servers using the Windows Media Services snap-in, you can manage them more effectively by organizing them into groups. Each group should contain servers that need to be monitored and controlled together. A server can be a member of more than one group, if necessary.
  • Troubleshooting. You can use the troubleshooting feature to identify problems or potential problems in your server operation. The Troubleshooting item provides a list of the most recent events and error messages that have occurred since the Windows Media Services service was started.
  • Cache/Proxy Management. Cache/proxy servers significantly reduce the latency of your digital media content as well as the load on the origin server. When you click the Cache/Proxy Management item in the console tree, the details pane displays a page containing information about plug-ins and other tools that can help you manage your cache/proxy servers.
  • Publishing Points. You can click the Publishing Points item to display a list of the names and statistics for all the publishing points hosted by a server. Each server can have one or more associated publishing points. By clicking an individual publishing point in the console tree, you can control and analyze the publishing point's activity by using the corresponding tabs in the details pane. A publishing point can operate by using one of two different methods: on-demand and broadcast. Each method provides the user with different types of content control and playback.

Working with the details pane

The details pane is the area of the interface used to perform tasks and monitor the operation of Windows Media servers. The contents of the details pane changes depending on the item you click in the console tree.

The details pane typically consists of several tabs. Each tab provides you with information and server management capabilities specific to certain aspects of server operation. The buttons at the bottom of the tab enable you to perform common server tasks.

Working with groups of servers

Each administrative interface handles the administration of multiple servers differently. The following list describes the differences:

  • Windows Media Services snap-in. Multiple servers or groups can be added to or removed from the console tree. To administer a server, expand the server item in the console tree and click an item in the server list in order to view its statistics or configure its settings in the details pane. Both server and publishing point groups are available.
  • Windows Media Services Administrator for the Web. On the Security Settings page that appears when Windows Media Services Administrator for the Web first starts, click Administer a list of Windows Media Servers. When the Administrator page opens, you can see the list of servers that are controlled by Windows Media Services Administrator for the Web. You can use the Add Server and Remove Server buttons to manage the list of servers. To administer a server, click a server listed on the server list page to display that server's administration page. To administer a different server, you must return to the server list page. For security reasons, you must use an authentication method other than NTLM that supports delegation in order to administer multiple Windows Media servers.

Working with wizards

In the Windows Media Services snap-in, four wizards are available to help you perform complex tasks. Each wizard takes you through a step by step process that helps you understand the operations you are performing.

  • Add Publishing Point Wizard. This wizard helps you choose a content source and a distribution method. It can also help you create a playlist, log files, and archive files. If you do not want to use the wizard to create a publishing point or you want to include advanced features in your publishing point, you can use the Add Publishing Point (Advanced) command instead.
  • Create Wrapper Wizard. This wizard helps you add advertising or other content to the start and end of your unicast broadcast.
  • Unicast Announcement Wizard. This wizard helps you create an announcement file which can be used by unicast clients to access your publishing point. You can also use the wizard to create a simple Web page with an embedded link to your publishing point.
  • Multicast Announcement Wizard. This wizard helps you create an announcement file and a multicast information file that clients can use to connect to your multicast stream.

This section contains the following topics:

  • Viewing group details
  • Viewing server details
  • Viewing publishing point details
  • About troubleshooting
  • About properties and plug-ins

Note Image Note

  • Cache/Proxy Management, multicast streaming and the Multicast Announcement Wizard are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Administration
  • Managing your Windows Media server
  • Understanding publishing points
  • Working with the Add Publishing Point Wizard
  • Working with the announcement wizards
  • Working with the Create Wrapper Wizard


Viewing group details

If you click a group in the console tree, the details pane displays the items in the group and their associated statistics and provides a set of buttons you can use to perform general tasks related to the group.

This section contains the following topic:

  • About groups

Note Image Notes

  • This feature is only available in the Windows Media Services snap-in.
  • You can view and configure settings for an individual item in a group by double-clicking or expanding the item in the console tree.

Related topics

  • Working with the administrative interfaces


About groups

The details pane displays following information about the group.

Item | Description
Server Name | Displays the name of the server.
Connections | Displays the number of players that are receiving streams, which provides an overall measure of server use.
Bandwidth | Displays the amount of bandwidth consumption, which indicates whether you have allocated sufficient network resources.
System CPU | Displays the current processor use on your server, which provides a means of measuring server health.
Stream Errors | Displays the number of stream errors, which provides a means of measuring the quality level of a stream.

You can use the following buttons in the details pane to perform common group tasks:

  • Add Server. Adds a server to the group.
  • Remove Server. Removes the selected server from the group.
  • View properties. Opens the Group Properties dialog box. Use it to modify group properties such as group name and refresh rate.
  • Refresh list. Refreshes the information on the server list.

Note Image Note

  • This feature is only available in the Windows Media Services snap-in.

Related topics

  • Managing your Windows Media server
  • To add a server to a group
  • To modify group properties
  • To refresh the statistics in the server list for a group
  • To remove a server from a group
  • Using groups
  • Viewing group details


Add a group

By adding a group to Windows Media Services, you can create a logical grouping of servers to monitor and manage. You must have administrator rights and permissions in order to add a group. Use the following information to complete the Add Group dialog box.

Item | Description
Group name | Type a unique name for the group.

Note Image Note

  • This feature is only available in the Windows Media Services snap-in.

Related topics

  • About groups
  • To add a group


Specify group properties

Groups have the following properties that you can modify. Use the following information to complete the <Group> Properties dialog box.

Item | Description
Group name | Type a unique name for the group.
Refresh rate (seconds) | Click the number of seconds you want between updates of statistics: 1, 2, 5, 10, 30, or 60.

Note Image Note

  • This feature is only available in the Windows Media Services snap-in.

Related topics

  • About groups
  • To modify group properties


Add a server

You can add any server running Windows Media Services to a group, but you must have administrator rights and permissions to do so. Use the following information to complete the Add Server dialog box.

Item | Description
Server name or IP address | Type the name or IP address of the server you want to add to the administrative console.

Related topics

  • About groups
  • To add a server to a group


Viewing server details

When you click a server in the console tree or server list page, a set of tabs is displayed in the details pane. You can use the options on these tabs to configure different features of Windows Media Services, such as setting limits, configuring authentication, and enabling logging. Options set at the server level apply to all publishing points on that server.

Note Image Note

  • Some options can be set at both the publishing point level and the server level. If a publishing point setting conflicts with a server setting, the server setting overrides the publishing point setting.

This section contains the following topics:

  • About the Monitor tab for a server
  • About the Advertising tab for a server
  • About the Properties tab for a server

Related topics

  • Managing your Windows Media server
  • Working with the administrative interfaces


About the Monitor tab for a server

The Monitor tab displays the following information about your server.

Item | Description
General
Last counter reset | Displays the date and time when the counter was last reset. If the counter has not been reset, this area displays the date and time when the server was started.
System CPU | Displays the current percentage of processor capacity used on the server.
Clients
Current limit setting | Displays the player connection limit you set for the server.
Percentage of limit | Displays the number of players connected to the server as a percentage relative to the limit.
Peak (since last counter reset) | Displays the highest number of players that have been connected to the server since the Windows Media Services service was started or the Reset button was clicked.
Connected unicast players | Displays the current number of players that have unicast connections to the server.
Bandwidth
Current limit setting | Displays the bandwidth limits you set for the server.
Percentage of limit | Displays the amount of bandwidth being used by the server as a percentage relative to the bandwidth limit.
Peak (since last counter reset) | Displays the largest amount of bandwidth used by the server since the Windows Media Services service was started or the Reset button was clicked.
Current allocated bandwidth | Displays the total amount of bandwidth used by the server to provide streams to all of the clients receiving a unicast stream.
Advertising
Advertisements served by this server | Displays the total number of advertising impressions delivered by this server.
Refresh rate
Current refresh rate | Displays the rate at which the statistics on this tab are updated. To change the refresh rate, click the up or down arrows.

On this tab, you can use the following buttons to perform server-related tasks:

  • Stop the service. Stops the Windows Media Services service on the Windows Media server.
  • Allow new unicast connections. Allows new client connections to the server.
  • Deny new unicast connections. Denies new client connections to the server.
  • Reset all counters. Resets the peak values.
  • View Performance Monitor. (Windows Media Services snap-in only) Starts Windows Media Performance Monitor, which provides a graphical display of server and publishing point performance counters.

Web administration feature For Windows Media Services Administrator for the Web

Use the following setting to configure additional server options:

  • Select interval. Sets how often the page is refreshed. This setting is found in the Page Loaded area. Select an interval value from never to 60 minutes.

Related topics

  • Managing your Windows Media server
  • Setting server limits
  • To add a group
  • To set limits for a server or publishing point
  • Using groups
  • Viewing server details


About the Advertising tab for a server

Use the Advertising tab to find an advertising partner.

Item | Description
Resources on the Web
Find an advertising partner | In the Windows Media Services snap-in, click to open the Windows Media Technologies Partner center Web site to locate advertising partners and solutions providers on the Internet.

Related topics

  • Understanding advertising
  • Viewing server details


About the Properties tab for a server

Use the Properties tab to view and configure properties for your server. You can set limits to manage your server resources and enable and disable the properties and plug-ins used by your server.

The Properties tab displays the following information about server properties.

Item | Description
Show all plug-in categories | Select this check box to display all of the plug-in categories that are available, including the core system plug-ins. Changing or disabling the core system plug-ins may result in your server not functioning as expected.
Category | Displays the list of property or plug-in categories available for the server. Click the category name to view the list of available properties or plug-ins.
Property or Plug-in | Displays the properties or plug-ins available, depending on the selected category. For more information, see About properties and plug-ins.

If you select a property or plug-in that is configurable, you can use the following buttons to perform common tasks:

  • Enable. Enables the property or plug-in on the server.
  • Disable. Disables the property or plug-in on the server.
  • Remove plug-in. Marks the plug-in for removal from the list. The plug-in is not removed until you stop or start the server. You cannot remove the last instance of a core system plug-in.
  • Duplicate plug-in. Makes a copy of the selected plug-in, including its configuration.
  • View properties. Displays the properties of the item. Some items do not have configurable settings.
  • Refresh list. (Windows Media Services snap-in only) Reloads all of the registered plug-ins in the selected category.

Web administration feature For Windows Media Services Administrator for the Web

Use the following button and setting to configure additional plug-in or property options:

  • Rename plug-in. Allows you to rename a plug-in.
  • Select interval. Sets how often the page is refreshed. This setting is found in the Page Loaded area. Select an interval value from never to 60 minutes.

Note Image Note

  • Some options can be set at both the publishing point level and the server level. If a publishing point setting conflicts with a server setting, the server setting overrides the publishing point setting.

Related topics

  • Control access to content
  • Logging data and events
  • Plug-in architecture
  • Setting server limits
  • Understanding authentication
  • Understanding authorization
  • Understanding event handler plug-ins
  • Understanding protocols
  • Viewing server details


Duplicate a plug-in

Duplicating a plug-in creates a new instance of the selected plug-in with the same property configuration as the original. Use the following information to complete the Duplicate plug-in dialog box.

Item | Description
Plug-in name | Type a unique name for the new plug-in instance. The name cannot exceed 250 characters and is not case-sensitive. The following characters cannot be used in a plug-in name: &"'<>\.


Renaming a plug-in

Renaming a plug-in assigns a new unique identifier to the plug-in selected on the Properties tab. The name cannot exceed 250 characters and is not case-sensitive. The following characters cannot be used in a plug-in name: &"'<>\.


About troubleshooting

Clicking the Troubleshooting item in the console tree displays the troubleshooting list in the details pane. You can use the troubleshooting list to view system events and warnings that have occurred since the Windows Media Services service started or since the list was cleared. You can use the data in this list to help you to identify and resolve issues on the server. The area at the top of the details pane indicates the number of unresolved events.

The details pane displays the following information for each event in the list.

Item | Description
Type | Displays an icon that identifies the event as either an error, warning, or information event.
Date | Displays the month, day, and year the event occurred.
Time | Displays the time of day the event occurred. The time is displayed in the time format used by the server, which can be either Coordinated Universal Time (UTC) or local time.
Location | Displays the name of the server or publishing point that generated the event.
Number | Displays the number of times the event has occurred.
Description | Provides more specific information about the type of event.

You can use the following buttons in the details pane to perform troubleshooting tasks:

  • Clear list. Removes all events from the list.
  • Refresh list. (Windows Media Services snap-in only) Updates the list of troubleshooting events.
  • View error details. (Windows Media Services snap-in only) Displays more information about the selected event.
  • View options. (Windows Media Services snap-in only) Opens the Troubleshooting Options dialog box that enables you to specify the settings for the events reported in the list. For more information, see Setting troubleshooting options.

Web administration feature For users of Windows Media Services Administrator for the Web

Use the following settings to configure additional troubleshooting options:

  • Filter Events. Sets troubleshooting options. For more information, see Setting troubleshooting options.
  • Select interval. Sets how often the page is refreshed. This setting is found in the Page Loaded area. Select an interval value from never to 60 minutes.

Note Image Note

  • Troubleshooting events are also logged in Event Viewer. If you want to review troubleshooting events that have been cleared or that occurred before the Windows Media Services service was started, you can view them in Event Viewer. For more information about Event Viewer, see Windows Help and Support.

Related topics

  • Working with the administrative interfaces


Setting troubleshooting options

You can set the following options to determine how events are displayed in the troubleshooting list.

Item | Description
Number of events server stores | Enter the maximum number of events to be displayed in the troubleshooting list In the Windows Media Services snap-in, type or select a value. In Windows Media Services Administrator for the Web, type a value in the text box, and then click the Apply button.
Filter events
Display limit hits | Select this check box if you want the troubleshooting list to display errors related to the limits set at the publishing point and server levels; for example, Client limit exceeded and, Server limit exceeded.
Display server warnings | Select this check box if you want the troubleshooting list to display warnings from the server components.
Display server errors | Select this check box if you want the troubleshooting list to display errors from the server components.
Display plug-in warnings | Select this check box if you want the troubleshooting list to display warnings from the plug-ins that you are using; for example, Data source not available and Log file not found. Warnings are a sign that plug-ins are not able to function as configured. Because each plug-in supports a different component, the plug-in warnings can help you identify the problem in your configuration.
Display plug-in errors | Select this check box if you want the troubleshooting list to display warnings from the server and publishing points about the plug-ins they are trying to use; for example, Cache plug-in could not be started and Control protocol plug-in failed. These warnings are from plug-ins that are not functioning at all and should be disabled or reconfigured. Sometimes a plug-in must be reinstalled to resolve the error condition.

Related topics

  • About troubleshooting
  • To configure troubleshooting options for a server


Viewing publishing point details

When you click a publishing point in the console tree, the details pane displays a set of tabs. The information available on some of the tabs differs slightly depending on whether the publishing point is on-demand or broadcast. You can use these tabs to perform tasks related to publishing points, such as modifying the content source, changing the publishing point properties, and adding advertisements. The Announce tab, which you can use to create announcements that direct clients to your content, is only available in the Windows Media Services snap-in.

This section contains the following topics:

  • About publishing points
  • About the Monitor tab for a publishing point
  • About the Source tab for a publishing point
  • About the Advertising tab for a publishing point
  • About the Announce tab for a publishing point
  • About the Properties tab for a publishing point

Note Image Note

  • Some options can be set at both the publishing point level and the server level. If a publishing point setting conflicts with a server setting, the server setting overrides the publishing point setting.


About publishing points

Clicking the Publishing Points item in the console tree opens the Summary tab in the details pane where the publishing points on your server can be viewed and managed,

Summary tab

The Summary tab of the Publishing Points item displays the following information about the publishing points on your server.

Item | Description
Name | Displays the name of the publishing point.
Type | Displays whether a publishing point is on-demand or broadcast.
Content Location | Displays the source location of the content, such as a digital media file, a directory, another Windows Media server, an encoder, or a playlist file.
Status | Displays the current activity of the publishing point.
Players (Current/Limit) (Windows Media Services Administrator for the Web only) | Displays the current number of players connected to the server and player connection limits that are set for the publishing point.
Bandwidth (Current/Limit) (Windows Media Services Administrator for the Web only) | Displays the total bandwidth in use and the bandwidth limits that are set for the publishing point.

After you click a publishing point from the list on the details pane, you can use the following buttons to perform publishing point tasks:

  • Add publishing point. Starts the Add Publishing Point Wizard, which helps you add a new on-demand or broadcast publishing point to the server.
  • Remove publishing point. Removes a publishing point from the server.
  • Start publishing point. Starts a broadcast publishing point.
  • Stop publishing point. Stops a broadcast publishing point, disconnecting all clients and refusing any new connection requests.
  • Allow new unicast connections. Allows unicast connection requests to the publishing point.
  • Deny new unicast connections. Denies new unicast connection requests, but allows currently connected unicast clients to continue receiving the stream.
  • View playlist editor. (Windows Media Services snap-in only) Starts the Windows Media Playlist Editor. You can create a playlist file for a publishing point by using the Playlist Editor.

Web administration feature For Windows Media Services Administrator for the Web

Use the following buttons to configure additional publishing point options:

  • Disconnect all clients. Disconnects all clients without stopping the publishing point.
  • Rename publishing point. Enables you to rename a publishing point.
  • Duplicate publishing point. Enables you to create an identical instance of the publishing point.

Related topics

  • Managing your Windows Media server
  • Plug-in architecture
  • To access the Add Publishing Point Wizard
  • To add a publishing point using the advanced method
  • To allow unicast connections to a publishing point
  • To deny unicast connections to a publishing point
  • To duplicate a publishing point
  • To remove a publishing point
  • To rename a publishing point
  • To start a broadcast publishing point
  • To stop a broadcast publishing point
  • Understanding publishing points
  • Viewing publishing point details


Duplicate a publishing point

Duplicating a publishing point creates a new publishing point that has the same properties, plug-in configuration, and references the same content as the original publishing point. Use the following information to complete the Duplicate Publishing Point dialog box.

Item | Description
Type the name for the new publishing point | Type a unique name for the publishing point. The name is not case-sensitive.

Note Image Note

  • The characters <>\?%&'#"{}|^[]* are reserved and cannot be used in the publishing point name.


Rename a publishing point

Renaming a publishing point assigns a new unique identifier to the publishing point. Use the following information to complete the Rename Publishing Point dialog box.

Item | Description
Publishing point name | Type a unique name for the publishing point. The name is not case-sensitive.

Note Image Notes

  • The characters <>\?%&'#"{}|^[]* are reserved and cannot be used in the publishing point name.
  • Existing announcements on the publishing point will not work after you rename it. You need to create a new announcement for the renamed publishing point.


Add a publishing point (advanced)

Adding a publishing point creates a publishing point with the default plug-in configuration and properties. Use the following information to complete the Add Publishing Point dialog box.

Item | Description
Publishing point type
Broadcast Select this option for live events such as chats, radio programs, and television shows. Users are passive participants, meaning that the server administrator has control of content playback.

You can use multicast transmission with this option to conserve network bandwidth.

On-demand | Select this option when providing content such as individual songs, custom playlists, archived broadcast content, and computer-based training. Users are active participants, meaning that they control the stream and can start, stop, pause, fast-forward, or rewind the content as desired. This option requires unicast transmission of the content.
Publishing point name | Type a unique name for the publishing point. The name is not case-sensitive.
Location of content | Enter the path to the content.
Content type examples Displays examples of the available types of content and provides sample syntax for specifying the location of content:

File. Content from this source is a digital media file located in an accessible file storage system.

Encoder (pull). Content from this source is generated and encoded in real time. The Windows Media server connects to the encoder and streams the content.

Remote publishing point. Content from this source is a stream that originates from another Windows Media server.

Dynamic source. Content from this source is a Windows Media metafile generated by a Web page.

Playlist. Content from this source is referenced by a Windows Media metafile.

Directory. Content from this source is stored in a folder and its associated subfolders located in an accessible file storage system.

Encoder (push). Content from this source is generated and encoded in real time. The encoder directs the Windows Media server to stream the content.

Multicast stream. Content from this source is generated in real time by another Windows Media server. The Windows Media server connects to a multicast stream generated by a remote publishing point.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Browse a data source

Browsing is a way for you to navigate through your files, folders, and network locations to locate the content you want to publish. The Browse dialog box supports selecting individual digital media files or entire directories. Use the following information to complete the Browse dialog box.

Item | Description
Data Source | Select the location of the content. The drop-down list may contain local drives, network drives, or URLs.
Location | Displays the current location. Click the up arrow to move up one level in the directory structure.
Name and Type | Provides a list of the names and types of files and folders at the current location. You can use the scroll bars to move up and down on the list. Double-click an item in the list to select it.
Select File | Click this button to use the path to the selected digital media file as the content source path and close the Browse dialog box.
Select Directory | Click this button to use the path to the selected directory as the content source path and close the Browse dialog box.
Cancel | Click this button to close the Browse dialog box without making any change to the content source path.
File name/Directory name | Displays the name of the selected file or directory.
Files of type | Select the type of files to display in the list.

Related topics

  • About publishing points


About the Monitor tab for a publishing point

Use the Monitor tab to monitor activity on your server. The Monitor tab displays the following information about your publishing point.

Item | Description
General
Now playing | Displays the source of the content currently being streamed. This item is shown for broadcast publishing points only.
Last counter reset | Displays the date and time that the counter was last reset. If the counter has not been reset, this item displays the date and time when the publishing point was started.
System CPU | Displays the current percentage of processor capacity used on the server.
Clients
Limit | Displays the player connection limit for the publishing point.
Percentage of limit | Displays the number of players connected to the server as a percentage relative to the limit.
Peak (since last counter reset) | Displays the highest number of players that have connected to the publishing point since the Windows Media Services service was started or the Reset button was clicked.
Players | Displays the current number of players that have unicast connections to the publishing point.
Bandwidth
Current limit setting | Displays the bandwidth limits for the publishing point.
Percentage of limit | Displays the amount of bandwidth used by the server as a percentage relative to the bandwidth limit.
Peak (since last counter reset) | Displays the largest amount of bandwidth used by the publishing point since the Windows Media Services service was started or the Reset button was clicked.
Current allocated bandwidth | Displays the total amount of bandwidth used by the publishing point to provide streams to all of the players receiving a unicast stream.
Advertising
Advertisements served by this publishing point | Displays the total number of advertising impressions delivered by the publishing point.
Refresh rate
Current refresh rate | Displays the rate at which the statistics on this tab are updated. To change the refresh rate, click the up or down arrows.

On this tab, you can use the following buttons to perform publishing point tasks:

  • Start publishing point. (Broadcast publishing point only) Starts broadcasting the content.
  • Stop publishing point. (Broadcast publishing point only) Stops broadcasting the content.
  • Allow new unicast connections. Allows new client connections to the publishing point.
  • Deny new unicast connections. Denies new client connections to the publishing point.
  • Disconnect all clients. Disconnects all client connections to the publishing point.
  • Reset all counters. Resets the peak values for the statistics displayed on the Monitor tab.
  • View Performance Monitor. (Windows Media Services snap-in only.) Starts Windows Media Performance Monitor, which provides a graphical display of server and publishing point performance counters.

Web administration feature For Windows Media Services Administrator for the Web

Use the following setting to configure additional options:

  • Select interval. Sets how often the page is refreshed. This setting is found in the Page Loaded area. Select an interval value from never to 60 minutes.

Related topics

  • Announcing content
  • Controlling unicast connections to a publishing point
  • Logging data and events
  • Setting publishing point limits
  • Sourcing from playlists, files, and encoders
  • To set limits for a server or publishing point
  • Understanding publishing points
  • Viewing publishing point details


About the Source tab for a publishing point

Use the Source tab to identify the content you want to stream from your publishing point. The Source tab provides the following information about the publishing point.

Item | Description
Location | Displays the path to the content and identifies the content type. For example, C:\Wmpub\Wmroot identifies a directory as the source of the content. In Windows Media Services Administrator for the Web, type the location of the content, and then click Apply to change the source of the content.
Change | In the Windows Media Services snap-in, click to specify the type and source of the content.
Content toolbar | In the Windows Media Services snap-in, use to modify the contents and behavior of items in the Source details area. This toolbar is primarily used when you are working with an existing playlist source. If the content source is not a playlist, many of the buttons in the toolbar are unavailable. For more information, see Editing online playlists.
Content details | In the Windows Media Services snap-in, displays details about the content source. For example, if the source is a directory, the files and file types in the directory are listed in this area. If the source is a playlist, the playlist elements and properties are displayed in a tree structure. For more information, see the Playlist reference.

On this tab, you can use the following buttons to perform publishing point tasks:

  • Start publishing point. (Broadcast publishing point only) Starts broadcasting the content.
  • Stop publishing point. (Broadcast publishing point only) Stops broadcasting the content.
  • Start archiving. (Broadcast publishing point only) Starts storing the content being broadcast to an archive file.
  • Stop archiving. (Broadcast publishing point only) Stops storing the content and closes the archive file.
  • Allow new unicast connections. (On-demand publishing point only) Allows new client connections to the publishing point.
  • Deny new unicast connections. (On-demand publishing point only) Denies new client connections to the publishing point.
  • View playlist editor. (Windows Media Services snap-in only) Starts the Windows Media Playlist Editor. You can create a playlist or modify an existing playlist by using the Playlist Editor.
  • Test stream. (Windows Media Services snap-in only) Starts Windows Media Player and attempts to connect to the publishing point to verify that the publishing point is streaming the selected content and is configured correctly.

Web administration feature For Windows Media Services Administrator for the Web

Use the following buttons and setting to configure additional publishing point options:

  • Allow new unicast connections. Allows new client connections to the publishing point.
  • Deny new unicast connections. Denies new client connections to the publishing point.
  • Select interval. Sets how often the page is refreshed. This setting is found in the Page Loaded area. Select an interval value from never to 60 minutes.

Related topics

  • Editing online playlists
  • Sourcing from playlists, files, and encoders
  • Viewing publishing point details


About the Advertising tab for a publishing point

Use the Advertising tab to manage advertising streams for the publishing point. The Advertising tab provides the following information.

Item | Description
Interstitial advertisements
What is an interstitial advertisement? | Click to display a Help topic about how to place advertisements throughout your content.
Wrapper advertisements
Advertisements inside wrappers | Click to display a Help topic about how to place advertisements at the beginning and end of content.
Use a wrapper with this publishing point | Select to use the wrapper playlist indicated in the Wrapper location text box with the publishing point.
Wrapper location | In the Windows Media Services snap-in, displays the path to the wrapper playlist file. In Windows Media Services Administrator for the Web, provides a space for you to modify the path to the wrapper playlist file.
Change (Windows Media Services snap-in only) | Click to modify the path to the wrapper playlist.
Apply (Windows Media Services Administrator for the Web only) | Click to accept any changes made to the wrapper location.
Resources on the Web
Find an advertising partner (Windows Media Services snap-in only) | Click to open the Windows Media Technologies Partner center Web site to locate advertising partners and solutions providers on the Internet.

On this tab, you can use the following button to perform an additional task:

  • Wrapper Editor. Click to open the Wrapper Editor, which allows you to add advertisements to the beginning or end of content.

Related topics

  • About wrapper playlists
  • To start the Create Wrapper Wizard
  • Viewing publishing point details


About the Announce tab for a publishing point

The Announce tab enables you to create an announcement that you can use to direct users to your content. The Announce tab appearance depends on whether the publishing point is an on-demand or a broadcast publishing point.

Unicast publishing points

For on-demand and broadcast publishing points, the Announce tab displays the following options for guiding users to your content. The Announce tab displays the current publishing point address so you can distribute it individually to clients or post it as a link.

Item | Description
Run Unicast Announcement Wizard | Click to start the Unicast Announcement Wizard and create announcement files.

Multicast publishing points

For multicast broadcast publishing points, the Announce tab displays the following additional options for guiding users to your content.

Item | Description
Run Multicast Announcement Wizard | Click to start the Multicast Announcement Wizard to create both a multicast information file and an announcement file.

Note Image Notes

  • This feature is only available in the Windows Media Services snap-in.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Announcing content
  • Working with the Unicast Announcement Wizard
  • Working with the Multicast Announcement Wizard
  • Viewing publishing point details


About the Properties tab for a publishing point

Use the Properties tab to view and configure properties for your publishing point. You can set limits to manage the resources allocated to this publishing point and enable and disable plug-ins.

The Properties tab displays the following information.

Item | Description
Category | Displays the property and plug-in categories available for the publishing point.
Property or Plug-in | Displays a list of properties and plug-ins available in the selected category. For more information, see About properties and plug-ins.

If you select a category with configurable properties, you can use the following buttons to perform common tasks:

  • Enable. Enables the property or plug-in on the publishing point.
  • Disable. Disables the property or plug-in on the publishing point.
  • Remove plug-in. Marks the plug-in for removal from the list. The plug-in is not removed until you stop or start the server. You cannot remove the last instance of a core system plug-in.
  • Duplicate plug-in. Makes a copy of the selected plug-in, including its configuration.
  • View properties. Displays the properties of the item. Some items do not have configurable settings.
  • Refresh list. (Windows Media Services snap-in only) Reloads all of the registered plug-ins in the selected category.

Web administration feature For Windows Media Services Administrator for the Web

Use the following button and setting to configure additional plug-in or property options:

  • Rename plug-in. In Windows Media Services Administrator for the Web, enables you to rename plug-ins.
  • Select interval. Sets how often the page is refreshed. This setting is found in the Page Loaded area. Select an interval value from never to 60 minutes.

Note Image Note

  • If a publishing point setting conflicts with a server setting, the server setting overrides the publishing point setting.

Related topics

  • Control access to content
  • Logging data and events
  • Plug-in architecture
  • Understanding authentication
  • Understanding authorization
  • Understanding event handler plug-ins
  • Viewing publishing point details


About properties and plug-ins

Plug-ins and properties are used at both the server and publishing point levels to control the operation and configuration of Windows Media Services. Each plug-in and property has its own unique function that affects the operation of the Windows Media server. Many plug-ins and properties regulate the core functionality of the server, and improper settings can affect the ability of the server to stream content or the ability of clients to access content. Plug-ins and properties are categorized into groups in order to identify their function on the server.

This section includes the following topics:

  • Archiving category
  • Authentication category
  • Authorization category
  • Cache/Proxy category
  • Cache/Proxy Management category
  • Control protocol category
  • Credentials category
  • Data source category
  • Event notification category
  • General category
  • Limits category
  • Logging category
  • Media parser category
  • Multicast streaming category
  • Networking category
  • Playlist parser category
  • Playlist transform category
  • Unicast streaming category
  • Wireless category

Note Image Note

The available properties and plug-ins differ depending on which version of Windows Server 2003 you are running. For a complete list of the features available in each version of Windows Media Services, see Comparing versions of Windows Media Services.

Related topics

  • Plug-in architecture
  • Working with the administrative interfaces


Archiving category

Archiving plug-ins enable you to make and maintain a recorded copy of a live broadcast. By adjusting the Archive plug-in properties, you can specify the save location of the archive.

This section includes the following topic:

  • WMS Archive Data Writer - general properties

Related topics

  • About properties and plug-ins


WMS Archive Data Writer - general properties

The WMS Archive Data Writer plug-in is used to write data from a broadcast publishing point to a file. You can configure the following options for the plug-in.

Item | Description
Start archiving when publishing point starts | Select this check box to have the archive plug-in start archiving when the publishing point is started.
Directory Type a path to the archive file, including an archive file name template. The default path is %systemdrive%\WMPub\WMArchive\<V>\Archive_<Y><m><d>.asf, where <V> represents a folder with the same name as the source publishing point. If you are using a remote computer for administration, this path is the archive file location on the server, not on the administration computer. You can use a Universal Naming Convention (UNC) path or an absolute path.

The default archive file name template is Archive_<Y><m><d>.asf, where <Y> is the year, <m>is the month, and <d> is the day. When the archive file is closed, the template is used to determine the appropriate file name. For example, if the archive file is closed on January 1, 2002 and the default file name template is used, the resulting archive file name is Archive_20020101.asf.

You can use environment variables and wildcard characters in the path and archive file name. Environment variables must be delimited by the percent character (%). Wildcard characters must be delimited by less than (<) and greater than (>) characters. For more information about wildcard characters that can be used in naming archive files, see the Archive wildcard characters reference.

If you change the path or name of the archive file after the publishing point has started, you must stop and restart archiving before the change takes effect.

In the Windows Media Services snap-in, you can do the following:

  • Click Browse to specify a new directory and file name for the archive file.
  • Click Expand to display the full path and file name for the current archive file. If the value of the wildcard character cannot be resolved, it will be replaced in the file name by an underscore (_) character. If the value of the wildcard character can be determined when the broadcast publishing point and the archiving plug-in are active, then the wildcard character will be expanded to the placeholder variable, for example <F> will expand to PL_ROLE.

Note Image Notes

  • The broadcast publishing point must be stopped before you can enable the WMS Archive Data Writer plug-in.
  • A new archive file cannot overwrite an existing archive file. A version number is added to the end of the archive file name to differentiate between files, if necessary.
  • Archive files are always saved using the Advanced Systems Format (ASF) regardless of the format of the original content.
  • If the WMS Archive Data Writer plug-in is enabled and packets are lost during streaming, the troubleshooting list displays the event and the number of lost packets.
  • If you are streaming content that includes video and you enable both the WMS Archive Data Writer plug-in and Fast Start on your publishing point, clients that connect to your publishing point may miss the first few seconds of the broadcast. If you want to use the Fast Start feature, it is recommended that you use a different publishing point to create the archive file.
  • By default, archive files are created on the system drive of your server. If you do not have adequate disk space on your system drive, make sure to change the default path. The WMS Archive Data Writer plug-in will stop archiving and post a warning message to the troubleshooting list if you do not have at least 60 megabytes (MB) of free disk space.
  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are saving files to a location other than C:\WMPub and its subdirectories, make sure that the folder is shared and that the Network Service account has read and write permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to save files to it. For more information about rights and permissions, see Understanding rights.
  • In the event of a network outage or stream interruption that exceeds two seconds in length, the archive file is closed. If the publishing point reconnects to the stream, a new archive file is created and starts archiving from that point. The troubleshooting list will report the amount of time lost during the stream interruption.


Authentication category

Authentication plug-ins are used in conjunction with one or more authorization plug-ins to control access to the content on the server. By adjusting the plug-in properties, you can specify how a client's authorization credentials are obtained by the server.

This section includes the following topics:

  • WMS Anonymous User Authentication - general properties
  • WMS Negotiate Authentication
  • WMS Digest Authentication - general properties

Note Image Note

  • The WMS Digest Authentication plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • About properties and plug-ins


WMS Anonymous User Authentication - general properties

The WMS Anonymous User Authentication plug-in provides anonymous users access to your server. If you have enabled other authentication methods on your server, you can also enable the Anonymous User Authentication plug-in to support users that do not have an assigned user name and password. You can configure the following options for this plug-in.

Item | Description
User name | Type the user name you want to assign to anonymous users when they are accessing content. The default user name is WMUS_computername, where computername is the name of the server on which Windows Media Services is running. WMUS_computername is created when you install Windows Media Services.
Password | Type the password associated with the anonymous user account. The password is used only within the Windows operating system; anonymous users do not log on by using a password. During Setup, a password is randomly generated for the WMUS_computername user account, where computername is the name of the server on which Windows Media Services is running. If you change the password for the anonymous user account in the operating system, you must update that password here in order to allow anonymous users access to your content. Passwords are case sensitive.
Confirm password | Retype the password to verify that you entered it correctly.


WMS Negotiate Authentication

The WMS Negotiate Authentication plug-in grants access to the server based upon the user's network logon approval. This plug-in uses an encrypted challenge/response scheme to authenticate users. It is a secure form of authentication because the user name and password are not sent across the network; the player acknowledges the password by using a cryptographic exchange with the Windows Media server. Because the WMS Negotiate Authentication plug-in relies upon established user logon credentials, the player and server must be on the same domain or on trusted domains. Negotiate authentication does not work across proxy servers or other firewall applications.

Note Image Note

  • If the WMS Negotiate Authentication plug-in is enabled, Windows Media Services must have logged on using the Network Service account. Negotiate authentication will not operate if another account is used. For more information about user accounts, rights, and permissions, see Windows Help and Support.


WMS Digest Authentication - general properties

The WMS Digest Authentication plug-in uses hashed encryption to send user names, passwords, and realm information over the network. It is the preferred method for providing secure passwords over the Internet. The server only needs the realm the publishing point or server belongs to in order to obtain the correct decryption key; it does not need the user name or password. You can configure the following option for this plug-in.

Item | Description
Realm | Type the domain to which the publishing point or server belongs. If you do not specify the realm, the user must provide the fully qualified domain name and the user name to obtain access to the server.

Note Image Notes

  • To use the WMS Digest Authentication plug-in, Windows Media Services must be part of a Microsoft Active Directory™ domain. The domain controller for the Active Directory domain must be a computer running Windows Server 2003.
  • Digest authentication is only supported by Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control. Users that attempt to connect using a previous version of the Player will not be able to be authenticated and they will receive an "Access denied" message.
  • The WMS Digest Authentication plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.


Authorization category

Authorization plug-ins use the information obtained by the authentication plug-ins to grant clients access to the content. By adjusting the plug-in properties, you can make access to the content as restrictive or as open as you want.

This section includes the following topics:

  • WMS NTFS ACL Authorization
  • WMS IP Address Authorization - general properties
  • WMS IP Address Authorization - edit IP address
  • WMS Publishing Points ACL Authorization - general properties

Related topics

  • About properties and plug-ins


WMS NTFS ACL Authorization

The WMS NTFS ACL Authorization plug-in is used to control access to your content based on permissions you have set on files and directories in your NTFS file system. You can use this plug-in to grant permissions for users and groups to access your Windows Media server.

Note Image Note

  • If your publishing point references content files on a computer running Windows 2000 Server, you may have difficulty streaming the content due to differences in the way that Windows 2000 Server and Windows Server 2003 handle user account authorization and rights. If the two computers are members of the same domain, on-demand publishing points with the WMS NTFS ACL Authorization plug-in enabled that attempt to retrieve content from the computer running Windows 2000 Server will cause remote clients to receive an error message. Local clients are not affected. If the two computers are not members of the same domain, see To access content on a computer running Windows 2000 Server.


WMS IP Address Authorization - general properties

The WMS IP Address Authorization plug-in is used to control access to your content based on client Internet Protocol (IP) addresses. You can add specific IP addresses or ranges of IP addresses for which you want to allow or restrict access. In the Windows Media Services snap-in, you have the following options for configuring this plug-in.

Item | Description
Set IP address access permissions
Allow all except those in the Deny list | Select this option to restrict certain clients from accessing your server based on their IP addresses. If this permission level is set, all clients have access by default.
Deny all except those in the Allow list | Select this option to allow certain clients to access your server based on their IP addresses. If this permission level is set, all clients do not have access by default.
Restrict as specified in the following lists | Select this option to allow and deny access to the content on your server based on client IP addresses.
Allow Displays the IP addresses and subnet masks that are allowed to access the content on your publishing points.
  • Click Add to add an IP address or subnet to the list.
  • Click Edit to modify an IP address or subnet in the list.
  • Click Remove to delete an IP address or subnet from the list.
Deny Displays a list of IP addresses and subnet masks that are not allowed to access the content on your publishing points.
  • Click Add to add an IP address or subnet to the list.
  • Click Edit to modify an IP address or subnet in the list.
  • Click Remove to delete an IP address or subnet from the list.


WMS IP Address Authorization - edit IP address

In the Windows Media Services snap-in, use the following options to specify which IP addresses or subnets are allowed or denied access to your server.

Item | Description
Single computer | Select this option to add the IP address of a single computer to the list.
IP Address | Type the unique 32-bit address used to identify the computer; for example, 208.147.66.20.
Group of computers | Select this option to add a range of computers based on the subnet address and subnet mask.
Subnet address | Type the unique 32-bit address used to identify a client computer in the group; for example, 208.147.66.20.
Subnet mask | Type the 32-bit number used to evaluate the subnet address and produce a range of IP addresses for the access list; for example, 255.255.255.0.

Note Image Note

  • If an IP address is specified in both the Allow and Deny lists, the Deny list takes precedence. To set a range of addresses, each bit in the mask is compared to the corresponding bit in the IP address. Where the value in the mask is 1, the corresponding bit in the IP address is included in the list. Where the value in the mask is 0, any value is acceptable. In the example, the IP address in the list is 208.147.66.20 and the mask is 255.255.255.0; thus all IP addresses from 208.147.66.0 to 208.147.66.255 are included in the list. If the mask were 255.255.255.128, all IP addresses from 208.147.66.128 to 208.147.66.255 would be included in the list.


WMS Publishing Points ACL Authorization - general properties

The WMS Publishing ACL Authorization plug-in is used to control access to your content based on the permissions you have set on your publishing points. You can use this plug-in to grant permissions for users and groups to access your Windows Media server. You have the following options when adding users to the access list.

Item | Description
Name Displays the users and groups that currently are allowed to access content on your server. Do any of the following:
  • Click Add to add a user or group to the list.
  • Click Remove to remove the selected user or group from the list.
Permissions
Read | Select either the Allow or Deny check box to set whether the user or group can read data from your server.
Write | Select either the Allow or Deny check box to set whether the user or group can write data to your server. You must select both Write and Create in order for a user or group to create a publishing point.
Create When setting permission levels for a server, select either the Allow or Deny check box to set whether the user or group can create publishing points on your server.

When setting permission levels for a publishing point, select either the Allow or Deny check box to set whether the user or group can use this publishing point as a template for creating other publishing points on your server when pushing content from an encoder.

You must select both Write and Create in order for a user or group to create a publishing point.


Cache/Proxy category

Cache/Proxy properties are used to control the behavior of remote cache/proxy servers during the streaming event. By adjusting these properties, the user can specify the frequency with which the cache/proxy server checks the origin server for updated content. The Cache expiration property (in on-demand publishing points) and the Stream splitting property (in broadcast publishing points) use the same properties dialog box.

This section contains the following topics:

  • Cache expiration - general properties
  • Stream splitting expiration - general properties

Note Image Note

  • Cache/proxy services are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About properties and plug-ins


Cache expiration - general properties

Use this dialog box to control how long content streamed from this server (origin server) to another server (cache/proxy server) is valid. You can configure the following options for this plug-in.

Item | Description
After (seconds) | Select this option to have the cache/proxy server check the origin server for updated content after a specified number of seconds has passed. The default setting is 86,400 seconds (24 hours). If the content on the origin server is newer than the content on the cache/proxy server, the cache/proxy server will update its content.
Immediately | Select this option to have the cache/proxy server update the content from the origin server each time a client requests the content from the cache/proxy server.
Never | Select this option to have the cache/proxy server never update the content from the origin server. In order to update the content, the cache/proxy server administrator must explicitly request a new version of the content.


Stream splitting expiration - general properties

Use this dialog box to determine the length of time that content streamed from this origin server to a stream splitting server is valid. You can configure the following options for this property.

Item | Description
After (seconds) | Select this option to have the stream splitting server check the origin server for updated content after the specified number of seconds has passed. The default setting is 86,400 seconds (24 hours). If the content on the origin server is newer than the content on the stream splitting server, the stream splitting server updates its content.
Immediately | Select this option to have the stream splitting server update its content from the origin server each time a client requests the content.
Never | Select this option to have the stream splitting server never update the content from the origin server. In order to update the content, the stream splitting server system administrator must request the new version of the content from the origin server.


Cache/Proxy Management category

Cache/Proxy plug-ins control the ability of your Windows Media server to perform caching and proxy functions. You can obtain third-party cache/proxy plug-ins from a Windows Media-based caching partner or by creating your own by using the Windows Media Services Software Development Kit (SDK).

To view a list of Windows Media-based caching partners, or to download a copy of the Windows Media Services SDK, see the Windows Media home page at the Microsoft Web site.

Note Image Note

  • Cache/proxy services are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About properties and plug-ins


Control protocol category

Control protocol plug-ins control the communication between the Windows Media server and the client. By adjusting the plug-in properties, you can specify which IP addresses and ports can use the protocol.

This section includes the following topics:

  • WMS HTTP Server Control Protocol - general properties
  • WMS MMS Server Control Protocol - general properties
  • WMS RTSP Server Control Protocol - general properties

Related topics

  • About properties and plug-ins


WMS HTTP Server Control Protocol - general properties

The WMS HTTP Server Control Protocol plug-in is used to control Hypertext Transfer Protocol (HTTP) streaming from your server. You can configure the following options for this plug-in.

Item | Description
IP addresses | Settings in this area define how the control protocol can use IP addresses on your server.
Allow all IP addresses to use this protocol | Select this option to allow all of the IP addresses on your server to use HTTP when streaming content.
Allow selected IP addresses to use this protocol | Select this option to allow only those IP addresses you select in the IP address list to use HTTP when streaming content. This option is useful if you have created multiple IP addresses on your server.
Port selection | Settings in the area define the port used by the control protocol.
Use default port | Select this option to use the default HTTP streaming port 80.
Use other port | Select this option to specify a different port to use with HTTP streaming, and then type the port you want to use in the space provided.

Note Image Notes

  • Changes made to this plug-in are applied to new client connection requests only. Clients that are already connected to the server are not affected. .
  • Attempting to use Windows Media Services and a Web service such as Microsoft Internet Information Services (IIS) concurrently on a server can cause conflicts because both services attempt to bind to port 80 by default. You can avoid port conflicts by assigning Windows Media Services to a different port or by creating additional IP addresses so that each service can use port 80 on a separate IP address. For more information, see To add IP addresses to resolve port 80 conflicts.
  • If a server control protocol plug-in is enabled on a Windows Media server with multiple network interface cards, you can prevent IP addresses from using a certain protocol by selecting those addresses in Allow selected IP addresses to use this protocol. If you select Allow selected IP addresses to use this protocol but don't select any of the IP addresses listed, all IP addresses will be allowed to use the protocol. If you do not want to allow any of the IP addresses to use the protocol, you should disable the server control protocol plug-in.
  • Windows Media Services is Internet Protocol version 6 (IPv6) enabled. IPv6 is the newest version of the Internet Protocol and was designed to accommodate the rapidly increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use it when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.


WMS MMS Server Control Protocol - general properties

The WMS MMS Server Control Protocol plug-in is used to control MMS streaming from your server. You can configure the following options for this plug-in.

Item | Description
IP addresses | Settings in this area define how the control protocol can use IP addresses on your server.
Allow all IP addresses to use this protocol | Select this option to allow all of the IP addresses on your server to use the Microsoft Media Server (MMS) protocol when streaming content.
Allow selected IP addresses to use this protocol | Select this option to allow only those IP addresses in the IP address list to use the MMS protocol when streaming content.
Port selection | Settings in the area define the port used by the control protocol.
Use default port | Select this option to use the default MMS streaming port, which is 1755.
Use other port | Select this option to specify a different port to use with MMS streaming, and then type the port you want to use in the space provided.

Note Image Notes

  • Changes made to this plug-in are applied to new client connection requests only. Clients that are already connected to the server are not affected.
  • Multiple IP addresses are available if you have multiple network interface cards or have created multiple virtual IP addresses for your server.
  • Windows Media Services is Internet Protocol version 6 (IPv6) enabled. IPv6 is the newest version of the Internet Protocol and was designed to accommodate the rapidly increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use it when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.
  • If a server control protocol plug-in is enabled on a Windows Media server with multiple network interface cards, you can prevent IP addresses from using a certain protocol by selecting those addresses in Allow selected IP addresses to use this protocol. If you select Allow selected IP addresses to use this protocol but don't select any of the IP addresses listed, all IP addresses will be allowed to use the protocol. If you do not want to allow any of the IP addresses to use the protocol, you should disable the server control protocol plug-in.


WMS RTSP Server Control Protocol - general properties

The WMS RTSP Server Control Protocol plug-in is used to control RTSP streaming from your server. You can configure the following options for this plug-in.

Item | Description
IP addresses | Settings in this area define how the control protocol can use IP addresses on your server.
Allow all IP addresses to use this protocol | Select this option to allow all of the IP addresses on your server to use RTSP when streaming content.
Allow selected IP addresses to use this protocol | Select this option to allow only those IP addresses in the IP address list to use RTSP when streaming content.
Port selection | Settings in the area define the port used by the control protocol.
Use default port | Select this option to use the default RTSP streaming port, which is 554.
Use other port | Select this option to specify a different port to use with RTSP streaming, and then type the port you want to use in the space provided.

Note Image Notes

  • Changes made to this plug-in are applied to new client connection requests only. Clients that are already connected to the server are not affected.
  • Multiple IP addresses are available if you have multiple network interface cards or have created multiple virtual IP addresses for your server.
  • If a server control protocol plug-in is enabled on a Windows Media server with multiple network interface cards, you can prevent IP addresses from using a certain protocol by selecting those addresses in Allow selected IP addresses to use this protocol. If you select Allow selected IP addresses to use this protocol but don't select any of the IP addresses listed, all IP addresses will be allowed to use the protocol. If you do not want to allow any of the IP addresses to use the protocol, you should disable the server control protocol plug-in.
  • Windows Media Services is Internet Protocol version 6 (IPv6) enabled. IPv6 is the newest version of the Internet Protocol and was designed to accommodate the rapidly increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use it when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.


Credentials category

Credentials properties allow your Windows Media server to respond to authentication requests from other servers. By entering values for the properties of the credentials property, you can specify the permissions and access your server will have when communicating with an origin server.

This section includes the following topic:

  • Credentials - general properties

Related topics

  • About properties and plug-ins


Credentials - general properties

Use these settings to enable your server to respond to authentication requests from other servers.

Item | Description
Distribution authentication | Settings in this area identify the user account used for distribution authentication.
User Name | Type the user name that you want the server to use on the network.
Password | Type the password that authenticates the server on the network.
Confirm password | Type the password again to be sure that you have specified it correctly.

Note Image Note

  • The credentials specified in this property are used to respond to authentication requests from other Windows Media servers and from Web servers. If Windows Media Services receives an authentication request from a proxy server, it will use the credentials specified in the proxy settings of the WMS Network Data Source plug-in.

    If Windows Media Services is sourcing from a dynamic playlist and Internet Information Services (IIS) authentication is enabled on the Web server, the user name and password you specify on this tab are used to authenticate the connection. Ensure the user name and password entered in the Credentials Properties dialog box match those required by IIS. For more information about dynamic playlists, see Using dynamic sources.


Data source category

Data source plug-ins enable you to stream content from a variety of sources. By adjusting the properties of the WMS Network Data Source plug-in, you can modify the way Windows Media Services retrieves content over your network.

This section includes the following topics:

  • WMS Network Data Source - general properties
  • WMS Network Data Source - configure protocol properties
  • WMS HTTP Download Data Source
  • WMS Push Data Source
  • WMS File Data Source

Related topics

  • About properties and plug-ins


WMS Network Data Source - general properties

The WMS Network Data Source plug-in permits the server to communicate with and receive streams from encoders or publishing points on other Windows Media servers. This plug-in is enabled by default. You can configure the following options for this plug-in.

Item | Description
Protocols | Settings in this area identify which protocols will by used by the server for RTSP-based streaming.
UDP | Select this check box to use RTSP-based User Datagram Protocol (UDP) distribution to receive data. This type of transmission does not require that the server acknowledge receipt of the data packets.
Receive data on ports | Select this check box to allow the server to receive data on a range of ports; for example, 2037-2046.
TCP | Select this check box to use RTSP-based Transmission Control Protocol (TCP) distribution to receive data. This type of distribution requires that the server acknowledge receipt of the data packets and is considered fully reliable. Even if this check box is not selected, TCP will be used when streaming content using the HTTP protocol.
Proxy settings | Settings in this area control how your server interacts with proxy servers.
Proxy settings | Select the protocol your server will use when it connects to another Windows Media server through a proxy server. Click the Configure button to specify settings for the protocol.

Note Image Notes

  • Changes made to the properties of this plug-in take effect the next time a new data path is created. For on-demand publishing points, this is the next time a client requests a stream. For broadcast publishing points, this is the next time the publishing point is started.
  • Windows Media Services is Internet Protocol version 6 (IPv6) enabled. IPv6 is the newest version of the Internet Protocol and was designed to accommodate the rapidly increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use it when it is available. For more information about IPv6, refer to IPv6 page at the Microsoft Web site.


WMS Network Data Source - configure protocol properties

You can configure proxy server settings to enable your server to connect to another Windows Media server using either HTTP or RTSP. You can configure the following options for each protocol that uses a proxy server.

Item | Description
Use a proxy server | Select this check box to use a proxy server with the selected protocol and complete the following items.
Address | Type the IP address or DNS name of the proxy server.
Port | Type the port through which the proxy server connects to the network.
Proxy server requires authentication | Select this check box if your proxy server requires authentication information from the server, and then type the appropriate information in the space provided.

Note Image Note

  • Changes made to the properties of this plug-in take effect the next time a new data path is created. For on-demand publishing points, this is the next time a client requests a stream. For broadcast publishing points, this is the next time the publishing point is started.


WMS HTTP Download Data Source

When the source of the content streamed by your publishing point is another computer on your network, such as an encoder or another Windows Media server, Windows Media Services uses the WMS Network Data Source plug-in to locate the content. This plug-in is able to read streaming data packets from a network and can use a control protocol plug-in to negotiate a connection to the network source.


WMS Push Data Source

When the source of the content streamed by your publishing point is an encoder, the encoder administrator has the option of broadcasting directly from the encoding program or broadcasting through a Windows Media server. If the administrator chooses to broadcast through a Windows Media server, the encoder can initiate a connection to the Windows Media server, create a broadcast publishing point for its use, and send the stream over the network to the server. This series of events is commonly called an encoder push, because the encoder is pushing the stream to the server for broadcasting. In this situation, Windows Media Services uses the WMS Push Data Source plug-in to maintain the connection between the encoder and the server. This plug-in is able to accept incoming digital media data packets from an encoder.

Note Image Note

  • When the WMS Publishing Points ACL Authorization plug-in is enabled, the encoder administrator must have been granted the appropriate rights and permissions at the server level and publishing point level to be able to create a new publishing point on your server. On the WMS Publishing Points ACL Authorization plug-in property sheet, add the encoder administrator account or the group to which that account belongs and then grant that account both write and create permissions. For more information about the WMS Publishing Points ACL Authorization plug-in and server and publishing point permissions, see WMS Publishing Points ACL Authorization - general properties.


WMS File Data Source

When the source of the content streamed by your publishing point is a local file system, storage area network (SAN), or network-attached storage (NAS) device, Windows Media Services uses the WMS File Data Source plug-in to locate the content. This plug-in is able to read data from the NTFS, FAT, FAT32, or CIFS file systems and can use UNC addressing. If your content is stored by using an alternate file system, then you need to obtain a custom data source plug-in to enable Windows Media Services to read the data.


Event notification category

Event notification plug-ins enable you to control the way that Windows Media Services responds to internal events. By adjusting the properties of the Event notification plug-ins, you can specify which internal events are reported and what action the server takes.

This section includes the following topics:

  • WMS WMI Event Handler - general properties
  • WMS Active Script Event Handler - general properties

Note Image Note

  • The WMS Active Script Event Handler plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • About properties and plug-ins


WMS WMI Event Handler - general properties

The WMI Event Handler plug-in controls which Windows Management Instrumentation (WMI) events Windows Media Services reports. You can select which events to report individually or by clicking either the Select All or Clear All buttons.

Windows Media Services and other programs use these events to respond to activity on your server. Because of the large number and high frequency of client events, the event handler does not report them by default. If you choose to report client events, carefully monitor the performance of your server to make sure that its processor is not overloaded. For more information about event classes and creating custom event handlers, see the Windows Media Services Software Development Kit (SDK). You can configure the following options for this plug-in.

Item | Description
Server | Select this check box to report events that are invoked when the status of the server changes or when a change is made to the server properties.
Client | Select this check box to report events that are invoked when a client connects or disconnects to the server or changes the mode of playback; for example, when the user fast–forwards or stops a digital media file.
Limit | Select this check box to report events that are invoked when the limits of a publishing point or server are modified or reached.
Playlist | Select this check box to report events that are invoked by activity related to broadcast playlists.
Cache | Select this check box to report events that are invoked by activity related to caching content, such as a cache hit or cache miss.
Publishing point | Select this check box to report events that are invoked when the status of a publishing point changes or when a change is made to the plug-in properties.
Plug-in | Select this check box to report events that are invoked by any activity related to server or publishing point plug-ins.

Note Image Notes

  • This plug-in is responsible for communicating event information between the Windows Media Services service and other services and programs. Changing the reported events can cause issues with client programs, including the Windows Media Services snap-in and the Windows Media Services Administrator for the Web.
  • In many streaming media scenarios, client events can accumulate rapidly. If you select the Client check box to report client events, the large volume of client events may obscure other, more serious events. Because of this, the Client check box is disabled by default.


WMS Active Script Event Handler - general properties

The WMS Active Script Event Handler plug-in enables you to attach a custom script that you can use to provide feedback about events on your Windows Media server. You can write the script in any scripting language that supports the Microsoft ActiveX scripting interfaces; for example, Microsoft JScript, Microsoft Visual Basic Scripting Edition (VBScript), Perl, PScript, and Python. You can configure the following options for this plug-in.

Item | Description
File name of script to run | Type the name of the script file that you want to run. In the Windows Media Services snap-in, you can also click Browse to locate the file.
Debugging information | Settings in this area determine whether or not you will use a debugger with your script file.
Enable script debugging | Select this option to attach the Microsoft Script Debugger to your script file. If an error is encountered while running the script, the debugger stops the script, traps the error, and presents the error in a dialog box to enable you to troubleshoot the problem.
Last script error information | Settings in this area provide information about the last error encountered when the specified script was run.
Line number | Displays the line number in the script file where the error was encountered.
Character Column | Displays the character number in the line where the error was encountered.
Most recent error message | Displays the error code that the scripting engine encountered.

Note Image Notes

  • To enable script debugging, a script debugger must be installed on your server. You can download the Microsoft Script Debugger from the Microsoft Scripting Technologies page on the Microsoft Web site.
  • The Microsoft Script Debugger does not work with the Network Service account. In order to use the Microsoft Script Debugger with Windows Media Services, you must configure Windows Media Services to use the Local System account. When using the Local System account, Windows Media Services will have limited access to network resources that require authentication when those resources are referenced by using IP addresses. Remember to set Windows Media Services to use the Network Service account when debugging is complete to resume normal operation.
  • The proper script engine must be installed for the debugger to work correctly. The VBScript and JScript engines are installed by default with the Windows operating system. If you use another scripting language, be sure to install the proper script engine.
  • Custom or third-party plug-ins should be located in a protected directory to prevent tampering. The protected directory can be any directory that has been set to deny write permissions to unauthorized users. For more information about restricting directory access, see Windows Help and Support.
  • The WMS Active Script Event Handler plug-in is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.


Plug-in loading properties

You can run authentication, authorization, and event handler plug-ins out-of-process (as executable files) instead of loading them in-process (as a part of the server process). Plug-ins that are loaded in-process as part of the server run faster and respond faster to information requests. Out-of-process plug-ins are slower, but they do not cause the Windows Media server to stop working if they stop responding, so they can be useful in environments where server downtime is an unacceptable risk.

You can configure the following options for this plug-in.

Item | Description
Plug-in loading | Settings in this area define how the plug-in programs are loaded when they start.
In-process | Select this option to have the Windows Media Services service run the plug-in as part of the server process.
Out-of-process | Select this option to have the Windows Media Services service run the plug-in as its own process.

Note Image Note

  • All enabled plug-ins are loaded when the Windows Media Services service starts. If you change the loading behavior of a plug-in, you must stop and restart the service before the change takes effect. For more information about modifying plug-in loading behavior that does not require stopping or restarting the service, see the Windows Media Services Software Development Kit (SDK).


General category

General properties affect the general operation of the Windows Media server. By enabling or disabling these properties, the user can control several basic functions of the server. Different sets of properties are available for servers, on-demand publishing points and broadcast publishing points.

This section includes the following topics:

  • Windows Media Services version
  • Enable Fast Cache
  • Enable caching by cache/proxy servers
  • Enable access to directory content using wildcards
  • Enable stream splitting
  • Start publishing point when first client connects

Related topics

  • About properties and plug-ins


Windows Media Services version

Available only when viewing server properties. Select this property to display the current Windows Media Services version number.


Enable Fast Cache

Available to on-demand and broadcast publishing points. Enable this setting to allow players to cache the content locally prior to playback.

Note Image Notes

  • If you define the src attribute of a server-side playlist media element as being a publishing point on the local server using the lpp:// syntax, you must enable or disable player caching on the source publishing point. Changing the setting of the Enable Fast Cache property on any publishing point except the source will not affect the ability of players to cache content. For more information about the Fast Cache feature, see Understanding Fast Cache.
  • If you are using Fast Cache with a server-side playlist, clients that connect to your server must use the RTSP or MMS protocol to receive the benefit of Fast Cache.


Enable caching by cache/proxy servers

Available to on-demand publishing points only. Enable this property to allow cache/proxy servers to cache the content locally and stream the content to clients from the cache rather than from this server.


Enable access to directory content using wildcards

Available to on-demand publishing points only. Enable this property to allow the contents of a directory to stream to a client in the same manner that a playlist streams a sequence of content.


Enable stream splitting

Available to broadcast publishing points only. Enable this property to allow cache/proxy servers to distribute the broadcast stream to multiple clients.


Start publishing point when first client connects

Available to broadcast publishing points only. Enable this property to have the broadcast publishing point start when the first client connects and requests the content. If this option is not selected, the broadcast publishing point must be started manually.

Note Image Note

  • Manually starting a broadcast publishing point may interfere with the Start publishing point when first client connects property. If you want your broadcast publishing point to start and stop automatically based on client connections, do not manually start the publishing point.


Limits category

Limits properties enable you to specify the performance boundaries for your Windows Media server. By adjusting the Limits properties, you can ensure that your transmission does not exceed the capabilities of your server, your network, or your audience.

This section includes the following topics:

  • Limit player connections
  • Limit outgoing distribution connections
  • Limit aggregate player bandwidth (Kbps)
  • Limit aggregate outgoing distribution bandwidth (Kbps)
  • Limit bandwidth per stream per player (Kbps)
  • Limit bandwidth per outgoing distribution stream (Kbps)
  • Limit connections rate (per second)
  • Limit player timeout inactivity (seconds)
  • Limit connection acknowledgement (seconds)
  • Limit Fast Start bandwidth per player (Kbps)
  • Limit Fast Cache content delivery rate

Related topics

  • About properties and plug-ins


Limit player connections

This property allows you to set the maximum number of player connections.

Note Image Notes

  • To optimize server security when setting player connection limits, you should limit outgoing distribution connections to be equal to or less than the player connection limits.
  • It is possible that a player can bypass the player connection limit by identifying itself as a distribution server. Therefore, it is recommended that you limit the number of distribution server connections as well. For more information about setting limits, see To set limits for a server or publishing point.


Limit outgoing distribution connections

This property allows you to set the maximum number of distribution servers that can connect to this origin server.

Note Image Notes

  • To optimize server security when setting distribution connection limits, you should limit outgoing distribution connections to be equal to or less than the player connection limits.
  • It is possible that a distribution server can bypass the outgoing distribution connection limit by identifying itself as a player. Therefore, it is recommended that you limit the number of player connections as well. For more information about setting limits, see To set limits for a server or publishing point.


Limit aggregate player bandwidth (Kbps)

This property allows you to set the maximum amount of bandwidth in kilobits per second (Kbps) that player connections can use.


Limit aggregate outgoing distribution bandwidth (Kbps)

This property allows you to specify the maximum amount of bandwidth in kilobits per second (Kbps) that distribution server connections can use.


Limit bandwidth per stream per player (Kbps)

This property allows you to specify the maximum amount of bandwidth in kilobits per second (Kbps) that a single player connection can use.


Limit bandwidth per outgoing distribution stream (Kbps)

This property allows you to specify the maximum amount of bandwidth in kilobits per second (Kbps) that a single distribution server connection can use.


Limit connections rate (per second)

This property allows you to specify the maximum number of connection requests processed per second. The default value is 50.


Limit player timeout inactivity (seconds)

This property allows you to specify the number of seconds that a player can remain connected but inactive before being automatically disconnected. The default value is 86,400 seconds (24 hours). This default value supports users pausing playback for an extended period of time and then restarting playback without having to reconnect to the server.


Limit connection acknowledgement (seconds)

This property allows you to specify the number of seconds that the server will wait for the player to respond to a connection acknowledgement request before disconnecting the player. Connection acknowledgement requests are sent to the player by the server to verify that the connection to the player still exists. The default value is 60 seconds. If you are streaming in an environment with high latency, consider increasing this value to correspond with network conditions.


Limit Fast Start bandwidth per player (Kbps)

This property allows you to specify the maximum amount of bandwidth in kilobits per second (Kbps) that a single player can use for accelerated initial buffering of the streaming content.


Limit Fast Cache content delivery rate

This property allows you to limit the acceleration factor of the initial buffering of the streaming content.


Logging category

Logging plug-ins are used to record server and client activity during a streaming media session. By adjusting the properties of the logging plug-ins, you can specify what events are logged and where the log file is stored.

This section includes the following topics:

  • WMS Client Logging - general properties
  • WMS Client Logging - log cycle period
  • WMS Client Logging - advanced properties
  • WMS Client Logging - log entries

Related topics

  • About properties and plug-ins


WMS Client Logging - general properties

The WMS Client Logging plug-in logs the activity of clients that connect to your content. You can use it on both servers and publishing points. You can configure the following options for this plug-in.

Item | Description
Directory The default directory is %systemroot%\System32\LogFiles\WMS\<V>\, where <V> represents a folder with the same name as the publishing point from which the logging data is originating. If the plug-in is logging data for a server, <V> represents the [Global] folder. If you are using a remote computer for administration, the directory is located on the server generating the log file, not the administration computer. You can use UNC format or an absolute address.

The default file name template is WMS_<Y><m><d>.log, where <Y> is the year, <m> is the month, and <d> is the day. When the log file is closed, the template is used to determine the appropriate file name. For example, if the log file is closed on January 1, 2001 and the default file name template is used, the resulting log file name is WMS_20010101.log.

You can use environment variables and wildcard characters. Environment variables must be delimited by the percent character (%). Wildcard characters must be delimited by the less than (<) and greater than (>) characters. For more information on wildcard characters, see the Wildcard characters reference. The following characters will be replaced with an underscore (_) character: <, >, ?, %, ", , or *.

  • In the Windows Media Services snap-in, click Browse to navigate to a new directory for log file storage.
  • Click Expand to display the full path of the current log file.

If the Logging plug-in is enabled, the active log file path is displayed in the Currently logging to box.
Log cycle period Displays the frequency at which the current log file is closed and a new log file is created. The default value is Daily.
  • In the Windows Media Services snap-in, click Modify to set a new log cycle period.
  • In the Windows Media Services Administrator for the Web, set the log cycle period on the same page.

For more information on log cycle period settings, see WMS Client Logging - log cycle period.
Cycle Now | Click to save the current log file and begin a new log.

For information about additional logging properties, see WMS Client Logging - advanced properties and WMS Client Logging - log entries.

Note Image Notes

  • A new log file cannot overwrite an existing log file. A version number is added to the end of the log file name to differentiate between log files, if necessary.
  • A new log file is created each time the Windows Media Services service starts, regardless of the settings on the WMS Client Logging plug-in.


WMS Client Logging - log cycle period

This dialog box defines how often the server creates a log file. You can select one of the following options.

Item | Description
Hourly | Choose this option to have the current log file close and a new one created at the top of each hour.
Daily | Choose this option to have the current log file close and a new one created at midnight of each day.
Weekly | Choose this option to have the current log file close and a new one created every Sunday at midnight.
Monthly | Choose this option to have the current log file close and a new one created at midnight on the first day of each month.
When file size reaches (KB): | Choose this option to have the current log file close and a new one created when the log file reaches the specified file size.
Never | Choose this option to have the current log file continually updated and not cycled automatically. This is useful if you are writing the log file to a named pipe or other network location where a script or another program can extract the data.

For information about additional logging properties, see WMS Client Logging - general properties, WMS Client Logging - advanced properties, and WMS Client Logging - log entries.


WMS Client Logging - advanced properties

The WMS Client Logging plug-in logs the activity of clients that connect to your content. You can use it on both servers and publishing points. You can configure the following options for this plug-in.

Item | Description
Time format | Settings in this area define the time format used in the log entries.
Use Coordinated Universal Time (UTC) | Select this option (the default) to have the log file use Coordinated Universal Time (UTC) when generating log files.
Use local time | Select this option to have the log file use the local time of the server when generating log files.
Buffer | Settings in this area define how the plug-in will save entries to the log file.
Buffer log entries | Select this option (the default) if you want log entries saved to a buffer and then periodically written to the log file. This option optimizes server performance, but there is a risk that some entries may be lost if the Windows Media Services service stops abnormally.
Write log entries to file immediately | Select this option to have the entries written to the log file immediately. This option sets the logging plug-in processes to the highest priority and can cause delays to other server processes.
File format | Settings in this area define the format the plug-in will use when writing log entries to the log file.
Use Unicode characters (UTF-8) | Select this option (the default) to use Unicode text encoding. Unicode is the current standard for text encoding because it supports the widest range of languages and character sets.
Use ANSI characters | Select this option to use American National Standards Institute (ANSI) text encoding. ANSI text was the preferred standard for text encoding prior to the development of Unicode. Some programs require files be in ANSI format.
Log format | Settings in this area define the format of the log file.
Windows Media Services Format | Select this option to use a log format that is designed to be compatible with Fast Streaming technology and to provide practical information about distribution server usage.
Legacy (Windows Media Services 4.1) Format | Select this option to use a log format that is compatible with Windows Media Services version 4.1. The legacy log format is useful when Fast Streaming and distribution servers are not used or when your automated log parsing scripts have not been updated to read the latest log format.

For information about additional logging properties, see WMS Client Logging - general properties and WMS Client Logging - log entries.


WMS Client Logging - log entries

The WMS Client Logging plug-in logs the activity of clients that connect to your content. You can use it on both servers and publishing points. You can configure the following options for this plug-in.

Item | Description
Log entries | Settings in this area define which statistics are to be written to the log file.
Clients connected to the server | Select this check box to gather data from clients that are receiving the stream directly from the server.
Sessions played from a player cache or a cache/proxy server | Select this check box to gather client activity data from downstream servers
Player statistics | Select this check box to have the plug-in save logs that are created by player activity only.
Only player statistics with the Role attribute value | When content is being streamed from a playlist, select this check box to customize which player statistics logs are saved based on the role attribute of the media element. The default role attribute for the logging plug-in is ADVERTISEMENT, which is used to identify a stream in a playlist as an advertisement. If you are using other role attributes, you can type a different role value in the space provided. For more information about the role attribute, see role attribute. The role attribute is not available in the legacy log format.
Distribution server statistics | Select this check box to have the plug-in save logs that are created by distribution server activity.

For information about additional logging properties, see WMS Client Logging - general properties and WMS Client Logging - advanced properties.


Media parser category

Media parser plug-ins enable you to stream specific types of digital media content by using Windows Media Services. By enabling or disabling the media parser plug-ins, you can control the ability of the Windows Media server to stream content.

This section contains the following topics:

  • WMS MP3 Media Parser
  • WMS JPEG Media Parser
  • WMS Windows Media Parser

Related topics

  • About properties and plug-ins


WMS MP3 Media Parser

The MP3 Media Parser plug-in allows Windows Media Services to stream MP3-encoded audio files.

Note Image Note

  • Windows Media Services will not stream variable-bit-rate (VBR) MP3 files.


WMS JPEG Media Parser

The WMS JPEG Media Parser plug-in allows Windows Media Services to stream JPEG-encoded picture files.

Note Image Note

  • Streaming large picture files can cause delays during rendering. To achieve optimal performance, avoid streaming JPEG files larger than 35 kilobytes (KB). In addition, files in JPEG format are not supported by multicast publishing points.


WMS Windows Media Parser

The WMS Windows Media Parser allows Windows Media Services to stream Windows Media files.


Multicast streaming category

Multicast plug-ins enable the distribution of content using multicast streaming. By adjusting the multicast streaming plug-in properties, you can customize your multicast transmission to suit your audience and make the best use of your network capabilities.

This section contains the following topics:

  • WMS Multicast Data Writer - general properties
  • WMS Multicast Data Writer - advanced properties

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About properties and plug-ins


WMS Multicast Data Writer - general properties

The WMS Multicast Data Writer plug-in is used to transmit content through multicast streaming. You can configure the following options for this plug-in.

Item | Description
Destination multicast IP address and port | Settings in this area define how your multicast is broadcast over the network.
IP address | Type the multicast IP address.
Port | Type the port number on the Windows Media server that the multicast will be streamed through. You can use any valid port number between 1 and 65535.
Time-to-live(TTL) | Enter the number of routers (hops) that your multicast can pass through on the network before expiring.
Custom TTL (Windows Media Services Administrator for the Web only) | Type a custom TTL if the value is not available in the Time-to-live (TTL) list.
Enable unicast rollover | Select this check box to enable players to automatically switch to a unicast stream if they cannot receive the stream through multicast.
Use this publishing point | Select this option to allow the current publishing point to stream content by using the Unicast Data Writer plug-in.
Use other publishing point | Select this option to redirect unicast client connection requests to an alternate publishing point, and then type the URL of the publishing point (for example, rtsp://unicast_server/publishing_point_name) in the space provided.

For information about additional WMS Multicast Data Writer properties see, WMS Multicast Data Writer - advanced properties.

Note Image Notes

  • If the properties for this plug-in appear dimmed, you must stop the broadcast publishing point before making any modifications. After modifying this plug-in you must run the Multicast Announcement Wizard again to update the multicast information (.nsc) file with your changes before restarting the publishing point.
  • Windows Media Services is Internet Protocol version 6 (IPv6) enabled. IPv6 is the newest version of the Internet Protocol and was designed to accommodate the rapidly increasing demand for unique IP addresses. IPv6 increases the IP address size from 32 bits to 128 bits to support more levels of addressing hierarchy and a greater number of addressable nodes. Not all networks are configured to use IPv6, but Windows Media Services will automatically use it when it is available. For more information about IPv6, refer to the IPv6 page at the Microsoft Web site.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


WMS Multicast Data Writer - advanced properties

You can configure the following options for this plug-in.

Item | Description
IP address of the network interface card to multicast from | Select the IP address for the network interface card on your server that can use multicast to transmit data over the network.
Logging URL | Type the URL to the Multicast and Advertisement Logging Agent; for example, http://server_name/folder/wmsiislog.dll, where server_name is the name of the Internet Information Server (IIS) computer and folder is the name of the folder on your Web server in which you have placed the Wmsiislog.dll file.

For information about additional WMS Multicast Data Writer properties, see WMS Multicast Data Writer - general properties.

Note Image Notes

  • If the properties for this plug-in are disabled, you must stop the broadcast publishing point before making any modifications. After modifying this plug-in you must run the Multicast Announcement Wizard again to update the multicast information (.nsc) file with your changes before restarting the publishing point.
  • The Multicast and Advertisement Logging Agent installs the Wmsiislog.dll on a Web server that has Internet Information Services 6.0 installed. You are not required to have Wmsiislog.dll on the Windows Media server; however, Wmsiislog.dll must be installed in a directory that is Web-accessible.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Networking category

Networking properties enable you to control how content from a broadcast publishing point is delivered over the network. By selecting certain Networking properties, you can optimize your transmission for the type of content you are streaming.

This section contains the following topic:

  • Enable buffering - general properties

Related topics

  • About properties and plug-ins


Enable buffering - general properties

Use the Enable buffering properties to control how your broadcast publishing point streams data.

You can configure the following options for this property.

Item | Description
Buffer options | Settings in this area define how the server will buffer data.
Buffer content | Select this option if you want the publishing point to buffer data in the server cache before streaming it to clients. This option is selected by default. Buffering decreases the amount of wait time for the stream to start playing, but it also causes the broadcast to be delayed slightly.
Disable buffering | Select this option if the content you are streaming must remain more closely synchronized with client playback.


Playlist parser category

Playlists enable you to structure your content in a specific order. Windows Media Services uses playlist parser plug-ins to translate server-side playlists into content streams that can be sent to clients. By enabling or disabling the playlist parser plug-ins, you can control the ability of the Windows Media server to stream content that is structured in different playlist formats. Windows Media Services contains two playlist parser plug-ins. Additional playlist parsers may be created using the Windows Media Services Software Development Kit (SDK).

This section contains the following topics:

  • WMS Directory Playlist Parser
  • WMS SMIL Playlist Parser

Related topics

  • About properties and plug-ins


WMS Directory Playlist Parser

The WMS Directory Playlist Parser plug-in allows Windows Media Services to stream multiple content files from a directory.


WMS SMIL Playlist Parser

The WMS SMIL Playlist Parser plug-in allows Windows Media Services to use Synchronized Multimedia Integration Language (SMIL)-based playlists.

Note Image Note

  • Windows Media playlist files are Extensible Markup Language (XML) documents that are compliant with the Synchronized Multimedia Integration Language (SMIL) 2.0 language specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.


Playlist transform category

The Playlist transform plug-in provides settings such as loop and shuffle that enable you to control the order that content is streamed from a directory or playlist.

This section includes the following topic:

  • WMS Playlist Transform - general properties

Related topics

  • About properties and plug-ins


WMS Playlist Transform - general properties

The WMS Playlist Transform plug-in is used to control the playback order for the contents of a directory or playlist. You can configure the following options for this plug-in.

Item | Description
Loop | Select this check box if you want the directory or playlist to repeat its contents in sequence continually until stopped by an administrator.
Shuffle | Select this check box if you want the contents of the directory or playlist to be played back in random order.


Unicast streaming category

Unicast plug-ins enable the distribution of content using unicast streaming. By adjusting the unicast streaming plug-in properties, you can specify transmission protocols as well as packet sizes.

This section includes the following topic:

  • WMS Unicast Data Writer - general properties

Related topics

  • About properties and plug-ins


WMS Unicast Data Writer - general properties

The WMS Unicast Data Writer plug-in is used to transmit content through unicast streaming. You can configure the following options for the plug-in.

Item | Description
Protocols | Settings in this area control how unicast streams are transmitted over a network.
TCP | Select this check box to allow unicast transmission of data from application-layer control protocols, such as RTSP and HTTP, by the Transmission Control Protocol (TCP) transport protocol.
UDP | Select this check box to allow unicast transmission of data from application-layer control protocols, such as MMS and RTSP, by the User Datagram Protocol (UDP) transport protocol.
Use default packet size from content | Select this option to have the header information in the content stream determine the optimum packet size for streaming.
Use maximum packet size (in bytes) | Select this option to specify the number of bytes that each streaming packet should contain. The default packet size is 1452 bytes. The minimum number of bytes per packet is 36; the maximum number of bytes per packet is 65507.

Note Image Notes

  • Changes made to this plug-in are applied to new client connection requests only. Clients that are already connected to the server are not affected.
  • When using a UDP-based RTSP protocol (RTSPU), setting the RTSP packet size to a very small value can prevent the Windows Media server from being able to stream. For more information about unicast packet sizes, see How unicast works.


Wireless category

Wireless properties enable you to make your transmission more reliable for clients using wireless networking equipment. By adjusting the Forward Error Correction property settings, you can specify how tolerant your transmission will be of erroneous and missing data.

This section includes the following topic:

  • Forward Error Correction - general properties

Note Image Note

  • Forward error correction is 9 Series available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About properties and plug-ins


Forward Error Correction - general properties

To provide higher-quality content to clients that have unreliable network connections, you can use forward error correction (FEC). FEC sends data packets with redundant data that the client uses to correct missing or corrupted data packets during playback. FEC is useful for wireless networks, satellites, or wide area network (WAN) connections that have long round-trip times between the client and server.

Item | Description
FEC packets per span | Enter the number of redundant data packets that can be sent with each portion of content. The default value is 24. You can enter a value from 0 to 24. A value of 0 disables forward error correction.

Note Image Notes

  • Forward error correction can only be used with players that connect to your server using the RTSPU protocol.
  • In order to use forward error correction, the player must request that the server send FEC data. If you do not limit the amount of FEC data that the server sends by using the FEC packets per span setting, the server will attempt to deliver the amount of FEC data requested by the player. Excessive FEC data requests can cause the server's processor to be overloaded and may result in poor server performance. If you notice that the processor use is out of the normal range, set the FEC packets per span setting to a lower number.
  • Forward error correction is available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, this feature is not supported.

Related topics

  • Controlling streaming behavior
  • Customizing announcement files
  • Understanding Fast Recovery


Working with the Add Publishing Point Wizard

The Add Publishing Point Wizard helps you create a new publishing point on your Windows Media server. You can start the Add Publishing Point Wizard by clicking Add Publishing Point (Wizard) on the Action menu of a server or the Publishing Points item in the console tree. You can also start the wizard by clicking the Add Publishing Point button on the Getting Started tab of those items.

This section provides information to assist you in completing the Add Publishing Point Wizard. This section contains the following topics:

  • Naming the publishing point
  • Determining the content type
  • Selecting the publishing point type
  • Using an existing publishing point
  • Identifying the content location
  • Selecting content playback options
  • Enabling logging
  • Verifying your publishing point options
  • Completing the Add Publishing Point Wizard

Note Image Note

  • The Add Publishing Point Wizard is designed to support common uses of Windows Media Services and does not incorporate advanced features, such as setting up cache/proxy publishing points. To create a new publishing point that uses advanced content sources, on the server Action menu, click Add Publishing Point (Advanced) and complete the dialog box.


Naming the publishing point

Specify the unique identifier for the new publishing point. This identifier will be used in the URL of your publishing point and, thus, should be meaningful to your users. If you are using multiple Windows Media servers, you can use the same publishing point name on each server; for example, server1 can have the publishing point Jazz music and server2 can have the publishing point Jazz music, but you cannot use the same name twice on the same server.

Note Image Notes

  • The characters <>\?%&'#"{}|^[]* are reserved and cannot be used in the publishing point name.
  • When naming a publishing point, you should avoid using names that are identical to those of directories or subdirectories on the Windows Media server. A publishing point with the same name as a directory may interfere with the operation of another publishing point that sources from that directory.


Determining the content type

Specify what type of audio and video content you are going to stream from your publishing point. You have the following content type options available when creating a new publishing point using the Add Publishing Point Wizard:

  • Encoder (a live stream). Select this option to have your server connect to an encoding computer and broadcast the stream created by the encoder. This content is commonly called a live stream because it is not a Windows Media file. However, the content that the encoder is creating can originate from a videotape, a DVD, an .avi file, or a live source such as a camera or microphone.
  • Playlist (a mix of files and/or live streams that you can combine into a continuous stream). Select this option to use your publishing point to stream a sequence of content that has been specified in a playlist.
  • One file (useful for a broadcast of an archived file). Select this option to use the publishing point to stream a single file. Windows Media Services can stream files with the following file name extensions by default: .wma, .wmv, .asf, .wsx, and .mp3.
  • Files (digital media or playlists) in a directory (useful for providing access for on-demand playback through a single publishing point). Select this option to enable your publishing point to stream multiple pieces of content. All of the files in the specified folder will be accessible to clients. You can request a single file by including the file name in the URL, or you can stream all of the files in the directory in a sequence.

Note Image Note

  • You can later change the content that is being streamed from an existing publishing point on the Source tab of the publishing point.

Related topics

  • Reference for content sources
  • Sourcing from playlists, files, and encoders


Selecting the publishing point type

Specify which type of publishing point you want the wizard to create. Windows Media Services uses two different types of publishing points to distribute audio and video content to users. You should select a publishing point type based on the playback scenario you are trying to create for your users. Use the following information to help you make your choice:

  • Broadcast publishing point. Click this option to distribute the content as a synchronized stream controlled by your server. Users that receive this content cannot modify its playback by pausing, rewinding, or fast-forwarding the stream. This type of publishing point is commonly used when the content originates from an encoder, such as for live presentations and radio broadcasts.
  • On-demand publishing point. Click this option to distribute the content only when it is requested by a client. The client requesting the content also controls its playback and can pause, rewind, or fast-forward the content. This type of publishing point is commonly used when the content originates from a file, such as a playlist or other Windows Media file, and can be used for personalized radio stations, online video stores, and self-paced training applications. On-demand publishing points always deliver their content as a unicast stream.

Note Image Notes

  • Broadcast publishing points can deliver their content either as a unicast or a multicast stream. You will choose delivery options for broadcast publishing points later in the wizard. For more information about choosing delivery options, see Choosing delivery options for broadcast publishing points.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Understanding publishing points
  • About on-demand and broadcast playlists
  • Delivering content as a unicast stream
  • Delivering content as a multicast stream


Choosing delivery options for broadcast publishing points

Specify whether you want to deliver content as a unicast or a multicast stream.

Select your delivery method from the following options.

Item | Description
Unicast | Select this option if you want each client to connect to the server and have a unique stream. This option enables you to stream multiple-bit-rate content and use the Fast Streaming features of Windows Media Services. It also allows you to use a wrapper playlist with your publishing point to stream supplementary content.
Multicast | Select this option if you want many clients to be able to connect to the same stream. Your network must be fully multicast-enabled.
Enable unicast rollover | Select this check box if you are streaming content over a network with a mixture of routers and switches, some of which are not multicast-enabled, but you still want to conserve the available network bandwidth when possible.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Delivering content as a multicast stream
  • Delivering content as a unicast stream


Using an existing publishing point

You have the option of using a preexisting publishing point instead of creating a new one. For example, Windows Media Services installs an on-demand publishing point by default that can be used to stream on-demand content without any further configuration. To use the default publishing point, simply place the content in the %systemdrive%\Wmpub\Wmroot directory. You can also change the source of the default publishing point to a playlist or another directory on the Source tab of the default publishing point. If you choose to use an existing publishing point, you will exit the Add Publishing Point Wizard.

Related topics

  • Sourcing from playlists, files, and encoders
  • To stream a directory of files
  • To stream a Windows Media file from an on-demand publishing point


Identifying the content location

Specify where Windows Media Services can locate the content you want to stream from your publishing point. The field on this page differs depending on the content type you selected on the Content Type page. Use the following table to help you determine the proper syntax to use to identify the content location.

Selected content type Location syntax
Encoder On the Encoder URL page, type the URL from which the encoder is sending the content. The URL information is available on the encoder machine. The URL has the following syntax:

http://encoder_name:port

If you do not specify a port number, the server will try to connect to the encoder on the default port of 8080.
Playlist On the File Location page, select one of the following two options:

New Playlist

When you select this option, you do not specify a content location at this time. Instead, the wizard will take you through the steps involved in creating a new playlist. (For more information, see Creating a new playlist file.) When you save the new playlist file, you will specify a location that will be used as the content location for the publishing point.

-or-

Existing playlist

When you select this option, you specify the location of the playlist file using a local path or an URL. For example:

C:\Folder\Playlist.wsx
http://web_server/playlist.wsx

Windows Media playlist files use a .wsx file name extension.
One File On the File Location page, type the name and location of the file you want to stream. The file can be locally stored on the server or available on a remote drive through a local area network (LAN). For example:

C:\Folder\File_name.wmv

\\Computer_Name\Folder\File_name.wmv

Windows Media Services can stream files with the following file name extensions by default: .wma, .wmv, .asf, .wsx, and .mp3.
Files On the Directory Location page, type the directory path to the content you want to stream. For example:

C:\Folder

\\Computer_Name\Folder

If you are creating an on-demand publishing point, select the Enable access to directory content using wildcards check box if you want to be able to stream all of the files in the directory in order. You can then use an announcement file to determine whether users will be connecting to a single file or to all of the files in the directory.

Note Image Notes

  • If your content location is a folder on another computer on your network, make sure that the folder is shared and that the server computer has at least read access to the folder. This allows the server to connect to the resource even if the system administrator is logged off. For more information about setting sharing permissions in Windows, see Windows Help and Support.
  • The Add Publishing Point Wizard does not allow you to use multicast information files (files with .nsc file name extensions) as a content source. If you need to use your new publishing to rebroadcast content from a multicast broadcast publishing point specify a file content source here and then modify the publishing point using the instructions in To use a multicast stream as a content source.


Creating a new playlist file

A playlist file is used to cause a sequence of content to play in a specific order. To add items to your playlist, click either Add Media or Add Advertisement and use the associated dialog box to select the content you want to add.

Once you have items in your playlist, you can select an item and then click Move Up or Move Down to change the playback order. If you have added a file that you do not want in your playlist, click the file and then click Remove to remove it from the playlist.

Note Image Note

  • To modify your playlist file after your publishing point has been created, use the Source tab of your publishing point. You can modify a playlist file during a broadcast using the toolbar and tree control.

Related topics

  • Creating and editing offline playlists
  • Editing online playlists
  • Understanding playlists


Adding media elements to the playlist file

When adding media elements to your playlist, you can choose from any of the following types of content and then specify the appropriate path:

  • File. The content is in a supported file format and stored in an accessible location, such as a local drive, a shared network drive, or database. By default, Windows Media Services can stream files with the following file name extensions: .asf, .wma, .wmv, .mp3, and .wsx. Type the path to the file or click Browse to locate the file, for example, C:\Folder\File_Name. If you click Browse, you can make multiple file selections by pressing the CTRL key while you click other files that you want to select. The files will appear in the playlist in the order they were selected. To select multiple consecutive files, click the first file, press and hold SHIFT, and click the last file.
  • Encoder. The content is being streamed from an encoding program, such as Windows Media Encoder. Type the URL of the encoder; for example, http://encoder_name:port.
  • Remote publishing point. The content is being streamed from a broadcast publishing point on another Windows Media server to be redistributed from this publishing point. When distributing content from a remote publishing point, be sure to use a reliable connection protocol such as RTSP or HTTP when specifying the connection URL; for example, rtsp://originserver/pubptname.
  • Dynamic source. The request for a content item is being generated by an Active Server Page (ASP) or a Common Gateway Interface (CGI) script. Type the URL of the ASP page; for example, http://webserver/content_requests.asp.
  • Playlist. The content is referenced by a playlist. By default, Windows Media playlist files have a .wsx file name extension. Type the path to the playlist file or click Browse to locate the file; for example, C:\Playlist_Folder\Playlist_File.wsx.
  • Directory. The content is located in a locally accessible directory. Only the content in the directory specified is streamed. Subdirectories are not included. Type the directory path or click Browse to locate the directory (wildcard characters are not necessary); for example, C:\Computer_Name\Folder.

Note Image Note

  • In order to ensure reliable rendering on certain versions of Windows Media Player, content used with Windows Media Services must meet or exceed the minimum content length supported by the Player. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.


Adding interstitial advertisements to the playlist file

An advertisement can originate from your local file system or from an Advertising Service Vendor. When the advertisement is added to your playlist, its role attribute is marked as advertisement and its noSkip attribute is marked as TRUE. This allows you to filter logging data and makes the playback of the file mandatory if the user wants to continue to receive the content in the playlist.

In Identify the location of the advertisement, type the directory path or click Browse to locate your advertising content. If you want to specify advertising content supplied by an advertising partner, type the URL of the remote server.

Note Image Note

  • In order to ensure reliable rendering on certain versions of Windows Media Player, content used with Windows Media Services must meet or exceed the minimum content length supported by the Player. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.


Saving the playlist file

Once you have added content to a playlist, it must be saved as a .wsx file in order for the publishing point to stream the content. In File name, type the location where you want the file to be saved and specify a name for the playlist file.

Note Image Note

  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are saving your playlist file to a location other than C:\WMPub and its subdirectories, make sure that the folder is shared and that the Network Service account has at read and write permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to save to it. For more information about rights and permissions, see Understanding rights.

Related topics

  • Creating and editing offline playlists
  • Editing online playlists
  • Understanding playlists


Selecting content playback options

You have the following content playback options:

  • Loop. Select Loop to set the publishing point to play continuously. For an on-demand publishing point, the stream will repeat until stopped by the player or until the player disconnects. For broadcast publishing points, the stream will repeat until stopped by the server administrator.
  • Shuffle. Select Shuffle to set the contents of the publishing point to play in random order without repeating.

Selecting both of these options will provide continuous, randomized playback of the content specified by this publishing point, creating a user experience similar to a 24-hour unattended radio station.

Note Image Note

  • You can change these settings after your publishing point is created by using the property sheet for the WMS Playlist Transform plug-in, which can be accessed on the Properties tab of your publishing point. These settings only apply to publishing points that are streaming content from a playlist or a directory that contains more than one entry or digital media file.


Enabling logging

By logging data, you can perform tasks such as determining what content is most popular and which times of day your server is busiest. Through the Add Publishing Point Wizard, you can enable the WMS Client Logging plug-in, which logs data about clients that receive content as a unicast stream. After completing the wizard, go to the Properties tab of your publishing point and view the property sheet for the WMS Client Logging plug-in to see the location of the log file and to make any configuration changes.

Note Image Note

  • To log data about clients that receive data as a multicast stream, you must use a Windows Media Internet Server Application Programming Interface (ISAPI) extension (wmsiislog.dll). For more information on multicast client logging, see Logging data about multicast streams.

Related topics

  • Log file entries reference
  • Logging data about unicast streams


Verifying your publishing point options

You should verify the choices that you made in the wizard before creating the publishing point. If you want to change any of your choices, you can click Back until you return to the specific page that you want to change.

After the publishing point is created, you can modify all of the options except the publishing point type by using the different tabs available in the details pane of the Windows Media Services snap-in.

Related topics

  • About publishing point types
  • Understanding publishing points


Completing the Add Publishing Point Wizard

Before completing the Add Publishing Point Wizard, you have several options.

Select the After the wizard finishes check box to do any of the following:

  • Create an announcement. Click this option to launch the announcement wizard that takes you through the process of creating an announcement. The announcement wizard can also be started at any time from the Announce tab of the publishing point.
  • Create a wrapper playlist. Click this option to launch the Create Wrapper Wizard, which helps you create a wrapper playlist for your content. The Create Wrapper Wizard can also be started at any time by clicking the Wrapper Editor button on the Advertising tab of the publishing point.
  • Create both a wrapper playlist and an announcement. Click this option to start the Create Wrapper Wizard and the corresponding announcement wizard, in that order.
  • Start publishing point when wizard finishes. (Broadcast unicast publishing points only) Select this check box to start broadcasting the content from your publishing point immediately after the wizard finishes. If you want to start it later instead, you can click Start on the Action menu of the publishing point.
  • Start archiving when publishing point starts. (Broadcast unicast publishing points only) Select this check box to begin recording your broadcast to an archive file when the publishing point is activated. You can change the properties of the WMS Archive Data Writer plug-in on the Properties tab of your publishing point. You can also manually start and stop archiving using the buttons on the Source tab of your publishing point.

After the Add Publishing Point Wizard has finished, a new publishing point will be visible in the console tree of the Windows Media Services snap-in. Click the publishing point name to monitor and modify the settings for that publishing point.

Note Image Note

  • Selecting the Start publishing point when wizard finishes check box on this page may interfere with the Start publishing point when first client connects property. If you want your broadcast publishing point to start and stop automatically based on client connections, do not select the Start publishing point when wizard finishes check box and do not start the publishing point manually.

Related topics

  • About announcements
  • About publishing point types
  • Archiving content
  • To start a broadcast publishing point


Working with the Create Wrapper Wizard

You can use a wrapper playlist with any publishing point that uses unicast transmission. The wrapper playlist is a simple way to put introductory or closing content before or after the main content.

This section contains the following topics:

  • Creating a new wrapper playlist file
  • Saving the wrapper playlist file
  • Completing the Create Wrapper Wizard


Creating a new wrapper playlist file

By default, the wrapper playlist contains the item Content requested by client, which represents the content the user requests from the publishing point. This item must be included in the wrapper playlist or the user will receive only the wrapper and not the rest of the content on the publishing point.

To add content to the wrapper playlist, click Add. After you add items to your wrapper playlist, you can arrange the playback order by using the Move Up or Move Down buttons. To remove an item from the wrapper playlist, click the file, and then click Remove.

Note Image Notes

  • To modify your wrapper playlist file after creating your publishing point, use the Advertising tab of your publishing point.
  • In order to ensure reliable rendering on certain versions of Windows Media Player, content used with Windows Media Services must meet or exceed the minimum content length supported by the Player. The minimum supported content length for Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds.


Saving the wrapper playlist file

After you have added content to a wrapper playlist, you must save it as a .wsx file in order for the publishing point to stream it. In File name, type the location where you want the file to be saved and specify a name for the wrapper playlist file.


Completing the Create Wrapper Wizard

After you complete the Create Wrapper Wizard, you may have one or both of the following options:

  • Start publishing point when wizard finishes (broadcast publishing points only). Select this check box to have the broadcast publishing point start streaming when the wizard finishes.
  • Enable wrapper playlist when wizard finishes. Select this check box to apply the wrapper you just created to the currently selected publishing point.


Working with the announcement wizards

This section provides information to assist you in completing the announcement wizards. This section contains the following topics:

  • Working with the Unicast Announcement Wizard
  • Working with the Multicast Announcement Wizard
  • Testing the announcement files

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • About multicast information files
  • About announcements


Working with the Unicast Announcement Wizard

If you are delivering content as a unicast stream, either through an on-demand publishing point or a broadcast publishing point, use the Unicast Announcement Wizard to create an announcement. This section contains the following topics:

  • Announcing an on-demand directory
  • Specifying the access to the content
  • Modifying the server name
  • Selecting the announcement options
  • Editing announcement metadata
  • Completing the Unicast Announcement Wizard


Announcing an on-demand directory

If you have sourced the publishing point from a directory, you have the option of announcing either a single file or all of the files in the directory.

  • A file in the directory. Click this option to create an announcement file that directs Windows Media Player to connect to the file specified in the text box. Type the name of the file or click Browse to locate it.
  • All files in the directory. Click this option to create an announcement file that directs Windows Media Player to connect to the publishing point using a wildcard character. This causes all of the files in the directory to be streamed to the Player. To use this option, you must enable the Enable access to directory content using wildcards property on the Properties tab of the publishing point.


Specifying the access to the content

To connect to the content, the player must be directed to the URL of the content. This URL will be included in the announcement file created by the wizard.

  • URL to content. The URL displayed in the text box contains the default control protocol, the Domain Name System (DNS) name of the Windows Media server, and the location of the content on the server, such as a publishing point or a publishing point and a file name.

Click Modify to modify the server name used in the announcement file. For more information, see Modifying the server name.

Note Image Note

  • If you are sourcing your content from a directory or playlist and have enabled the Enable access to directory content using wildcards property on the Properties tab, the URL of the content can use an asterisk (*) wildcard character to replace the file name or the file name and extension; for example *.wma, or *.*. It cannot be used to replace portions of a file name or extension.


Modifying the server name

In some circumstances you may need to have a different server name in the announcement file. For example:

  • Your server is inside a firewall.
  • Your clients cannot resolve the Domain Name System (DNS) entry.
  • You are creating an announcement to be used by an alternate server.

To specify a different server, type the IP address or DNS name of the server in the space provided in the Modify Server Name dialog box.


Selecting the announcement options

You must provide a name and a location for the announcement file. In addition to creating an announcement file, the wizard can also create Web pages that make it easier to place a link to the announcement on a Web server. If you have a Web page to which you want to add an embedded player, the wizard can also copy the syntax for embedding a Windows Media Player ActiveX control to the Clipboard so you can easily paste it into the source code of an existing Web page.

  • Announcement file (.asx) name and location. Type the location in which you want to save the announcement file and the name you want for the file in the text box or accept the default. The default setting uses the publishing point name as the file name and saves the announcement file in the %systemdrive%\Inetpub\Wwwroot folder. If you are not using Internet Information Services (IIS) to distribute your announcement file, you should change the path to a more suitable location.
  • Create a Web page with an embedded player and a link to the content. Select this option to create a Web page with an embedded Windows Media Player ActiveX control. This Web page links to the publishing point and also enables the user to click a link to open the content in a stand-alone Player. When a user clicks the stand-alone Player link on the Web page, Windows Media Player starts and then connects to the content using the publishing point URL. If the user simply views the Web page, the content is streamed to the embedded Windows Media Player and is visible in the browser frame after the Web page is rendered. The syntax used to embed the Player control and create the Web page is compatible with most standard browsers. In the space provided, type the location of your Web server and the name you want for the Web page or accept the default.
  • Copy the syntax for embedding a player in a Web page to the clipboard. Select this option to have the wizard copy the HTML code used to create a Web page with an embedded Windows Media Player ActiveX control version 7 or later to the Clipboard of your operating system. You can then paste the HTML code into whichever Web development program you are using. The code supplied by the wizard includes options for scripting, Netscape Navigator support, and the URL of the publishing point you are announcing.


Editing announcement metadata

By adding metadata to your announcement file (the file with an .asx file name extension), you can provide information that will appear in the captioning area of Windows Media Player when users receive the content. You can also specify the location to which the Player sends client log information. All entries on this wizard page are optional.

  • Title. Type the name of the content you are announcing.
  • Author. Type the producer of the content you are announcing.
  • Copyright. Type the legal owner of the copyright of the content you are announcing.
  • Banner. Type the location of the banner that you want to appear in the banner area of the player.
  • LogURL. Type the location of the Web server to which the Player posts log files for this content. The URL must point to a Web server that can process logging requests. For example, the LogURL can be to an ISAPI application such as http://example.microsoft.com/logs/wmsiislog.dll, a CGI script such as http://example.microsoft.com/cgi-bin/script.pl, or an ASP page such as http://example.microsoft.com/logs/log_page.asp. If you are posting logs to a secure Web server, you should use the https:// prefix.

When a player connects to a unicast stream, it submits log data back to the Windows Media server. By including a value for this property in your announcement file, the player submits two sets of log data: one to the Windows Media server and one to the Web server you specify in LogURL.

If you are announcing a multicast stream and have already specified the URL of a Web server on the Multicast Logging page, you can leave this property blank or specify an additional Web server. The URL of the Web server specified on the Multicast Logging page is saved to the multicast information file, while this URL is saved to the announcement file. If the same Web server address is specified on both pages, the log files will be submitted to the Web server twice.

Note Image Notes

  • If you want to submit logging information to additional Web servers, you can add the following syntax to the .asx file by using a text editor:<LOGURL HREF="http://web_server_name/log_folder_name/logging_page_name" />.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Completing the Unicast Announcement Wizard

Click Finish to complete the wizard. The wizard may create the following types of files:

  • Announcement file (.asx). A metafile for insertion into a Web page or e-mail that points the player to the content.
  • Web page (.htm). A Web page with an embedded Windows Media Player ActiveX control and a link to the URL for the content.

Select Test files when this wizard finishes to open a test page immediately after the wizard completes. The test page provides an easy way for you to verify that the files created by the Unicast Announcement Wizard are ready for use.


Working with the Multicast Announcement Wizard

If you are delivering content as a multicast stream through a broadcast publishing point, use the Multicast Announcement Wizard to create an announcement. This section contains the following topics:

  • Specifying the files to create
  • Retrieving stream format information
  • Identifying stream formats
  • Enabling multicast logging
  • Saving the multicast announcement files
  • Specifying the URL to the multicast information file
  • Specifying an archive location
  • Completing the Multicast Announcement Wizard

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Specifying the files to create

Select which of the following types of files you want the wizard to create:

  • Multicast information file (.nsc) and announcement file (.asx). Click to have the wizard create an announcement file (a file with an .asx file name extension) and a multicast information file (a file with an .nsc file name extension). The announcement file directs users to the location of the multicast information file. The multicast information file provides the player with the information it needs to connect to the multicast and render the stream. Select this option if this is the first time you have announced this publishing point.
  • Automatically create a Web page. Select this checkbox to have the wizard create a Web page with an embedded player control that accesses the multicast stream.
  • Multicast information file (.nsc). Click to have the wizard only create the multicast information file. This is useful if you have already announced the content but need to update the stream format or if you have reconfigured the WMS Multicast Data Writer plug-in on the Properties tab of the publishing point.
  • Announcement file (.asx). Click to have the wizard only create the announcement file. This is useful if you have already created the .nsc file but need to update the location of the announcement file.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Retrieving stream format information

When you are pulling a stream from an encoder for a multicast broadcast, you need to provide the players with the information necessary to decode the stream. You have the following options for obtaining encoder stream format information:

  • Automatically retrieve stream formats from my encoder (suitable only when the encoder is running). Select this option to have the server connect to the encoder and retreive the stream format file from the header information.
  • Manually select stream formats (recommended when the encoder is not running or when using an existing stream format). Select to locate a stream format file manually. If the encoder is not running, you must select this option.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Identifying stream formats

Identify the format or formats of the content by either identifying the source file or files to be streamed or by identifying the appropriate stream format file from Windows Media Encoder. The encoder system administrator can provide you with the stream format file.

All the stream formats used in your multicast session must be idenitfied either by locating the Windows Media file or by locating the stream format file provided by the encoder. To identify the stream formats do the following:

  • Click Add to open the Add Stream Formats dialog box .
  • In the Location of content text box, type the path or browse to the stream format file (if you are streaming content from an encoder) or to the source file or files (if you are not streaming from an encoder).
  • Select multiple files by using ctrl-click in the Browse window or by clicking Add after each file is selected. Once all of the files have been added click OK.
  • The selected files are displayed in the list on the Stream Formats page. If any have been inadvertently added, click Remove to remove them from the list.

Stream formats contain information a player needs to decode a stream, including codecs, bit rates, and frame sizes. If your content was encoded using different codecs, bit rates, frame sizes, and so on, ensure that you add each type of content to the stream format list. If you need to change the list of stream formats after creating an announcement for a multicast stream, you can run the announcement wizard again to create a new multicast information file. You are not required to create a new announcement.

Click Remove to delete a stream format from the list.

Note Image Notes

  • Multicast information files must include all the stream formats used by your content. If the stream format is not listed in the stream format file, clients cannot access the multicast stream. If clients access your content through a manually or dynamically-generated server-side playlist, ensure that the multicast information file includes each stream format used.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Enabling multicast logging

You must specify the URL of the Web server location where you placed the Windows Media Internet Server Application Programming Interface (ISAPI) logging application (wmsiislog.dll). This DLL must be configured to be executed by Internet Information Services (IIS) in order for it to log information about clients that connect to your multicast.

  • Yes, enable logging for this publishing point. Select this option to log information about your multicast streaming session.
  • Logging URL. Type the logging URL in the text box. The logging URL is the URL of wmsiislog.dll. For example, if you have placed the DLL in the scripts directory of wwwroot, the URL would be http://IIS_server_name/scripts/wmsiislog.dll.

Note Image Notes

  • The logging URL can also be modified in the Properties page of the WMS Multicast Data Writer plug-in. Changes made to the plug-in properties after creation of the multicast information file invalidate the announcement file and require that you run the announcement wizard again to update the file.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Saving the multicast announcement files

Depending on the selections you made in the wizard, you must to name and save some or all of the following types of files:

  • Multicast information file name. Enter a name and location for the multicast information file or accept the default. The file must have an .nsc file name extension. This file contains information a player needs to access and decode the stream, such as the IP address, port, and stream format. You should save this file to a location that can be accessed by clients when they are connecting to your multicast broadcast, such as a network shared folder or a Web folder. Clients must obtain this file before they can receive a multicast stream.
  • Announcement file name. Enter a name and location for the announcement file or accept the default. This file directs clients to the multicast information file. It can either be directly opened by the player or embedded within a Web page. If you are going to use your announcement file with a Web page, make sure to save it in a location that is accessible to your Web server and clients.
  • Web page with embedded player. Enter a name and location for the Web page or accept the default. This is an automatically generated Web page with an embedded Player control that a user can use to access the multicast stream. You should save this file in a location that can be referenced by your Web server.
  • Copy syntax for embedding a player to clipboard. Select this check box if you want to copy the HTML code for the embedded Player control to the Clipboard. You can then use the code as part of an existing Web page.

Note Image Notes

  • If you make the multicast information file available on your Web server, be sure to configure the Web server to either not allow caching of the file or to require a "freshness" check when cached by a client. This will prevent players from using multicast information that is outdated.
  • If you want to select the Test files when this wizard finishes option at the end of the wizard, you must either enable Internet Information Services (IIS) on your computer or save the .nsc file to a computer that has IIS enabled or to a public Universal Naming Convention (UNC) share location. Then, on the Specify URL to Multicast Information File page, select the Network share option.
  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are saving files to a location other than C:\WMPub and its subdirectories, make sure that the folder is shared and that the Network Service account has read and write permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to save files to it. For more information about rights and permissions, see Understanding rights.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Specifying the URL to the multicast information file

Determine the method that players can use to access the multicast information (.nsc) file. The player needs to access the multicast information (.nsc) file either from an HTTP server or a UNC path. If you specify a UNC path, the player must have at least read permission to the path.

  • Web server. Click this option if you will make the .nsc file available by using a Web site. Accept the default name and location or enter a different one.
  • Network share. Click this option if you will be making the .nsc file available by sharing a network resource. Enter the path and file name of the multicast information file you want the player to access.

Note Image Notes

  • If the Web server address of your .nsc file specifies a port other than 80, you must specify the port in the URL. The following is an example of a URL that uses a non-standard port: http://computername.domain.com:83/broadcast.nsc.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Specifying an archive location

An archive is a recording of your broadcast stream. If you choose to create an archive of your broadcast, the archive is saved to a file that can be played back later or made available as on-demand content. This page contains the following options:

  • Do you want to create an archive for your multicast? If you click No, an archive file will not be created. If you click Yes, an archive file will be created and saved to the location you specify.
  • Archive location. Type the location where you want the file to be saved. You can specify a name for the archive file or use the default. The default archive name is Archive_<Y><M><D>.asf. When the archive file is created <Y><M><D>.are replaced with the year, month, and date that the archive file was created. For more information about the wildcard characters that can be used in file names see Archive wildcard characters reference.
  • Automatically start archiving when publishing point starts. Select this check box if you want the archive to start when the publishing point starts.

Note Image Notes

  • The server does not use your user account to access folders and other resources; it uses the Network Service account by default. If you are saving files to a location other than C:\WMPub and its subdirectories, make sure that the folder is shared and that the Network Service account has read and write permissions for the folder. If the Network Service account does not have permissions for a folder, the server will not be able to save files to it. For more information about rights and permissions, see Understanding rights.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Completing the Multicast Announcement Wizard

Click Finish to complete the wizard. The wizard may create the following types of files:

  • Multicast information file (.nsc). The file that contains the stream format information and multicast address.
  • Announcement file (.asx). The redirector file that points the player to the multicast information file.
  • Web page (.htm). The Web page with the embedded Windows Media Player ActiveX control and a link to the multicast information file.

Optionally, you can select the following check boxes to perform the following tasks after the wizard has created the announcement files:

  • Test files when this wizard finishes. Select to open a test page immediately after this page closes. The test page provides an easy way for you to verify that the files created by the announcement wizard are ready for use.
  • Start publishing point when wizard finishes. Select to have the publishing point start sending out the stream as soon as the wizard finishes.

Note Image Notes

  • If you want to select the Test files when this wizard finishes option at the end of the wizard, you must either enable Internet Information Services (IIS) on your computer or save the .nsc file to a computer that has IIS enabled or to a public Universal Naming Convention (UNC) share location. Then, on the Specify URL to Multicast Information File page, select the Network share option.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Testing the announcement files

From this page, you can test the files created by the announcement wizard.

  • Test announcement. Click Test to start Windows Media Player and connect to the stream.
  • Test Web page with an embedded player. Click the Test button to open the Web page in your browser. You will be able to see the stream from your publishing point in the embedded Player.

Note Image Notes

  • If the content does not play back during the test, check the following:
    1. If you accepted the default file locations for the multicast information file and the announcement file, ensure that you are running Internet Information Services (IIS) on the same server as Windows Media Services. If you are not running IIS, clients cannot access the multicast information file.
    2. Because Windows Media Services logs on using the Network Service account, make sure that all files and folders that you are accessing have granted read permissions to the Network Service account.
    3. Make sure that the URL of the multicast information file matches the location of the multicast information file.
  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.


Troubleshooting

This section provides information to help you resolve common issues with Windows Media Services. This section contains the following topics:

  • Frequently asked questions. A list of frequently asked questions and answers about using Windows Media Services.
  • Getting help from other resources. A reference list for other sources of information about Windows Media Services.

Related topics

  • Windows Media Services


Frequently asked questions

The following is a list of frequently asked questions about using Windows Media Services:

  • What is the server list file and do I need to maintain it?
  • Why do I get an error when I try to use a .wav file?
  • Why do I get an error when I try to connect my server to the Windows Media components that came with Windows NT Server 4.0 Service Pack 4?
  • Why can't I get artist or track information for my .mp3 file?
  • How can I add artist or track information to my content?
  • Why don't some of my .mp3 files play?
  • Why are some of the playback controls unavailable on the Player?
  • What is the difference between .asf, .wma, and .wmv files?
  • Can I use Windows Media Services on a domain controller?
  • Why are unicast clients experiencing excessive buffering?
  • Why isn't there a server list in Windows Media Services Administrator for the Web?
  • How can I find out if clients are having difficulty accessing my content?
  • What is the difference between encoder push and encoder pull?
  • Why do ISA clients have trouble connecting to my server using the MMS protocol?
  • Can I use a playlist as an element in another playlist?
  • How can I tell if packet loss has occurred?
  • Can I archive my broadcast to a compressed folder?
  • Will I lose my server settings if I need to reinstall my server?
  • Is there a way to enhance performance when sourcing from an encoder?
  • Why am I having trouble opening Windows Media Services Administrator for the Web?
  • Why can't I see my Windows Media Services counters in performance monitor after I do an upgrade?
  • Why do I get an error when I click Test stream?


What is the server list file and do I need to maintain it?

The server list file contains the names of the Windows Media servers that you can administer with Windows Media Services Administrator for the Web. Generally, you do not need to edit this file directly. However, if the server list is not loading correctly, check the file to verify that the Windows Media server names are entered on separate lines. Windows Media Services Administrator for the Web cannot read data that is separated by tab marks or spaces. If you find that your server list file is formatted incorrectly, you can reformat it manually or delete the server entries and recreate the server list using Windows Media Services Administrator for the Web.

Related topics

  • Troubleshooting


Why do I get an error when I try to use a .wav file?

Windows Media Services supports a wide array of file types; however, .wav files are not supported.

Related topics

  • Troubleshooting


Why do I get an error when I try to connect my server to the Windows Media components that came with Windows NT Server 4.0 Service Pack 4?

Windows Media Services 9 Series can connect to Windows Media Services version 4.1 and Windows Media Encoder version 4.1, that were released with Windows 2000 Server, or to the versions that were subsequently made available for download from the Windows Media Technologies Web site by using the HTTP protocol. (MSBD is no longer a supported protocol.)

Windows Media Services 9 Series does not support using versions of Windows Media Technologies shipped prior to Windows 2000 Server.

Note Image Note

  • Windows Media Services (version 4.1) cannot be used to distribute streams from Windows Media Services 9 Series.

Related topics

  • Troubleshooting


Why can't I get artist or track information for my .mp3 file?

Windows Media Services does not support the ID3v2 header format that supplies this information to .mp3 files. However, this does not prevent you from streaming .mp3 files.

Related topics

  • Troubleshooting


How can I add artist or track information to my content?

You can add a clientData element to each of the media elements in your playlist. A clientData element allows you to specify a wide range of information for each track, including artist information, track information, genre, and so on. This information is then displayed to the user as the player renders the track. For more information about the clientData element, see clientData element. For instructions on how to add a clientData element to a playlist, see To add a clientData element to a playlist.

Related topics

  • Troubleshooting


Why don't some of my .mp3 files play?

Windows Media Services does not support variable-bit-rate .mp3 files. If your .mp3 file was encoded using a variable bit rate, it will not play back as expected when it is streamed from Windows Media Services.

Another problem may be that your .mp3 file content is too short. In order to ensure reliable rendering on certain versions of Windows Media Player, content used with Windows Media Services must meet or exceed the minimum content length supported by the Player. The minimum supported content length Windows Media Player 9 Series is 5 seconds. The minimum supported content length for previous versions of Windows Media Player is 30 seconds. Content that is shorter than this minimum length may not render completely or at all.

Related topics

  • Troubleshooting


Why are some of the playback controls unavailable on the Player?

Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control can use the fast-forward, rewind, pause, and skip controls when rendering streaming media content. However, these features are not available in all streaming situations. The following conditions must be met for users to use all of the playback controls when receiving a stream:

  • Users must be using Windows Media Player 9 Series. The ability to fast-forward, skip, rewind, and pause content within a playlist is only supported by Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control.
  • Content must be streamed from an on-demand publishing point. The fast-forward, skip, rewind, and pause controls are not available to clients when content is streamed from a broadcast publishing point.
  • Content cannot be live. The fast-forward, skip, rewind, and pause controls are not available to clients when content is streamed live from an encoder or a remote publishing point.
  • Content must be indexed. The ability to fast-forward, skip, rewind, and pause content is not available to clients if the content has not been indexed. Indexing can be performed during the encoding process or as a separate process after the content has been encoded.
  • The noSkip attribute must set to False. The ability to fast-forward, skip, rewind, and pause content is not available when the player is rendering content for which the noSkip attribute has been set to True.

Related topics

  • Troubleshooting


What is the difference between .asf, .wma, and .wmv files?

They are all valid file extensions for Windows Media files. The .asf file name extension is used when the content of the file is formatted as Advanced Systems Format (ASF) and is compressed using any codec. If the content was compressed using the Windows Media Audio codec, the .wma file name extension is used. If the content was compressed using the Windows Media Video codec, the .wmv file name extension is used. Some programs may require a file to have an .asf file name extension in order to accept the content. If so, you can simply rename any .wma or .wmv file to use an .asf file name extension and then use them with the program.

Related topics

  • Troubleshooting


Can I use Windows Media Services on a domain controller?

Windows Media Services can run on a server that is also acting as a domain controller. If you want to make an existing Windows Media server configuration act as a domain controller as well, keep the following in mind:

  • If the domain controller is the first domain in a new forest, Windows Media Services will migrate its accounts and settings as expected.
  • If the domain controller is creating a new domain tree in an existing forest, all local user accounts and settings are deleted. This causes an error, and Windows Media Services will not able to stream. To resolve this issue, do the following:
    1. Create a new user account with guest privileges after the server has been promoted to a domain controller.
    2. On the Windows Media server, disable the WMS Anonymous Authentication plug-in.
    3. Configure the properties of the WMS Anonymous Authentication plug-in to use the new user account you created in step 1.
    4. Enable the WMS Anonymous Authentication plug-in.
    5. Stop and then restart the Windows Media Services service.

Related topics

  • Troubleshooting


Why isn't there a server list in Windows Media Services Administrator for the Web?

Under certain circumstances, the security settings for Windows Media Services Administrator for the Web will not permit you to administer multiple servers. In these cases, you can only administer the local host. Some common causes of this condition are:

  • Your browser is not Secure Sockets Layer (SSL) capable. SSL allows secure communication over the Internet using encryption. If SSL is not used, your remote server communications may be vulnerable to interception.
  • You were authenticated using only NTLM. NTLM uses your network logon credentials to provide authentication and is not as secure as direct server authentication.

Related topics

  • Troubleshooting


Why are unicast clients experiencing excessive buffering?

You may be serving too many simultaneous connections. Due to hardware limitations, a Windows Media server can only transmit a limited number of streams at one time. Servers that are overloaded will often lose data, interrupt transmissions, and drop clients. Alternatively, you may be exceeding the bandwidth capacity of your network. Your network may have a weak point or a failure, or it may not have been designed to transfer the amount of data that your clients require.

There are several ways to solve this problem. You can implement any or all of these solutions to ease the data transfer load on your server or network:

  • Set limits on your server. You can configure your server to limit client connections and bandwidth so that the server and network capacities are not exceeded. For more information about setting Windows Media server limits, see Setting server limits.
  • Create a server cluster. You can make a group of Windows Media servers work as one server by using server clusters. While clients connect to the cluster using a single URL, the streaming load is shared by all of the servers in order to reduce the load on an individual server. For more information about server clusters, see Performing load balancing and clustering.
  • Add distribution servers. You can disperse the streaming load over the entire network by using distribution servers at points in the network where streaming demand tends to be highest. This can dramatically improve streaming performance because the distance between the server and client is often reduced. For more information about distribution servers, see Using distribution servers.
  • Modify your streaming media content. You can lower the bandwidth requirements of your content by encoding it differently. For more information about encoding, see Understanding encoding.

Note Image Note

  • If you want to test how your server performs under different client loads, you can download the Windows Media Services Load Simulator from the Windows Media home page at the Microsoft Web site.

Related topics

  • Troubleshooting


How can I find out if clients are having difficulty accessing my content?

It is not always easy to know if clients are receiving your content properly. Many clients do not call your attention to a problem, and client-side errors often are not apparent at the server level.

Logs are extremely valuable for determining the effectiveness of your streaming media broadcast. Whenever you create a publishing point, you should enable the appropriate logging plug-in so you can analyze the successes and failures of your broadcast. A careful review of the logs after a broadcast can often reveal not only what problems have occurred and when, but also a possible solution.

The following log file entries are typically the most helpful when trying to identify a client-side problem:

  • x-duration. This is the amount of time that the player rendered the stream. If the time in this field is less than the overall length of the content, the client may have been dropped.
  • c-status. These are codes that describe the client connection status. Certain common connection problems appear in this field.
  • avgbandwidth. This is the average bandwidth of the connection. If it is lower than the bit rate of the stream from the server, the client may have reduced bandwidth capacity.
  • c-bytes. This is the number of bytes received by the client. If this number differs from the number of bytes sent by the server (sc-bytes), then packet loss has occurred.
  • c-pkts-lost-client. This is the number of packets that were not delivered to the client.
  • c-buffercount. This is the number of times the client buffered the stream. A high buffer count value can indicate bandwidth problems.

For more information about how log files are used to identify streaming problems, see Logging data and events.

Related topics

  • Troubleshooting


What is the difference between encoder push and encoder pull?

In order to accommodate the widest possible range of streaming conditions, Windows Media Services enables you to receive content from an encoder using two different methods: push and pull.

In some live encoding situations, the Windows Media server may not be able to coordinate the content feed between the encoder and the Windows Media server. Other circumstances may require that you maintain control of the broadcast at the content source. You can use the encoder to control the server and "push" the encoded content to a broadcast publishing point. Using encoder push, you can create a new publishing point on the server and set it to delete itself when the broadcast is finished. In order to use the encoder to push a broadcast to the Windows Media server, the encoder administrator must have the Windows Media server name, the URL, and all of the necessary permissions.

When Windows Media Services "pulls" the content from the encoder, the server connects to an encoder stream that is already in progress. Encoder pull is useful if your publishing point is set to start when the first client connects or if the Windows Media server is separated from the encoder by a firewall. In an encoder pull configuration, the encoder must be started and encoding content before the Windows Media server can connect to it. The server publishing point must use the encoder URL as the source of its content.

Related topics

  • Troubleshooting


Why do ISA clients have trouble connecting to my server using the MMS protocol?

The default port that the Microsoft Media Server (MMS) protocol uses is 1755. Some ISA clients may have trouble connecting to this port because ISA uses different connection criteria for ports above 1023.

You can correct this problem in of the following ways:

  • Change the port to which the MMS protocol binds. For more information about configuring the MMS protocol, see To configure the WMS MMS Server Control Protocol plug-in.
  • Create a file called Wspcfg.ini and save it to the folder named %systemroot%\Windows\System32\Windows Media\Server. The file should contain the following text:
    [WMServer]
LocalBindTcpPorts=1755
LocalBindUdpPorts=1755

Related topics

  • Troubleshooting


Can I use a playlist as an element in another playlist?

Yes. This process is known as playlist nesting. Playlist nesting can be useful for creating continuous streams.

In the following example, the playlist named MainPlaylist.wsx makes the publishing point stream continuously by switching between Playlist1.wsx and Playlist2.wsx. You can use this type of playlist to update the content played by the publishing point without ever having to stop streaming.

MainPlaylist.wsx

<smil>
   <media src="playlist1.wsx" />
   <media src="playlist2.wsx" />
</smil>

Playlist1.wsx

<smil>
   <media src="welcome2.asf" />
</smil>

Playlist2.wsx

<smil>
   <media src= "welcome3.asf" />
</smil>

Playlist nesting can cause some unintended effects or server instability if it is not performed properly. For example, a playlist cannot reference itself by using a physical URL such as http://server/playlist.wsx. In this instance, the playlist will not stream and your server may become unstable. In addition, if a playlist uses a local file reference, such as C:\Wmpub\Wmroot\Playlist.wsx, it will fail and then proceed to stream the next item in the playlist.

The server may also become unstable when two playlists reference each other. In the following example, playlist1 references playlist2, which references playlist1. Because the server can never successfully complete a data path for the playlist content, the playlists continue to build up in memory. This implementation will eventually cause the server to become unstable and fail.

Playlist1.wsx

<smil>
<media src = "playlist2.wsx"/>
</smil>

Playlist2.wsx

<smil>
<media src = "playlist1.wsx"/>
</smil>

Related topics

  • Troubleshooting


How can I tell if packet loss has occurred?

Packet loss can occur in a stream from a server to client because of network congestion, router problems, and so on. Packets are also considered to be lost if they arrive too late for the client to play them on time. There are several ways to monitor packet loss.

Tracking packet loss using a log file

You can use a log file to determine if any packets were lost, where the loss occurred, and if any of the lost packets were recovered. The following log file fields help you determine if packet loss occurred:

  • s-pkts-sent. This is the number of content packets sent by the server to a connected client. The value does not include TCP or UDP packets. This field contains a hyphen (-) in remote cache client logs propagated from the cache/proxy server to the origin server and in multicast log files.
  • c-pkts-received. This is the number of packets from the server (s-pkts-sent) that are received correctly by the client on the first try. Packets that are not received correctly on the first try can be recovered if they are resent through the UDP protocol. Packets that are not recovered through UDP resend are considered lost in the network. You can recover these packets if error correction is enabled. The value does not include TCP or UDP packets.
  • c-pkts-lost-client. This is the number of packets lost that were not recovered at the client layer through error correction or at the network layer through UDP resends, during transmission from server to client. These packets are sent by the Windows Media server but never played by the client. The value does not include TCP or UDP packets.
  • c-pkts-lost-net. This is the number of packets lost on the network layer. You can still recover these packets if error correction is enabled. The value does not include TCP or UDP packets.
  • c-pkts-lost-cont-net. This is the maximum number of continuously lost packets on the network layer during transmission from server to client. If the value is high, the network conditions were bad, with long periods of time during which the client received no packets. The value does not include TCP or UDP packets.
  • c-resendreqs. This is the number of client requests to receive new packets. This field contains a zero unless the client is using UDP resend.
  • c-pkts-recovered-ECC. This is the number of packets lost in the network (c-pkts-lost-net) that were repaired and recovered at the client layer because error correction was enabled. Error correction is the only means of packet recovery for multicast streams. Packets repaired and recovered at the client layer are equal to the difference between c-pkts-lost-net and c-pkts-lost-client. The value does not include TCP or UDP packets.
  • c-pkts-recovered-resent. This is the number of packets recovered because they were resent through UDP. The value does not include TCP or UDP packets. This field contains a zero unless the client is using UDP resend.

Tracking packet loss using the WMS Archive Data Writer plug-in

When packets are lost during the streaming or archiving process, the WMS Archive Data Writer plug-in will post a warning message to the Troubleshooting tab in Windows Media Services to report the amount of loss. The plug-in must be enabled in order for the warning to be sent.

Tracking packet loss by observing archiving behavior

If the content stream being received by your server is interrupted by packet loss for a period greater than two seconds, the WMS Archive Data Writer plug-in will stop archiving and begin archiving to a new file when the incoming stream resumes. The presence of several small archive files is an indicator that packet loss is occurring during your broadcast.

Related topics

  • Troubleshooting


Can I archive my broadcast to a compressed folder?

Avoid archiving your broadcast content to compressed folders. Most encoded content files are already compressed and do not benefit significantly from additional compression. In addition, server performance may be reduced.

Related topics

  • Troubleshooting


Will I lose my server settings if I need to reinstall my server?

No. Windows Media Services preserves your server settings whether you are upgrading Windows Media Services or reinstalling it.

Upgrade

When upgrading Windows Media Services, Windows Media server settings are migrated automatically.

Reinstall

You should always uninstall Windows Media Services before attempting to reinstall it. Your server settings are automatically saved during the uninstall process. After reinstalling Windows Media Services, you can manually restore your previous server settings by doing the following:

  1. Stop the Windows Media Services service.
  2. In %systemroot%\Windows\System32\Windows Media\Server, rename the file ServerNamespace.bak to ServerNamespace.xml.
  3. From the command prompt, type WMSServerConfig.exe /repair.
  4. When you start the Windows Media Services service, your server settings are restored.

Related topics

  • Troubleshooting


Is there a way to enhance performance when sourcing from an encoder?

If you are using live content from an encoder as part of a playlist, your clients may experience latency as the server buffers the encoder content. Also, as each client switches to the live content streams, the server must make a new connection to the encoder. This increases network congestion.

By creating an additional publishing point on your server that operates as an intermediary between your main publishing point and the encoder, you can improve network and client-side performance. Performance is improved because the server maintains a single connection to the encoder regardless of how many concurrent clients you are serving. You can create this publishing point by doing the following:

  1. Create two identical broadcast publishing points.
  2. On the first publishing point, configure the publishing point to receive content from the encoder.
  3. Start the publishing point.
  4. Configure the second publishing point to reference a playlist. Add a media element to the playlist that receives content from the first publishing point. Use the address lpp://publishing_point_1 as the source of the media element.
  5. Use the second publishing point to stream the content to your clients.

Related topics

  • Troubleshooting


Why am I having trouble opening Windows Media Services Administrator for the Web?

Windows Media Services Administrator for the Web is a browser-based interface that uses Active Server Pages (ASP) hosted by Internet Information Services (IIS). ASP documents are not compatible with the FAT32 file structure. If you are having difficulty viewing Windows Media Services Administrator for the Web, ensure that your file system does not use the FAT32 architecture.

Related topics

  • Troubleshooting


Why can't I see my Windows Media Services counters in performance monitor after I do an upgrade?

You will not be able to see your counters until you reboot your machine. After setup completes, reboot your Windows Media server and you will be able to see the Windows Media Services counters.

Related topics

  • Troubleshooting


Why do I get an error when I click Test stream?

There are several conditions that can cause an error when you attempt to test the stream from your publishing point. Check for the following conditions:

  • Is the content referenced by the publishing point accessible using Windows explorer?

    If you cannot navigate to the content then the server cannot access it. Check that you have adequate rights to the content location and that your network is operational if the content is located on a network resource.

  • Can the content be played back using Windows Media Player?

    The test stream utility uses the Windows Media Player control to play back content.

  • Is the content contained in a subdirectory?

    If you are streaming content from an on-demand publishing point and the content is located in a subdirectory the Enable access to directory content using wildcards property must be enabled. This property is disabled by default.

Related topics

  • Troubleshooting


Getting help from other resources

The following Web sites contain additional information that can help you when using Windows Media Services:

  • Audio and Video page at MSDN Online. Provides information, advanced methods, and techniques for digital media professionals.
  • Deployment guide. Provides overall strategies you can use to launch your own streaming media project using Windows Media Services.
  • Microsoft Producer for PowerPoint 2002. Provides information about Microsoft Producer for PowerPoint 2002.
  • 8Microsoft Windows - IPv6. This white paper presents an overview of Internet Protocol version 6 (IPv6) technology and information about Microsoft implementations, support, and development of IPv6.
  • Streaming Methods: Web Server vs. Streaming Media Server. Compares the relative advantages of two popular methods of digital media content distribution.
  • Windows Server 2003. Provides the latest news and information about Microsoft Windows Server 2003.
  • Windows Media Application Development. Provides information resources for Windows Media application developers.
  • Windows Media Digital Rights Management. Provides information about protecting the rights of digital media content producers and users.
  • Windows Media Encoder. Provides information about Windows Media Encoder.
  • Windows Media Format . Describes the benefits of Windows Media Format.
  • Windows Media Partner Center. Provides a way to locate worldwide partners who specialize in Windows Media Technologies.
  • Windows Media Player. Provides general information about Windows Media Player.
  • Windows Media Services. Provides the latest news and information about Windows Media Services 9 Series.
  • Windows Media Technologies Download Center. Provides the latest downloadable Windows Media tools, technologies, and updates.
  • Windows Media Technologies. Provides an overview of Windows Media Technologies and links to related information.
  • Windows Media Updates. Provides the latest updates on Windows Media 9 Series.
  • World Wide Web Consortium (W3C). Details the efforts of the World Wide Web Consortium, including their work on Internet Protocol version 6 (IPv6).

Note Image Note

  • Web addresses can change, so you might be unable to connect to the Web site or sites mentioned here.

Related topics

  • Troubleshooting


Playlist reference

Windows Media server-side playlist files are Extensible Markup Language (XML) documents that are based on the Synchronized Multimedia Integration Language (SMIL 2.0) language specification. They are used to enable the server to collect and stream data to clients.

You can create playlist files by using the Windows Media Playlist Editor or by using a text editor such as Notepad. Playlists are then interpreted by the corresponding playlist parser plug-in. Server-side playlist files that use the WMS SMIL Playlist Parser have .wsx file name extensions. Third-parties can build playlist parser plug-ins using the Windows Media Services SDK that have different extensions.

Windows Media playlists are comprised of several different types of playlist elements. The most common playlist elements are media elements, which reference the digital media files and other content sources to be streamed. Other playlist elements define the behavior of elements, the order in which elements play, and text attributes, such as title and author.

This section contains the following topics:

  • Using the Windows Media Playlist Editor
  • Understanding playlist syntax
  • Constructing a playlist
  • Playlist elements
  • Playlist attributes
  • Time formats

Note Image Notes

  • Examples in this section are given in the same XML syntax you would see if you opened a playlist in a text editor. The examples are presented this way in order to depict the entire playlist and enable you to see the interrelation of the various playlist elements and attributes. For more information about the XML syntax used with Windows Media server-side playlists, see Understanding playlist syntax.
  • For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • For additional information about creating server-side playlists, see the Windows Media Services Software Development Kit (SDK), which can be downloaded from the Windows Media home page at the Microsoft Web site.

Related topics

  • Windows Media Services


Using the Windows Media Playlist Editor

You can use the Source tab to view and edit a playlist that has been assigned as the source of a publishing point. If you want to create a new playlist or view and edit any playlist, you can use the Windows Media Playlist Editor.

The Playlist Editor window is composed of a toolbar, a playlist tree, and a properties area. You use the toolbar to add items to your playlist such as songs, video, and advertisements. The items referenced by the playlist are shown in the playlist tree in the Playlist Editor window. You can then modify how the item is played back to the user by modifying the attributes associated with it.

The items in the playlist are referred to as elements and the properties of the items are called attributes. The following illustration shows how these elements and attributes are displayed in the Playlist Editor.

Playlist Editor window

Note Image Notes

  • You can also open the Playlist Editor as a stand-alone program by double-clicking the Wmseditor.exe file, which is located in the folder in which you installed Windows Media Services. By default, this folder is %systemroot%\Windows\System32\Windows Media\Server\Admin\MMC.
  • For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.

Related topics

  • Constructing a playlist
  • Playlist attributes
  • Playlist elements
  • Playlist reference


Understanding playlist syntax

Playlists are based on Extensible Markup Language (XML). One of the advantages of using the Windows Media Playlist Editor to create and edit playlists is that you do not need to know XML code. After you add all the items to your playlist, the Playlist Editor then automatically transforms your playlist into a Synchronized Multimedia Integration Language (SMIL) 2.0-based XML document. Keep in mind that the changes or additions you make to the playlist do not take effect you save the file.

However, if you are familiar with XML, you can create or modify playlist files by using a text editor such as Notepad. The information in this topic should help you gain the basic knowledge you need to read and edit playlists in a text editor, if the need arises.

The following illustration compares how a sample playlist file, Serverside_Playlist.wsx, appears when opened in a text editor versus how it looks when opened in the Playlist Editor. Serverside_Playlist.wsx is provided by default with Windows Media Services.

After you create a playlist file by using either the Playlist Editor or a text editor, you can assign it as the source of a publishing point. If the playlist is the source of an on-demand publishing point, it starts when a client connects to it. If the playlist is the source of a broadcast publishing point, it starts when you start the publishing point. Although Serverside_Playlist.wsx is a fairly simple playlist, you can create complex playlists that are very long and that contain many complex timing and behavior elements. If you are creating your playlist files by using a text editor, make sure to comply with the following guidelines:

  • Elements that contain child elements are defined within a set of start and end tags. Tags are denoted by angle brackets (< and >) that surround the element type. The following is an example of a start tag for a smil element: <smil>. An end tag is denoted by a forward slash (/) preceding the element type, such as </smil>. Everything that follows the start tag and precedes the end tag acts as "instructions" for that element and any elements within it. Elements that do not contain child elements can be written without end tags and within a single pair of angle brackets ending with a forward slash (/), for example <media src="content_clip1.wmv"/>. For a list of all the element types that can be used in a Windows Media playlist file, see Playlist elements.
  • Attributes define name-value pairs that correspond to certain properties of the element. Each element supports a different set of attributes. If an element has specified attributes, they will appear after the element in the XML code. For example, in the following line
    <media noSkip="true" role="advertisement" src="C:\WMPub\WMRoot\advert1.asf"/>

    media is the type of element, and the following attributes and values are specified.

    Attribute | Value
    noSkip | true
    role | advertisement
    src | C:\WMPub\WMRoot\advert1.asf

  • Elements, attributes, and their values are case-sensitive. Make sure that the correct case is used when specifying an attribute value or it will not be recognized during playback. Predefined attribute values, such as begin, end, true, and false should all be specified using lowercase.

The examples used in the playlist reference section depict playlists as they appear in a text editor. Keep in mind that all the examples can also be created or opened using the Playlist Editor.

Related topics

  • About creating and editing playlists
  • About playlist elements
  • Constructing a playlist
  • Playlist reference


Constructing a playlist

A playlist file is made up of seven basic Extensible Markup Language (XML) elements: smil, media, seq, switch, excl, priorityClass, and clientData. An element can either contain information about the element or control the behavior of one or more other elements. By arranging these elements and setting values for their corresponding attributes, you can determine the playback and presentation structure of a playlist.

The organization of the playlist elements defines the playlist's control structure. For example, if you open a playlist in a text editor, you will notice that some playlist elements are enclosed within other playlist elements. Elements that contain other playlist elements are known as parent elements. A parent element controls the behavior of all the elements within it, known as the child elements.

Six of the seven basic XML playlist elements act as parent elements: smil, seq, excl, media, priorityClass, and switch. The seq and excl elements act as time containers, meaning that they control the timing of child elements. The priorityClass and switch elements act as control containers, meaning that they control the interaction of child elements.

The following example shows two media elements contained inside a seq element.

<seq>
    <media src="File3.wmv"/>
    <media src="File4.wmv"/>
</seq>

The function of a seq element is to stream the elements that are contained within it in order. Therefore, in the previous example, File3.wmv will play first, followed by File4.wmv. This arrangement of elements contained within other elements is called nesting.

In a playlist, the smil element is the document root, meaning that it is the parent of all the other elements in the playlist. In the following example, a seq element is the child the smil element. The seq element contains media and clientData elements, which are modified by src and title attributes, respectively. The wsx element preceding the smil element is used to identify the version of the server-side Synchronized Multimedia Integration Language (SMIL) syntax being used.

<?wsx version='1.0'?>
<smil>
    <seq>
        <media src="file1.wmv">
            <clientData title="My File #1"/>
        </media>
        <media src="file2.wmv">
            <clientData title="My File #2"/>
        </media>
        <media src="file3.wmv">
            <clientData title="My File #3"/>
        </media>
        <media src="File4.wmv"/>
            <clientData title="My File #4"/>
        </media>
    </seq>
</smil>

Once you understand the playlist elements and their attributes, you will be able to construct many creative solutions for presenting your digital media content.

Related topics

  • Playlist attributes
  • Playlist elements
  • Playlist reference
  • Time formats


Playlist elements

An element is used to either contain information or control one or more child elements. By using multiple elements and their attributes, you can determine the playback and presentation structure of a playlist. This section describes the following playlist elements:

  • smil element
  • media element
  • seq element
  • switch element
  • excl element
  • priorityClass element
  • clientData element

Related topics

  • About playlist elements
  • Constructing a playlist
  • Understanding playlist syntax

Note Image Note

  • For more detailed information about playlist elements, see the Windows Media Services Software Development Kit (SDK), which can be downloaded from the Windows Media home page at the Microsoft Web site.


smil element

The smil element is the root element of the playlist file. Its primary purpose is to identify that the playlist is based upon Synchronized Multimedia Integration Language (SMIL). Additionally, a smil element has the same function as a seq element, meaning that its child elements are played sequentially.

The following example shows a simple playlist with two media elements:

<?wsx version="1.0"?>
<smil>
      <media src="Song1.wma" />
      <media src="Song2.wma" />
</smil>

Attributes

Attributes define the properties of a playlist element. You can use the following optional attributes with a smil element.

Name | Description
begin | Specifies the when the smil element becomes active. For more information, see begin attribute.
dur | Specifies the duration of the element. For more information, see dur attribute.
end | Specifies when the smil element becomes inactive. For more information, see end attribute.
syncEvent | Specifies a string that triggers the beginning or end of an element in a wrapper playlist. For more information, see syncEvent attribute.
id | Specifies a name for the smil element that can be referenced by other elements or playlists. For more information, see id attribute.
repeatCount | Specifies the number of times the playlist (all the elements within the smil element) repeats before stopping. If no value is specified, the playlist is played once. For more information, see repeatCount attribute.
repeatDur | Specifies the length of time that the playlist repeats before stopping. For more information, see repeatDur attribute.

Note Image Notes

  • Windows Media playlist files are Extensible Markup Language (XML) documents that are based on the Synchronized Multimedia Integration Language (SMIL 2.0) language specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the smil element tags are typed in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist elements that are not listed properly.

Related topics

  • excl element
  • media element
  • Playlist attributes
  • Playlist elements
  • switch element


media element

The media elements in a playlist provide the locations of digital media sources and can specify how the digital media content plays back or is presented to the client. A media element can refer to any digital media source that can be accessed by a data source plug-in and parsed by a media or playlist parser plug-in. The appropriate plug-ins are enabled by default.

Examples of digital media sources include files on a local computer, streams from a remote computer running Windows Media Encoder or Windows Media Services, other playlist files, Active Server Pages (ASP pages) on Web servers, or digital media files on third-party storage systems.

The following example shows a simple playlist that consists of three digital media types: an image file, a video file, and an audio file:

<?wsx version='1.0'?>
<smil>
    <media src="Title.jpg" dur="10s"/>
    <media src="Video.wmv"/>
    <media src="Audio.wma"/>
</smil>

The three files play in sequence, starting with the first listed media element. The first media element has a specified value for the dur attribute because image files do not have an implicit duration.

Attributes

Attributes modify the properties of a playlist element. You can use the following attributes with a media element. The src attribute is the only required attribute.

Name | Description
src | Specifies the name and location of the source of the digital media content. For more information, see src attribute.
begin | Specifies the when the media element becomes active. For more information, see begin attribute.
clipBegin | Specifies the point in the digital media source at which playback begins. For more information, see clipBegin attribute.
clipEnd | Specifies the point in the digital media source at which playback ends. For more information, see clipEnd attribute.
dur | Specifies the length of time that the digital media source plays. For more information, see dur attribute.
end | Specifies when the media element becomes inactive. For more information, see end attribute.
syncEvent | Specifies a string used to trigger the beginning or end of an element in a wrapper playlist. For more information, see syncEvent attribute.
id | Specifies a name for the media element that can be referenced by other elements. For more information, see id attribute.
mediaName | Specifies a name for the media element to replace the src attribute value in the client log and the client content description list. For more information, see mediaName attribute.
noSkip | Specifies whether fast-forward, rewind, seek, or skip are enabled for the media element. For more information, see noSkip attribute.
repeatCount | Specifies the number of times the media element repeats before stopping. If no value is specified, the element is played once. For more information, see repeatCount attribute.
repeatDur | Specifies the length of time the media element repeats before stopping. For more information, see repeatDur attribute.
role | Specifies the role of the media element. For more information, see role attribute.

The following example playlist shows media elements with id, src, and dur attribute values:

<?wsx version="1.0"?>
<smil>
    <media id="Media1" src="C:\Wmpub\Wmroot\Clip1.wmv" dur="120s" />
    <media id="Media2" src="C:\Wmpub\Wmroot\Clip2.wmv" />
</smil>

In this example, Clip1.wmv plays for a duration of two minutes, followed by Clip2.wmv.

Note Image Notes

  • Do not use a JPEG image file as a child element of a priorityClass element if the image is to be paused using either the peers or higher attributes. Pausing the image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • If your playlist includes JPEG image files and you are using the playlist file with a broadcast publishing point, be aware that users who connect to the broadcast while the JPEG image is being streamed will not receive the image. They will instead see a black screen. Once the playlist continues on to the next item, playback will continue as expected. If you want a JPEG image to be displayed for a certain period of time, you should use the repeatCount attribute to repeat the image for short durations that together equal the amount of time that the image is to be displayed. That way, players that connect while the image is being streamed can receive the image when it repeats. For example, if a JPEG image is to be displayed for 60 seconds, you could set a dur attribute value of five seconds and a repeatCount attribute value of 12. If a user connects two seconds into the broadcast, the image would be displayed after three seconds. If the repeatCount and dur attribute values were not used, the user would see a black screen for 58 seconds.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the media element is in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist elements that are not listed properly.

Related topics

  • excl element
  • Media definition attributes
  • Playlist elements
  • seq element
  • switch element


seq element

The seq element is a time-container element that specifies the order in which its child elements are played. Child media elements within the seq element are played in order, from the first element to the last. Other types of elements contained in the seq element are also activated in order.

In the following example, Song1.wma plays first, and is followed by the seq element containing Song3.wma and Song4.wma. The repeatCount attribute is set to 2, meaning that the two files within the seq element play in order twice. Finally, Song2.wma plays.

<?wsx version="1.0"?>
<smil>
    <media src="Song1.wma"/>
    <seq repeatCount="2">
        <media src="Song3.wma"/>
        <media src="Song4.wma"/>
    </seq>
    <media src="Song2.wma"/>
</smil>

Attributes

Attributes modify the properties of a playlist element. You can use the following optional attributes with a seq element.

Name | Description
begin | Specifies the amount of time until the seq element becomes active and its child elements start playing. For more information, see begin attribute.
dur | Specifies the length of time that a seq element is active and its child elements play. For more information, see dur attribute.
end | Specifies when the seq element becomes inactive and its child elements stop playing. For more information, see end attribute.
syncEvent | Specifies a string used to trigger the beginning or end of an element in a wrapper playlist. For more information, see syncEvent attribute.
id | Specifies a name for the seq element that can be referenced by other elements. For more information, see id attribute.
repeatCount | Specifies the number of times the elements within the seq element repeat before stopping. If no value is specified, the child elements are played once. For more information, see repeatCount attribute.
repeatDur | Specifies the length of time the elements within the seq element repeat before stopping. For more information, see repeatDur attribute.

Note Image Notes

  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the seq element is in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist elements that are not listed properly.
  • Elements contained within a smil element are also activated sequentially.

Related topics

  • excl element
  • media element
  • Playlist attributes
  • Playlist elements
  • switch element


switch element

The switch element specifies alternative media elements that can be used if one or more of the current media elements fails. The server evaluates the child elements within the switch element in the order they are listed in order to identify a valid element that can be successfully accessed and streamed. When the server identifies and streams a valid element, the other elements within the switch element are ignored. After the selected element stops streaming, the server continues to stream the portion of the playlist after the switch element.

The switch element is useful for implementing content rollover in a server-side playlist. You can configure content rollover by using the switch element with multiple live sources and stored files to provide fault tolerance for your stream.

The following example illustrates a flaw in the way the switch element is often used to provide fault tolerance. This sample playlist uses a switch element to reference streams from two alternative encoders:

<?wsx version="1.0"?>
<!---This playlist contains an error. Do not use.--->
<smil>
   <switch>
      <media id="media1" src="http://encoder1:8080"/>
      <media id="media2" src="http://encoder2:8080"/>
   </switch>
   <media id="media3" src="Alternate.wmv"/>
</smil>

In this playlist, the switch element is the first active element. First, the server attempts to connect to the media element named media1. If the server cannot establish a connection to media1, the server attempts to connect to media2. If the server cannot establish a connection to media2, the switch element ends, and the server plays media3 instead. Although that is the expected server behavior, the end user will probably not receive the full sequence because switching delays may cause a time-out condition in the player. This playlist does not result in a fault-tolerant broadcast for two primary reasons:

  • Switching from one network encoder to another takes a minimum of 20 seconds. This delay may cause some players to time out and disconnect.
  • The Fast Reconnect feature in Windows Media Services creates an additional delay because it transparently attempts to request reconnections to data sources that are interupted during a broadcast. Thus, in this example, the server will try to reconnect to the first encoder five times before reporting that the encoder is not valid. This process can cause enough delay that clients connected to the broadcast may time out and disconnect.

Because of these potential problems, it is best to add the Fast Streaming modifier WMReconnect to the encoder URLs. In this example, the modifier prevents the Fast Reconnect feature from attempting to reconnect to the encoder and enables the playlist to switch to Alternate.wmv while the server attempts to connect to the second encoder. The following example playlist provides fault tolerance and prevents client time-outs during the switch to the other encoder:

<?wsx version="1.0"?>
<!---This example shows the use of a switch element with a WMReconnect modifier.--->
<smil>
   <switch>
      <media id="media1" src="http://encoder1:8080?WMReconnect=0"/>
      <media id="media2" src="Alternate.wmv"/>
   </switch>
   <switch>
      <media id="media3" src="http://encoder2:8080?WMReconnect=0"/>
      <media id="media4" src="Alternate.wmv"/>
   </switch>
</smil>

In this example, if the server connects to media1 and that connection ends or fails, the server will not attempt to reconnect to the source. Instead it immediately plays the file Alternate.wmv and then attempts to connect to media3. If the repeatCount or repeatDur attribute of the smil element is set to Indefinite, then the server continually tries to connect to the encoders until one of the encoders is back online. You can use this type of playlist syntax to maintain connections with both players and distribution servers during a broadcast.

Attributes

Attributes modify the properties of a playlist element. You can use the following optional attributes with a switch element.

Name | Description
syncEvent | Specifies a string used to trigger the beginning or end of an element in a wrapper playlist. For more information, see syncEvent attribute.
id | Specifies a name for the switch element that can be referenced by other elements. For more information, see id attribute.

You can use the switch element in combination with a client-side playlist (a Windows Media metafile with an .asx file name extension) in order to provide a higher level of fault tolerance. For example, assume that the following .asx file refers to publishing points that reference the playlist from the previous example:

<ASX version="3.0">
  <TITLE>MyServer Rollover</TITLE>
  <ENTRY>
    <REF HREF="mms://server1/pubpoint1" />
    <REF HREF="mms://server2/pubpoint1" />
    <REF HREF="mms://server3/pubpoint1" />
  </ENTRY>
</ASX>

The previous example .asx file provides clients with alternative servers in case the client is unable to establish a connection with the primary server. After the client successfully connects to a server, the server-side playlist provides encoder rollover.

Note Image Note

  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the switch element is in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist elements that are not listed properly.

Related topics

  • Controlling streaming behavior
  • excl element
  • media element
  • Playlist elements
  • seq element


excl element

The excl element is a time-container element in which only one media element can be played at a time, but the playback order of the child elements is not determined. Use an excl element if you want to control when child elements begin based on variable criteria. For example, a child element can be triggered by using either a programmatic event or a begin attribute that explicitly specifies a start time. Unlike child elements of a seq element, which play in order once the seq element has been activated, the child elements of an excl element do not play unless they are explicitly started.

In the following example, the values for the begin attributes determine the playback order of the media elements. Since its begin value is 0 seconds (0s), the media element media2 plays immediately. The third element, media3, is set to begin when media2 ends (media2.end). Likewise, the fourth element, media4, is set to start at the end of media3, and the first element, media1, is set to start when media4 ends.

<?wsx version="1.0"?>
<smil>
    <excl>
        <media id="media1" src="Video1.wmv" begin="media4.end"/>
        <media id="media2" src="Video2.wmv" begin="0s"/>
        <media id="media3" src="Video3.wmv" begin="media2.end"/>
        <media id="media4" src="Video4.wmv" begin="media3.end"/>
    </excl>
</smil>

An excl element is often used in conjunction with priorityClass elements, which control how one media element interrupts the playback of another element. For more information, see priorityClass element.

Attributes

Attributes modify the properties of a playlist element. You can use the following optional attributes with an excl element.

Name | Description
begin | Specifies the amount of time until the excl element becomes active and its child elements start playing. For more information, see begin attribute.
dur | Specifies the length of time that the excl element is active and its child elements play. For more information, see dur attribute.
end | Specifies when the excl element becomes inactive and its child elements stop playing. For more information, see end attribute.
endSync | Specifies which child element determines when the excl element ends. For more information, see endSync attribute.
syncEvent | Specifies a string used to trigger the beginning or end of an element in a wrapper playlist. For more information, see syncEvent attribute.
id | Specifies a name for the excl element that can be referenced by other elements. For more information, see id attribute.
repeatCount | Specifies the number of times the child elements within the excl element repeat before stopping. If no value is specified, the element is played once. For more information, see repeatCount attribute.
repeatDur | Specifies the length of time the child elements within the excl element repeat before stopping. For more information, see repeatDur attribute.

Note Image Notes

  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the excl element is in correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist elements that are not listed properly.
  • If an endSync attribute value is not specified for an excl element, the excl element acts as if the endSync attribute was defined as Last, by default.

Related topics

  • media element
  • Playlist attributes
  • Playlist elements
  • priorityClass element
  • seq element
  • switch element


priorityClass element

The priorityClass element controls how one media element interrupts the playback of another element and the playback state of the interrupted media element. If you simply want to configure one element to interrupt playback of another, you can use an excl or seq element with a begin attribute set to start one element while another element is playing.

The priorityClass element, however, enables you to specify whether the interrupted element stops, pauses, or can never be interrupted. If a media element is set to Pause when interrupted, it will continue to stream from the point at which it was paused when the element that interrupted it ends. If it is set to Stop, it will not stream when the element that interrupted it ends. Using the priorityClass element, you can also specify whether an interruption is deferred until the current media element finishes or ignored altogether. Furthermore, the child elements in a priorityClass element and the priorityClass elements contained within an excl element container are prioritized by the order in which they are listed in the playlist. The ability to adjust the priority further enables you to control the behavior of child elements.

Keep the following points in mind when working with priorityClass elements:

  • A priorityClass element must be a child of an excl element and must be directly beneath the excl element. If an excl element contains one or more priorityClass elements, all of the media elements associated with that excl element must be contained within the priorityClass elements.
  • Priority levels are assigned to priorityClass elements based upon the order in which they are declared in the excl element. The first declared priorityClass has the highest priority, and the last declared priorityClass has the lowest priority.
  • If the priorityClass element is not used, all the media elements within the excl element behave as if their peers attribute is set to Stop. In this case, if one media element interrupts another element, the interrupted element stops and does not resume.

The following example features each of the three attributes that are exclusive to the priorityClass element: peers, higher, and lower. In practical use, you would probably choose a simpler playlist design, but this example illustrates how the priorityClass element and its attributes control the interruption and flow of a playlist.

The playlist consists of three priorityClass elements contained within an excl element. Since its begin attribute is set to 0 seconds (0s), the media element named media1 plays first. After 10 seconds, media2 interrupts media1. Media2 is within the same priorityClass element as media1, meaning that they are peers. Because the peers attribute of media1's priorityClass is set to Stop, media1 stops when media2 interrupts it.

The media element named media4 is set to begin four seconds into the playlist. However, the lower attribute of the priorityClass element named Priority1 is set to Defer. Therefore, because media4 is in a lower-ranking priorityClass element (Priority3) than the media elements in Priority1, media4 cannot start until all the media elements in Priority1 finish.

Ten seconds after media4 begins, the media element named media3 begins (because its begin attribute is set to media4.begin+10s). The element named media3 is in the priorityClass element named Priority2, which has a higher priority than Priority3. Because the higher attribute in Priority3 is set to Pause, media4 pauses until media3 has finished playing. After media3 is finished, media4 continues playing back from the point at which it was paused.

<?wsx version='1.0'?>
<smil>
    <excl>
        <priorityClass id="Priority1" peers="Stop" lower="Defer">
            <media id="media1" src="Media1.wmv" begin="0s"/>
            <media id="media2" src="Media2.wmv"
             begin="media1.begin+10s"/>
        </priorityClass>
        <priorityClass id="Priority2">
            <media id="media3" src="Media3.wmv" begin="media4.begin+10s"/>
        </priorityClass>
        <priorityClass id="Priority3" higher="Pause">
            <media id="media4" src="Media4.wmv" begin="4s"/>
        </priorityClass>
    </excl>
</smil>

There are many ways to use priorityClass elements in playlists to insert ads or other digital media content. In the following example playlist, script commands embedded in a stream from an encoder (which is the media element named media1) trigger different media elements in the playlist. The begin attributes of the advertisements in the playlist have values of Ad1Event, Ad2Event, and Ad3Event. When the server detects a FIRE_EVENT script command that has a value that matches one of the begin attribute values, the corresponding media element interrupts the live stream. Playback returns to the encoder stream (media1) after the element finishes because the peers attribute of media1 is set to Pause. For example, if a script command contains the text strings FIRE_EVENT and Ad2Event, media1 pauses and Ad2 plays back. When Ad2 is completed, media1 resumes playback.

<?wsx version='1.0'?>
<smil>
    <excl>
        <priorityClass peers="Pause">
            <media id="media1" src="http://encoder/livestream:1000"
             begin="0s"/>
            <media id="Ad1" src="Comml1.wma" begin="Ad1Event"/>
            <media id="Ad2" src="Comml2.wma" begin="Ad2Event"/>
            <media id="Ad3" src="Comml3.wma" begin="Ad3Event"/>
        </priorityClass>
    </excl>
</smil>

When switching from a live encoder stream, you can precede the FIRE_EVENT command with a CUE_EVENT command. When the server receives this command, it prepares the media element specified in the script command and buffers the beginning portion of the content. This way, when the FIRE_EVENT command is received, the switch to the media element is seamless. For example, sending the script command type CUE_EVENT and value Ad2Event prepares the file Comm2.wma for broadcast.

Attributes

Attributes modify the properties of a playlist element. You can use the following optional attributes with a priorityClass element.

Name | Description
syncEvent | Provides a string used to trigger the beginning or end of an element in a wrapper playlist. For more information, see syncEvent attribute.
higher | Controls how child elements within a priorityClass element behave when interrupted by child elements in higher priority priorityClass elements. For more information, see higher attribute.
id | Provides a name for the priorityClass element that can be referenced by other elements. For more information, see id attribute.
lower | Controls how child elements within a priorityClass element behave when interrupted by child elements in lower priority priorityClass elements. For more information, see lower attribute.
peers | Controls how child elements behave when interrupted by child elements within the same priorityClass element. For more information, see peers attribute.

Note Image Notes

  • Do not use a JPEG image file as a child element of a priorityClass element if the image is to be paused using either the peers or higher attributes. Pausing the image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • If your playlist includes JPEG image files and you are using the playlist file with a broadcast publishing point, be aware that users who connect to the broadcast while the JPEG image is being streamed will not receive the image. They will instead see a black screen. Once the playlist continues on to the next item, playback will continue as expected. If you want a JPEG image to be displayed for a certain period of time, you should use the repeatCount attribute to repeat the image for short durations that together equal the amount of time that the image is to be displayed. That way, players that connect while the image is being streamed can receive the image when it repeats. For example, if a JPEG image is to be displayed for 60 seconds, you could set a dur attribute value of five seconds and a repeatCount attribute value of 12. If a user connects two seconds into the broadcast, the image would be displayed after three seconds. If the repeatCount and dur attribute values were not used, the user would see a black screen for 58 seconds.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the priorityClass element is in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist elements that are not listed properly.

Related topics

  • excl element
  • Playlist elements
  • Synchronization attributes


clientData element

You can use the clientData element to associate descriptive text, banner images, and logging information with playlist elements. Descriptive text, such as artist name and track title, is then displayed in Windows Media Player 9 Series or a player that uses the Windows Media Player 9 Series ActiveX control. Using the clientData element, you can also display banner images, associated hyperlinks, and ToolTip text.

You can insert a clientData element anywhere in a playlist. It can be a child of any element except another clientData element. The information it contains is sent to the client when the clientData element becomes active.

An excl, seq, priorityClass or switch element may have more than one clientData element, and each clientData element may contain multiple attributes. Depending on where you add a clientData element, the information will apply either to an individual media element or to a collection of media elements. A clientData element is overridden by a clientData element of a higher level. For example, the title information specified for a group of media elements takes precedence over the title information specified for an individual media element. Likewise, text properties, such as title, author, and copyright, encoded in a file's header are overridden by the corresponding clientData elements in the playlist.

In the following example, a seq element is nested inside another seq element. The clientData elements specify titles for both an individual media element and a nested sequence of elements. The media element Open.wmv plays first, displaying the individual title attribute value of Welcome. Then the nested sequence plays, starting with Video1.wmv. Because the clientData element is a child of the seq element, the title attribute value Segment 1 displays as the title for all the media elements in the sequence. The title attribute value associated with the media element Video1.wmv is overridden by the sequence title.

<?wsx version='1.0'?>
<smil>
    <seq>
        <media src="Open.wmv">
            <clientData title="Welcome"/>
        </media>
        <seq>
            <clientData title="Segment 1"/>
            <media src="Video1.wmv">
                <clientData title="Video 1"/>
            </media>
            <media src="Video2.wmv"/>
            <media src="Video3.wmv"/>
        </seq>
    </seq>
</smil>

The following example incorporates multiple clientData attributes.

<?wsx version="1.0"?>
<smil>
   <media id="Media1" src="C:\Wmpub\Wmroot\Musictrack1.wma">
      <clientData album="Album Name" artist="Don Funk"
       copyright="(c) Company name" genre="Rock" title="Music" />
   </media>
</smil>

Attributes

Attributes modify the properties of a playlist element. You can use the following optional attributes with the clientData element.

Name | Description
album | Specifies the album name. For more information, see album attribute.
artist | Specifies the artist name. For more information, see artist attribute.
author | Specifies the author's name. For more information, see author attribute.
bannerAbstract | Specifies the text that is displayed as a ToolTip for the banner image displayed in Windows Media Player. For more information, see bannerAbstract attribute .
bannerInfoURL | Specifies the URL that the user can access by clicking the banner image in Windows Media Player. For more information, see bannerInfoURL attribute.
bannerURL | Specifies the URL of an image file that appears in the display panel of Windows Media Player. For more information, see bannerURL attribute.
copyright | Specifies copyright information. For more information, see copyright attribute.
genre | Specifies the genre. Fore more information, see genre attribute.
logURL | Specifies the URL that is used to post log statistics to either the origin server or any Web server. For more information, see logURL attribute.
title | Specifies a title. For more information, see title attribute.

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the clientData element is in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist elements that are not listed properly.

Related topics

  • Metadata information attributes
  • Playlist elements


Playlist attributes

This section describes the attributes that configure the properties of elements in a Windows Media playlist file. The attributes are categorized by usage.

  • Media definition attributes
    • id attribute
    • mediaName attribute
    • noSkip attribute
    • role attribute
    • src attribute

  • Metadata information attributes
    • album attribute
    • artist attribute
    • author attribute
    • bannerURL attribute
    • bannerAbstract attribute
    • bannerInfoURL attribute
    • copyright attribute
    • genre attribute
    • logURL attribute
    • title attribute

  • Synchronization attributes
    • higher attribute
    • lower attribute
    • peers attribute

  • Timing attributes
    • Timing values
    • begin attribute
    • clipBegin attribute
    • clipEnd attribute
    • dur attribute
    • end attribute
    • endSync attribute
    • repeatCount attribute
    • repeatDur attribute
    • syncEvent attribute

Related topics

  • About playlist elements
  • Understanding playlist syntax


Media definition attributes

The attributes in this section are most often used with media elements to describe the element or the playback behavior of the element source. The id attribute can also be used with other elements.

This category consists of the following attributes:

  • id attribute
  • mediaName attribute
  • noSkip attribute
  • role attribute
  • src attribute

Related topics

  • Playlist attributes


id attribute

The id attribute can be used to apply a name to an element so that it can be referenced by another element in the playlist. You can use the id attribute to add an identifier to any element, but it is most useful for identifying media elements. The id attribute is used to identify an element as a SyncBase for timing and synchronization purposes.

In the following example, id attributes are used with begin attributes to control playback:

<?wsx version='1.0'?>
<smil>
    <excl>
        <media id="Music1" src="14442A.wma" begin="0s"/>
        <media id="Music2" src="65563B.wma" begin="Music1.end"/>
    </excl>
</smil>

The id of the first element is used to identify it as a SyncBase in the begin value of the second element. In this example, Music2 begins at the point at which Music1 ends (Music1.end). In addition to its value for referencing elements, the id attribute can also be used simply to make a playlist easier to read.

Each value for the id attribute must be a text string and should be unique within a playlist. For example, if you assign the value Introduction to the id attribute of a media element, you should not assign the value Introduction to the id attribute of any other element in that playlist. Numbers can be used within id attribute text strings, but they cannot be used as the first character of an id attribute value. For example, if 3media is used as a value, the id attribute is ignored. The string Media3 is valid, however.

The id attribute can be specified for the following playlist elements:

  • excl element
  • media element
  • priorityClass element
  • seq element
  • smil element
  • switch element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK).
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the id attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • begin attribute
  • Media definition attributes
  • media element
  • seq element
  • src attribute
  • Timing values


mediaName attribute

The mediaName attribute provides clients with a name for a media element. The server uses the mediaName attribute to log data, and the mediaName attribute value overrides name information sent to clients. This attribute is useful if you are using log files for reporting or if you want to prevent users from seeing the names of your servers and the paths to your content.

The following example shows how the mediaName attribute can make logs and playlists easier to read. When the WMS Client Logging plug-in receives data from the client, it writes the information to the appropriate fields of a log file. When a mediaName value is specified for a media element, that name replaces the file name in the cs-media-name field in the client logging data.

When the playlist is played, the first entry is logged with the name X-563cvb12.wmv. The second entry is logged with the name My Movie.

<?wsx version='1.0'?>
<smil>
    <media src="X-563cvb12.wmv/>
    <media src="Bv-291X.wmv" mediaName="My Movie"/>
</smil>

You can also use the mediaName attribute to increase the security of your system, as shown in the following example. Specifying a value for the mediaName attribute causes that information to be sent to the client instead of the file name or publishing point name specified in the src attribute. The information is sent to the client in a content description list, which provides the client with content information about each item in a playlist. Because the content description list is not encrypted, you can use the mediaName attribute to prevent malicious users from discovering the actual names of the digital media content on your network.

When the following playlist is played, the content description list received by the client contains the file name of the first entry, and the mediaName attribute value of Movie1 for the second entry.

<?wsx version="1.0"?>
<smil>
    <media src="file://\\movie_server\licensed_content\2XM-56YZ.wmv" />
    <media src="file://\\movie_server\licensed_content\2XM-34YZ.wmv"
    mediaName="Movie1" />
</smil>

The mediaName attribute can be specified for the following playlist element:

  • media element

Note Image Notes

  • The value specified in the mediaName attribute is a string value that may include any characters except restricted Extensible Markup Language (XML) characters, such as ampersands (&), less-than signs(<), and quotation marks (").
  • If the user is running Windows Media Player for Windows XP and earlier, the mediaName element information will be ignored. The mediaName element is supported by Windows Media Player 9 Series.
  • The mediaName attribute is a Microsoft extension of the Synchronized Multimedia Integration Language (SMIL 2.0) specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the mediaName attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • Log file entries reference
  • Logging category
  • Media definition attributes
  • media element
  • src attribute


noSkip attribute

The noSkip attribute specifies whether the next, rewind, fast-forward, pause, and seek functions are enabled in Windows Media Player when a media element plays. You can use this attribute to prevent users from skipping a media element, such as an advertisement.

If the noSkip attribute value is set to true, the next, fast-forward, pause, and seek functions are disabled. Players will only have the ability to skip to the previous item in the playlist, rewind to the previous item or to stop playback. If the value is not specified or is set to false, all of the functions are enabled.

In the following example, users must play all of IntroClip.wmv before they can stream MovieClip.wmv.

<?wsx version="1.0"?>
<smil>
    <media src="c:\Wmpub\Wmroot\IntroClip.wmv" noSkip="true" />
    <media src="c:\Wmpub\Wmroot\MovieClip.wmv" mediaName="Movie" />
</smil>

The noSkip attribute can be specified for the following playlist element:

  • media element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the noSkip attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • Media definition attributes
  • media element
  • src attribute


role attribute

The role attribute specifies the purpose or type of a media element. This attribute enables you to create custom categories for digital media sources, such as music, bumper, promo, or public service announcement. The WMS Client Logging plug-in uses the value specified in the role attribute to populate the cs-media-role field.

You can use any naming scheme to set values for the role attribute. However, the value Advertisement has a special meaning. Whenever the server starts to stream a media element with the role attribute value of Advertisement, the Advertisement counter is incremented on the Monitor tab. Advertisements streamed by wrapper playlists increment the counters in the same manner.

In the following example, the first entry is logged with a role attribute value of music segment, and the second with the role attribute value of Advertisement. The second entry also includes a noSkip attribute set to true in order to prevent the user from skipping the advertisement.

<?wsx version='1.0'?>
<smil>
    <media src="MusicVideo.wmv" role="music segment"/>
    <media src="Comml1.wmv" role="Advertisement" noSkip="true"/>
</smil>

The primary purpose of the role attribute is to help you analyze and understand logging data. If you use a database to track logging data, you can create reports that separate content usage by type; for example, you can create a report showing the different types of music files played, a chart showing the types of content that users preferred, or the number of public service announcements that you played. For example, you can set the value of the role attribute to movie and then interpret the log file to determine how many times movies have been streamed. Keep in mind that if the media element references another playlist, rather than a specific item, the advertisement counters are not updated.

The role attribute can be specified for the following playlist element:

  • media element

Note Image Notes

  • The role attribute is a Microsoft extension to the Synchronized Multimedia Integration Language (SMIL 2.0) specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the role attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • Log file entries reference
  • Logging data and events
  • Media definition attributes
  • media element
  • noSkip attribute
  • src attribute


src attribute

The src attribute identifies the content source of a media element using a URL, Universal Naming Convention (UNC) path, or absolute path. The source can be any type of digital media content or file as long as there is an enabled data source plug-in that can access the content and a media parser or playlist parser plug-in that can parse the content. In general, any stream that can be assigned as the source of a publishing point is a valid value for the src attribute. By default, you can specify any of the following sources for a media element: a Windows Media file, a JPEG image file, an MP3 audio file, an encoder stream, a stream or file from a remote Windows Media server, a stream or file from a local publishing point, or a playlist file.

The following example uses four types of content sources in one playlist:

<?wsx version='1.0'?>
<smil>
    <media id="VideoFile" src="D:\LocalMedia\Video4.wmv"/>
    <media id="Playlist" src="Playlist.wsx"/>
    <media id="LocalPubPoint" src="lpp://pubpoint5"/>
    <media id="LiveStream" src="http://encoder:1000"/>
</smil>

The following table shows examples of valid path syntax for the src attribute.

Value | Description
%systemdrive%\Wmpub\Wmroot\Movie1.wmv \\Server1\Movie_Folder\Movie1.wmv | References a digital media file on a local or remote server.
%systemdrive%\Wmpub\Wmroot\Playlist1.wsx \\Server1\Playlist_Folder\Playlist1.wsx | References a playlist file on a local or remote server.
http://encoder1:port | References an encoder stream.
rtsp://server2/pubpoint2 http://server2/pubpoint | References a stream from another publishing point on a local or remote Windows Media server.
http://server1/station_name http://server1/pubpoint | References a stream from a station or publishing point on a server running Windows 2000 Server with Windows Media Services version 4.1, which requires the HTTP protocol.
rtsp://server2/pubpoint1/movie1.wmv | References a specific digital media file or playlist from a publishing point on a remote Windows Media server. You can specify whether the stream is sent using UDP or TCP by changing the protocol to RTSPU or RTSPT, respectively.
lpp://pubpoint1/movie1.wmv | References a specific digital media file or playlist from another publishing point on the local Windows Media server.
httpd://server1/custom_playlist.asp httpd://server1/playlist.wsx | References a Web server page that generates a custom playlist file.
MCast://C:\Wmpub\Wmroot\File.nsc MCast://\\MachineName\Inetpub\Wwwroot\File.nsc | References a multicast stream using the multicast information file. Relative URLs cannot be used to specify this path.

If the publishing point is on a local server, you can use an lpp:// (local publishing point) prefix instead of specifying the server name in the path. Content streamed using the lpp:// prefix is more efficient because it does not use the network transport layer. However, if the specified publishing point has a wrapper playlist enabled, the contents of the wrapper will not be streamed. If you want to include the wrapper content with the publishing point content, you must use the rtsp:// or http:// prefixes instead of lpp://.

The following examples illustrate the use of physical and relative URLs. The media elements illustrate three ways that you can reference Movie1.wmv if the playlist is located at C:\Wmroot\Playlist.wsx:

<media src="c:\wmroot\Movie1.wmv" />

In the previous example, the src attribute uses the physical path of Movie1.wmv.

<media src=".\Movie1.wmv"/>

This example uses a relative URL, substituting the base URL with the path segment of a period (.), which indicates that the content is located on the current directory level. The path segment could also be represented by two periods (..) to indicate that the content is located on the directory level above the current level.

<media src="Movie1.wmv"/>

This example specifies the file name only. If the src attribute value is a file name without a path, the absolute base URL is implied, which means that the playlist and the file are in the same location.

The src attribute can be specified for the following playlist element:

  • media element

Note Image Notes

  • You can control the behavior of individual streams by adding Fast Streaming modifiers to the source URLs. For example, the WMCache modifier enables a client to use the Fast Cache feature when it uses the following URL format to connect to the server: http://servername/file.wmv?WMCache=1. You can also control the maximum bandwidth available to stream a file or live stream by using the modifiers WMBitrate and WMContentBitrate. Modifiers can be added to any valid src attribute and anywhere else a source path is used, such as the content source path in the Source tab. For more information, see Controlling streaming behavior.
  • If you define the src attribute as being a publishing point on the local server using the lpp:// syntax, you must enable or disable player caching on the source publishing point. Changing the setting of the Enable Fast Cache property on any publishing point except the source will not affect the ability of players to cache content. For more information about the Fast Cache feature, see Understanding Fast Cache.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the src attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • Media definition attributes
  • media element
  • Sourcing from playlists, files, and encoders


Metadata information attributes

The attributes in this section can be used with the clientData element to associate metadata information, such as text information, banner images, and logging information, with digital media sources. This metadata information is included as part of the stream and displayed on the client interface or used in some other manner. The clientData element can be associated with an individual digital media source or with a collection of media elements.

This category consists of the following attributes:

  • album attribute
  • artist attribute
  • author attribute
  • bannerURL attribute
  • bannerAbstract attribute
  • bannerInfoURL attribute
  • copyright attribute
  • genre attribute
  • logURL attribute
  • title attribute

Related topics

  • Playlist attributes


album attribute

The album attribute specifies the album name associated with a single media element or a collection of media elements. When an album attribute value is specified, the information is included in the content description list that is sent to the client. Windows Media Player displays the album attribute value when the media element or elements are played. Values specified for the album attribute must be text strings.

When the following example playlist runs, Music Album is displayed as the album title for all of the media elements within the seq element. The album title does not appear with Ad1.wma, which plays before the sequence.

<?wsx version='1.0'?>
<smil>
    <media src="Ad1.wma"/>
    <seq>
        <media src="Music1.wma"/>
        <media src="Music2.wma"/>
        <media src="Music3.wma"/>
        <media src="Music4.wma"/>
        <clientData album="Music Album"/>
    </seq>
</smil>

The album attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the album is in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • media element
  • Metadata information attributes
  • seq element


artist attribute

The artist attribute specifies an artist name for a single media element or collection of media elements. When an artist attribute is specified, the value is included in the content description list that is sent to the client. Windows Media Player displays the artist attribute value when the media element or elements are played. Values specified for the artist attribute must be text strings.

In the following example, the value of the artist attribute for the source file IntroFile1.wma is Jeff Smith:

<?wsx version="1.0"?>
<smil>
   <media id="intro" src="IntroFile1.wma">
      <clientData artist="Jeff Smith"/>
   </media>
</smil>

The artist attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the artist attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • media element
  • Metadata information attributes


author attribute

The author attribute specifies a content creator name for a single media element or collection of media elements. If a value is specified for the author attribute, the value is included in the content description list sent to the client. Windows Media Player displays the value when the media element or elements are played. Values specified for the author attribute must be text strings.

In the following example, the author attribute value Karen Berge is specified for the source file, IntroFile1.wma:

<?wsx version="1.0"?>
<smil>
   <media id="intro" src="IntroFile1.wma">
      <clientData author="Karen Berge"/>
   </media>
</smil>

The author attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the author attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • media element
  • Metadata information attributes


bannerURL attribute

The bannerURL attribute is typically used with the bannerInfoURL and bannerAbstract attributes to add a banner image to the Windows Media Player interface. The bannerURL attribute value is the URL of a banner image file.

When a client accesses a playlist that has a banner image, the client downloads the image specified by the bannerURL attribute value. When the parent element of the bannerURL attribute becomes active, the banner image is displayed in the lower third of the Windows Media Player Now Playing pane.

The maximum area for the image is 32 pixels high by 194 pixels wide. If the graphic defined in the URL is smaller than the maximum size, it displays at its original size. If the graphic is larger than the maximum, Windows Media Player crops the image to fit the space. Typically an image is accessed from a Web page, with a bannerURL attribute value such as http://webserver/images/image.gif. Values specified for the bannerURL attribute must be text strings.

The following example shows a playlist with banner attributes specified.

<?wsx version="1.0"?>
<smil>
    <media src="lpp://server/spain">
        <clientData title="Spain"
         bannerAbstract="Click here for more information about Spain"
         bannerInfoURL="http://webserver/spain/default.asp"
         bannerURL="http://webserver/images/spain_banner1.gif"/>
    </media>
</smil>

When a client accesses the playlist, Spain_Banner1.gif is downloaded and displayed in the Player. The bannerAbstract value is displayed as a ToolTip when the user pauses on the banner. When the user clicks the banner, the user's browser opens to the URL specified in the bannerInfoURL attribute.

The bannerURL attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the bannerURL attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • bannerAbstract attribute
  • bannerInfoURL attribute
  • Metadata information attributes
  • media element


bannerAbstract attribute

The bannerAbstract attribute is typically used with the bannerURL and bannerInfoURL attributes to add ToolTip information to a banner image displayed in Windows Media Player. The bannerAbstract attribute value provides the text information displayed when a user pauses the mouse pointer on the banner image.

When a client accesses a playlist that has a banner image, the client downloads the image specified by the bannerURL attribute value. When the parent element of the bannerURL attribute becomes active, the banner image is displayed in the lower third of the Windows Media Player Now Playing pane. Values specified for the bannerAbstract attribute must be text strings.

The following example shows a playlist with specified banner attribute values:

<?wsx version="1.0"?>
<smil>
    <media src="lpp://server/spain">
        <clientData title="Spain"
         bannerAbstract="Click here for more information about Spain"
         bannerInfoURL="http://webserver/spain/default.asp"
         bannerURL="http://webServer/images/spain_banner1.gif"/>
    </media>
</smil>

When the client accesses the playlist, Spain_Banner1.gif is downloaded and displayed in the Player. The bannerAbstract attribute value is displayed as a ToolTip. When the user clicks the banner image, the Web browser displays the Web page specified in the bannerInfoURL attribute.

The bannerAbstract attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the bannerAbstract attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • bannerInfoURL attribute
  • bannerURL attribute
  • media element
  • Metadata information attributes


bannerInfoURL attribute

The bannerInfoURL attribute is typically used with the bannerURL and bannerAbstract attributes to add a hyperlink to a banner image displayed in Windows Media Player. You can use the bannerInfoURL attribute to provide users with a link to a Web page that is associated with one or more media elements. For example, the Web page may provide users with more information about the content source or an advertiser.

When a client accesses a playlist that has a banner image, the client downloads the image specified by the bannerURL attribute value. When the parent element of the bannerURL attribute becomes active, the banner image is displayed in the lower third of the Windows Media Player Now Playing pane. When a user clicks a banner that has an associated bannerInfoURL attribute, the Player starts the Web browser and displays the specified Web page. Values specified for the bannerInfoURL attribute must be text strings.

The following example shows a playlist with specified banner attributes:

<?wsx version="1.0"?>
<smil>
    <media src="lpp://Server/Spain">
        <clientData title="Spain"
         bannerAbstract="Click here for more information about Spain"
         bannerInfoURL="http://webserver/spain/default.asp"
         bannerURL="http://webserver/images/spain_banner1.gif"/>
    </media>
</smil>

When a client accesses the playlist, Spain_Banner1.gif is downloaded and displayed in the Player. When the user clicks the banner, the Web browser displays the Web page specified in the bannerInfoURL attribute. The bannerAbstract attribute value is displayed as a ToolTip.

The bannerInfoURL attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the bannerInfoURL attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • bannerAbstract attribute
  • bannerURL attribute
  • media element
  • Metadata information attributes


copyright attribute

The copyright attribute specifies copyright information for a media element or collection of media elements. The copyright attribute value is included in the content description list that is sent to the client. Windows Media Player displays the value when the media element or elements are played. Values specified for the copyright attribute must be text strings.

In the following example, a copyright attribute value is specified for the source file, IntroFile1.wma:

<?wsx version="1.0"?>
<smil>
   <media id="intro" src="IntroFile1.wma">
      <clientData copyright="(c)Microsoft Corporation 2002"/>
   </media>
</smil>

The copyright attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the copyright attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • media element
  • Metadata information attributes


genre attribute

The genre attribute specifies a type for the media element or collection of media elements. The genre attribute value is included in the content description list that is sent to the client. Windows Media Player displays the value when the media element or elements are played.

There is no standardized naming convention for creating and assigning genre names. You can create a custom naming scheme to categorize your digital media sources. Values specified for the genre attribute must be text strings.

In the following example, the genre attribute value Documentary is specified for the source file, IntroFile1.wma:

<?wsx version="1.0"?>
<smil>
   <media id="intro" src="IntroFile1.wma">
      <clientData genre="Documentary"/>
   </media>
</smil>

The genre attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the genre attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • media element
  • Metadata information attributes


logURL attribute

In addition to the unicast and multicast logging capabilities included with Windows Media Services, the logURL attribute enables each clientData element to direct logging information to other locations on the network. By using the logURL attribute within a clientData element, usage information about the elements contained within the clientData element is sent by the client to a logging program that either displays the data, integrates it into a database, or saves it as a file. Logging data is sent once for each address specified in the logURL attribute.

The logURL attribute is particularly useful if you require logging data for individual elements in a playlist or if you want to send relevant data about specific elements in the playlist directly to the content providers. If you are working with an advertising partner that wants real-time data about the clients that receive their advertisements, you can provide that information by using the logURL attribute. The log data sent using the logURL attribute can be received and interpreted by the multicast logging program Wmsiislog.dll. This means that any computer configured to receive multicast logs can receive data from the logURL attribute.

Client log data varies depending on the logURL attribute's parent element. In the following example, log data is sent to a network location running Showlog.asp when the client first opens the playlist and to a different network location running Wmsiislog.dll when the client plays the media element Example01.wmv.

<?wsx version='1.0'?>
<smil>
    <clientData logURL="http://webserver1/log/showlog.asp"/>
    <media src="Example01.wmv">
        <clientData logURL="http://webserver2/data/wmsiislog.dll"/>
    </media>
    <media src="Example02.wmv"/>
</smil>

The logURL attribute can be specified for the following playlist element:

  • clientData element.

Note Image Notes

  • If the user is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the logURL attribute is in correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • Distributing log files to customers
  • Logging data about multicast streams
  • Logging data about unicast streams
  • Metadata information attributes
  • Understanding logging


title attribute

The title attribute specifies a content title for a media element or collection of media elements. The title attribute value is included in the content description list that is sent to the client. Windows Media Player displays the value when the media element or elements are played. Values specified for the title attribute must be text strings.

In the following example, a title attribute value is specified for the source file, IntroFile1.wma.

<?wsx version="1.0"?>
<smil>
   <media id="intro" src="IntroFile1.wma">
      <clientData title="Windows Media Services Introductory Video"/>
   </media>
</smil>

The title attribute can be specified for the following playlist element:

  • clientData element

Note Image Notes

  • If the client is running Windows Media Player for Windows XP and earlier, the clientData element information will be ignored. The clientData element is supported by Windows Media Player 9 Series.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the title attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • media element
  • Metadata information attributes


Synchronization attributes

The attributes in this section are used exclusively with the priorityClass element to define what happens when one child media element interrupts another. The priorityClass element must be contained within an excl element and can only have media elements as its child elements. Multiple priorityClass elements are prioritized by the order in which they are declared in an excl element.

This category consists of the following attributes:

  • higher attribute
  • lower attribute
  • peers attribute

Related topics

  • Playlist attributes


higher attribute

The higher attribute specifies the behavior of the media elements within a priorityClass element when they are interrupted by media elements of a higher priorityClass.

You can assign the following values to the higher attribute.

Value | Description
pause | Specifies that the media element pauses when its playback is interrupted by a media element that has a higher priority. The interrupted media element resumes playback when the higher-priority element ends. This is the default value for the higher attribute.
stop | Specifies that the media element stops when playback is interrupted by a media element in that has a higher priority. The interrupted element does not resume playback.

Priority is determined by the order in which priorityClass elements are declared in an excl element. The first priorityClass element in an excl element has the highest priority, and the last priorityClass element has the lowest priority.

A media element will be interrupted if the begin attribute of another media element is set to start while the first is still playing. You can also interrupt a media element by initiating a server event that triggers the start of another element. Server events can be initiated by using a script command that is embedded in a stream from an encoder or by using the server object model. For more information about server events, see the Windows Media Services Software Development Kit (SDK). For more information about stream switching using script commands, see priorityClass element.

The following example uses three priorityClass elements, each containing one media element. The priorityClass element P3 begins playback with the media element named Broadcast1, which is a broadcast stream from an encoder.

At 45 seconds, the media element named Ad1 interrupts Broadcast1 because it is the child of a higher priorityClass element called P2. Because the higher attribute of P3 is set to pause, Broadcast1 pauses when Ad1 interrupts and resumes playback when Ad1 ends.

After Ad1 plays for 10 seconds, the media element named Wait1 interrupts because it is the child of the higher priorityClass element called P1. Because P2 has a higher attribute value of stop, Ad1 will not continue playing when Wait1 finishes. As soon as Wait1 is complete, Broadcast1 resumes playback.

<?wsx version="1.0"?>
<smil>
   <excl>
      <priorityClass id="P1">
         <media id="Wait1" src="Bumper1.wma" begin="Ad1.begin+10s"/>
      </priorityClass>
      <priorityClass id="P2" higher="stop">
         <media id="Ad1" src="Ad1.wma" begin="45s"/>
      </priorityClass>
      <priorityClass id="P3" higher="pause">
         <media id="Broadcast1" src="http://encoder:1000" begin="0s"/>
      </priorityClass>
   </excl>
</smil>

The higher attribute can be specified for the following playlist element:

  • priorityClass element

Note Image Notes

  • Do not use a JPEG image file as a child element of a priorityClass element if the image is to be paused using either the peers or higher attributes. Pausing the image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • For more information about defining playlist attributes, see the Windows Media Services SDK at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the higher attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • excl element
  • id attribute
  • lower attribute
  • media element
  • peers attribute
  • priorityClass element
  • Synchronization attributes


lower attribute

The lower attribute specifies the behavior of the media elements within a priorityClass element when they are interrupted by media elements of a lower priorityClass.

You can assign the following values to the lower attribute.

Value | Description
defer | Specifies that an attempt by a lower-priority media element to interrupt playback is deferred. Playback of the interrupting media element begins when the higher-priority media element ends. This is the default behavior.
never | Specifies that an attempt by a lower-priority media element to interrupt playback is denied. The interrupting media element does not play.

Priority is determined by the order in which priorityClass elements are declared in an excl element. The first priorityClass element in an excl element has the highest priority, and the last priorityClass element has the lowest priority.

A media element will be interrupted if the begin attribute value of another media element is set to start while the first is still playing. You can also interrupt a media element by initiating a server event that triggers the start of another element. Server events can be initiated by using a script command that is embedded in a stream from an encoder or by using the server object model. For more information about server events, see the Windows Media Services Software Development Kit (SDK). For more information about stream switching using script commands, see priorityClass element.

The following example shows three priorityClass elements which each contain one media element. Playback begins with the media element named Intro1 in the priorityClass element named P1. Music2 in P2 is set to start playing at 10 seconds. However, because the lower attribute value in P1 is set to defer, Music2 cannot start playing until Intro1 finishes. Music3 in P3 is set to start playing 10 seconds after Music2 begins. However, because the lower attribute value in P2 is set to never, Music3 cannot interrupt Music2 and therefore never plays.

<?wsx version="1.0"?>
<smil>
    <excl>
        <priorityClass id="P1" lower="nefer">
            <media id="Intro1" src="Intro1.wmv" begin="0s"/>
        </priorityClass>
        <priorityClass id="P2" lower="never">
            <media id="Music2" src="Music2.wmv" begin="10s"/>
        </priorityClass>
        <priorityClass id="P3">
            <media id="Music3" src="Music3.wmv" begin="Music2.begin+10s"/>
        </priorityClass>
    </excl>
</smil>

The lower attribute can be specified for the following playlist element:

  • priorityClass element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services SDK at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the lower attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • excl element
  • higher attribute
  • id attribute
  • media element
  • peers attribute
  • priorityClass element
  • Synchronization attributes


peers attribute

The peers attribute specifies the behavior of a media element within a priorityClass element when its playback is interrupted by another media element in the same priorityClass (called a peer).

You can assign the following values to the peers attribute.

Value | Description
pause | Specifies that the media element pauses when its playback is interrupted by a peer media element. The interrupted media element resumes playback when the peer ends.
stop | Specifies that the media element stops when its playback is interrupted by a peer media element. Playback does not resume. This is the default value for media elements contained within an excl or priorityClass element.
defer | Specifies that an attempt by a media element to interrupt playback of a peer is deferred. Playback begins when the peer element ends.
never | Specifies that an attempt by a media element to interrupt playback of a peer element is denied. The interrupting element does not play.

Priority is determined by the order in which priorityClass elements are declared in an excl element. The first priorityClass element in an excl element has the highest priority, and the last priorityClass element has the lowest priority.

A media element will be interrupted if the begin attribute value of another media element is set to start while the first is still playing. You can also interrupt a media element by initiating a server event that triggers the start of another element. Server events can be initiated by using a script command that is embedded in a stream from an encoder or by using the server object model. For more information about server events, see the Windows Media Services Software Development Kit (SDK). For more information about stream switching using script commands, see priorityClass element.

You can also cause one element to interrupt another by using timing values, such as SyncBase values and offsets. In the following example, the media element named Program lasts 24 minutes, and Ad1, Ad2, and Ad3 are two-minute commercials. Because its begin attribute time is set to 0s, Program starts when the publishing point starts. After Program plays for seven minutes, Ad1 interrupts. Because the peers attribute value of the priorityClass element is pause, Program pauses until Ad1 ends. At that point, Program begins playing again from the point at which it was paused. After Program has played for 15 minutes and 22 minutes, Ad2 and Ad3 play, respectively. Note the variety of methods for entering a time value.

<?wsx version='1.0'?>
<smil>
   <excl>
      <priorityClass peers="pause">
         <media id="Program" src="Pgm.wma" begin="0s"/>
         <media id="Ad1" src="Comml1.wma" begin="7min"/>
         <media id="Ad2" src="Comml2.wma" begin="program.begin+15min"/>
         <media id="Ad3" src="Comml3.wma" begin="00:22:00"/>
      </priorityClass>
   </excl>
</smil>

The peers attribute value of defer is used in the following example. When the playlist starts, the media element named Clip3.wmv begins playing. The remaining elements are set to begin one and two seconds after Clip3.wmv begins. However, because the peers attribute value of the priorityClass element is defer, Clip2.wmv cannot play until Clip3.wmv finishes. Likewise, Clip1.wmv must waits until both elements finish before it can play.

<?wsx version='1.0'?>
<smil>
   <excl>
      <priorityClass peers="defer">
         <media src="Clip1.wmv" begin="2s"/>
         <media src="Clip2.wmv" begin="1s"/>
         <media src="Clip3.wmv" begin="0s"/>
      </priorityClass>
   </excl>
</smil>

The peers attribute can be specified for the following playlist element:

  • priorityClass element

Note Image Notes

  • Do not use a JPEG image file as a child element of a priorityClass element if the image is to be paused using either the peers or higher attributes. Pausing the image in this manner can cause the player to enter a permanent wait state. If you must show a still image under these circumstances, create a video file of that image and then use the video file in the playlist instead.
  • For more information about defining playlist attributes, see the Windows Media Services SDK at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the peers attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • begin attribute
  • excl element
  • higher attribute
  • lower attribute
  • media element
  • priorityClass element
  • Synchronization attributes
  • Timing values


Timing attributes

The attributes in this section define the timing of an element, such as when one element begins and ends in relation to other elements. This section also describes the values that can be used with timing attributes.

This category consists of the following topics:

  • Timing values
  • begin attribute
  • clipBegin attribute
  • clipEnd attribute
  • dur attribute
  • end attribute
  • endSync attribute
  • repeatCount attribute
  • repeatDur attribute
  • syncEvent attribute

Related topics

  • Playlist attributes


Timing values

A timing attribute and its value define the aspects of an element's behavior that relate to time and sequence. For example, the timing value assigned to a begin attribute defines when an element starts playing; while the timing value assigned to a clipEnd attribute defines when a media element ends. If an attribute has no assigned value, the default value is used.

Timing values are specified as either clock values or as events. In cases where a clock value is used, the value can be shown in the following ways (where h is hours, m is minutes, s is seconds and ms is milliseconds):

  • Full clock (h:m:s.ms)
  • Partial clock (m:s.ms)
  • Timecount

For more information about clock value time formats, see Time formats.

Timing values that are specified as events consist of the id attribute value of the trigger element followed by a period (.) and the attribute of the trigger element on which the timing is based. For example, a begin attribute value of Advert1.begin means that an element is set to begin playing when the media element Advert1 starts.

The following sections describe the supported timing values and their use.

SyncBase

A SyncBase timing value is a value that is based on the timing of another element or on an event. SyncBase timing values can only be used with excl and media elements.

The default SyncBase value is the start of the parent element. The following is an example of an attribute using a SyncBase value. In this case, the begin attribute is dependant upon the end of the Advert1 media element:

begin="Advert1.end"

Offset

An offset timing value refers to the length of time between a specific event and the time you want to specify. If no event is specified, the default event that is used for offset timing values is the SyncBase timing value. For example, given the SyncBase value in the previous section, an offset timing value of +30s is equivalent to a value of Advert1.end+30s.

The first element in a playlist is indicated with an offset value of 0s or 00:00.

All of the following examples are valid offset values that result in a delay of 30 seconds from the SyncBase timing value:

end=30s
end=+30s
end=00:30
end=+00:30

SyncEvent

A SyncEvent timing value defines the timing value in relation to an event. In playlists, events are defined by the syncEvent attribute. For example, the wrapper playlist element could start based on a syncEvent attribute in a broadcast playlist. This timing value is specified using the syncEvent attribute value in the broadcast playlist followed by a period (.) and either begin or end. You can also combine a SyncEvent timing value with an offset timing value for greater flexibility. SyncEvent timing values can only be used with media and excl elements.

In the following example, the begin attribute uses a combination of SyncEvent and offset timing values to indicate a time of 10 seconds after the start of the element with a syncEvent attribute named AdEvent:

begin="AdEvent.begin+10s"

SyncToPrev

A SyncToPrev timing value bases the timing of an element on the beginning or end of the element that immediately preceded it. You can also combine a SyncToPrev timing value with an offset timing value for greater flexibility.

In the following example, the begin attribute indicates a time that corresponds to the end of the previous element:

begin="prev.end"

Event

An Event timing value bases the activation of an element on a server event. Typically, a server event is raised by script commands encoded in a broadcast stream. If a broadcast publishing point receives a FIRE_EVENT script command from a live stream, the server searches the playlist for a media element that has a begin attribute value equal to the value associated with the FIRE_EVENT command. If there is a matching media element, that element interrupts the broadcast.

Events can also be raised by a plug-in or by an application based on the Windows Media Services Software Development Kit (SDK). Events can only be used with excl and media elements.

In this example, if the server receives a script command from the broadcast stream with the type FIRE_EVENT and a value of AdEvent, the server interrupts the broadcast and plays the media element that has a begin attribute that matches the FIRE_EVENT value:

begin="AdEvent"

Indefinite

An attribute that has a timing value of indefinite is intentionally not defined. indefinite can be used with both the repeatCount and repeatDur attributes to cause the element to repeat until an event occurs to end the element. In this example, the repeatCount attribute is specified with an indefinite value so that the element will repeat for as long as the publishing point is active:

repeatCount="Indefinite"

Related topics

  • begin attribute
  • end attribute
  • syncEvent attribute
  • Timing attributes


begin attribute

The begin attribute specifies the timing value used to start or activate an element.

The begin attribute works differently depending on the element it is used with. If used with a media element, the begin attribute value specifies when the content source begins playing.

Child elements of seq or smil elements begin automatically and play sequentially, so they do not require a begin attribute value to start. You can add a begin value if you do not want an element in a seq or smil container to start immediately after the previous element. Offset values are the only supported timing values for child elements of seq or smil containers, and the value for the begin attribute must be positive.

The begin attribute is most useful for activating elements in excl or priorityClass elements. Unlike the immediate children of seq or smil containers, child elements of an excl or priorityClass element have no default start time, and will therefore not start without a begin attribute value.

An element can be activated relative to the timing of other elements in the playlist or by a server event. You can use the begin attribute with a list of semicolon-delimited event values to identify multiple times when the element should be played; for example begin="event1;event2;event3". Negative time values and time values that are shorter in duration than the length of the element are ignored. For complete information about the supported begin attribute values, see Timing values.

In the following example, the media element Intro.wma starts the playlist because it has begin attribute value of 0s. When a begin attribute value uses an offset timing value without a SyncBase timing value, such as in this example, the currently active element (excl) is the implied SyncBase, or point of time reference. When the playlist starts, the excl element becomes the first active element because it has a media element that has a begin value of 0s.

Ten seconds into the playlist named Prog, the third media element in the priorityClass element, interrupts playback of Intro.wma because it has a begin attribute value of 10s. After Prog has played for 10 seconds, the media element Comml1 interrupts because it has a begin attribute value of prog.begin+10s. Note that Comml1 has a begin attribute value that is relative to the media element Prog instead of relative to the time container. Similarly, when Comml1 ends, Comml2 plays because it has a begin attribute value of comml1.end. Because the priorityClass element has a peers attribute value of pause, Prog will continue playing when Comml2 ends.

<?wsx version="1.0"?>
<smil>
    <excl>
        <media src="Intro.wma" begin="0s"/>
        <priorityClass peers="pause">
            <media id="Comml1" src="Commercial1.wma"
             begin="prog.begin+10s"/>
            <media id="Comml2" src="Commercial2.wma"
             begin="comml1.end"/>
            <media id="Prog" src="Program.wma" begin="10s"/>
        </priorityClass>
    </excl>
</smil>

The begin attribute can be specified for the following playlist elements:

  • excl element
  • media element
  • seq element
  • smil element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the begin attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • end attribute
  • id attribute
  • priorityClass element
  • Time formats
  • Timing attributes
  • Timing values


clipBegin attribute

The clipBegin attribute specifies the point in a media element source at which playback begins. If no clipBegin attribute value is set, playback begins at the beginning of the element. If the value specified is greater than the duration of the media element or is another invalid value, the clipBegin attribute value is ignored. The values of clipBegin attributes are not valid for broadcast sources, and only positive offset values can be used. The value of the clipBegin attribute must be in valid time format. For more information about time formats, see Time formats.

If the clipBegin attribute is used with a video file, the element will actually begin on the nearest key frame prior to the clipBegin attribute value. For example, if a video file has key frames every 5 seconds, and the clipBegin attribute value is 12s, the video will actually begin at 10 seconds. This is done so that the first frame that appears is a complete frame. If a video file were to start playing back on any other frame, the user would see an incomplete picture until the next key frame.

Keep in mind the difference between the clipBegin and begin attributes. The begin attribute specifies a start time value in relation to other elements in a playlist, whereas the clipBegin attribute specifies a start time value in relation to the timeline of the media element itself.

In the following example, the media element Program.wma begins when Bumper1.wma ends and starts playing back at a point that is 35 seconds into the file.

<?wsx version="1.0"?>
<smil>
    <media src="Bumper1.wma"/>
    <media src="Program.wma" clipBegin="00:35"/>
</smil>

The clipBegin attribute can be specified for the following playlist element:

  • media element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • Society of Motion Picture and Television Engineers (SMPTE) values and markers are not supported in server-side playlists.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the clipBegin attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • begin attribute
  • clipEnd attribute
  • media element
  • Time formats
  • Timing attributes
  • Timing values


clipEnd attribute

The clipEnd attribute specifies the end point for a media element. If no clipEnd attribute value is set, playback continues until the natural end of an element. In most cases, the clipEnd and end attributes can be used interchangeably.

If a media element's clipEnd value is less than its clipBegin value, the media element is not played. If the clipEnd value is greater than the duration of an element, the clipEnd attribute value is ignored. If the media element is a playlist file, the clipEnd attribute value is applied to the first media element in the nested playlist. Only positive offset values can be used. The value of the clipEnd attribute must be a valid time format. For information about time formats, see Time formats.

In the following example, the clipEnd attribute is used with the clipBegin attribute to play back a short section of a long lecture video. The media element Intro.wmv plays all to completion, followed by the first segment of LongLecture.wmv. The first segment ends at 01:23 minutes and is followed by the second segment which starts 5:35 minutes into the file. This segment ends at 7:05 minutes and is followed by the last segment, which plays from 12:30 to 15:00.

<?wsx version="1.0"?>
<smil>
    <media src="Intro.wmv"/>
    <media src="LongLecture.wmv" clipEnd="01:23"/>
    <media src="LongLecture.wmv" clipBegin="05:35" clipEnd="07:05"/>
    <media src="LongLecture.wmv" clipBegin="12:30" clipEnd="15:00"/>
</smil>

A dur attribute value could be used in this example instead of the clipEnd attribute. For example, the last segment could be defined as having a dur attribute value of 2.30m. An end value could also be used in place of clipEnd.

The clipEnd attribute can be specified for the following playlist element:

  • media element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • Society of Motion Picture and Television Engineers (SMPTE) values and markers are not supported in server-side playlists.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the clipEnd attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • clipBegin attribute
  • dur attribute
  • end attribute
  • media element
  • Time formats
  • Timing attributes
  • Timing values


dur attribute

The dur attribute specifies the length of time that an element plays.

Typically, the dur attribute is used to play back a shorter segment of a media element. For example, you could play 30 seconds from the middle of a 10-minute video file by using a dur attribute value of 30s and entering a clipBegin attribute value of 5:00. If you enter a dur attribute value that extends beyond the end of a media element, for example a dur value of 30s for a 20-second file, the value of the dur attribute is ignored.

If a dur value is specified for a time container element, the child elements can only play back during that amount of time. For example, if you specify a dur value of 2:00 for the smil element, the playlist plays back for two minutes and then stops.

In the following example, three media elements are child elements of an excl time container element. The media element named Logo plays first, because it has a begin value of 0s, and continues for a duration of 10 seconds. Billboard begins when Logo ends. Billboard starts playing 7 seconds into the file Bboard.wmv and continues to play for 10 seconds. Finally, Program plays back for two minutes 30 seconds.

<?wsx version="1.0"?>
<smil>
   <excl>
      <media id="Logo" src="Logo.wmv" begin="0s" dur="10s"/>
      <media id="Billboard" src="Bboard.wmv" begin="Logo.end"
       clipBegin="7s" dur="10s"/>
      <media id="Program" src="Prg.wmv" begin="Billboard.end" dur="2:30"/>
   </excl>
</smil>

The dur attribute supports offset values. For information about valid time formats, see Time formats. For more information about the offset value, see Timing values.

The dur attribute can be specified for the following playlist elements:

  • media element
  • excl element
  • seq element
  • smil element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the dur attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • begin attribute
  • clipBegin attribute
  • end attribute
  • media element
  • repeatDur attribute
  • Time formats
  • Timing attributes


end attribute

The end attribute specifies the timing value at which an element stops streaming data and ends. By default, the end attribute value is the natural end of the element.

Typically, the end attribute is used to stop a media element before its natural end. Any timing value can be used to define an end attribute value, but you will probably find that an offset value is the most useful. For example, an end attribute value of 30s stops the element 30 seconds after it has begun. Time container elements can also have end attribute values. These end attribute values determine the point at which a time container will stop streaming its child elements.

You can use the end attribute with a list of semicolon-delimited event values to identify multiple times when the element should end; for example end="event1;event2;event3". This indicates that if any of the events listed occurs, the element must stop playing. Time values greater than the length of the element and negative time values are ignored. For complete information about supported end values, see Timing values. For information about valid time formats, see Time formats.

In the following example, an excl element contains two child media elements. The media element named Intro plays as soon as the excl element begins. Ten seconds later, Intro ends, because it has an end attribute value of 10s. The media element named Music is configured to begin as soon as Intro ends and to play for 25 seconds. But because the parent excl element is configured to stop playing after its child elements have played for a total of 30 seconds, the child element Music will only be able to play for 20 seconds.

<?wsx version="1.0"?>
<smil>
   <excl begin="0s" end="30s">
      <media id="Intro" src="Audio1.wma" begin="0s" end="10s"/>
      <media id="Music" src="MusicTrack.wma" begin="Intro.end" end="25s"/>
   </excl>
</smil>

The end attribute can be specified for the following playlist elements:

  • media element
  • excl element
  • seq element
  • smil element

Note Image Notes

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the end attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • begin attribute
  • clipEnd attribute
  • dur attribute
  • media element
  • Time formats
  • Timing attributes
  • Timing values


endSync attribute

The endSync attribute enables you to base the end of an excl element on the end of one of its child elements.

The endSync attribute is used in situations in which child elements in an excl element can be activated randomly, such as through a program created using the Windows Media Services Software Development Kit (SDK). In these cases, the elements' begin attribute values or durations may be undetermined when the playlist is created, and the endSync attribute provides a way to control playback within the excl container after the playlist is online. The endSync attribute is particularly useful for an excl element that contains child elements of unknown durations or whose end is based on a particular event.

The endSync attribute can have the following values.

Value | Description
first | Specifies that the excl element ends after the first active child element ends.
all | Specifies that the excl element ends after all child elements that have a resolved begin attribute value end. Elements with an unresolved begin attribute value will prevent the excl element from ending because the duration cannot be determined.
id-value | Specifies that the excl element ends when the child element with the specifed id attribute value ends.
last | Specifies that the excl element ends when the last active child element with a resolved and definite begin attribute value ends. If there are no children with a resolved begin attribute value, the excl element ends immediately.

When you specify an endSync attribute value for an excl element, you define the duration of the excl element based on the duration of its child elements. The following rules dictate how the playlist evaluates the endSync attribute value:

  • If both the endSync and dur attributes are specified for an excl element, the endSync attribute is ignored because the dur attribute defines the duration of the excl element.
  • If both the endSync and end attributes are specified for an excl element, but not the dur, repeatDur or repeatCount attributes, the endSync attribute is ignored. In this case, the element's duration is indefinite and is defined by the end attribute value.
  • If an element is paused, it has not ended its active duration. The playlist must consider paused elements when evaluating the endSync attribute. For example, if a excl element has an endSync attribute that is equal to last and child elements that are paused, the excl element cannot end until the paused children resume or otherwise end.

In the following example, the endSync attribute value is first. The second and third media elements are never played because the excl element ends after the first media element, Clip_1.wmv, ends.

<?wsx version="1.0"?>
<smil>
  <excl endSync="first">
    <media src="C:\Wmpub\Wmroot\Clip_1.wmv" begin="0s" clipEnd="10s" />
    <media src="C:\Wmpub\Wmroot\Clip_2.wmv" begin="15s" dur="15s" />
    <media src="http://encoder_name:80" begin="Event1" />
  </excl>
</smil>

However, if the endSync attribute value in this example was equal to last, the first and second media elements would play, but the third media element would not, because it has an indeterminate start time. If the endSync attribute value in this example was equal to all, all three media elements would play, but the element that sources from an encoder would not start playing until the event specified by the begin attribute occurs.

The endSync attribute can be specified for the following playlist element:

  • excl element

Note Image Notes

  • If an endSync attribute value is not specified for an excl element, the excl element acts as if the endSync attribute was defined as last, by default.
  • For more information about defining playlist attributes, see the Windows Media Services SDK at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the endSync attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • begin attribute
  • dur attribute
  • end attribute
  • excl element
  • id attribute
  • Timing attributes


repeatCount attribute

The repeatCount attribute specifies how many times an element repeats. For example, a repeatCount attribute value of 2 means an element plays twice (repeating once). You can use this attribute to repeat a media element or a time container element, such as a seq or excl element.

The repeatCount attribute can have the following values.

Value | Description
number | Specifies how many times the timeline repeats. Fractions are rounded up to the nearest whole number. For example, 2.1 would be rounded up to 3.
indefinite | Specifies that the element should repeat indefinitely.

If you want to base playback on duration rather than on the number of repetitions, use the repeatDur attribute instead. Typically, you will use either the repeatDur attribute or the repeatCount attribute, but not both. If both are defined for the same element, the element will repeat for the duration specified in the repeatDur attribute and then repeat for the count specified in the repeatCount attribute.

In the following example, the repeatCount attribute causes the entire playlist, which contains an individual media element and an excl element, to repeat. Although this is not a practical example, it demonstrates how the repeatCount attribute works with elements.

First, the media element named Logo plays twice because it has a repeatCount attribute value of 2. Then the elements in the excl element play through and repeat because the excl element also has a repeatCount attribute value of 2. Finally the entire playlist plays for a second time.

<?wsx version="1.0"?>
<smil repeatCount="2">
    <media id="Logo" src="Logo.wmv" repeatCount="2"/>
    <excl repeatCount="2">
        <media id="Music1" src="Music1.wmv" begin="0s"/>
        <media id="Music2" src="Music2.wmv" begin="Music1.end"/>
    </excl>
</smil>

The repeatCount attribute can be specified for the following playlist elements:

  • excl element
  • media element
  • seq element
  • smil element

Note Image Note

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the repeatCount attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • excl element
  • media element
  • repeatDur attribute
  • seq element
  • Timing attributes


repeatDur attribute

The repeatDur attribute specifies the length of time that an element repeats before stopping. For example, a media element that is five seconds long with a repeatDur attribute value of 20s plays four times and then stops. If an element is still playing when the repeatDur attribute value ends, the element stops, even if it has not repeated. Thus, when it has a specified repeatDur attribute value, an element may repeat many times, repeat for a fractional number of times, never repeat, or play for a shorter time than its duration. You can use this attribute to repeat a media element or a time container element, such as a seq or excl element.

The repeatDur attribute can have the following values.

Value | Description
time | Specifies the total duration of the repeated element. For information about valid time formats, see Time formats.
indefinite | Specifies that the element should be repeated for an indefinite duration.

If you want to base playback on the number of repetitions rather than on the duration, use the repeatCount attribute instead. Typically, you will use either the repeatDur attribute or the repeatCount attribute, but not both. If both are defined for the same element, the element will repeat for the duration specified in the repeatDur attribute and then repeat for the count specified in the repeatCount attribute.

In the following example, the repeatDur attribute causes the entire playlist, which contains an individual media element and an excl element, to repeat. Although this is not a practical example, it demonstrates how the repeatDur attribute works with elements.

First the media element named LogoGroove repeats for 15 seconds because it has a repeatDur attribute value of 15s. Then the media elements in the excl container play through and repeat for 30 seconds because the excl element has a repeatDur attribute value of 30s. Finally, the entire playlist repeats for a total of three minutes. Given that the total duration of the playlist is 45 seconds, the playlist will repeat four times.

<?wsx version="1.0"?>
<smil repeatDur="3:00">
    <media id="LogoGroove" src="LG.wma" repeatDur="15s"/>
    <excl repeatDur="30s">
        <media id="Introduction" src="Intro.wma" begin="0s"/>
        <media id="Sample" src="Sample.wma" begin="Introduction.end"/>
    </excl>
</smil>

The repeatDur attribute can be specified for the following playlist elements:

  • excl element
  • media element
  • seq element
  • smil element

Note Image Note

  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the repeatDur attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.

Related topics

  • excl element
  • media element
  • repeatCount attribute
  • seq element
  • Time formats
  • Timing attributes


syncEvent attribute

The syncEvent attribute can be used to activate an element in a wrapper playlist from an element in a broadcast playlist that is being streamed from a publishing point.

Wrapper playlists are commonly used to deliver introductory content such as announcements and other information to the user before and/or after the requested content streams. The syncEvent attribute also enables you to insert wrapper playlists during user-requested content; for example, you can use a wrapper playlist to interrupt a broadcast with an advertisement and then return to the broadcast. The syncEvent attribute can be used to switch from a broadcast to a wrapper element and then switch back to the live broadcast.

Using the syncEvent attribute to activate an element in a wrapper playlist is a two-part process. First, you must select an element in the broadcast playlist that will activate the wrapper element. Then you must configure the wrapper playlist to respond to the event and interrupt the broadcast playlist. In the broadcast playlist, choose the element that will initiate the event and assign it a syncEvent attribute with a unique name, such as PlayEvent1. In the wrapper playlist, choose the element that will play when the event specified by the syncEvent attribute occurs. The element in the wrapper playlist must be a child element of an excl element for the server to be able to switch to the wrapper content properly.

Next you must configure the begin attribute of the wrapper playlist element to start at either the beginning or the end of the broadcast playlist element that initiates the syncEvent. For example, to start the wrapper playlist element after the broadcast playlist element PlayEvent1 ended, you would use the following syntax:

begin="PlayEvent1.end"

Additionally, if you want the broadcast playlist to resume playback after the wrapper playlist ends, ensure that the wrapper element is contained in a priorityClass element with a peers attribute value of pause.

The syncEvent attribute value can only be used with broadcast publishing points. Keep in mind that the broadcast publishing point runs independently of the wrapper playlist. As the wrapper element plays, the broadcast playlist continues to run. Therefore, you may need to consider how to maintain synchronization when using a syncEvent attribute. For example, if you plan to switch from a broadcast to a 60-second wrapper announcement, you may want to insert a 60-second placeholder file in the broadcast playlist, so that the broadcast playlist will resume at the right time. Note that clients that connect to the publishing point while the wrapper element is playing will not receive the wrapper content. Your placeholder file should provide the user with something besides silence or a blank screen and indicate that the content will resume eventually.

The following two sample playlists provide an example of a syncEvent attribute implementation. The first playlist is the source for a broadcast publishing point; the second is the associated wrapper playlist. The second media element in the broadcast playlist contains a syncEvent attribute with a value of Wrap. When that media element becomes active, the associated wrapper playlist is searched for an element with a begin or end attribute value equal to Wrap.

<?wsx version="1.0"?>
<smil>
    <media src="ProgSegment1.wmv"/>
    <media src="Bumper.wmv" syncEvent="Wrap"/>
    <media src="Break1.wmv" dur="30s"/>
    <media src="ProgSegment2.wmv"/>
</smil>

The second media element in the following wrapper playlist has a begin attribute value of Wrap.end. Therefore, when the broadcast playlist media element Bumper.wmv activates the syncEvent attribute, the corresponding wrapper element plays back after Bumper.wmv ends. Because the media element LocalAd.asp is contained in a priorityClass element that has a peers attribute value equal to pause, the broadcast playlist resumes playback after the wrapper playlist element finishes.

<?wsx version="1.0"?>
<smil>
    <excl>
        <priorityClass peers="pause">
            <media src="%requestedUrl%" begin="0s"/>
            <media src="httpd://webserver1/localad.asp" begin="Wrap.end"/>
        </priorityClass>
    </excl>
</smil>

In the following example, the publishing point source is a playlist that references a broadcast stream from an encoder. When the encoder sends a script command to the server containing the type FIRE_EVENT and the value PlayEvent, the media element named Bmp becomes active and the syncEvent attribute value of Wrap signals the wrapper playlist to begin streaming. When Bmp ends, the wrapper playlist streams to the client while the server-side playlist continues with the media element named Break. Assuming the wrapper element is a 30-second advertisement, the broadcast playlist resumes playback of the live encoder stream after the wrapper element ends.

<?wsx version="1.0" ?>
<smil>
   <excl>
      <priorityClass peers="pause">
         <media id="Live" src=http://encoder:8080 begin="0s"/>
         <media id="Bmp" src="Bumper.wmv" begin="PlayEvent"
          syncEvent="Wrap"/>
         <media id="Break" src="break1.wmv" begin="Bmp.end" dur="30s"/>
      </priorityClass>
   </excl>
</smil>

The syncEvent attribute can be specified for the following playlist elements:

  • excl element
  • media element
  • priorityClass element
  • seq element
  • smil element
  • switch element

Note Image Notes

  • The syncEvent attribute is a Microsoft extension to the Synchronized Multimedia Integration Language (SMIL 2.0) specification. For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.
  • The syncEvent attribute can only be used with content that is being delivered as a unicast stream.
  • It is recommended that you manually start the broadcast publishing point if you are using the syncEvent attribute. The behavior specified by the syncEvent attribute will not occur if the publishing point starts when the first client connects and if there is only a single client connection.
  • If you are creating or editing server-side playlists by using either a text editor or an automated script, ensure that the syncEvent attribute tags are in the correct case. XML is a case-sensitive language, and Windows Media Services will not recognize playlist attributes that are not listed properly.
  • For more information about defining playlist attributes, see the Windows Media Services Software Development Kit (SDK) at the Microsoft Web site.

Related topics

  • About wrapper playlists
  • begin attribute
  • excl element
  • peers attribute
  • priorityClass element
  • Timing attributes


Time formats

The begin, clipBegin, clipEnd, dur, end, and repeatDur element attributes support timing and synchronization. You can use the following three formats to denote time in playlist element attributes.

Format Description
Full clock Uses the following syntax:

hours:minutes:seconds.decimal

For example, the following value represents 50 hours, 10 seconds, and 250 milliseconds:

50:00:10.25
Partial clock Uses the same syntax as the full-clock format, except that hours are not included:

minutes:seconds.decimal

For example, the following value represents 10.5 seconds:

00:10.5
Timecount Uses the following syntax:

integer(.decimal)(suffix)

The decimal and suffix values are optional. For example, the following value represents 1 hour and 30 minutes:

1.5h

Valid values for suffix are h (hours), min (minutes), s (seconds), and ms (milliseconds). The default value is s.

Examples

The following values represent 3 hours and fifteen minutes:

  • 3.25h
  • 03:15:00.0

The following values represent 45 minutes:

  • 45min
  • 45:00.0

The following values represent 30 seconds:

  • 30
  • 30s
  • 00:30.0

The following values represent 5 milliseconds:

  • 5ms
  • 00:00.005

Note Image Note

  • For more information about the SMIL 2.0 Specification, W3C Recommendation, see the W3C Web site.

Related topics

  • begin attribute
  • clipBegin attribute
  • clipEnd attribute
  • dur attribute
  • end attribute
  • Playlist reference
  • repeatDur attribute


Deployment guide

This section describes the practical application and deployment of Windows Media Services. Since Windows Media Services is an extremely versatile and configurable technology, you can use it to achieve a suitable streaming media solution for almost any situation. The following information can assist you during the deployment process and enable you to use your knowledge of local hardware and network conditions to set up a streaming media solution that suits your needs.

Any streaming media project has three main stages: project planning, assembling and managing the content, and coordinating content distribution. In addition to these three stages, there are many initial precautions and follow-up steps that you can take to improve the streaming media process.

Overview

A streaming media system based on Windows Media Technologies typically consists of a computer running an encoder, such as Windows Media Encoder, a server running Windows Media Services, and a number of client computers running a player, such as Windows Media Player. The encoder converts both live and prerecorded audio and video content to Windows Media Format. The Windows Media server distributes the content over a network or the Internet. The player then receives the content.

Overview of streaming media request

In the typical user scenario, the user clicks a link on a Web page to request content. The Web server then redirects the request to the Windows Media server and starts the player on the user's computer. At this point, the Web server no longer plays a role in the streaming media process, since the Windows Media server establishes a direct connection with the player and begins streaming the content directly to the user.

Overview of content sources

The Windows Media server can receive content from several different sources. Prerecorded content can be stored locally on the server or retrieved from a networked file server. Live events can be captured using a digital recording device and processed through an encoder before being sent to the Windows Media server for broadcast. Windows Media Services can also rebroadcast content streamed from a publishing point on a remote Windows Media server.

Preliminary considerations

An effective streaming media deployment requires that you successfully manage three primary factors: the bandwidth available to your audience, the capabilities of your network or Internet connection, and the streaming requirements of your content.

The first, most important, factor is your audience. The amount of bandwidth your audience has available plays a key role in determining the type and quality of the content you provide. A large, high-definition video stream with stereo sound requires more bandwidth than is available for clients using a standard, dial-up modem connection. You should also know how large your audience will be. Even a small number of high-speed streams can affect the performance of the average commercial network or Internet gateway.

Evaluating your network capacity is the second factor. A computer network such as a local area network (LAN) can transfer a limited amount of data at a given time. Each individual connection to that network uses up a portion of its capacity. As the total amount of data being transferred approaches the network limit, individual data connections begin to slow down. When planning your streaming media deployment, make sure that your network capacity is well beyond the bandwidth requirements of your content.

Content is the most flexible and diverse factor. With both audio and video, improved content quality increases the bandwidth requirements. The use of quality improvement methods such as multiple-bit-rate encoding or variable-bit-rate encoding can create large differences in necessary bandwidth. Before it can be streamed to the audience, live and prerecorded content goes through the encoding process. The choices that are made during this process have a significant impact on the range of audience you can reach and the amount of necessary bandwidth.

This section covers the following topics:

  • Deployment considerations
  • Content management and production
  • Capacity planning
  • Follow-up considerations

Related topics

  • 7Windows Media Services


Deployment considerations

A streaming media deployment project does not have to be difficult. In all deployment scenarios, there are some basic choices you must make. Your choices will be guided by the type of digital media content you want to distribute, the nature of your audience, and the equipment you want to use to deliver the content. The topics in this section are designed to provide you the necessary background so that you can make informed choices about your deployment.

This section covers the following topics:

  • Streaming live vs. prerecorded content
  • Selecting unicast vs. multicast distribution

Related topics

  • About on-demand and broadcast playlists
  • Deployment guide
  • Streaming from a Windows Media server vs. a Web server


Streaming live vs. prerecorded content

Windows Media Services can be used to stream either live or prerecorded content. However, there are some differences in how you should approach developing a streaming solution depending on whether the content is live or prerecorded.

Live content

You can obtain live content in several different ways. You can connect a live capture device such as a microphone or digital camcorder to a computer that is running an encoder, such as Windows Media Encoder, and has a network connection to the Windows Media server. You can also connect other digital media playback devices such as video and CD players to the encoding computer in the same fashion to create a live broadcast of recorded material.

Normally, you will stream live content as a broadcast instead of as an on-demand stream because the user cannot control the playback of live content. In addition, network connections between the encoder and the server should have a allocated amount of bandwidth that can not be interrupted by other network traffic.

Additionally, the system is less able to recover from streaming errors during a live broadcast because the content is only in the buffer memory of the server for a short amount of time. You can use forward error correction to provide error correction during playback without forcing the player to request error correction information from the server.

If you want your content to be available to users after the broadcast ends, consider archiving the broadcast so you can either rebroadcast the content or provide it on demand.

Prerecorded content

Prerecorded content is the easiest type of content to manage and set up. It typically takes the form of pre-encoded digital audio or video files that can be rendered using a player, such as Windows Media Player. You can stream a single file or several files, or you can create a playlist file that organizes your content into a cohesive user experience.

If your prerecorded content is stored in a network source rather than on the local server, verify that the server has access to the network and can retrieve the content in a timely manner. Typically, this is not a concern because the server can retrieve prerecorded content at a high data rate because the server does not have to render the content.

When streaming prerecorded content you should decide what type of user experience you want to create. Prerecorded content can be streamed using both on-demand and broadcast publishing points.

Related topics

  • Deployment considerations
  • Obtaining content
  • Sourcing from an encoder
  • Supporting different file types
  • Understanding playlists


Selecting unicast vs. multicast distribution

Unicast and multicast are two distinct forms of streaming media distribution. Each has unique strengths and weaknesses based on the nature of your audience and the type of content.

Unicast

A unicast broadcast transmits a single stream to each player. Unicast streaming offers the benefits of interactivity between the player and server, easier setup, and multiple-bit-rate streaming capability. However, the number of users that are able to receive unicast streams is limited by the bitrate of the content and the speed of the server network. A large unicast audience can quickly overwhelm a network or server. Consider using unicast streaming if:

  • You want to take advantage of multiple-bit-rate encoding and intelligent streaming.
  • Your projected audience size and content bitrate is compatible with the capabilities of your network and server.
  • You require a detailed client log.
  • Your network is not multicast-enabled.

Multicast

A multicast transmission creates a one-to-many relationship with clients. The server broadcasts a single stream, and users may then access the stream in progress. Users do not have control of content playback. Multicast streams are much less demanding on the server and network but may require network modification for multicasts and regular network traffic to coexist effectively. Consider using multicast streaming if:

  • You are broadcasting content to a large audience, and network bandwidth and server capacity are limited.
  • Your network is multicast-enabled.

Note Image Note

  • Multicast streaming and the WMS Multicast Data Writer plug-in are available only if Windows Media Services 9 Series is running on the following editions of the operating system: Windows Server 2003, Enterprise Edition and Windows Server 2003, Datacenter Edition. If you are running Windows Server 2003, Standard Edition, these features are not supported.

Related topics

  • Delivering content as a multicast stream
  • Delivering content as a unicast stream
  • Deployment considerations


Content management and production

Content management methods and priorities will differ from one project to another based on a variety of factors, such as audience demographics, content type, and available equipment. This section addresses the issue of content management in terms of either live or prerecorded content. Because advertising content can be presented in so many different ways, it is discussed separately from the other types of content.

As with any complex project, planning is your first priority. Because streaming media projects must operate flawlessly and can be deployed in so many different ways, the importance of effective planning cannot be overstated. The following sections help you plan your content before preparing it for distribution:

  • Prerecorded content
  • Live content
  • 7Advertising content
  • Content distribution

Related topics

  • Deployment guide


Prerecorded content

Prerecorded content consists of digital media files. It is important that your digital media files are in the correct format for streaming and playback. You can configure the server running Windows Media Services to stream a single file or multiple files, according to your needs.

You can use a playlist to help you manage the distribution of your prerecorded content by using a single playlist file to point to any number or type of digital media files. After you create your playlists, you can use them to configure your content to stream any way you want.

There are a wide variety of digital media file formats, but not all of them can be streamed by using Windows Media Services. In certain cases, you must first convert your digital media files into a compatible format before they can be streamed.

The following topics will help you plan your prerecorded content and then prepare it for broadcast:

  • Supporting different file types
  • Planning prerecorded content
  • Storing content
  • Creating and editing offline playlists

Related topics

  • Content management and production


Supporting different file types

By default, you can use the following file types with Windows Media Services. The file name extensions of these files are provided in parentheses:

  • Advanced Systems Format files (.asf). These are Windows Media files that can contain several elements, such as video, audio, script commands, HTML, and metadata and can be encoded with any codec.
  • Windows Media Audio files (.wma). These digital media files are formatted using Advanced Systems Format and are encoded using the Windows Media Audio codec. They are generally audio files, although they can also contain scripts, pictures, and metadata.
  • Windows Media Video files (.wmv). These digital media files are formatted using Advanced Systems Format and are encoded using the Windows Media Video codec. They are generally video files, although they can also contain scripts and other instructions.
  • MP3 files (.mp3). These digital media files use the audio format from the Motion Pictures Experts Group (MPEG).
  • JPEG files (.jpeg or .jpg). These files are image files that are formatted according the Joint Photographic Expert Group standard.
  • Multicast information files (.nsc). These files are Windows Media metafiles that direct clients to a multicast broadcast. They are used to define the properties of a multicast stream to a player, such as Windows Media Player.
  • Client-side playlist files (.asx, .wax, and .wvx). These are Windows Media metafiles that are used as client-side playlists and as client redirectors by the server. They contain instructions and references for use by a player, such as Windows Media Player.
  • Server-side playlist files (.wsx). These files are a Windows Media metafiles that are used as server-side playlists. They can contain combinations of audio, video and image files.

You can also use the Windows Media Services 9 Series SDK to create custom media parsers to support additional file types. For more information on the Windows Media Services SDK, see the Microsoft Web site.

Note Image Notes

  • MP3 files cannot use the intelligent streaming feature in Windows Media Services.
  • You can stream other digital media file formats from a Windows Media server if an appropriate media parser plug-in is enabled. A media parser plug-in translates the information contained in the file into a format that is compatible with the Windows Media server and player. Contact the digital media format developer to see if there is a media parser available for the format you want to use.

Related topics

  • Prerecorded content
  • Understanding intelligent streaming


Planning prerecorded content

You can use your knowledge of your system capabilities and the capabilities of your audience to plan and develop content that will preserve as much of the quality of the original as possible throughout the encoding and streaming process. The planning process for prerecorded content differs significantly from the planning that must take place for live content.

For example, if the bit rate of your streaming audio files is too high for your audience's bandwidth capability, the stream will be forced to pause during playback so the player can buffer the content. If your bit rate is too low, the sound quality will suffer. Small adjustments to the encoding process, such as switching from stereo sound to mono sound, can reduce the required streaming bit rate by as much as half without impacting the quality of the sound.

You are also likely to encounter situations in which you will be streaming content to a wide range of audience bandwidth profiles: some on a local area network (LAN), others using a digital subscriber line (DSL), and still others connected through dial-up modems. Careful preparation of your content will allow you to stream content to all of these audiences simultaneously while providing each with the best possible quality.

Audio

You can stream audio content in either Windows Media Audio (WMA), ASF, or MP3 formats by using Windows Media Services. Prepare your audio content by converting or encoding it into one of these file formats.

Bandwidth is a concern when attempting to stream audio content. A high-quality stereo broadcast can easily overwhelm the abilities of a standard dial-up modem. There are several configurable components of an audio recording that can be adjusted during the encoding process to help you achieve the right balance of data transfer rate and audio quality. It is a good idea to experiment with your encoding process to find out what combination of settings works best for you. For more information about how audio content is prepared for streaming, see Windows Media Encoder Help.

If your audio content comes from several different sources, you may find that the quality of your content is inconsistent. Try to maintain a smooth, unbroken quality flow from one content file to the next.

Video

The bit rate of your digital media content is an even more important factor when attempting to stream video content. To avoid long delays, gaps, and distortion during playback, the video streaming bit rate should accommodate the often limited bandwidth of your audience's equipment.

Video is simply a rapid display of a series of still pictures, called frames. Each frame must display a certain amount of detail, or resolution, to render the subject accurately. As the frame resolution is enhanced, more detail is shown. The number of frames displayed per second is known as the frame rate. As the frame rate increases, the motion in the video becomes smoother. The bit rate of the stream is determined by the combination of video frame rate and resolution. Both of these parameters can be modified during the encoding process to achieve the ideal bit rate for the user.

Over a high-speed Internet connection or a LAN, smooth, high-resolution video is easily transmitted. Extremely fast networks can render video and audio content that rivals the quality of a DVD; however, over a typical telephone connection, high-quality video becomes impossible without prohibitively long buffering times. There are techniques that you can use during the video production and encoding processes that will improve the audience experience regardless of the type of connection being used:

  • Keep movement to a minimum. Rather than send the entire picture of each frame in a video, a digital media stream only details the differences from one frame to the next. If the differences are kept to a minimum, the bit rate can be kept low. While creating video content, minimize movement of the subjects, the camera, and the backgrounds in order to reduce the amount of information that must be streamed later.
  • Keep the production design simple. You can often reduce the number of bits it takes to render a video frame by reducing the complexity of a scene being shot. Shooting a subject against a plain background requires less data transfer than shooting a subject in front of a multicolored or irregular background. You can also sacrifice some sound quality in exchange for improved video quality during the encoding process, if video quality is more important than audio quality.
  • Make use of the intelligent streaming capability of Windows Media Services. You can set the encoder to encode your digital media at several different bit rates. That way, no matter what type of connection the user has, the Windows Media server will be able to send a stream that is optimized for that bit rate.

For more information about encoding, see Windows Media Encoder Help.

Note Image Note

  • MP3 files cannot use the intelligent streaming feature in Windows Media Services.

Related topics

  • Obtaining content
  • Prerecorded content
  • Understanding intelligent streaming
  • Understanding terminology


Storing content

Content storage only becomes a real concern when you are managing a large number of digital media files. In many cases, you can maintain all of the relevant digital media files in a directory on the server itself. As your content library grows, you may need to develop a separate file storage and management solution.

Naming

A file naming convention is one of the most useful content management techniques you can employ. For example, you can use alphanumeric codes to specify such things as digital media type, genre, artist, and sequence number. If used consistently, a well-designed file naming standard will enable you to manage virtually any number of files effectively.

Folders and servers

Dividing your digital media files into separate folders lets you cluster your content according to your own criteria. Keep the number of folders to a minimum to avoid confusion and redundancy.

Archives

Maintaining an up-to-date digital media library requires not just the addition of new content as it becomes available, but also the archival of old or obsolete content. It is usually not practical or necessary to delete inactive content, but inactive content should be removed from the active digital media library and stored in a way that will allow you to retrieve it at a later time. Use file compression technology if necessary to reduce file sizes to manageable levels.

Backup and security

Your content library, like any other repository of data, is vulnerable to damage or theft over the local network. Refer to your network documentation or ask your network administrator about setting up a system of user permissions and periodic backups for your content library.

Related topics

  • Prerecorded content


Live content

Streaming live content can have distinct advantages over streaming prerecorded content. Entertainment and news information generally have a greater impact when broadcast live, and certain time-sensitive information may have no value to the user if it is recorded and broadcast later.

Producing live content for broadcast does not have to be difficult or expensive. Even live video can be streamed relatively easily with the right equipment. Moreover, a live stream can consist of nothing more than connecting your encoder to a live feed from a television or radio signal.

In any case, notifying the audience of the proper time and URL of the live streaming event is very important. Notify users early and often to make sure they know where to connect and when.

As with any complex project, planning is your first priority. Because live digital media streams often cannot be revised or adjusted once they have begun, you must plan your broadcast before the event. The following topics help you plan your live content and then prepare it for broadcast:

  • Preparing live content
  • Use your server to publish live content from Windows Media Encoder
  • Archiving content

Related topics

  • Content management and production


Preparing live content

Careful planning and organization at the start of your project is important to the success of your live broadcast. The three primary steps in this process are: event preparation, input media preparation, and encoder preparation.

Event preparation

Regardless of the type of live broadcast event, you should set a predetermined start and end time. By setting a start time, you can let your audience know when the broadcast will take place.

Placement of the broadcast equipment is also an important factor in the planning process. The movement of your digital media capture device is restricted by the cable that connects it to the encoding computer. The encoding computer, in turn, must be networked to the computer running Windows Media Services, which of course must have access to a network or the Internet so that your audience can receive the stream.

If you intend to broadcast or rebroadcast copyrighted material, ensure that you have the proper permissions and licenses.

Input media preparation

Input media can consist of a capture device, such as a digital video camera or a microphone, or a feed from a media source, such as a television signal. Be sure that your capture device has a digital output signal or that you have the proper equipment for generating a digital output. Many camcorders and video cassette players are not compatible with the digital input requirements of an encoder, such as Windows Media Encoder.

You must know how your equipment operates. Practice your event beforehand to avoid mishaps during a live broadcast. Ensure that all batteries are sufficiently charged and that any required equipment maintenance has been performed.

Encoder preparation

Bit rate is the main concern when streaming digital media of any type. The bit rate affects both the range and number of people that will be able to experience your broadcast. In general terms, a low bit rate will allow you to reach the widest audience and permit the largest number of individual connections, but quality can suffer. Higher quality requires a higher bit rate, and the number of individual connections is limited.

Remember that audio and video encoding of live content occurs in real-time with no opportunities to change settings once you have begun. You should practice your broadcast beforehand to determine the proper encoder settings.

Live audio broadcasts are typically a simple encoding scenario. Even so, a high-quality stereo broadcast can easily overwhelm a standard dial-up modem connection. There are several configurable components of an audio capture that can be adjusted during the encoding process to help you achieve the right balance of bit rate and audio quality. For more information about how audio content is prepared for streaming, see Windows Media Encoder Help.

Encoding video content is a much more complicated process. Video is simply a rapid display of a series of still pictures, called frames. Each frame must display a certain amount of detail, or resolution, to render the subject accurately. As the frame resolution is enhanced, more detail is shown. The number of frames displayed per second is known as the frame rate. As the frame rate increases, the motion in the video becomes smoother. The bit rate of the stream is determined by the combination of video frame rate and resolution. Both of these parameters can be modified during the encoding process to achieve the ideal bit rate for the user.

Over a high speed Internet connection or a LAN, smooth, high-resolution video is readily available. Extremely fast networks can render video and audio that can rival the quality of a DVD; however, over a typical dial-up connection, high-quality video becomes impossible without prohibitively long buffering times. There are techniques that you can use during the production of your live video content that will improve the audience experience regardless of the type of connection being used:

  • Keep movement to a minimum. Rather than send the entire picture of each frame in a video, streaming media only sends information corresponding to the differences from one frame to the next. If the differences are kept small, the bit rate can be kept low. Minimize movement of the subjects, the camera, and the backgrounds to reduce the amount of information that must be streamed.
  • Keep the production design simple. Wherever possible, reduce the complexity of the video images being streamed. Filming a subject against a plain background is going to require the transfer of less data than using a multicolored or irregular background. You can also sacrifice some sound quality for improved video quality in the encoding process, depending upon where your priorities lay.
  • Make use of the intelligent streaming feature of Windows Media Services. You can set your encoder to encode your digital media at several different bit rates so that no matter what type of connection the user has, the Windows Media server will always send a stream that is optimized for that bit rate.

For more information about encoding, see Windows Media Encoder Help.

Related topics

  • Live content
  • Understanding encoding


Advertising content

Windows Media Services offers several advertising options for prerecorded and live content:

  • Wrapper ads. Streaming advertisements that play before or after the user views the live content. A wrapper advertisement is ideal for live content because it plays regardless of the point at which the user joins the broadcast.
  • Interstitial ads. Streaming ads that are inserted into a playlist with your content. You must use a playlist to make use of interstitial advertising.
  • Banner ads. Static or multimedia ads that appear on a player independent of the streaming content.

As with the other forms of content, planning is a necessary first step in the production of advertising content. This section contains the following topic:

  • Planning advertising

Related topics

  • About the Advertising tab for a publishing point
  • Content management and production
  • To add an advertisement to a playlist
  • Working with the Create Wrapper Wizard


Planning advertising

When you are using advertising with your streaming media solution, you must balance your advertising priorities with the type of content you are streaming, your advertiser's preferences, and the kind of experience you want your audience to have. For this reason, Windows Media Services offers a wide range of advertising options. Refer to the following topics for help in making your critical advertising decisions:

  • Working with wrapper ads. Learn how to add opening content to your stream when users first connect to it and closing advertisements when the stream ends. Typical content used as wrapper advertisements includes introductory pages that generate custom playlists, site branding information, and sponsor identification.
  • Displaying interstitial ads. Learn how to intersperse advertisements with other content in your playlist. The advertisements in the playlist can come from a local server or from an advertising service vendor, and you can make playback of the advertising mandatory during reception of the playlist.
  • Displaying banner ads. Learn how to display banner ads in players and on Web pages using Windows Media Services. Banners can include content such as animations, video streams, and audio streams.
  • Choosing an advertising infrastructure. Provides information about the different ways you can advertise by using Windows Media Services.
  • Creating advertisement policies. Provides information about the different operations you can perform on advertising content.
  • Personalizing advertising content. Provides information about how you can target advertising to a specific user.

Related topics

  • Advertising content


Content distribution

After you have determined the type of content you want to stream, you need to select the best way to distribute it. Windows Media Services offers two basic methods of streaming live or prerecorded content: through an on-demand publishing point or through a broadcast publishing point. The type of publishing point you choose determines the streaming format.

Some of the decisions you need to make when creating a new publishing point include:

  • What to name the publishing point. The name of your publishing point should be descriptive but also as brief as possible. When a client connects to your stream, the publishing point name is part of the address that directs the player to the content. Typing a long, complicated publishing point name is tedious and increases the chance for errors.
  • What type of content you want to stream. If you have properly prepared your content, you should have no trouble selecting your content type.
  • Which streaming format you want to use. You must stream live content from a broadcast publishing point. For all other content types, you can use either broadcast or on-demand publishing points, and you can choose how your audience accesses your content.
  • Where the content is located. In the case of live content, be sure you have the URL of the encoder or remote publishing point that is streaming the content. Prerecorded content can be located either on the server itself or in a content library location that is accessible over the network. Be sure your path information is accurate.
  • When the publishing point will be activated. You can create a publishing point and start it manually when you are ready to start streaming content. When a broadcast publishing point is started, it begins streaming immediately, even if no clients have connected to it. Alternatively, you can set up a broadcast publishing point to start streaming when the first client connects to it. You can also start an on-demand publishing point manually and set it to either allow or deny new connections.
  • Whether to create an announcement. Windows Media Services can create an announcement file that you can use to direct clients to your publishing point automatically. Announcement files are typically Web page links or e-mail attachments that the client can invoke.

If you haven't already configured your server for streaming, you can use the following quick start procedures to help you prepare your server:

On-demand streaming

Use the following quick start procedures to set up the Windows Media server to stream your content from an on-demand publishing point:

  • Stream Windows Media files on demand . Shows you how to distribute prerecorded content files on demand.
  • Use a playlist with on-demand Windows Media files. Shows you how to distribute prerecorded content from a playlist.

Broadcast streaming

Use the following quick start procedures to set up the Windows Media server to stream your content from a broadcast publishing point:

  • Use your server to publish live content from Windows Media Encoder. Shows you how to distribute live content directly from the encoding machine.
  • Use your server to broadcast a stream published by Windows Media Encoder. Shows you how to rebroadcast a live stream from another Windows Media server.
  • Alternate between live and prerecorded content in your broadcast. Shows you how to stream a combination of live and prerecorded content.

Advertising

Use the following quick start procedures to set up the Windows Media server to include advertising with your content:

  • Include interstitial advertising in your on-demand playlist. Shows you how to insert advertising content into your stream.
  • Use wrappers to provide advertising with your live broadcast. Shows you how to append advertisements to the beginning or end of your stream.

Related topics

  • Content management and production
  • To configure a multicast stream from a broadcast publishing point.
  • Working with the Add Publishing Point Wizard


Capacity planning

The purpose of capacity planning is to ensure that your content can reach all of your users without delays or interruptions. A streaming media network that has been properly planned and configured will improve response time, data throughput, content availability, and reduce the data error rate.

Capacity planning is based on three variables: audience volume, type and size of the content, and the number and speed of the servers. In most cases, capacity planning is used to determine the server requirements necessary to provide a given amount of content to a selected audience, although you may choose to plan for any of the variables under certain circumstances.

You can estimate your required network capacity by using the following equation:

Required network capacity = Content bit rate x estimated number of clients

There are several steps involved in capacity planning. The topics in this section introduce the steps and give an overview of the concepts involved. This section contains the following topics:

  • Evaluating the streaming content
  • Estimating the audience volume
  • Calculating required server capacity
  • Evaluating growth potential
  • Assembling required capacity
  • Testing capacity

Related topics

  • Deployment guide


Evaluating the streaming content

As your content's screen size and resolution increase, so do its demands on the server. Determine how you want to use the content and in what context. Are you distributing the content to a wide audience? If so, then you should try to keep the file size to a minimum. Will your audience be using a variety of connection speeds to access the content? If so, you may want to use multiple-bit-rate encoding for your content.

To determine a rough estimate of the bandwidth requirement for each user, divide the file size by the playback time in seconds. For example, a 2 megabyte (MB) digital media file represents about 16,000,000 bits. If the content is about 1 1/2 minutes in length, you have an average bit rate of 180 kilobits per second (Kbps). Most dial-up modems cannot transfer information faster than 56 Kbps, which means a client accessing your stream using a telephone line will either have to wait for the player to buffer the file before it begins to play or will only receive intermittent video and audio.

Related topics

  • Capacity planning


Estimating the audience volume

Even if you do not expect all of your users to request content at the same time, it is important to allow for peaks in usage. You should take into account user connection speeds as well because they may differ greatly.

To estimate your audience volume, determine the highest number of concurrent users during a streaming event. For example, a company plans to offer online training to all of its 10,000 employees over the local area network (LAN). Past training performance indicates that a maximum of five percent of the employees are likely to access the training at any given time. Therefore, the network must be capable of reliably delivering the content to 500 concurrent users.

Related topics

  • Capacity planning


Calculating required server capacity

Use the estimated bandwidth requirement and the estimated audience volume to determine how much capacity your network and server system must have to accommodate demand.

To estimate the total required server capacity, multiply the required bit rate per user by the estimated audience volume. The actual capacity of a given server will vary from computer to computer. As a general rule, a single processor (233 megahertz) computer with 256 MB of RAM that is running Windows Media Services can serve up to 1,000 28.8 Kbps unicast streams.

The following table demonstrates the need for additional server capacity as the number of users and content bit rate increases.

Bit rate of stream (Kbps) | Type of network connection | Number of concurrent users per server
28.8 (20 actual) | Telephone modem | 1,200
56.6 (33 actual) | Telephone modem | 600
100 | ISDN | 300
300 | DSL/cable/LAN | 100

For example, if online training content is delivered at a bit rate of 300 Kbps to 500 concurrent users, the server system and network must be capable of handling 150 megabits per second. If the server meets the minimum requirements for running Windows Media Services, at least six Windows Media servers would be required to service this demand.

Related topics

  • Capacity planning
  • Estimating the audience volume
  • Evaluating the streaming content


Evaluating growth potential

Over time, audiences tend to grow larger and content tends to multiply. Evaluate your long-term streaming media plans and adjust your required capacity calculations accordingly. Some other things that can affect the streaming overhead include security features and additional services such as automatic content replication and load balancing software.

As more people use your server, the number of simultaneous connections is likely to increase. Be aware of the upper limits for your system and consider what kind of response is appropriate for your deployment. For example, you will need to consider whether you want to be able to support 50 percent growth potential, 25 percent growth potential, or whether you want to let the capacity of your system be an environmental limit on your deployment.

Related topics

  • Calculating required server capacity
  • Capacity planning
  • Estimating the audience volume
  • Evaluating the streaming content


Assembling required capacity

After you have estimated the bandwidth requirement of your content, the size of your audience, and your desired server capacity and have determined your projected growth ratio, you can build the server system and make whatever changes are necessary to your current network to accommodate the server capacity.

The following list outlines some effective techniques for upgrading server and network capacity:

  • Upgrade a single-CPU server to a multiple-CPU server.
  • Install additional network cards, or upgrade the server network card to support a higher bandwidth network connection.
  • Add additional servers running Windows Media Services and implement a load balancing program to create a larger logical server for streaming media on the network.
  • Distribute cache/proxy servers throughout the network and implement a content replication program to distribute your content closer to the clients and relieve some of the demand on the originating content servers.
  • Set the network switches that will be processing streaming media requests and transmissions to full duplex mode to maintain an uninterrupted information flow.

Related topics

  • Calculating required server capacity
  • Capacity planning
  • Estimating the audience volume
  • Evaluating growth potential
  • Evaluating the streaming content


Testing capacity

Before deploying your streaming media solution, you should perform a load test to make sure that the assembled server system can support the required content and audience and that it behaves as expected.

You can run Windows Media Load Simulator 9 Series on one or more client computers to simulate any number of client connections. You can also configure the load simulator to recreate a number of client behaviors, including playing content continuously, streaming multiple-bit-rate content, browsing and seeking on-demand content, and connecting using authentication. Depending on the machine speed, each load simulator can test the upper limits of both the network and the server by loading the server with more than 1,000 simultaneous connections. You should run enough concurrent load simulations to simulate the peak load on your Windows Media server while you monitor the server to verify that no limits are exceeded. For more information about Windows Media Load Simulator 9 Series see Windows Media Load Simulator 9 Series Help.

Related topics

  • Content distribution
  • Capacity planning


Follow-up considerations

There are a number of techniques for refining the streaming process, improving system reliability, and gathering valuable information about your system, content, and audience. This section contains the following topics:

  • Performing load balancing and clustering
  • Understanding encoding
  • Monitoring server performance
  • Understanding fault tolerance
  • Implementing a cache/proxy system
  • Understanding scalability
  • Understanding content replication
  • Logging client information

Related topics

  • Deployment guide


Performing load balancing and clustering

Clustering ensures the availability of critical services by using a group of computers, or cluster, instead of a single computer. Each computer in a cluster is called a node. Clustering enhances the fault tolerance and scalability of a system by allowing one or more nodes to be removed from service without hindering system operation. Clustering is usually part of a larger load balancing process in which content requests are distributed among the nodes to spread the workload evenly.

Simple clustering diagram

Clustering

Each node in a cluster provides a particular set of resources to the group. Windows Media Services might be only one of several resources available on a particular node, and not all of the nodes on a given cluster might have Windows Media Services installed. If a node fails or is shut down, the clustering software reallocates the server demand to the other members of the cluster that have the correct resources available. This process is called failover. There are two common failover modes:

  • Cascading failover. Resources from the failed node are distributed evenly to other nodes throughout the cluster. This mode assumes that all of the other nodes in the cluster have some additional capacity.
  • N+1 failover. Resources from the failed node are redirected to a standby node that is held in reserve. This mode assumes that most or all of the cluster's excess capacity is assigned to one node.

When a failed or offline node is recovered, the clustering software can automatically move some or all of the redistributed resources back to their original location.

In addition to controlling failover, clustering software allows administrators to control and manage the nodes as a single system rather than as individual computers.

In order to provide effective failover protection, each node in the cluster must have a direct connection to the content source. The content source can be an encoder, a publishing point, or a file server.

Network Load Balancing Clusters is a server clustering method offered within Microsoft Windows Server 2003. Each cluster can support up to 32 computers under a single, logical Internet name. The cluster automatically detects server failure or change of status and redirects requests to the remaining servers while maintaining a seamless operational appearance to the user. For more information about setting up a cluster, see Windows Help and Support.

Load balancing

Load balancing software typically works with the clustering software to manage the server workload within the cluster so that it is evenly distributed among the nodes. It monitors the operation of each node and divides the streaming media workload according to a predetermined formula or algorithm. It also ensures that, even though the stream may originate from any of several different nodes, the content is represented by a single IP address.

Load balancing distribution

There are two primary load balancing strategies:

  • Hardware-based load balancing. Also known as reverse proxy, this method relies on a proxy server that is placed in the network between the server cluster and the clients. The reverse proxy server receives stream requests from the client and either redirects the client to the appropriate server or proxies content from that server to the client. To avoid creating a single point of failure, you can use two or more reverse proxy machines in parallel.
  • Software-based load balancing. Software-based load balancing products such as Microsoft Network Load Balancing assign a percentage of the total server load to each node in the cluster. The load balancing software runs on each node of the cluster and calculates which node will be the next to accept a new request based on each server's percentage of the total workload. The advantages of this load balancing method include speed, configurability, reliability, and reduced cost.

Load balancing fault

Network Load Balancing is offered within Microsoft Windows Server 2003 and uses a fully distributed filtering algorithm. Every second, each node in the cluster emits a "heartbeat" signal which contains information about its status. The Network Load Balancing software monitors these signals for changes in the cluster status and changes the service request distribution appropriately.

Related topics

  • Follow-up considerations
  • Understanding fault tolerance
  • Understanding reverse proxy


Understanding encoding

Encoding is the process of preparing the content for distribution. In some cases, how you encode the content can make a big difference in how the user experiences it. The following subjects cover the most common content encoding issues:

Using codecs

Streaming audio and video content can consume a lot of bandwidth on a network. By compressing the content, it can be broadcast using less bandwidth, which makes the content available to a larger audience. You can compress content by applying compression algorithms to the data, taking into account the desired output quality and available bandwidth. Before the content is played on a player, it is decompressed using decompression algorithms. These compression and decompression algorithms are called codecs. Codecs are designed to reduce a stream to a certain bit rate. The target bit rate determines how much the content must be reduced and therefore which codec is best suited to your needs. Files that are encoded at a higher bit rate produce content that usually sounds and looks richer and more dynamic, but it requires more bandwidth to stream.

There is an additional encoding method that can provide high-quality content to unicast clients with high-bandwidth network connections, while also ensuring that dial-up clients do not have to suffer long periods of latency. Windows Media Encoder can encode your content using multiple bit rates, allowing a single content file to be streamed to a variety of client connections. Before the encoding process begins, you can specify the target bit rates for your content encoded with. Then, when the client connects to the Windows Media server, information about the client's network connection is assessed. The server streams the bit rate that provides the best quality content with the least amount of latency.

Sources of digital media content

Digital media content can come from many different sources. Content from video cameras, microphones, television tuner cards, and video playback devices can be captured using a card or capture device that is installed on the encoding computer. Once the digital media content has been captured, it can be encoded into the Windows Media Format and streamed or saved to a file.

Defining encoding parameters

You should tailor your encoding process to the type of content being encoded, the audience, and the intended distribution method (file or broadcast). You need to define the following parameters:

  • Audio quality. Audio content can be either stereo or mono. It can also be sampled at varying audio frequencies to provide greater range of sound differentiation. To determine the best encoding settings you should know whether the audio files contain voices only, music only, or both.
  • Video quality. Video content can be played back in different windows sizes. Small video displays make it much harder to see errors in the video and are normally used with low bit rate content. Large video displays provide greater visibility and are most often used with higher bit rate content. Frame rate is also a major consideration. A high number of video frames displayed per second provides smoother video motion. If your video has high motion content, increasing the frame rate may be useful. If there is not much motion in your video, you may be able to decrease the frame rate and devote some of the bandwidth resources to other portions of the content.
  • Target audience. To determine ideal encoding settings, you should think about whether the content needs to support clients that connect at different bandwidths or whether the audience has the same bandwidth capability. Increasing the audio and video quality causes an increase in required bandwidth. You will need to balance quality consideration against bandwidth limitations.
  • Codecs. The audio and video codecs define the method of compression performed on the content. Some codecs are optimized for low bandwidth scenarios, others for high bandwidth scenarios, while other codecs are optimized for audio content, and some for video content.

You can simplify the encoding process by considering these parameters before setting up an encoding session.

Related topics

  • Follow-up considerations


Monitoring server performance

The ability to monitor the performance of your server system is vital to its effective management. By monitoring performance, you can:

  • Achieve the best performance from your server.
  • Assess the value of the content to your audience.
  • Evaluate patterns and trends in audience usage.

Using the Performance Monitor

A real-time, graphical performance monitor is included with Windows Media Services for observing the behavior of both servers and publishing points. The graphical display shows your choice of performance data over time. In addition to the display, the Windows Media Performance Monitor has a variety of configurable performance counters.

Using the WMS WMI Event Handler plug-in

This plug-in enables you to monitor specific aspects of server operation. After enabling and configuring the WMS WMI Event Handler plug-in, you can receive local or remote notification of server events. You can monitor the following server functions:

  • Server. Reports server status or property changes.
  • Client. Reports client-side events in Windows Media Player.
  • Limit. Reports server limits whenever they are changed or reached.
  • Playlist. Reports playlist-related events.
  • Cache. Reports any events pertaining to cache activity.
  • Publishing point. Reports changes in publishing point status or properties.
  • Plug-in. Reports publishing point and server plug-in activity.

For more information about configuring this plug-in, see To configure the WMS WMI Event Handler properties.

Using Simple Network Management Protocol

You can use Simple Network Management Protocol (SNMP) to configure remote devices, monitor network performance, audit network usage, and detect network faults or inappropriate access.

SNMP uses a distributed architecture consisting of managers and agents:

  • A manager generates queries to the SNMP agent applications and receives objects from SNMP agent applications.
  • An agent responds to queries from SNMP manager applications. The SNMP agent is responsible for retrieving and updating local management information based on the requests of the SNMP manager. The agent also notifies registered managers when significant events or traps occur.

Related topics

  • About the Windows Media SNMP objects
  • Follow-up considerations
  • Monitor and set limits
  • Understanding event handler plug-ins
  • Using Windows Media performance counters


Understanding fault tolerance

When streaming digital media content, fault tolerance refers to the ability of a streaming media system to maintain, or at least recover, service after a system fault. The likelihood of a fault in the system resulting in failure is also a measure of the fault tolerance of the system. Fault tolerance can also be measured in terms of the availability of the system or the percentage of up-time for the system.

A streaming media system is nothing more than a chain of components stretching from the content origin to the consumer. Like a chain, each component must adequately perform its assigned task or the system itself fails.

Faults can occur anywhere in a streaming media system. Upstream faults, in relation to Windows Media Services, are those that have to do with the source of the content, such as an encoder or digital media library. Downstream faults are those having to do with distribution of the content to the client, such as faults in distribution servers or cache/proxy servers.

Upstream and downstream components

The key to fault tolerance in a streaming media system is redundancy. A system that relies on a single component at any stage in the media distribution process is vulnerable to failure.

Upstream faults

An input failure to Windows Media Services, either from an encoder, a remote publishing point, or a file server, is particularly challenging because the system administrator may not be aware that there is a problem. When an upstream content source fails or disconnects, an error is written to the Troubleshooting tab and the session log, but there is no overt indication of a problem in Windows Media Services.

You can minimize the risk of an upstream fault by using multiple content sources for your publishing point. Multiple content sources can consist of redundant encoders or alternate content files that the publishing point can use if the primary content source is unavailable.

Protect against encoder failures

Downstream faults

Failure of the Windows Media server or one of its downstream components, such as a distribution server, can prevent clients from receiving the content they requested. Using multiple Windows Media servers to stream the same content, called clustering, reduces the risk of interrupted service.

Clustering is a valuable fault tolerance technique because reduced capacity or failure of any one server is unlikely to interrupt the whole system. If one server stops responding, the workload of the failed server can be immediately and seamlessly transferred to the other servers.

Highly fault tolerant system

This section contains the following topics:

  • Software faults
  • Hardware faults
  • Network faults
  • Operational faults
  • Environmental faults
  • Security faults

Related topics

  • Follow-up considerations
  • Performing load balancing and clustering
  • To enable content rollover in case of encoder failure


Software faults

The most common causes of software failures are improper software configuration and incompatibilities between software products.

It is important to follow the software vendor's instructions carefully when installing and configuring software in any component of your streaming media system.

Always use software brands and versions that you know work well together. During operation, maintain strict controls on the kind and quality of software that is added to the system, including updates to existing programs.

Related topics

  • Understanding fault tolerance


Hardware faults

Hardware failures occur most frequently in moving mechanical parts such as fans and disk drives. Hardware failures may not cause the system to fail immediately. A single, small hardware failure may often go undetected until it leads to more serious failures. For instance, a burned out cooling fan can cause a processor to overheat, resulting in increased errors and reduced performance for a long time before the hardware component fails completely.

Using some common hardware fault tolerance techniques, you can often isolate and minimize the effects of small hardware failures:

  • RAID controllers
  • Multiple power supplies
  • Error correcting RAM
  • Hot-swappable disk drives
  • Multiple processors
  • Multiple network interface cards

You can also configure Simple Network Management Protocol (SNMP) to notify you of any detectable abnormal conditions in your hardware.

Related topics

  • Understanding fault tolerance


Network faults

Your network is an integral part of your streaming media system. If it is inadequate or improperly configured, you risk reduced performance or even complete failure. Apply the following considerations when configuring your network to stream digital media.

  • Bandwidth is the most critical feature of a streaming network. Your network must be able to accommodate peak data loads as well as extended periods of heavy traffic.
  • Multicast streaming can reduce the network workload, but the network must be specially configured to carry multicast data.

You can achieve network reliability by avoiding data restrictions where a single fault can cause the entire network to fail. Redundant use of hubs, switches, routers, and even cabling can reduce the danger of a single point of failure.

Related topics

  • Understanding fault tolerance
  • Performing load balancing and clustering
  • Capacity planning


Operational faults

A thorough and rigorous program of operational procedures and processes can reduce the chance of introducing new faults to the streaming media system as well as reducing the impact any resulting failures will have. Some valuable operational processes that you can perform on a regular basis include:

  • Backing up content.
  • Removing unused playlists, publishing points, and content from the system.
  • Regularly reviewing stream logs for abnormalities.
  • Monitoring streaming operation using the Monitor tab and investigating error conditions.
  • Establishing a regular schedule for hardware maintenance.
  • Reviewing and rehearsing recovery plans.

Related topics

  • Understanding fault tolerance
  • Monitoring server performance


Environmental faults

Environmental faults most often involve a loss of power. Even a momentary loss of power to any part of the streaming media system can cause the system to fail. A small battery backup power supply can keep the system running during a brief power loss. For longer power outages, a backup generator may be necessary.

In large facilities, a loss of air conditioning can cause system components to overheat and fail. In such cases, you can prolong operation by shutting down unnecessary equipment and redundant systems.

Dirt and dust are long-term threats to electronic equipment reliability. A buildup of dirt on electronic components puts those components at risk in the following ways:

  • A layer of dirt reduces cooling system effectiveness, allowing the components to overheat.
  • Dirt can cause a partial or complete short circuit, introducing errors or stopping operation altogether.
  • Dirt, in the vicinity of hot or overheated electronics, can cause a fire.

Be sure your hardware location is clean, and prevent excess dirt and dust from entering the area.

Accidents can also cause system faults. Protect your hardware components from the physical hazards posed by accidents. For instance, route cables where they will not be stepped on or tripped over. Secure hardware components so that they cannot be easily tipped over or dropped. Prohibit food and beverages from the area.

Related topics

  • Understanding fault tolerance


Security faults

Access to the streaming media system by unauthorized persons, either by accident or design, can seriously damage the content and the system. Some content may not have intrinsic value but may contain sensitive information or images that must be protected against theft. Locked doors and network firewalls may not be enough to keep out a determined intruder.

The security of your streaming media system and content is dependant upon two things: the physical security of the system hardware and storage and the virtual security of your network. The level of value and sensitivity you place on your content will best determine the amount of effort and expense you must undertake to secure it.

Physical security

All critical streaming media storage and hardware components should be housed in a room that has been dedicated to that purpose. Access to the room should be restricted to persons directly associated with the operation of the streaming media system. The viability of additional access and monitoring measures such as card key readers, combination locks, alarm systems, and closed circuit video depend on the value of your data and your overall security strategy.

Network security

Network security is a multifaceted subject consisting of several different methods and levels of complexity. While many of the general principles of network security are shared across all networking platforms, the specifics of implementing a network security strategy will vary according to the equipment and software used. Consult your network documentation or administrator for specific information about the correct implementation of the following network security measures:

  • Authentication. Authentication is the process of verifying the credentials of the person requesting access. This process usually involves giving a log in name and password.
  • Authorization. Once the requestor's identity has been established, it must meet certain criteria before the requestor can gain access to the restricted content. The criteria can be set in several different ways based on whether you are authorizing individual users, groups of users, or excluding specific users.
  • Permissions. Each user that is granted access to the system will have a specific set of permissions which allow the user to perform certain functions and may prohibit the user from performing others. For example, a user with read-only access to the system may be able to copy content to another location, but cannot add, change, or delete content.
  • Firewalls. Firewalls protect the network from outside intrusion by restricting network access to specific, closely-monitored ports. The firewall can also restrict the type of information that can pass through the ports. Firewalls are typically used to separate a proprietary network from the Internet, but they can also be used to provide a heightened level of security within a network.

You should understand that as you place more security precautions on an area of your network, the transfer of data across the network becomes more difficult to manage. Choose a network security strategy for your content that provides an adequate level of administrative access while effectively blocking users that do not have the proper authorization.

Related topics

  • Understanding fault tolerance


Implementing a cache/proxy system

A cache/proxy server is typically a client-side server at the edge of the local area network (LAN) through which all streaming media requests are passed. The cache/proxy server stores the most recently streamed content for use by other clients seeking the same material. During live broadcasts, cache/proxy servers can perform a task called stream splitting which allows many unicast clients to receive content while only a single stream is sent from the origin server.

The three primary benefits of the cache/proxy system are:

  • Reduces response times for all subsequent requests. Local networks are usually much more responsive than the Internet. Because the material is already maintained on the local network, the requests can be served locally.
  • Reduces Internet traffic. Less traffic passing between the local network and the Internet means lower bandwidth requirements and a corresponding reduction in costs. On a larger scale, widespread use of cache/proxy servers can measurably reduce Internet congestion.
  • Improves security. Network administrators have more control over streaming media usage and access if all requests pass in and out of a particular point in the system.

You must install a cache/proxy plug-in on your Windows Media server for the server to function as a cache/proxy server. A cache/proxy plug-in can be either obtained from a Microsoft Windows Media-based caching partner or created using the Windows Media Services Software Development Kit (SDK).

Under certain circumstances, streaming media content can be preloaded into the cache/proxy server's content database before the stream even begins. This process, called content replication, gives you the benefits of local media storage during a streaming media session.

Related topics

  • Cache expiration - general properties
  • Caching and proxying content
  • Follow-up considerations
  • Understanding content replication


Understanding scalability

Scalability describes the ease with which you can add or remove components from a system while maintaining system reliability. As your audience grows, you may need to add servers so that the increased demand does not overload your system. Alternatively, you may want to break up a large server system into several smaller, more specialized ones. In either case, you will have to address software and hardware scalability as separate issues.

Software scalability

Windows Media Services is scalable by design to support a wide range of deployments—from small Internet radio stations that have hundreds of connection requests to large-scale streaming media Web sites that generate millions of requests. The Windows Media Services snap-in allows you to administer both groups of servers and publishing points as well as single servers and publishing points.

Hardware scalability

In the context of Windows Media Services, scalability refers primarily to the addition or removal of individual servers from a system. Adding servers to a system that has been overwhelmed by an increase in connections or content can dramatically improve its performance. The number of servers required in a system is based upon the bit rate of the content, the content type, and the number of concurrent client connections.

When using multiple servers, it is important to use some form of load balancing to prevent any one server from becoming overloaded. The servers should also closely match in performance and capacity to ensure that your load balancing method is as effective as possible. The number of servers that can be combined in one Windows Media Services system is unlimited.

Related topics

  • Follow-up considerations
  • Performing load balancing and clustering
  • Capacity planning


Understanding content replication

Content replication is the process of duplicating content files from one streaming server to multiple servers to meet user demand and avoid server overload. Demand for a particular piece of content is not always predictable, and too many requests for the same content can quickly overwhelm a server. Content replication software recognizes demand changes for individual content files and distributes that content to available servers as necessary to reduce pressure on individual computers.

Related topics

  • Follow-up considerations


Logging client information

The logging process gathers and stores information about users that are accessing the content and stores that information in a log file. With the proper analysis, you can retrieve a wealth of information from the log files concerning content usage and popularity, user viewing habits, network characteristics, and advertising value.

You can uncover a lot of information from a log file, including the following:

  • The date, time, and duration of the connection.
  • The type of computer and operating system the client is using.
  • The connection's peer address or IP address.
  • The client's language preference.
  • The content that was streamed.
  • The Web page that referred the client to this content.
  • Whether or not the stream was completed successfully.

Related topics

  • Follow-up considerations
  • Log data about clients
  • Log file entries reference
  • Logging data and events


Accessibility for people with disabilities

Microsoft is committed to making its products and services easier for everyone to use. The following topics provide information about the features, products, and services that make Microsoft Windows Media Services more accessible for people with disabilities:

  • Accessible features in Windows Media Services
  • Accessibility features in Windows Media Services Help

Note Image Note

  • The information in this section applies only to users who license Microsoft products in the United States. If you obtained this product outside the United States, your package contains a subsidiary information card listing Microsoft support services telephone numbers and addresses. You can contact your subsidiary to find out whether the products and services described in this section are available in your area. Accessibility information is available in other select languages, including Japanese and French. For more information, see the Microsoft Web site.

Related topics

  • Windows Media Services


Accessible features in Windows Media Services

In addition to accessibility features and utilities in Windows, the following features make Windows Media Services more accessible for people with disabilities:

  • Keyboard shortcuts for the Windows Media Services snap-in
  • Access keys in the Windows Media Services snap-in
  • Keyboard shortcuts for Windows Media Services Administrator for the Web

Related topics

  • Accessibility for people with disabilities


Keyboard shortcuts for the Windows Media Services snap-in

By using the following keyboard shortcuts in the Windows Media Services snap-in, you can quickly accomplish many common tasks.

To do this… | Use this keyboard shortcut…
Display context-sensitive Help for a selected item | F1 or ALT+A, and then press H
Move forward through items on the active window. | TAB
Move backward through the items on the active window | SHIFT+TAB
Move forward from tab to tab | CTRL+TAB
Move backward from tab to tab | SHIFT+CTRL+TAB
Scroll up one item in a list | UP ARROW
Scroll down one item in a list | DOWN ARROW
Scroll forward through tabs | PAGE UP
Scroll backward through tabs | PAGE DOWN
Scroll up a list | PAGE UP
Scroll down a list | PAGE DOWN
Close the current property sheet or dialog box | ESC
Activate a selected link | ENTER
Finish a wizard (Completion Page) | ENTER
Move forward through the items in a spin box or drop-down list | UP ARROW
Move backwards through the items in a spin box or drop-down list | DOWN ARROW
Remove the selected items and copy them to the Clipboard | CTRL+X
Copy the selected items to the Clipboard | CTRL+C
Insert the contents of the Clipboard at the selected location | CTRL+V
Open the property sheet of a selected object | ALT+ENTER
Open a file (Playlist Editor) | CTRL+O
Save a file (Playlist Editor) | CTRL+S
Close the current window | ALT+F4
Display the shortcut menu | SHIFT+F10
Select or clear an item | SPACEBAR
Display the context menu | Application key
Toggle High Contrast mode | LEFT ALT+LEFT SHIFT+PRINT SCREEN

Related topics

  • Access keys in the Windows Media Services snap-in
  • Accessibility for people with disabilities


Access keys in the Windows Media Services snap-in

Access keys enable you to initiate menu commands using the keyboard. Access keys are the ALT key followed by the keys denoted by the underlined characters in the menu commands. For example, to access Windows Media Services Help, press the ALT key, followed by the A key and then the H key.

In the Windows Media Services snap-in, menu bar choices can change depending on the item that is selected in the console tree. The following tables list the access keys that are available when a console tree item is selected.

When the Windows Media Services item is selected in the console tree, you can use the following access keys.

To do this… | Use this access key…
Add a group | ALT+A, and then press G
Add a server | ALT+A, and then press V
Import a console configuration | ALT+A, and then press I
Export a console configuration | ALT+A, and then press E
Open Windows Media Services Help | ALT+A, and then press H

When a server item is selected in the console tree, you can use the following access keys.

To do this… | Use this access key…
Start the server | ALT+A, and then press S
Stop the server | ALT+A, and then press O
Allow new connections to the server | ALT+A, and then press A
Deny new connections to the server | ALT+A, and then press D
Add a group | ALT+A, and then press G
Add a server | ALT+A, and then press V
Add a publishing point using the wizard | ALT+A, and then press W
Add a publishing point using the advanced method | ALT+A, and then press P
Remove the selected server | ALT+A, and then press M
Open Windows Media Services Help | ALT+A, and then press H

When the Troubleshooting item is selected in the console tree, you can use the following access key.

To do this… | Use this access key…
Open Windows Media Services Help | ALT+A, and then press H

When the Cache/Proxy Management item is selected in the console tree, you can use the following access keys.

To do this… | Use this access key…
Refresh the details pane | ALT+A, and then press R
Open Windows Media Services Help | ALT+A, and then press H

When the Publishing Points item is selected in the console tree, you can use the following access keys.

To do this… | Use this access key…
Add a publishing point using the wizard | ALT+A, and then press W
Add a publishing point using the advanced method | ALT+A, and then press P
Open Windows Media Services Help | ALT+A, and then press H

When an on-demand publishing point is selected in the console tree, you can use the following access keys.

To do this… | Use this access key…
Allow new connections to the publishing point | ALT+A, and then press A
Deny new connections to the publishing point | ALT+A, and then press D
Duplicate the publishing point | ALT+A, and then press U
Rename the publishing point | ALT+A, and then press R
Remove the publishing point | ALT+A, and then press M
Open Windows Media Services Help | ALT+A, and then press H

When a broadcast publishing point is selected in the console tree, you can use the following access keys.

To do this… | Use this access key…
Start the publishing point | ALT+A, and then press S
Stop the publishing point | ALT+A, and then press O
Allow new connections to the publishing point | ALT+A, and then press A
Deny new connections to the publishing point | ALT+A, and then press D
Duplicate the publishing point | ALT+A, and then press U
Rename the publishing point | ALT+A, and then press R
Remove the publishing point | ALT+A, and then press M
Open Windows Media Services Help | ALT+A, and then press H

When any item is selected in the console tree, you can use the following access keys.

To do this… | Use this access key…
Open the Options dialog box | ALT+F, and then press O
Exit the MMC Administrator | ALT+F, and then press X
Open Windows Media Services Help | ALT+H, and then press H
Open the Microsoft Management Console About dialog box | ALT+H, and then press A
Open the Windows Media Services dialog box | ALT+H, and then press B

In the Windows Media Playlist Editor, you can use the following access keys.

To do this… | Use this access key…
Open a new playlist | ALT+F, press N, and then press P
Open a new wrapper playlist | ALT+F, press N, and then press W
Open an existing playlist | ALT+F, and then press O
Save the current playlist | ALT+F, and then press S
Save the current playlist with another name | ALT+F, and then press A
Close the Playlist Editor | ALT+F, and then press X
Open Windows Media Services Help | ALT+H, and then press H
Open the Windows Media Playlist Editor | ALT+H, and then press A

Related topics

  • Accessibility for people with disabilities


Keyboard shortcuts for Windows Media Services Administrator for the Web

By using the following keyboard shortcuts in Windows Media Services Administrator for the Web, you can quickly accomplish many common tasks.

To do this… | Use this keyboard shortcut…
Move forward through the items on the page | TAB
Move backward through the items on the page | SHIFT+TAB
Scroll up one item in a list | UP ARROW
Scroll down one item in a list | DOWN ARROW
Scroll up a list | PAGE UP
Scroll down a list | PAGE DOWN
Refresh the current page | F5 or CTRL+R
Activate a selected link | ENTER
Move forward through the items in a spin box or drop-down list | UP ARROW
Move backward through the items in a spin box or drop-down list | DOWN ARROW
Remove the selected items and copy them to the Clipboard | CTRL+X
Copy the selected items to the Clipboard | CTRL+C
Insert the contents of the Clipboard at the selected location | CTRL+V
Close current window | ALT+F4
Select/Cancel the selection | SPACEBAR
Toggle High Contrast mode | LEFT ALT+LEFT SHIFT+PRINT SCREEN

Related topics

  • Accessibility for people with disabilities


Accessibility features in Windows Media Services Help

Windows Media Services Help includes features that make it accessible to a wider range of users, including those who have limited dexterity, low vision, or other disabilities.

Related topics

  • Accessibility for people with disabilities


Keyboard shortcuts for using the Help window

By using the following keyboard shortcuts in Help, you can quickly accomplish many common tasks.

To do this… | Use this keyboard shortcut…
Display the Help window. | F1
Switch the cursor between the Help topic pane and the navigation pane (Contents, Search, and Index tabs). | F6
Select the next hidden text or hyperlink. | TAB
Select the previous hidden text or hyperlink. | SHIFT+TAB
Perform the action for the selected Show All, Hide All, hidden text, or hyperlink. | ENTER
Display the Options menu to access any Help toolbar command. | ALT+O
Hide or show the navigation pane containing the Contents, Search, and Index tabs. | ALT+O, and then press T
Display the previously viewed topic | ALT+O, and then press B
Display the next topic in a previously displayed sequence of topics. | ALT+O, and then press F
Return to the specified home page. | ALT+O, and then press H
Stop the Help window from opening a Help topic (useful if you want to stop a Web page from downloading). | ALT+O, and then press S
Open the Internet Options dialog box for Microsoft Internet Explorer, where you can change accessibility settings. | ALT+O, and then press I
Refresh the topic (useful if you have linked to a Web page). | ALT+O, and then press R
Print all topics in a book or a selected topic only. | ALT+O, and then press P
Close the Help window. | ALT+F4

Related topics

  • Accessibility features in Windows Media Services Help


To change the appearance of a Help topic

  1. To customize the colors, font styles, and font sizes used in Help, open the Help window.
  2. Click Options, and then click Internet Options.
  3. On the General tab, click Accessibility. Select Ignore colors specified on Web pages, Ignore font styles specified on Web pages, and Ignore font sizes specified on Web pages. You also can choose to use the settings specified in your own style sheet.
  4. To change the colors used in Help, see To change the color of the background or text in Help. To change the font, see To change the font in Help.

Related topics

  • Accessibility features in Windows Media Services Help


To change the color of the background or text in Help

  1. Open the Help window.
  2. Click Options, and then click Internet Options.
  3. On the General tab, click Accessibility. Then select Ignore colors specified on Web pages. You also can choose to use the settings specified in your own style sheet.
  4. To customize the colors used in Help, on the General tab, click Colors. Clear the Use Windows Colors check box, and then select the font and background colors you want to use.

Note image Note

  • If you change the background color of the Help topics in the Help window, the change also affects the background color when you view a Web page in Microsoft Internet Explorer.

Related topics

  • Accessibility features in Windows Media Services Help


To change the font in Help

  1. Open the Help window.
  2. Click Options, and then click Internet Options.
  3. On the General tab, click Accessibility. To use the same settings as those used in your instance of Microsoft Internet Explorer, select Ignore font styles specified on Web pages and Ignore font sizes specified on Web pages. You also can choose to use the settings specified in your own style sheet.
  4. To customize the font style used in Help, on the General tab, click Fonts, and then click the font style you want.

Note image Note

  • If you change the font of the Help topics in the Help window, the change also affects the font when you view a Web page in Microsoft Internet Explorer.

Related topics

  • Accessibility features in Windows Media Services Help


Glossary

To find a term in the glossary, click the letter of the alphabet that is the first letter in the term you want to look up.

You can also read glossary terms within the text of Help by clicking the underlined glossary term links. After you click a glossary link, the glossary term and definition appear in a pop-up window. To close the window, click anywhere on the screen.

A | B | C | D | E | F | G | H | I | J | K | L | M
N | O | P | Q | R | S | T | U | V | W | X | Y | Z

A

access control list (ACL)

A list of security protections that applies to either an entire object, a set of the object's properties, or an individual property of an object.

See also: discretionary access control list (DACL), system access control list (SACL)

ACL

See definition for: access control list (ACL)

announcement

A Windows Media metafile that gives a player the information needed to receive content. Announcement files contain Extensible Markup Language (XML) scripts.

attribute

A name-value data pair.

authentication

The process of verifying that an entity or object is who or what it claims to be. For example, a username and password may be used to authenticate a user.

See also: authorization

authorization

The process of granting access to protected resources.

See also: authentication

Back to Top

B

bandwidth

A network's capacity for transferring an amount of data in a given time.

bit rate

The number of bits transferred per second.

broadcast

A method by which a client receives a stream. During a broadcast connection, clients cannot control the stream. This is the opposite of an on-demand presentation.

broadcast publishing point

A type of publishing point that streams content to multiple users at once, similar to a television broadcast. Content streamed from a broadcast publishing point can be delivered as a multicast or unicast stream.

buffer

An area of computer memory reserved for temporarily holding data before that data is used on the receiving computer. Buffering protects against the interruption of data flow.

bumper advertisements

Advertising content that is played before and after the primary content.

See also: interstitial advertisement, wrapper playlist

Back to Top

C

cache

A temporary data storage location, or the process of storing data temporarily. A cache is typically used for quick data access.

cache/proxy server

A server running Windows Media Services for which a cache/proxy plug-in has been enabled, allowing the server to provide cache and proxy support to another Windows Media server.

caption

Text that accompanies images or videos, either as a supplemental description or a transcript of spoken words.

client

Any computer or program connecting to, or requesting the services of, another computer or program. Client can also refer to the software that enables the computer or program to establish the connection.

codec

An abbreviation for compressor/decompressor. Software or hardware used to compress and decompress digital media.

compression

A process for removing redundant data from a digital media file or stream to reduce its size or the bandwidth used.

content

Audio, video, images, text, or any other information that is contained in a digital media file or stream.

Coordinated Universal Time (UTC)

The standard time common to every place in the world, coordinated by the International Bureau of Weights and Measures. UTC is used for the synchronization of computers on the Internet. Also known as Greenwich Mean Time.

Back to Top

D

DACL

See definition for: discretionary access control list (DACL)

discretionary access control list (DACL)

The part of an object's security descriptor that grants or denies specific users and groups permission to access the object. Only the owner of an object can change permissions granted or denied in a DACL; access to the object is thus at the owner's discretion.

See also: access control list (ACL), system access control list (SACL)

distribution server

A server running Windows Media Services that publishes content received from another streaming source, such as an encoder or another Windows Media server.

Back to Top

E

element

A fundamental syntactic unit in markup languages, such as HTML or XML. Elements are delimited by start tags and end tags. Empty elements are defined using an empty-element tag.

encode

To convert audio and video content to a specified digital format.

encoder

A technology that converts live or prerecorded audio and video content to a specified digital format. Typically, content is compressed during encoding. Windows Media Encoder is an example of an encoder.

event

Any significant occurrence in a system or software that requires users to be notified or an entry to be added to a log. For example, stopping the Windows Media Services service can be logged as an event.

exclusive element

In a playlist, an element used to contain media elements that have an indeterminate start time.

See also: element, media element

Extensible Markup Language (XML)

A markup language that provides a format for describing structured data. XML is a World Wide Web Consortium (W3C) specification, and is a subset of Standard Generalized Markup Language (SGML).

Back to Top

F

Fast Streaming

A method of delivering content that combines downloading and streaming to use the available network bandwidth in the most effective manner.

firewall

A combination of hardware and software that enforces a boundary between two or more networks and prevents unauthorized access to a private network.

frame

One of many sequential images that make up video.

frame rate

The number of video frames displayed per second. Higher frame rates generally produce smoother movement in the picture.

Back to Top

H

header

A part of the file structure that contains information required by an application to decompress and render the content. The header in a protected file also contains information required to get a license.

HTTP

See definition for: Hypertext Transfer Protocol (HTTP)

Hypertext Transfer Protocol (HTTP)

The Internet protocol used to deliver information over the World Wide Web.

Back to Top

I

IGMP

See definition for: Internet Group Management Protocol (IGMP)

intelligent streaming

A type of streaming that detects network conditions and adjusts the properties of a video or audio stream to maximize quality.

Internet Group Management Protocol (IGMP)

A protocol used by IP hosts to report their multicast group memberships to neighboring multicast routers.

Internet Protocol version 6 (IPv6)

A revised version of the Internet Protocol (IP) designed to address growth on the Internet. Improvements include a 128 bit IP address size, expanded routing capabilities, and support for authentication and privacy.

interstitial advertisement

An advertisement that appears between pieces of content. When one piece of content finishes playing, the ad appears before the next piece of content plays.

See also: wrapper playlist

IPv6

See definition for: Internet Protocol version 6 (IPv6)

Back to Top

L

latency

The delay that occurs while data is processed or delivered.

load balancing

A technique used for scaling the performance of a server-based program by distributing client requests across multiple servers.

logging

To record actions that take place on a computer, or the record of those actions.

loop

To repeat a stream continuously.

Back to Top

M

MBR

See definition for: multiple bit rate (MBR)

media element

A content item that is streamed from a playlist. This can be a file, a stream from an encoder, a remote stream, another playlist file, or a Windows Media file on a Web server.

metadata

Data about data. Title, subject, author, and size are examples of a file's metadata.

Microsoft Media Server (MMS) protocol

A proprietary protocol using UDP or TCP to deliver content as a unicast stream.

See also: Transmission Control Protocol (TCP), User Datagram Protocol (UDP)

MMS protocol

See definition for: Microsoft Media Server (MMS) protocol

multicast

A content delivery method in which a single stream is transmitted from a media server to multiple clients. The clients have no connection with the server. Instead, the server sends a single copy of the stream across the network to multicast-enabled routers, which replicate the data. Clients can then receive the stream by monitoring a specific multicast IP address and port.

multicast-enabled network

A network that has routers that can interpret Class D IP addresses.

multiple bit rate (MBR)

A characteristic of a data stream in which the same content is encoded at several different bit rates in order to optimize content delivery.

Back to Top

O

on-demand publishing point

A type of publishing point that streams content to clients by request. Content streamed from an on-demand publishing point is always delivered as a unicast stream.

origin server

A Windows Media server from which content is published.

Back to Top

P

packet

A unit of information transmitted as a whole from one device to another on a network.

parse

To break input into smaller chunks so that a program can act upon the information.

player

A client program or control that receives digital media content streamed from a server or played from local files. Windows Media Player is an example of a player.

playlist

A list of digital media content.

plug-in

An auxiliary software component that extends or enhances the features of other software.

port

A connection point in a computer through which a peripheral device or another computer can communicate.

protocol

A set of formats and procedures that enable computers to exchange information.

See also: Hypertext Transfer Protocol (HTTP), Microsoft Media Server (MMS) protocol, Real Time Streaming Protocol (RTSP), Transmission Control Protocol (TCP), User Datagram Protocol (UDP)

protocol rollover

A procedure that enables switching from one protocol to another when a Windows Media server fails to make a connection using a particular protocol.

proxy server

A server located on a network between client software, such as a Web browser, and another server. It intercepts all requests to the server to determine whether it can fulfill them itself. If not, it forwards the request to another server.

publishing point

An organized memory location that translates a client request for content into the physical path on the server hosting the content. A publishing point essentially acts as a redirector.

Back to Top

R

Real Time Streaming Protocol (RTSP)

An Internet protocol that deliver real-time, live, or stored audio and video streams over a network.

render

To display video, audio, or text content from a file or stream using a software program, such as Windows Media Player.

repacketization

The process by which the server breaks down existing data packets and reassembles them into different-sized data packets for distribution to clients.

RTSP

See definition for: Real Time Streaming Protocol (RTSP)

Back to Top

S

SACL

See definition for: system access control list (SACL)

scope

In a multicast transmission, the reach of a stream. The scope of a multicast transmission can be set to reach either an immediate subnetwork only or the entire Internet.

script commands

Named data that is associated with a designated time in Windows Media-based content. The data can be used by players to perform a specific action such as displaying a Web page.

Simple Network Management Protocol (SNMP)

A network protocol used to manage TCP/IP networks. In Windows, the SNMP service is used to provide status information about a host on a TCP/IP network.

SMIL

See definition for: Synchronized Multimedia Integration Language (SMIL)

SNMP

See definition for: Simple Network Management Protocol (SNMP)

stream

Digital media that is in the process of being delivered in a continuous flow across a network.

stream format

Information about the properties of a stream, such as the codecs used, frame rate, and frame size. A player uses stream format information to decode a stream.

stream format file

A file used by a player to decode a multicast stream.

See also: stream format

stream thinning

The process of lowering the frame rate of source video to reduce the bandwidth required for streaming to be lower than or equal to the available client bandwidth. If necessary, the video portion of the stream may stop streaming and only the audio portion streamed.

Synchronized Multimedia Integration Language (SMIL)

An XML-based language being developed by the World Wide Web Consortium (W3C) that would enable Web developers to divide content into separate streams (audio, video, text, and images), send them to a client computer, and then have them displayed as a single stream. This separation reduces the time required for transmission over the Internet.

system access control list (SACL)

A list that represents part of an object's security descriptor that specifies which events (such as logon attempts and file access) are to be audited per user or group.

See also: access control list (ACL), discretionary access control list (DACL)

Back to Top

T

TCP

See definition for: Transmission Control Protocol (TCP)

time-to-live (TTL)

The number of routers through which a multicast stream can pass before a router stops forwarding the stream.

Transmission Control Protocol (TCP)

The protocol within TCP/IP that governs the breakup of data messages into packets to be sent via IP, and the reassembly and verification of the complete messages from packets received by IP.

TTL

See definition for: time-to-live (TTL)

Back to Top

U

UDP

See definition for: User Datagram Protocol (UDP)

UDP resend

An error correction method that allows the client to request that the server retransmit lost data packets.

UNC

See definition for: Universal Naming Convention (UNC)

unicast

A method used by media servers for providing content to connected clients in which each client receives a discrete stream. No other client has access to that stream.

unicast rollover

Redirection of a client to a unicast stream in the event the client cannot access the multicast stream.

Universal Naming Convention (UNC)

The full name of a resource on a network. It conforms to the \\servername\sharename syntax, where servername is the name of the server and sharename is the name of the shared resource. UNC names of directories or files can also include the directory path under the share name, with the following syntax: \\servername\sharename\directory\filename.

User Datagram Protocol (UDP)

A connectionless transport protocol in the TCP/IP protocol stack that is used in cases where some packet loss is acceptable, for example, with digital media streams.

UTC

See definition for: Coordinated Universal Time (UTC)

Back to Top

W

Windows Media file

A file containing audio, video, or script data that is stored in Windows Media Format. Depending on their content and purpose, Windows Media files use a variety of file name extensions, such as: .wma, .wme, .wms, .wmv, .wmx, .wmz, or .wvx.

Windows Media Format

The format used by Microsoft Windows Media Technologies (or a third-party product that incorporates a licensed Windows Media technology) to author, store, edit, distribute, stream, or play timeline-based content.

Windows Media metafile

In Windows Media Technologies, a file that provides information about Windows Media files and their presentation. File name extensions for Windows Media metafiles include .asx, .wax, .wvx, .wmx, and .nsc.

wrapper playlist

A Windows Media metafile that places additional content at the beginning or end of a stream. Examples of this content include welcome messages, goodbye messages, advertisements, and station branding.

See also: interstitial advertisement

Back to Top

X

XML

See definition for: Extensible Markup Language (XML)

Back to Top


Legal Notice

Information in this document, including URL and other Internet Web site references, is subject to change without notice. Unless otherwise noted, the example companies, organizations, products, domain names, e-mail addresses, logos, people, places and events depicted herein are fictitious, and no association with any real company, organization, product, domain name, e-mail address, logo, person, places or events is intended or should be inferred. Complying with all applicable copyright laws is the responsibility of the user. Without limiting the rights under copyright, no part of this document may be reproduced, stored in or introduced into a retrieval system, or transmitted in any form or by any means (electronic, mechanical, photocopying, recording, or otherwise), or for any purpose, without the express written permission of Microsoft Corporation.

Microsoft may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except as expressly provided in any written license agreement from Microsoft, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

© 2000-2003 Microsoft Corporation. All rights reserved.

Microsoft, MS-DOS, Windows, Windows Media, Windows NT, Active Directory, ActiveSync, ActiveX, Direct3D, DirectDraw, DirectInput, DirectMusic, DirectPlay, DirectShow, DirectSound, DirectX, FrontPage, HighMAT, JScript, Microsoft Press, MSN, NetShow, Outlook, PowerPoint, Visual Basic, Visual C++, Visual InterDev, Visual J++, Visual Studio, WebTV, Win32, and Win32s are either registered trademarks or trademarks of Microsoft Corporation in the U.S.A. and/or other countries.

The names of actual companies and products mentioned herein may be the trademarks of their respective owners.

Portions, Copyright © 1994-2000 World Wide Web Consortium, (Massachusetts Institute of Technology, Institut National de Recherche en Informatique et en Automatique, Keio University). All Rights Reserved. http://www.w3.org/